/**
 * vis-network - network
 * http://visjs.org/
 *
 * A dynamic, browser-based visualization library.
 *
 * @version 6.4.4
 * @date    2019-11-19T22:13:45Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2018-2019 visjs contributors, https://github.com/visjs
 *
 * @license 
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports,require("vis-util"),require("keycharm"),require("vis-data")):"function"==typeof define&&define.amd?define(["exports","vis-util","keycharm","vis-data"],e):e((t=t||self).vis=t.vis||{},t.vis,t.keycharm,t.vis)}(this,(function(t,e,i,o){"use strict";var n="default"in e?e.default:e;i=i&&i.hasOwnProperty("default")?i.default:i;var s="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function r(t,e){return t(e={exports:{}},e.exports),e.exports}function a(t){return t&&t.default||t}var h=function(t){return t&&t.Math==Math&&t},d=h("object"==typeof globalThis&&globalThis)||h("object"==typeof window&&window)||h("object"==typeof self&&self)||h("object"==typeof s&&s)||Function("return this")(),l=function(t){try{return!!t()}catch(t){return!0}},c=!l((function(){return 7!=Object.defineProperty({},"a",{get:function(){return 7}}).a})),u={}.propertyIsEnumerable,p=Object.getOwnPropertyDescriptor,f={f:p&&!u.call({1:2},1)?function(t){var e=p(this,t);return!!e&&e.enumerable}:u},v=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},g={}.toString,y=function(t){return g.call(t).slice(8,-1)},m="".split,b=l((function(){return!Object("z").propertyIsEnumerable(0)}))?function(t){return"String"==y(t)?m.call(t,""):Object(t)}:Object,w=function(t){if(null==t)throw TypeError("Can't call method on "+t);return t},k=function(t){return b(w(t))},_=function(t){return"object"==typeof t?null!==t:"function"==typeof t},x=function(t,e){if(!_(t))return t;var i,o;if(e&&"function"==typeof(i=t.toString)&&!_(o=i.call(t)))return o;if("function"==typeof(i=t.valueOf)&&!_(o=i.call(t)))return o;if(!e&&"function"==typeof(i=t.toString)&&!_(o=i.call(t)))return o;throw TypeError("Can't convert object to primitive value")},E={}.hasOwnProperty,O=function(t,e){return E.call(t,e)},C=d.document,T=_(C)&&_(C.createElement),S=function(t){return T?C.createElement(t):{}},D=!c&&!l((function(){return 7!=Object.defineProperty(S("div"),"a",{get:function(){return 7}}).a})),M=Object.getOwnPropertyDescriptor,I={f:c?M:function(t,e){if(t=k(t),e=x(e,!0),D)try{return M(t,e)}catch(t){}if(O(t,e))return v(!f.f.call(t,e),t[e])}},P=/#|\.prototype\./,F=function(t,e){var i=z[B(t)];return i==A||i!=N&&("function"==typeof e?l(e):!!e)},B=F.normalize=function(t){return String(t).replace(P,".").toLowerCase()},z=F.data={},N=F.NATIVE="N",A=F.POLYFILL="P",R=F,L={},j=function(t){if("function"!=typeof t)throw TypeError(String(t)+" is not a function");return t},H=function(t,e,i){if(j(t),void 0===e)return t;switch(i){case 0:return function(){return t.call(e)};case 1:return function(i){return t.call(e,i)};case 2:return function(i,o){return t.call(e,i,o)};case 3:return function(i,o,n){return t.call(e,i,o,n)}}return function(){return t.apply(e,arguments)}},W=function(t){if(!_(t))throw TypeError(String(t)+" is not an object");return t},V=Object.defineProperty,q={f:c?V:function(t,e,i){if(W(t),e=x(e,!0),W(i),D)try{return V(t,e,i)}catch(t){}if("get"in i||"set"in i)throw TypeError("Accessors not supported");return"value"in i&&(t[e]=i.value),t}},U=c?function(t,e,i){return q.f(t,e,v(1,i))}:function(t,e,i){return t[e]=i,t},Y=I.f,X=function(t){var e=function(e,i,o){if(this instanceof t){switch(arguments.length){case 0:return new t;case 1:return new t(e);case 2:return new t(e,i)}return new t(e,i,o)}return t.apply(this,arguments)};return e.prototype=t.prototype,e},G=function(t,e){var i,o,n,s,r,a,h,l,c=t.target,u=t.global,p=t.stat,f=t.proto,v=u?d:p?d[c]:(d[c]||{}).prototype,g=u?L:L[c]||(L[c]={}),y=g.prototype;for(n in e)i=!R(u?n:c+(p?".":"#")+n,t.forced)&&v&&O(v,n),r=g[n],i&&(a=t.noTargetGet?(l=Y(v,n))&&l.value:v[n]),s=i&&a?a:e[n],i&&typeof r==typeof s||(h=t.bind&&i?H(s,d):t.wrap&&i?X(s):f&&"function"==typeof s?H(Function.call,s):s,(t.sham||s&&s.sham||r&&r.sham)&&U(h,"sham",!0),g[n]=h,f&&(O(L,o=c+"Prototype")||U(L,o,{}),L[o][n]=s,t.real&&y&&!y[n]&&U(y,n,s)))},K=[].slice,Z={},$=function(t,e,i){if(!(e in Z)){for(var o=[],n=0;n<e;n++)o[n]="a["+n+"]";Z[e]=Function("C,a","return new C("+o.join(",")+")")}return Z[e](t,i)},J=Function.bind||function(t){var e=j(this),i=K.call(arguments,1),o=function(){var n=i.concat(K.call(arguments));return this instanceof o?$(e,n.length,n):e.apply(t,n)};return _(e.prototype)&&(o.prototype=e.prototype),o};G({target:"Function",proto:!0},{bind:J});var Q=function(t){return L[t+"Prototype"]},tt=Q("Function").bind,et=Function.prototype,it=function(t){var e=t.bind;return t===et||t instanceof Function&&e===et.bind?tt:e};function ot(t,e,i,o){t.beginPath(),t.arc(e,i,o,0,2*Math.PI,!1),t.closePath()}function nt(t,e,i,o,n,s){var r=Math.PI/180;o-2*s<0&&(s=o/2),n-2*s<0&&(s=n/2),t.beginPath(),t.moveTo(e+s,i),t.lineTo(e+o-s,i),t.arc(e+o-s,i+s,s,270*r,360*r,!1),t.lineTo(e+o,i+n-s),t.arc(e+o-s,i+n-s,s,0,90*r,!1),t.lineTo(e+s,i+n),t.arc(e+s,i+n-s,s,90*r,180*r,!1),t.lineTo(e,i+s),t.arc(e+s,i+s,s,180*r,270*r,!1),t.closePath()}function st(t,e,i,o,n){var s=o/2*.5522848,r=n/2*.5522848,a=e+o,h=i+n,d=e+o/2,l=i+n/2;t.beginPath(),t.moveTo(e,l),t.bezierCurveTo(e,l-r,d-s,i,d,i),t.bezierCurveTo(d+s,i,a,l-r,a,l),t.bezierCurveTo(a,l+r,d+s,h,d,h),t.bezierCurveTo(d-s,h,e,l+r,e,l),t.closePath()}function rt(t,e,i,o,n){var s=n*(1/3),r=o/2*.5522848,a=s/2*.5522848,h=e+o,d=i+s,l=e+o/2,c=i+s/2,u=i+(n-s/2),p=i+n;t.beginPath(),t.moveTo(h,c),t.bezierCurveTo(h,c+a,l+r,d,l,d),t.bezierCurveTo(l-r,d,e,c+a,e,c),t.bezierCurveTo(e,c-a,l-r,i,l,i),t.bezierCurveTo(l+r,i,h,c-a,h,c),t.lineTo(h,u),t.bezierCurveTo(h,u+a,l+r,p,l,p),t.bezierCurveTo(l-r,p,e,u+a,e,u),t.lineTo(e,c)}function at(t,e,i,o,n,s){t.beginPath(),t.moveTo(e,i);for(var r=s.length,a=o-e,h=n-i,d=h/a,l=Math.sqrt(a*a+h*h),c=0,u=!0,p=0,f=+s[0];l>=.1;)(f=+s[c++%r])>l&&(f=l),p=Math.sqrt(f*f/(1+d*d)),e+=p=a<0?-p:p,i+=d*p,!0===u?t.lineTo(e,i):t.moveTo(e,i),l-=f,u=!u}var ht={circle:ot,dashedLine:at,database:rt,diamond:function(t,e,i,o){t.beginPath(),t.lineTo(e,i+o),t.lineTo(e+o,i),t.lineTo(e,i-o),t.lineTo(e-o,i),t.closePath()},ellipse:st,ellipse_vis:st,hexagon:function(t,e,i,o){t.beginPath();var n=2*Math.PI/6;t.moveTo(e+o,i);for(var s=1;s<6;s++)t.lineTo(e+o*Math.cos(n*s),i+o*Math.sin(n*s));t.closePath()},roundRect:nt,square:function(t,e,i,o){t.beginPath(),t.rect(e-o,i-o,2*o,2*o),t.closePath()},star:function(t,e,i,o){t.beginPath(),i+=.1*(o*=.82);for(var n=0;n<10;n++){var s=n%2==0?1.3*o:.5*o;t.lineTo(e+s*Math.sin(2*n*Math.PI/10),i-s*Math.cos(2*n*Math.PI/10))}t.closePath()},triangle:function(t,e,i,o){t.beginPath(),i+=.275*(o*=1.15);var n=2*o,s=n/2,r=Math.sqrt(3)/6*n,a=Math.sqrt(n*n-s*s);t.moveTo(e,i-(a-r)),t.lineTo(e+s,i+r),t.lineTo(e-s,i+r),t.lineTo(e,i-(a-r)),t.closePath()},triangleDown:function(t,e,i,o){t.beginPath(),i-=.275*(o*=1.15);var n=2*o,s=n/2,r=Math.sqrt(3)/6*n,a=Math.sqrt(n*n-s*s);t.moveTo(e,i+(a-r)),t.lineTo(e+s,i-r),t.lineTo(e-s,i-r),t.lineTo(e,i+(a-r)),t.closePath()}};var dt,lt,ct=Array.isArray||function(t){return"Array"==y(t)},ut=Math.ceil,pt=Math.floor,ft=function(t){return isNaN(t=+t)?0:(t>0?pt:ut)(t)},vt=Math.max,gt=Math.min,yt=function(t,e){var i=ft(t);return i<0?vt(i+e,0):gt(i,e)},mt=Math.min,bt=function(t){return t>0?mt(ft(t),9007199254740991):0},wt=function(t,e,i){var o=x(e);o in t?q.f(t,o,v(0,i)):t[o]=i},kt=d["__core-js_shared__"]||function(t,e){try{U(d,t,e)}catch(i){d[t]=e}return e}("__core-js_shared__",{}),_t=r((function(t){(t.exports=function(t,e){return kt[t]||(kt[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.4.1",mode:"pure",copyright:"© 2019 Denis Pushkarev (zloirock.ru)"})})),xt=0,Et=Math.random(),Ot=function(t){return"Symbol("+String(void 0===t?"":t)+")_"+(++xt+Et).toString(36)},Ct=!!Object.getOwnPropertySymbols&&!l((function(){return!String(Symbol())})),Tt=d.Symbol,St=_t("wks"),Dt=function(t){return St[t]||(St[t]=Ct&&Tt[t]||(Ct?Tt:Ot)("Symbol."+t))},Mt=function(t){return"function"==typeof t?t:void 0},It=function(t,e){return arguments.length<2?Mt(L[t])||Mt(d[t]):L[t]&&L[t][e]||d[t]&&d[t][e]},Pt=It("navigator","userAgent")||"",Ft=d.process,Bt=Ft&&Ft.versions,zt=Bt&&Bt.v8;zt?lt=(dt=zt.split("."))[0]+dt[1]:Pt&&(!(dt=Pt.match(/Edge\/(\d+)/))||dt[1]>=74)&&(dt=Pt.match(/Chrome\/(\d+)/))&&(lt=dt[1]);var Nt=lt&&+lt,At=Dt("species"),Rt=function(t){return Nt>=51||!l((function(){var e=[];return(e.constructor={})[At]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},Lt=Dt("species"),jt=[].slice,Ht=Math.max;G({target:"Array",proto:!0,forced:!Rt("slice")},{slice:function(t,e){var i,o,n,s=k(this),r=bt(s.length),a=yt(t,r),h=yt(void 0===e?r:e,r);if(ct(s)&&("function"!=typeof(i=s.constructor)||i!==Array&&!ct(i.prototype)?_(i)&&null===(i=i[Lt])&&(i=void 0):i=void 0,i===Array||void 0===i))return jt.call(s,a,h);for(o=new(void 0===i?Array:i)(Ht(h-a,0)),n=0;a<h;a++,n++)a in s&&wt(o,n,s[a]);return o.length=n,o}});var Wt=Q("Array").slice,Vt=Array.prototype,qt=function(t){var e=t.slice;return t===Vt||t instanceof Array&&e===Vt.slice?Wt:e},Ut=function(t){return Object(w(t))},Yt=Dt("species"),Xt=function(t,e){var i;return ct(t)&&("function"!=typeof(i=t.constructor)||i!==Array&&!ct(i.prototype)?_(i)&&null===(i=i[Yt])&&(i=void 0):i=void 0),new(void 0===i?Array:i)(0===e?0:e)},Gt=Math.max,Kt=Math.min;G({target:"Array",proto:!0,forced:!Rt("splice")},{splice:function(t,e){var i,o,n,s,r,a,h=Ut(this),d=bt(h.length),l=yt(t,d),c=arguments.length;if(0===c?i=o=0:1===c?(i=0,o=d-l):(i=c-2,o=Kt(Gt(ft(e),0),d-l)),d+i-o>9007199254740991)throw TypeError("Maximum allowed length exceeded");for(n=Xt(h,o),s=0;s<o;s++)(r=l+s)in h&&wt(n,s,h[r]);if(n.length=o,i<o){for(s=l;s<d-o;s++)a=s+i,(r=s+o)in h?h[a]=h[r]:delete h[a];for(s=d;s>d-o+i;s--)delete h[s-1]}else if(i>o)for(s=d-o;s>l;s--)a=s+i-1,(r=s+o-1)in h?h[a]=h[r]:delete h[a];for(s=0;s<i;s++)h[s+l]=arguments[s+2];return h.length=d-o+i,n}});var Zt,$t,Jt,Qt=Q("Array").splice,te=Array.prototype,ee=function(t){var e=t.splice;return t===te||t instanceof Array&&e===te.splice?Qt:e},ie=r((function(t){function e(t){if(t)return function(t){for(var i in e.prototype)t[i]=e.prototype[i];return t}(t)}t.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function i(){this.off(t,i),e.apply(this,arguments)}return i.fn=e,this.on(t,i),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var i,o=this._callbacks["$"+t];if(!o)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var n=0;n<o.length;n++)if((i=o[n])===e||i.fn===e){ee(o).call(o,n,1);break}return 0===o.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),i=this._callbacks["$"+t],o=1;o<arguments.length;o++)e[o-1]=arguments[o];if(i){o=0;for(var n=(i=qt(i).call(i,0)).length;o<n;++o)i[o].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}})),oe={},ne=_t("native-function-to-string",Function.toString),se=d.WeakMap,re="function"==typeof se&&/native code/.test(ne.call(se)),ae=_t("keys"),he=function(t){return ae[t]||(ae[t]=Ot(t))},de={},le=d.WeakMap;if(re){var ce=new le,ue=ce.get,pe=ce.has,fe=ce.set;Zt=function(t,e){return fe.call(ce,t,e),e},$t=function(t){return ue.call(ce,t)||{}},Jt=function(t){return pe.call(ce,t)}}else{var ve=he("state");de[ve]=!0,Zt=function(t,e){return U(t,ve,e),e},$t=function(t){return O(t,ve)?t[ve]:{}},Jt=function(t){return O(t,ve)}}var ge,ye,me,be={set:Zt,get:$t,has:Jt,enforce:function(t){return Jt(t)?$t(t):Zt(t,{})},getterFor:function(t){return function(e){var i;if(!_(e)||(i=$t(e)).type!==t)throw TypeError("Incompatible receiver, "+t+" required");return i}}},we=!l((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),ke=he("IE_PROTO"),_e=Object.prototype,xe=we?Object.getPrototypeOf:function(t){return t=Ut(t),O(t,ke)?t[ke]:"function"==typeof t.constructor&&t instanceof t.constructor?t.constructor.prototype:t instanceof Object?_e:null},Ee=(Dt("iterator"),!1);[].keys&&("next"in(me=[].keys())?(ye=xe(xe(me)))!==Object.prototype&&(ge=ye):Ee=!0),null==ge&&(ge={});var Oe={IteratorPrototype:ge,BUGGY_SAFARI_ITERATORS:Ee},Ce=function(t){return function(e,i,o){var n,s=k(e),r=bt(s.length),a=yt(o,r);if(t&&i!=i){for(;r>a;)if((n=s[a++])!=n)return!0}else for(;r>a;a++)if((t||a in s)&&s[a]===i)return t||a||0;return!t&&-1}},Te={includes:Ce(!0),indexOf:Ce(!1)},Se=Te.indexOf,De=function(t,e){var i,o=k(t),n=0,s=[];for(i in o)!O(de,i)&&O(o,i)&&s.push(i);for(;e.length>n;)O(o,i=e[n++])&&(~Se(s,i)||s.push(i));return s},Me=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],Ie=Object.keys||function(t){return De(t,Me)},Pe=c?Object.defineProperties:function(t,e){W(t);for(var i,o=Ie(e),n=o.length,s=0;n>s;)q.f(t,i=o[s++],e[i]);return t},Fe=It("document","documentElement"),Be=he("IE_PROTO"),ze=function(){},Ne=function(){var t,e=S("iframe"),i=Me.length;for(e.style.display="none",Fe.appendChild(e),e.src=String("javascript:"),(t=e.contentWindow.document).open(),t.write("<script>document.F=Object<\/script>"),t.close(),Ne=t.F;i--;)delete Ne.prototype[Me[i]];return Ne()},Ae=Object.create||function(t,e){var i;return null!==t?(ze.prototype=W(t),i=new ze,ze.prototype=null,i[Be]=t):i=Ne(),void 0===e?i:Pe(i,e)};de[Be]=!0;var Re=Dt("toStringTag"),Le="Arguments"==y(function(){return arguments}()),je=function(t){var e,i,o;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(i=function(t,e){try{return t[e]}catch(t){}}(e=Object(t),Re))?i:Le?y(e):"Object"==(o=y(e))&&"function"==typeof e.callee?"Arguments":o},He={};He[Dt("toStringTag")]="z";var We="[object z]"!==String(He)?function(){return"[object "+je(this)+"]"}:He.toString,Ve=q.f,qe=Dt("toStringTag"),Ue=We!=={}.toString,Ye=function(t,e,i,o){if(t){var n=i?t:t.prototype;O(n,qe)||Ve(n,qe,{configurable:!0,value:e}),o&&Ue&&U(n,"toString",We)}},Xe=Oe.IteratorPrototype,Ge=function(){return this},Ke=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,i={};try{(t=Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set).call(i,[]),e=i instanceof Array}catch(t){}return function(i,o){return W(i),function(t){if(!_(t)&&null!==t)throw TypeError("Can't set "+String(t)+" as a prototype")}(o),e?t.call(i,o):i.__proto__=o,i}}():void 0),Ze=function(t,e,i,o){o&&o.enumerable?t[e]=i:U(t,e,i)},$e=Oe.IteratorPrototype,Je=Oe.BUGGY_SAFARI_ITERATORS,Qe=Dt("iterator"),ti=function(){return this},ei=function(t,e,i,o,n,s,r){!function(t,e,i){var o=e+" Iterator";t.prototype=Ae(Xe,{next:v(1,i)}),Ye(t,o,!1,!0),oe[o]=Ge}(i,e,o);var a,h,d,l=function(t){if(t===n&&g)return g;if(!Je&&t in p)return p[t];switch(t){case"keys":case"values":case"entries":return function(){return new i(this,t)}}return function(){return new i(this)}},c=e+" Iterator",u=!1,p=t.prototype,f=p[Qe]||p["@@iterator"]||n&&p[n],g=!Je&&f||l(n),y="Array"==e&&p.entries||f;if(y&&(a=xe(y.call(new t)),$e!==Object.prototype&&a.next&&(Ye(a,c,!0,!0),oe[c]=ti)),"values"==n&&f&&"values"!==f.name&&(u=!0,g=function(){return f.call(this)}),r&&p[Qe]!==g&&U(p,Qe,g),oe[e]=g,n)if(h={values:l("values"),keys:s?g:l("keys"),entries:l("entries")},r)for(d in h)!Je&&!u&&d in p||Ze(p,d,h[d]);else G({target:e,proto:!0,forced:Je||u},h);return h},ii=be.set,oi=be.getterFor("Array Iterator");ei(Array,"Array",(function(t,e){ii(this,{type:"Array Iterator",target:k(t),index:0,kind:e})}),(function(){var t=oi(this),e=t.target,i=t.kind,o=t.index++;return!e||o>=e.length?(t.target=void 0,{value:void 0,done:!0}):"keys"==i?{value:o,done:!1}:"values"==i?{value:e[o],done:!1}:{value:[o,e[o]],done:!1}}),"values");oe.Arguments=oe.Array;var ni=Dt("toStringTag");for(var si in{CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0}){var ri=d[si],ai=ri&&ri.prototype;ai&&!ai[ni]&&U(ai,ni,si),oe[si]=oe.Array}var hi=[].push,di=function(t){var e=1==t,i=2==t,o=3==t,n=4==t,s=6==t,r=5==t||s;return function(a,h,d,l){for(var c,u,p=Ut(a),f=b(p),v=H(h,d,3),g=bt(f.length),y=0,m=l||Xt,w=e?m(a,g):i?m(a,0):void 0;g>y;y++)if((r||y in f)&&(u=v(c=f[y],y,p),t))if(e)w[y]=u;else if(u)switch(t){case 3:return!0;case 5:return c;case 6:return y;case 2:hi.call(w,c)}else if(n)return!1;return s?-1:o||n?n:w}},li={forEach:di(0),map:di(1),filter:di(2),some:di(3),every:di(4),find:di(5),findIndex:di(6)},ci=function(t,e){var i=[][t];return!i||!l((function(){i.call(null,e||function(){throw 1},1)}))},ui=li.forEach,pi=ci("forEach")?function(t){return ui(this,t,arguments.length>1?arguments[1]:void 0)}:[].forEach;G({target:"Array",proto:!0,forced:[].forEach!=pi},{forEach:pi});var fi=Q("Array").forEach,vi=Array.prototype,gi={DOMTokenList:!0,NodeList:!0},yi=function(t){var e=t.forEach;return t===vi||t instanceof Array&&e===vi.forEach||gi.hasOwnProperty(je(t))?fi:e};G({target:"Array",stat:!0},{isArray:ct});var mi=L.Array.isArray,bi=mi,wi=Te.includes;G({target:"Array",proto:!0},{includes:function(t){return wi(this,t,arguments.length>1?arguments[1]:void 0)}});var ki=Q("Array").includes,_i=Dt("match"),xi=function(t){if(function(t){var e;return _(t)&&(void 0!==(e=t[_i])?!!e:"RegExp"==y(t))}(t))throw TypeError("The method doesn't accept regular expressions");return t},Ei=Dt("match");G({target:"String",proto:!0,forced:!function(t){var e=/./;try{"/./"[t](e)}catch(i){try{return e[Ei]=!1,"/./"[t](e)}catch(t){}}return!1}("includes")},{includes:function(t){return!!~String(w(this)).indexOf(xi(t),arguments.length>1?arguments[1]:void 0)}});var Oi=Q("String").includes,Ci=Array.prototype,Ti=String.prototype,Si=function(t){var e=t.includes;return t===Ci||t instanceof Array&&e===Ci.includes?ki:"string"==typeof t||t===Ti||t instanceof String&&e===Ti.includes?Oi:e},Di=Te.indexOf,Mi=[].indexOf,Ii=!!Mi&&1/[1].indexOf(1,-0)<0,Pi=ci("indexOf");G({target:"Array",proto:!0,forced:Ii||Pi},{indexOf:function(t){return Ii?Mi.apply(this,arguments)||0:Di(this,t,arguments.length>1?arguments[1]:void 0)}});var Fi=Q("Array").indexOf,Bi=Array.prototype,zi=function(t){var e=t.indexOf;return t===Bi||t instanceof Array&&e===Bi.indexOf?Fi:e};G({target:"Object",stat:!0,sham:!c},{create:Ae});var Ni=L.Object,Ai=function(t,e){return Ni.create(t,e)},Ri=Ai;function Li(t){return qi=t,function(){var t={};Ui=0,void(Yi=qi.charAt(0)),no(),"strict"===Xi&&(t.strict=!0,no());"graph"!==Xi&&"digraph"!==Xi||(t.type=Xi,no());Gi===Wi.IDENTIFIER&&(t.id=Xi,no());if("{"!=Xi)throw co("Angle bracket { expected");if(no(),so(t),"}"!=Xi)throw co("Angle bracket } expected");if(no(),""!==Xi)throw co("End of file expected");return no(),delete t.node,delete t.edge,delete t.graph,t}()}var ji={fontsize:"font.size",fontcolor:"font.color",labelfontcolor:"font.color",fontname:"font.face",color:["color.border","color.background"],fillcolor:"color.background",tooltip:"title",labeltooltip:"title"},Hi=Ri(ji);Hi.color="color.color",Hi.style="dashes";var Wi={NULL:0,DELIMITER:1,IDENTIFIER:2,UNKNOWN:3},Vi={"{":!0,"}":!0,"[":!0,"]":!0,";":!0,"=":!0,",":!0,"->":!0,"--":!0},qi="",Ui=0,Yi="",Xi="",Gi=Wi.NULL;function Ki(){Ui++,Yi=qi.charAt(Ui)}function Zi(){return qi.charAt(Ui+1)}var $i=/[a-zA-Z_0-9.:#]/;function Ji(t){return $i.test(t)}function Qi(t,e){if(t||(t={}),e)for(var i in e)e.hasOwnProperty(i)&&(t[i]=e[i]);return t}function to(t,e,i){for(var o=e.split("."),n=t;o.length;){var s=o.shift();o.length?(n[s]||(n[s]={}),n=n[s]):n[s]=i}}function eo(t,e){for(var i,o,n=null,s=[t],r=t;r.parent;)s.push(r.parent),r=r.parent;if(r.nodes)for(i=0,o=r.nodes.length;i<o;i++)if(e.id===r.nodes[i].id){n=r.nodes[i];break}for(n||(n={id:e.id},t.node&&(n.attr=Qi(n.attr,t.node))),i=s.length-1;i>=0;i--){var a,h=s[i];h.nodes||(h.nodes=[]),-1===zi(a=h.nodes).call(a,n)&&h.nodes.push(n)}e.attr&&(n.attr=Qi(n.attr,e.attr))}function io(t,e){if(t.edges||(t.edges=[]),t.edges.push(e),t.edge){var i=Qi({},t.edge);e.attr=Qi(i,e.attr)}}function oo(t,e,i,o,n){var s={from:e,to:i,type:o};return t.edge&&(s.attr=Qi({},t.edge)),s.attr=Qi(s.attr||{},n),null!=n&&n.hasOwnProperty("arrows")&&null!=n.arrows&&(s.arrows={to:{enabled:!0,type:n.arrows.type}},n.arrows=null),s}function no(){for(Gi=Wi.NULL,Xi="";" "===Yi||"\t"===Yi||"\n"===Yi||"\r"===Yi;)Ki();do{var t=!1;if("#"===Yi){for(var e=Ui-1;" "===qi.charAt(e)||"\t"===qi.charAt(e);)e--;if("\n"===qi.charAt(e)||""===qi.charAt(e)){for(;""!=Yi&&"\n"!=Yi;)Ki();t=!0}}if("/"===Yi&&"/"===Zi()){for(;""!=Yi&&"\n"!=Yi;)Ki();t=!0}if("/"===Yi&&"*"===Zi()){for(;""!=Yi;){if("*"===Yi&&"/"===Zi()){Ki(),Ki();break}Ki()}t=!0}for(;" "===Yi||"\t"===Yi||"\n"===Yi||"\r"===Yi;)Ki()}while(t);if(""!==Yi){var i=Yi+Zi();if(Vi[i])return Gi=Wi.DELIMITER,Xi=i,Ki(),void Ki();if(Vi[Yi])return Gi=Wi.DELIMITER,Xi=Yi,void Ki();if(Ji(Yi)||"-"===Yi){for(Xi+=Yi,Ki();Ji(Yi);)Xi+=Yi,Ki();return"false"===Xi?Xi=!1:"true"===Xi?Xi=!0:isNaN(Number(Xi))||(Xi=Number(Xi)),void(Gi=Wi.IDENTIFIER)}if('"'===Yi){for(Ki();""!=Yi&&('"'!=Yi||'"'===Yi&&'"'===Zi());)'"'===Yi?(Xi+=Yi,Ki()):"\\"===Yi&&"n"===Zi()?(Xi+="\n",Ki()):Xi+=Yi,Ki();if('"'!=Yi)throw co('End of string " expected');return Ki(),void(Gi=Wi.IDENTIFIER)}for(Gi=Wi.UNKNOWN;""!=Yi;)Xi+=Yi,Ki();throw new SyntaxError('Syntax error in part "'+uo(Xi,30)+'"')}Gi=Wi.DELIMITER}function so(t){for(;""!==Xi&&"}"!=Xi;)ro(t),";"===Xi&&no()}function ro(t){var e=ao(t);if(e)ho(t,e);else if(!function(t){if("node"===Xi)return no(),t.node=lo(),"node";if("edge"===Xi)return no(),t.edge=lo(),"edge";if("graph"===Xi)return no(),t.graph=lo(),"graph";return null}(t)){if(Gi!=Wi.IDENTIFIER)throw co("Identifier expected");var i=Xi;if(no(),"="===Xi){if(no(),Gi!=Wi.IDENTIFIER)throw co("Identifier expected");t[i]=Xi,no()}else!function(t,e){var i={id:e},o=lo();o&&(i.attr=o);eo(t,i),ho(t,e)}(t,i)}}function ao(t){var e=null;if("subgraph"===Xi&&((e={}).type="subgraph",no(),Gi===Wi.IDENTIFIER&&(e.id=Xi,no())),"{"===Xi){if(no(),e||(e={}),e.parent=t,e.node=t.node,e.edge=t.edge,e.graph=t.graph,so(e),"}"!=Xi)throw co("Angle bracket } expected");no(),delete e.node,delete e.edge,delete e.graph,delete e.parent,t.subgraphs||(t.subgraphs=[]),t.subgraphs.push(e)}return e}function ho(t,e){for(;"->"===Xi||"--"===Xi;){var i,o=Xi;no();var n=ao(t);if(n)i=n;else{if(Gi!=Wi.IDENTIFIER)throw co("Identifier or subgraph expected");eo(t,{id:i=Xi}),no()}io(t,oo(t,e,i,o,lo())),e=i}}function lo(){for(var t,e,i=null,o={dashed:!0,solid:!1,dotted:[1,5]},n={dot:"circle",box:"box",crow:"crow",curve:"curve",icurve:"inv_curve",normal:"triangle",inv:"inv_triangle",diamond:"diamond",tee:"bar",vee:"vee"},s=new Array,r=new Array;"["===Xi;){for(no(),i={};""!==Xi&&"]"!=Xi;){if(Gi!=Wi.IDENTIFIER)throw co("Attribute name expected");var a=Xi;if(no(),"="!=Xi)throw co("Equal sign = expected");if(no(),Gi!=Wi.IDENTIFIER)throw co("Attribute value expected");var h=Xi;"style"===a&&(h=o[h]),"arrowhead"===a&&(a="arrows",h={to:{enabled:!0,type:n[h]}}),"arrowtail"===a&&(a="arrows",h={from:{enabled:!0,type:n[h]}}),s.push({attr:i,name:a,value:h}),r.push(a),no(),","==Xi&&no()}if("]"!=Xi)throw co("Bracket ] expected");no()}if(Si(r).call(r,"dir")){var d={arrows:{}};for(t=0;t<s.length;t++)if("arrows"===s[t].name)if(null!=s[t].value.to)d.arrows.to=t;else{if(null==s[t].value.from)throw co("Invalid value of arrows");d.arrows.from=t}else"dir"===s[t].name&&(d.dir=t);var l,c,u=s[d.dir].value;if(!Si(r).call(r,"arrows"))if("both"===u)s.push({attr:s[d.dir].attr,name:"arrows",value:{to:{enabled:!0}}}),d.arrows.to=s.length-1,s.push({attr:s[d.dir].attr,name:"arrows",value:{from:{enabled:!0}}}),d.arrows.from=s.length-1;else if("forward"===u)s.push({attr:s[d.dir].attr,name:"arrows",value:{to:{enabled:!0}}}),d.arrows.to=s.length-1;else if("back"===u)s.push({attr:s[d.dir].attr,name:"arrows",value:{from:{enabled:!0}}}),d.arrows.from=s.length-1;else{if("none"!==u)throw co('Invalid dir type "'+u+'"');s.push({attr:s[d.dir].attr,name:"arrows",value:""}),d.arrows.to=s.length-1}if("both"===u)d.arrows.to&&d.arrows.from?(c=s[d.arrows.to].value.to.type,l=s[d.arrows.from].value.from.type,s[d.arrows.to]={attr:s[d.arrows.to].attr,name:s[d.arrows.to].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:l}}},ee(s).call(s,d.arrows.from,1)):d.arrows.to?(c=s[d.arrows.to].value.to.type,l="arrow",s[d.arrows.to]={attr:s[d.arrows.to].attr,name:s[d.arrows.to].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:l}}}):d.arrows.from&&(c="arrow",l=s[d.arrows.from].value.from.type,s[d.arrows.from]={attr:s[d.arrows.from].attr,name:s[d.arrows.from].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:l}}});else if("back"===u)d.arrows.to&&d.arrows.from?(c="",l=s[d.arrows.from].value.from.type,s[d.arrows.from]={attr:s[d.arrows.from].attr,name:s[d.arrows.from].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:l}}}):d.arrows.to?(c="",l="arrow",d.arrows.from=d.arrows.to,s[d.arrows.from]={attr:s[d.arrows.from].attr,name:s[d.arrows.from].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:l}}}):d.arrows.from&&(c="",l=s[d.arrows.from].value.from.type,s[d.arrows.to]={attr:s[d.arrows.from].attr,name:s[d.arrows.from].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:l}}}),s[d.arrows.from]={attr:s[d.arrows.from].attr,name:s[d.arrows.from].name,value:{from:{enabled:!0,type:s[d.arrows.from].value.from.type}}};else if("none"===u){var p;s[p=d.arrows.to?d.arrows.to:d.arrows.from]={attr:s[p].attr,name:s[p].name,value:""}}else{if("forward"!==u)throw co('Invalid dir type "'+u+'"');d.arrows.to&&d.arrows.from?(c=s[d.arrows.to].value.to.type,l="",s[d.arrows.to]={attr:s[d.arrows.to].attr,name:s[d.arrows.to].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:l}}}):d.arrows.to?(c=s[d.arrows.to].value.to.type,l="",s[d.arrows.to]={attr:s[d.arrows.to].attr,name:s[d.arrows.to].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:l}}}):d.arrows.from&&(c="arrow",l="",d.arrows.to=d.arrows.from,s[d.arrows.to]={attr:s[d.arrows.to].attr,name:s[d.arrows.to].name,value:{to:{enabled:!0,type:c},from:{enabled:!0,type:l}}}),s[d.arrows.to]={attr:s[d.arrows.to].attr,name:s[d.arrows.to].name,value:{to:{enabled:!0,type:s[d.arrows.to].value.to.type}}}}ee(s).call(s,d.dir,1)}if(Si(r).call(r,"penwidth")){var f=[];for(e=s.length,t=0;t<e;t++)"width"!==s[t].name&&("penwidth"===s[t].name&&(s[t].name="width"),f.push(s[t]));s=f}for(e=s.length,t=0;t<e;t++)to(s[t].attr,s[t].name,s[t].value);return i}function co(t){return new SyntaxError(t+', got "'+uo(Xi,30)+'" (char '+Ui+")")}function uo(t,e){return t.length<=e?t:t.substr(0,27)+"..."}function po(t,e,i){for(var o=e.split("."),n=o.pop(),s=t,r=0;r<o.length;r++){var a=o[r];a in s||(s[a]={}),s=s[a]}return s[n]=i,t}function fo(t,e){var i={};for(var o in t)if(t.hasOwnProperty(o)){var n=e[o];bi(n)?yi(n).call(n,(function(e){po(i,e,t[o])})):po(i,"string"==typeof n?n:o,t[o])}return i}var vo=Li,go=function(t){var e,i=Li(t),o={nodes:[],edges:[],options:{}};if(i.nodes&&yi(e=i.nodes).call(e,(function(t){var e={id:t.id,label:String(t.label||t.id)};Qi(e,fo(t.attr,ji)),e.image&&(e.shape="image"),o.nodes.push(e)})),i.edges){var n,s=function(t){var e={from:t.from,to:t.to};return Qi(e,fo(t.attr,Hi)),null==e.arrows&&"->"===t.type&&(e.arrows="to"),e};yi(n=i.edges).call(n,(function(t){var e,i,n,r,a,h,d;(e=t.from instanceof Object?t.from.nodes:{id:t.from},i=t.to instanceof Object?t.to.nodes:{id:t.to},t.from instanceof Object&&t.from.edges)&&yi(n=t.from.edges).call(n,(function(t){var e=s(t);o.edges.push(e)}));(a=i,h=function(e,i){var n=oo(o,e.id,i.id,t.type,t.attr),r=s(n);o.edges.push(r)},bi(r=e)?yi(r).call(r,(function(t){bi(a)?yi(a).call(a,(function(e){h(t,e)})):h(t,a)})):bi(a)?yi(a).call(a,(function(t){h(r,t)})):h(r,a),t.to instanceof Object&&t.to.edges)&&yi(d=t.to.edges).call(d,(function(t){var e=s(t);o.edges.push(e)}))}))}return i.attr&&(o.options=i.attr),o},yo={parseDOT:vo,DOTToGraph:go},mo=Object.freeze({__proto__:null,default:yo,__moduleExports:yo,parseDOT:vo,DOTToGraph:go}),bo=li.map;G({target:"Array",proto:!0,forced:!Rt("map")},{map:function(t){return bo(this,t,arguments.length>1?arguments[1]:void 0)}});var wo=Q("Array").map,ko=Array.prototype,_o=function(t){var e=t.map;return t===ko||t instanceof Array&&e===ko.map?wo:e};function xo(t,e){var i,o={edges:{inheritColor:!1},nodes:{fixed:!1,parseColor:!1}};null!=e&&(null!=e.fixed&&(o.nodes.fixed=e.fixed),null!=e.parseColor&&(o.nodes.parseColor=e.parseColor),null!=e.inheritColor&&(o.edges.inheritColor=e.inheritColor));var n=t.edges,s=_o(n).call(n,(function(t){var e={from:t.source,id:t.id,to:t.target};return null!=t.attributes&&(e.attributes=t.attributes),null!=t.label&&(e.label=t.label),null!=t.attributes&&null!=t.attributes.title&&(e.title=t.attributes.title),"Directed"===t.type&&(e.arrows="to"),t.color&&!1===o.edges.inheritColor&&(e.color=t.color),e}));return{nodes:_o(i=t.nodes).call(i,(function(t){var e={id:t.id,fixed:o.nodes.fixed&&null!=t.x&&null!=t.y};return null!=t.attributes&&(e.attributes=t.attributes),null!=t.label&&(e.label=t.label),null!=t.size&&(e.size=t.size),null!=t.attributes&&null!=t.attributes.title&&(e.title=t.attributes.title),null!=t.title&&(e.title=t.title),null!=t.x&&(e.x=t.x),null!=t.y&&(e.y=t.y),null!=t.color&&(!0===o.nodes.parseColor?e.color=t.color:e.color={background:t.color,border:t.color,highlight:{background:t.color,border:t.color},hover:{background:t.color,border:t.color}}),e})),edges:s}}var Eo=Object.freeze({__proto__:null,parseGephi:xo}),Oo=Object.freeze({__proto__:null,default:void 0}),Co=l((function(){Ie(1)}));G({target:"Object",stat:!0,forced:Co},{keys:function(t){return Ie(Ut(t))}});var To=L.Object.keys,So=[].slice,Do=/MSIE .\./.test(Pt),Mo=function(t){return function(e,i){var o=arguments.length>2,n=o?So.call(arguments,2):void 0;return t(o?function(){("function"==typeof e?e:Function(e)).apply(this,n)}:e,i)}};G({global:!0,bind:!0,forced:Do},{setTimeout:Mo(d.setTimeout),setInterval:Mo(d.setInterval)});var Io=L.setTimeout,Po=li.filter;G({target:"Array",proto:!0,forced:!Rt("filter")},{filter:function(t){return Po(this,t,arguments.length>1?arguments[1]:void 0)}});var Fo=Q("Array").filter,Bo=Array.prototype,zo=function(t){var e=t.filter;return t===Bo||t instanceof Array&&e===Bo.filter?Fo:e},No=[],Ao=No.sort,Ro=l((function(){No.sort(void 0)})),Lo=l((function(){No.sort(null)})),jo=ci("sort");G({target:"Array",proto:!0,forced:Ro||!Lo||jo},{sort:function(t){return void 0===t?Ao.call(Ut(this)):Ao.call(Ut(this),j(t))}});var Ho=Q("Array").sort,Wo=Array.prototype,Vo=function(t){var e=t.sort;return t===Wo||t instanceof Array&&e===Wo.sort?Ho:e},qo=Dt("isConcatSpreadable"),Uo=Nt>=51||!l((function(){var t=[];return t[qo]=!1,t.concat()[0]!==t})),Yo=Rt("concat"),Xo=function(t){if(!_(t))return!1;var e=t[qo];return void 0!==e?!!e:ct(t)};G({target:"Array",proto:!0,forced:!Uo||!Yo},{concat:function(t){var e,i,o,n,s,r=Ut(this),a=Xt(r,0),h=0;for(e=-1,o=arguments.length;e<o;e++)if(s=-1===e?r:arguments[e],Xo(s)){if(h+(n=bt(s.length))>9007199254740991)throw TypeError("Maximum allowed index exceeded");for(i=0;i<n;i++,h++)i in s&&wt(a,h,s[i])}else{if(h>=9007199254740991)throw TypeError("Maximum allowed index exceeded");wt(a,h++,s)}return a.length=h,a}});var Go,Ko=Q("Array").concat,Zo=Array.prototype,$o=function(t){var e=t.concat;return t===Zo||t instanceof Array&&e===Zo.concat?Ko:e},Jo="\t\n\v\f\r                　\u2028\u2029\ufeff",Qo="["+Jo+"]",tn=RegExp("^"+Qo+Qo+"*"),en=RegExp(Qo+Qo+"*$"),on=function(t){return function(e){var i=String(w(e));return 1&t&&(i=i.replace(tn,"")),2&t&&(i=i.replace(en,"")),i}},nn={start:on(1),end:on(2),trim:on(3)},sn=nn.trim;G({target:"String",proto:!0,forced:(Go="trim",l((function(){return!!Jo[Go]()||"​᠎"!="​᠎"[Go]()||Jo[Go].name!==Go})))},{trim:function(){return sn(this)}});var rn=Q("String").trim,an=String.prototype,hn=function(t){var e=t.trim;return"string"==typeof t||t===an||t instanceof String&&e===an.trim?rn:e},dn={f:Dt},ln=q.f,cn=function(t){var e=L.Symbol||(L.Symbol={});O(e,t)||ln(e,t,{value:dn.f(t)})};cn("iterator");var un=function(t){return function(e,i){var o,n,s=String(w(e)),r=ft(i),a=s.length;return r<0||r>=a?t?"":void 0:(o=s.charCodeAt(r))<55296||o>56319||r+1===a||(n=s.charCodeAt(r+1))<56320||n>57343?t?s.charAt(r):o:t?s.slice(r,r+2):n-56320+(o-55296<<10)+65536}},pn={codeAt:un(!1),charAt:un(!0)}.charAt,fn=be.set,vn=be.getterFor("String Iterator");ei(String,"String",(function(t){fn(this,{type:"String Iterator",string:String(t),index:0})}),(function(){var t,e=vn(this),i=e.string,o=e.index;return o>=i.length?{value:void 0,done:!0}:(t=pn(i,o),e.index+=t.length,{value:t,done:!1})}));var gn=dn.f("iterator"),yn=Object.freeze({__proto__:null}),mn=Me.concat("length","prototype"),bn={f:Object.getOwnPropertyNames||function(t){return De(t,mn)}},wn=bn.f,kn={}.toString,_n="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],xn={f:function(t){return _n&&"[object Window]"==kn.call(t)?function(t){try{return wn(t)}catch(t){return _n.slice()}}(t):wn(k(t))}},En={f:Object.getOwnPropertySymbols},On=li.forEach,Cn=he("hidden"),Tn=Dt("toPrimitive"),Sn=be.set,Dn=be.getterFor("Symbol"),Mn=Object.prototype,In=d.Symbol,Pn=It("JSON","stringify"),Fn=I.f,Bn=q.f,zn=xn.f,Nn=f.f,An=_t("symbols"),Rn=_t("op-symbols"),Ln=_t("string-to-symbol-registry"),jn=_t("symbol-to-string-registry"),Hn=_t("wks"),Wn=d.QObject,Vn=!Wn||!Wn.prototype||!Wn.prototype.findChild,qn=c&&l((function(){return 7!=Ae(Bn({},"a",{get:function(){return Bn(this,"a",{value:7}).a}})).a}))?function(t,e,i){var o=Fn(Mn,e);o&&delete Mn[e],Bn(t,e,i),o&&t!==Mn&&Bn(Mn,e,o)}:Bn,Un=function(t,e){var i=An[t]=Ae(In.prototype);return Sn(i,{type:"Symbol",tag:t,description:e}),c||(i.description=e),i},Yn=Ct&&"symbol"==typeof In.iterator?function(t){return"symbol"==typeof t}:function(t){return Object(t)instanceof In},Xn=function(t,e,i){t===Mn&&Xn(Rn,e,i),W(t);var o=x(e,!0);return W(i),O(An,o)?(i.enumerable?(O(t,Cn)&&t[Cn][o]&&(t[Cn][o]=!1),i=Ae(i,{enumerable:v(0,!1)})):(O(t,Cn)||Bn(t,Cn,v(1,{})),t[Cn][o]=!0),qn(t,o,i)):Bn(t,o,i)},Gn=function(t,e){W(t);var i=k(e),o=Ie(i).concat(Jn(i));return On(o,(function(e){c&&!Kn.call(i,e)||Xn(t,e,i[e])})),t},Kn=function(t){var e=x(t,!0),i=Nn.call(this,e);return!(this===Mn&&O(An,e)&&!O(Rn,e))&&(!(i||!O(this,e)||!O(An,e)||O(this,Cn)&&this[Cn][e])||i)},Zn=function(t,e){var i=k(t),o=x(e,!0);if(i!==Mn||!O(An,o)||O(Rn,o)){var n=Fn(i,o);return!n||!O(An,o)||O(i,Cn)&&i[Cn][o]||(n.enumerable=!0),n}},$n=function(t){var e=zn(k(t)),i=[];return On(e,(function(t){O(An,t)||O(de,t)||i.push(t)})),i},Jn=function(t){var e=t===Mn,i=zn(e?Rn:k(t)),o=[];return On(i,(function(t){!O(An,t)||e&&!O(Mn,t)||o.push(An[t])})),o};if(Ct||(Ze((In=function(){if(this instanceof In)throw TypeError("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?String(arguments[0]):void 0,e=Ot(t),i=function(t){this===Mn&&i.call(Rn,t),O(this,Cn)&&O(this[Cn],e)&&(this[Cn][e]=!1),qn(this,e,v(1,t))};return c&&Vn&&qn(Mn,e,{configurable:!0,set:i}),Un(e,t)}).prototype,"toString",(function(){return Dn(this).tag})),f.f=Kn,q.f=Xn,I.f=Zn,bn.f=xn.f=$n,En.f=Jn,c&&Bn(In.prototype,"description",{configurable:!0,get:function(){return Dn(this).description}}),dn.f=function(t){return Un(Dt(t),t)}),G({global:!0,wrap:!0,forced:!Ct,sham:!Ct},{Symbol:In}),On(Ie(Hn),(function(t){cn(t)})),G({target:"Symbol",stat:!0,forced:!Ct},{for:function(t){var e=String(t);if(O(Ln,e))return Ln[e];var i=In(e);return Ln[e]=i,jn[i]=e,i},keyFor:function(t){if(!Yn(t))throw TypeError(t+" is not a symbol");if(O(jn,t))return jn[t]},useSetter:function(){Vn=!0},useSimple:function(){Vn=!1}}),G({target:"Object",stat:!0,forced:!Ct,sham:!c},{create:function(t,e){return void 0===e?Ae(t):Gn(Ae(t),e)},defineProperty:Xn,defineProperties:Gn,getOwnPropertyDescriptor:Zn}),G({target:"Object",stat:!0,forced:!Ct},{getOwnPropertyNames:$n,getOwnPropertySymbols:Jn}),G({target:"Object",stat:!0,forced:l((function(){En.f(1)}))},{getOwnPropertySymbols:function(t){return En.f(Ut(t))}}),Pn){var Qn=!Ct||l((function(){var t=In();return"[null]"!=Pn([t])||"{}"!=Pn({a:t})||"{}"!=Pn(Object(t))}));G({target:"JSON",stat:!0,forced:Qn},{stringify:function(t,e,i){for(var o,n=[t],s=1;arguments.length>s;)n.push(arguments[s++]);if(o=e,(_(e)||void 0!==t)&&!Yn(t))return ct(e)||(e=function(t,e){if("function"==typeof o&&(e=o.call(this,t,e)),!Yn(e))return e}),n[1]=e,Pn.apply(null,n)}})}In.prototype[Tn]||U(In.prototype,Tn,In.prototype.valueOf),Ye(In,"Symbol"),de[Cn]=!0,cn("asyncIterator");var ts=Object.freeze({__proto__:null});cn("hasInstance"),cn("isConcatSpreadable"),cn("match"),cn("matchAll"),cn("replace"),cn("search"),cn("species"),cn("split"),cn("toPrimitive"),cn("toStringTag"),cn("unscopables"),Ye(Math,"Math",!0),Ye(d.JSON,"JSON",!0),a(yn),a(ts);var es=L.Symbol;cn("asyncDispose"),cn("dispose"),cn("observable"),cn("patternMatch"),cn("replaceAll");var is=es,os=r((function(t){function e(t){return(e="function"==typeof is&&"symbol"==typeof gn?function(t){return typeof t}:function(t){return t&&"function"==typeof is&&t.constructor===is&&t!==is.prototype?"symbol":typeof t})(t)}function i(o){return"function"==typeof is&&"symbol"===e(gn)?t.exports=i=function(t){return e(t)}:t.exports=i=function(t){return t&&"function"==typeof is&&t.constructor===is&&t!==is.prototype?"symbol":e(t)},i(o)}t.exports=i}));G({target:"Date",stat:!0},{now:function(){return(new Date).getTime()}});var ns=L.Date.now,ss=Object.assign,rs=!ss||l((function(){var t={},e={},i=Symbol();return t[i]=7,"abcdefghijklmnopqrst".split("").forEach((function(t){e[t]=t})),7!=ss({},t)[i]||"abcdefghijklmnopqrst"!=Ie(ss({},e)).join("")}))?function(t,e){for(var i=Ut(t),o=arguments.length,n=1,s=En.f,r=f.f;o>n;)for(var a,h=b(arguments[n++]),d=s?Ie(h).concat(s(h)):Ie(h),l=d.length,u=0;l>u;)a=d[u++],c&&!r.call(h,a)||(i[a]=h[a]);return i}:ss;G({target:"Object",stat:!0,forced:Object.assign!==rs},{assign:rs});var as=L.Object.assign;function hs(){return(hs=as||function(t){for(var e=1;e<arguments.length;e++){var i=arguments[e];for(var o in i)Object.prototype.hasOwnProperty.call(i,o)&&(t[o]=i[o])}return t}).apply(this,arguments)}function ds(t,e){t.prototype=Ri(e.prototype),t.prototype.constructor=t,t.__proto__=e}function ls(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}var cs,us="function"!=typeof as?function(t){if(null==t)throw new TypeError("Cannot convert undefined or null to object");for(var e=Object(t),i=1;i<arguments.length;i++){var o=arguments[i];if(null!=o)for(var n in o)o.hasOwnProperty(n)&&(e[n]=o[n])}return e}:as,ps=["","webkit","Moz","MS","ms","o"],fs="undefined"==typeof document?{style:{}}:document.createElement("div"),vs="function",gs=Math.round,ys=Math.abs,ms=ns;function bs(t,e){for(var i,o,n=e[0].toUpperCase()+qt(e).call(e,1),s=0;s<ps.length;){if((o=(i=ps[s])?i+n:e)in t)return o;s++}}cs="undefined"==typeof window?{}:window;var ws=bs(fs.style,"touchAction"),ks=void 0!==ws;var _s="auto",xs="manipulation",Es="none",Os="pan-x",Cs="pan-y",Ts=function(){var t;if(!ks)return!1;var e={},i=cs.CSS&&cs.CSS.supports;return yi(t=["auto","manipulation","pan-y","pan-x","pan-x pan-y","none"]).call(t,(function(t){return e[t]=!i||cs.CSS.supports("touch-action",t)})),e}(),Ss="ontouchstart"in cs,Ds=void 0!==bs(cs,"PointerEvent"),Ms=Ss&&/mobile|tablet|ip(ad|hone|od)|android/i.test(navigator.userAgent),Is="touch",Ps="mouse",Fs=25,Bs=1,zs=2,Ns=4,As=8,Rs=1,Ls=2,js=4,Hs=8,Ws=16,Vs=Ls|js,qs=Hs|Ws,Us=Vs|qs,Ys=["x","y"],Xs=["clientX","clientY"];function Gs(t,e,i){var o;if(t)if(yi(t))yi(t).call(t,e,i);else if(void 0!==t.length)for(o=0;o<t.length;)e.call(i,t[o],o,t),o++;else for(o in t)t.hasOwnProperty(o)&&e.call(i,t[o],o,t)}function Ks(t,e){return os(t)===vs?t.apply(e&&e[0]||void 0,e):t}function Zs(t,e){return zi(t).call(t,e)>-1}var $s=function(){function t(t,e){this.manager=t,this.set(e)}var e=t.prototype;return e.set=function(t){var e;"compute"===t&&(t=this.compute()),ks&&this.manager.element.style&&Ts[t]&&(this.manager.element.style[ws]=t),this.actions=hn(e=t.toLowerCase()).call(e)},e.update=function(){this.set(this.manager.options.touchAction)},e.compute=function(){var t=[];return Gs(this.manager.recognizers,(function(e){Ks(e.options.enable,[e])&&(t=$o(t).call(t,e.getTouchAction()))})),function(t){if(Zs(t,Es))return Es;var e=Zs(t,Os),i=Zs(t,Cs);return e&&i?Es:e||i?e?Os:Cs:Zs(t,xs)?xs:_s}(t.join(" "))},e.preventDefaults=function(t){var e=t.srcEvent,i=t.offsetDirection;if(this.manager.session.prevented)e.preventDefault();else{var o=this.actions,n=Zs(o,Es)&&!Ts[Es],s=Zs(o,Cs)&&!Ts[Cs],r=Zs(o,Os)&&!Ts[Os];if(n){var a=1===t.pointers.length,h=t.distance<2,d=t.deltaTime<250;if(a&&h&&d)return}if(!r||!s)return n||s&&i&Vs||r&&i&qs?this.preventSrc(e):void 0}},e.preventSrc=function(t){this.manager.session.prevented=!0,t.preventDefault()},t}();function Js(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1}function Qs(t){var e=t.length;if(1===e)return{x:gs(t[0].clientX),y:gs(t[0].clientY)};for(var i=0,o=0,n=0;n<e;)i+=t[n].clientX,o+=t[n].clientY,n++;return{x:gs(i/e),y:gs(o/e)}}function tr(t){for(var e=[],i=0;i<t.pointers.length;)e[i]={clientX:gs(t.pointers[i].clientX),clientY:gs(t.pointers[i].clientY)},i++;return{timeStamp:ms(),pointers:e,center:Qs(e),deltaX:t.deltaX,deltaY:t.deltaY}}function er(t,e,i){i||(i=Ys);var o=e[i[0]]-t[i[0]],n=e[i[1]]-t[i[1]];return Math.sqrt(o*o+n*n)}function ir(t,e,i){i||(i=Ys);var o=e[i[0]]-t[i[0]],n=e[i[1]]-t[i[1]];return 180*Math.atan2(n,o)/Math.PI}function or(t,e){return t===e?Rs:ys(t)>=ys(e)?t<0?Ls:js:e<0?Hs:Ws}function nr(t,e,i){return{x:e/t||0,y:i/t||0}}function sr(t,e){var i=t.session,o=e.pointers,n=o.length;i.firstInput||(i.firstInput=tr(e)),n>1&&!i.firstMultiple?i.firstMultiple=tr(e):1===n&&(i.firstMultiple=!1);var s=i.firstInput,r=i.firstMultiple,a=r?r.center:s.center,h=e.center=Qs(o);e.timeStamp=ms(),e.deltaTime=e.timeStamp-s.timeStamp,e.angle=ir(a,h),e.distance=er(a,h),function(t,e){var i=e.center,o=t.offsetDelta||{},n=t.prevDelta||{},s=t.prevInput||{};e.eventType!==Bs&&s.eventType!==Ns||(n=t.prevDelta={x:s.deltaX||0,y:s.deltaY||0},o=t.offsetDelta={x:i.x,y:i.y}),e.deltaX=n.x+(i.x-o.x),e.deltaY=n.y+(i.y-o.y)}(i,e),e.offsetDirection=or(e.deltaX,e.deltaY);var d,l,c=nr(e.deltaTime,e.deltaX,e.deltaY);e.overallVelocityX=c.x,e.overallVelocityY=c.y,e.overallVelocity=ys(c.x)>ys(c.y)?c.x:c.y,e.scale=r?(d=r.pointers,er((l=o)[0],l[1],Xs)/er(d[0],d[1],Xs)):1,e.rotation=r?function(t,e){return ir(e[1],e[0],Xs)+ir(t[1],t[0],Xs)}(r.pointers,o):0,e.maxPointers=i.prevInput?e.pointers.length>i.prevInput.maxPointers?e.pointers.length:i.prevInput.maxPointers:e.pointers.length,function(t,e){var i,o,n,s,r=t.lastInterval||e,a=e.timeStamp-r.timeStamp;if(e.eventType!==As&&(a>Fs||void 0===r.velocity)){var h=e.deltaX-r.deltaX,d=e.deltaY-r.deltaY,l=nr(a,h,d);o=l.x,n=l.y,i=ys(l.x)>ys(l.y)?l.x:l.y,s=or(h,d),t.lastInterval=e}else i=r.velocity,o=r.velocityX,n=r.velocityY,s=r.direction;e.velocity=i,e.velocityX=o,e.velocityY=n,e.direction=s}(i,e);var u,p=t.element,f=e.srcEvent;Js(u=f.composedPath?f.composedPath()[0]:f.path?f.path[0]:p,p)&&(p=u),e.target=p}function rr(t,e,i){var o=i.pointers.length,n=i.changedPointers.length,s=e&Bs&&o-n==0,r=e&(Ns|As)&&o-n==0;i.isFirst=!!s,i.isFinal=!!r,s&&(t.session={}),i.eventType=e,sr(t,i),t.emit("hammer.input",i),t.recognize(i),t.session.prevInput=i}function ar(t){return hn(t).call(t).split(/\s+/g)}function hr(t,e,i){Gs(ar(e),(function(e){t.addEventListener(e,i,!1)}))}function dr(t,e,i){Gs(ar(e),(function(e){t.removeEventListener(e,i,!1)}))}function lr(t){var e=t.ownerDocument||t;return e.defaultView||e.parentWindow||window}var cr=function(){function t(t,e){var i=this;this.manager=t,this.callback=e,this.element=t.element,this.target=t.options.inputTarget,this.domHandler=function(e){Ks(t.options.enable,[t])&&i.handler(e)},this.init()}var e=t.prototype;return e.handler=function(){},e.init=function(){this.evEl&&hr(this.element,this.evEl,this.domHandler),this.evTarget&&hr(this.target,this.evTarget,this.domHandler),this.evWin&&hr(lr(this.element),this.evWin,this.domHandler)},e.destroy=function(){this.evEl&&dr(this.element,this.evEl,this.domHandler),this.evTarget&&dr(this.target,this.evTarget,this.domHandler),this.evWin&&dr(lr(this.element),this.evWin,this.domHandler)},t}();function ur(t,e,i){if(zi(t)&&!i)return zi(t).call(t,e);for(var o=0;o<t.length;){if(i&&t[o][i]==e||!i&&t[o]===e)return o;o++}return-1}var pr={pointerdown:Bs,pointermove:zs,pointerup:Ns,pointercancel:As,pointerout:As},fr={2:Is,3:"pen",4:Ps,5:"kinect"},vr="pointerdown",gr="pointermove pointerup pointercancel";cs.MSPointerEvent&&!cs.PointerEvent&&(vr="MSPointerDown",gr="MSPointerMove MSPointerUp MSPointerCancel");var yr=function(t){function e(){var i,o=e.prototype;return o.evEl=vr,o.evWin=gr,(i=t.apply(this,arguments)||this).store=i.manager.session.pointerEvents=[],i}return ds(e,t),e.prototype.handler=function(t){var e=this.store,i=!1,o=t.type.toLowerCase().replace("ms",""),n=pr[o],s=fr[t.pointerType]||t.pointerType,r=s===Is,a=ur(e,t.pointerId,"pointerId");n&Bs&&(0===t.button||r)?a<0&&(e.push(t),a=e.length-1):n&(Ns|As)&&(i=!0),a<0||(e[a]=t,this.callback(this.manager,n,{pointers:e,changedPointers:[t],pointerType:s,srcEvent:t}),i&&ee(e).call(e,a,1))},e}(cr);function mr(t){return qt(Array.prototype).call(t,0)}function br(t,e,i){for(var o=[],n=[],s=0;s<t.length;){var r=e?t[s][e]:t[s];ur(n,r)<0&&o.push(t[s]),n[s]=r,s++}return i&&(o=e?Vo(o).call(o,(function(t,i){return t[e]>i[e]})):Vo(o).call(o)),o}var wr={touchstart:Bs,touchmove:zs,touchend:Ns,touchcancel:As},kr="touchstart touchmove touchend touchcancel",_r=function(t){function e(){var i;return e.prototype.evTarget=kr,(i=t.apply(this,arguments)||this).targetIds={},i}return ds(e,t),e.prototype.handler=function(t){var e=wr[t.type],i=xr.call(this,t,e);i&&this.callback(this.manager,e,{pointers:i[0],changedPointers:i[1],pointerType:Is,srcEvent:t})},e}(cr);function xr(t,e){var i,o,n=mr(t.touches),s=this.targetIds;if(e&(Bs|zs)&&1===n.length)return s[n[0].identifier]=!0,[n,n];var r=mr(t.changedTouches),a=[],h=this.target;if(o=zo(n).call(n,(function(t){return Js(t.target,h)})),e===Bs)for(i=0;i<o.length;)s[o[i].identifier]=!0,i++;for(i=0;i<r.length;)s[r[i].identifier]&&a.push(r[i]),e&(Ns|As)&&delete s[r[i].identifier],i++;return a.length?[br($o(o).call(o,a),"identifier",!0),a]:void 0}var Er={mousedown:Bs,mousemove:zs,mouseup:Ns},Or="mousedown",Cr="mousemove mouseup",Tr=function(t){function e(){var i,o=e.prototype;return o.evEl=Or,o.evWin=Cr,(i=t.apply(this,arguments)||this).pressed=!1,i}return ds(e,t),e.prototype.handler=function(t){var e=Er[t.type];e&Bs&&0===t.button&&(this.pressed=!0),e&zs&&1!==t.which&&(e=Ns),this.pressed&&(e&Ns&&(this.pressed=!1),this.callback(this.manager,e,{pointers:[t],changedPointers:[t],pointerType:Ps,srcEvent:t}))},e}(cr),Sr=2500,Dr=25;function Mr(t){var e=t.changedPointers[0];if(e.identifier===this.primaryTouch){var i={x:e.clientX,y:e.clientY},o=this.lastTouches;this.lastTouches.push(i);Io((function(){var t=zi(o).call(o,i);t>-1&&ee(o).call(o,t,1)}),Sr)}}function Ir(t,e){t&Bs?(this.primaryTouch=e.changedPointers[0].identifier,Mr.call(this,e)):t&(Ns|As)&&Mr.call(this,e)}function Pr(t){for(var e=t.srcEvent.clientX,i=t.srcEvent.clientY,o=0;o<this.lastTouches.length;o++){var n=this.lastTouches[o],s=Math.abs(e-n.x),r=Math.abs(i-n.y);if(s<=Dr&&r<=Dr)return!0}return!1}var Fr=function(){return function(t){function e(e,i){var o;return(o=t.call(this,e,i)||this).handler=function(t,e,i){var n=i.pointerType===Is,s=i.pointerType===Ps;if(!(s&&i.sourceCapabilities&&i.sourceCapabilities.firesTouchEvents)){if(n)Ir.call(ls(ls(o)),e,i);else if(s&&Pr.call(ls(ls(o)),i))return;o.callback(t,e,i)}},o.touch=new _r(o.manager,o.handler),o.mouse=new Tr(o.manager,o.handler),o.primaryTouch=null,o.lastTouches=[],o}return ds(e,t),e.prototype.destroy=function(){this.touch.destroy(),this.mouse.destroy()},e}(cr)}();function Br(t,e,i){return!!bi(t)&&(Gs(t,i[e],i),!0)}var zr=1,Nr=2,Ar=4,Rr=8,Lr=Rr,jr=16,Hr=1;function Wr(t,e){var i=e.manager;return i?i.get(t):t}function Vr(t){return t&jr?"cancel":t&Rr?"end":t&Ar?"move":t&Nr?"start":""}var qr=function(){function t(t){void 0===t&&(t={}),this.options=hs({enable:!0},t),this.id=Hr++,this.manager=null,this.state=zr,this.simultaneous={},this.requireFail=[]}var e=t.prototype;return e.set=function(t){return us(this.options,t),this.manager&&this.manager.touchAction.update(),this},e.recognizeWith=function(t){if(Br(t,"recognizeWith",this))return this;var e=this.simultaneous;return e[(t=Wr(t,this)).id]||(e[t.id]=t,t.recognizeWith(this)),this},e.dropRecognizeWith=function(t){return Br(t,"dropRecognizeWith",this)?this:(t=Wr(t,this),delete this.simultaneous[t.id],this)},e.requireFailure=function(t){if(Br(t,"requireFailure",this))return this;var e=this.requireFail;return-1===ur(e,t=Wr(t,this))&&(e.push(t),t.requireFailure(this)),this},e.dropRequireFailure=function(t){if(Br(t,"dropRequireFailure",this))return this;t=Wr(t,this);var e,i=ur(this.requireFail,t);i>-1&&ee(e=this.requireFail).call(e,i,1);return this},e.hasRequireFailures=function(){return this.requireFail.length>0},e.canRecognizeWith=function(t){return!!this.simultaneous[t.id]},e.emit=function(t){var e=this,i=this.state;function o(i){e.manager.emit(i,t)}i<Rr&&o(e.options.event+Vr(i)),o(e.options.event),t.additionalEvent&&o(t.additionalEvent),i>=Rr&&o(e.options.event+Vr(i))},e.tryEmit=function(t){if(this.canEmit())return this.emit(t);this.state=32},e.canEmit=function(){for(var t=0;t<this.requireFail.length;){if(!(this.requireFail[t].state&(32|zr)))return!1;t++}return!0},e.recognize=function(t){var e=us({},t);if(!Ks(this.options.enable,[this,e]))return this.reset(),void(this.state=32);this.state&(Lr|jr|32)&&(this.state=zr),this.state=this.process(e),this.state&(Nr|Ar|Rr|jr)&&this.tryEmit(e)},e.process=function(t){},e.getTouchAction=function(){},e.reset=function(){},t}(),Ur={domEvents:!1,touchAction:"compute",enable:!0,inputTarget:null,inputClass:null,preset:[],cssProps:{userSelect:"none",touchSelect:"none",touchCallout:"none",contentZooming:"none",userDrag:"none",tapHighlightColor:"rgba(0,0,0,0)"}};function Yr(t,e){var i,o=t.element;o.style&&(Gs(t.options.cssProps,(function(n,s){i=bs(o.style,s),e?(t.oldCssProps[i]=o.style[i],o.style[i]=n):o.style[i]=t.oldCssProps[i]||""})),e||(t.oldCssProps={}))}var Xr=function(){function t(t,e){var i,o=this;this.options=us({},Ur,e||{}),this.options.inputTarget=this.options.inputTarget||t,this.handlers={},this.session={},this.recognizers=[],this.oldCssProps={},this.element=t,this.input=new((i=this).options.inputClass||(Ds?yr:Ms?_r:Ss?Fr:Tr))(i,rr),this.touchAction=new $s(this,this.options.touchAction),Yr(this,!0),Gs(this.options.recognizers,(function(t){var e=o.add(new t[0](t[1]));t[2]&&e.recognizeWith(t[2]),t[3]&&e.requireFailure(t[3])}),this)}var e=t.prototype;return e.set=function(t){return us(this.options,t),t.touchAction&&this.touchAction.update(),t.inputTarget&&(this.input.destroy(),this.input.target=t.inputTarget,this.input.init()),this},e.stop=function(t){this.session.stopped=t?2:1},e.recognize=function(t){var e=this.session;if(!e.stopped){var i;this.touchAction.preventDefaults(t);var o=this.recognizers,n=e.curRecognizer;(!n||n&&n.state&Lr)&&(e.curRecognizer=null,n=null);for(var s=0;s<o.length;)i=o[s],2===e.stopped||n&&i!==n&&!i.canRecognizeWith(n)?i.reset():i.recognize(t),!n&&i.state&(Nr|Ar|Rr)&&(e.curRecognizer=i,n=i),s++}},e.get=function(t){if(t instanceof qr)return t;for(var e=this.recognizers,i=0;i<e.length;i++)if(e[i].options.event===t)return e[i];return null},e.add=function(t){if(Br(t,"add",this))return this;var e=this.get(t.options.event);return e&&this.remove(e),this.recognizers.push(t),t.manager=this,this.touchAction.update(),t},e.remove=function(t){if(Br(t,"remove",this))return this;var e=this.get(t);if(t){var i=this.recognizers,o=ur(i,e);-1!==o&&(ee(i).call(i,o,1),this.touchAction.update())}return this},e.on=function(t,e){if(void 0===t||void 0===e)return this;var i=this.handlers;return Gs(ar(t),(function(t){i[t]=i[t]||[],i[t].push(e)})),this},e.off=function(t,e){if(void 0===t)return this;var i=this.handlers;return Gs(ar(t),(function(t){var o;e?i[t]&&ee(o=i[t]).call(o,ur(i[t],e),1):delete i[t]})),this},e.emit=function(t,e){var i;this.options.domEvents&&function(t,e){var i=document.createEvent("Event");i.initEvent(t,!0,!0),i.gesture=e,e.target.dispatchEvent(i)}(t,e);var o=this.handlers[t]&&qt(i=this.handlers[t]).call(i);if(o&&o.length){e.type=t,e.preventDefault=function(){e.srcEvent.preventDefault()};for(var n=0;n<o.length;)o[n](e),n++}},e.destroy=function(){this.element&&Yr(this,!1),this.handlers={},this.session={},this.input.destroy(),this.element=null},t}(),Gr={touchstart:Bs,touchmove:zs,touchend:Ns,touchcancel:As},Kr="touchstart",Zr="touchstart touchmove touchend touchcancel",$r=function(t){function e(){var i,o=e.prototype;return o.evTarget=Kr,o.evWin=Zr,(i=t.apply(this,arguments)||this).started=!1,i}return ds(e,t),e.prototype.handler=function(t){var e=Gr[t.type];if(e===Bs&&(this.started=!0),this.started){var i=Jr.call(this,t,e);e&(Ns|As)&&i[0].length-i[1].length==0&&(this.started=!1),this.callback(this.manager,e,{pointers:i[0],changedPointers:i[1],pointerType:Is,srcEvent:t})}},e}(cr);function Jr(t,e){var i=mr(t.touches),o=mr(t.changedTouches);return e&(Ns|As)&&(i=br($o(i).call(i,o),"identifier",!0)),[i,o]}var Qr=function(t){function e(e){return void 0===e&&(e={}),t.call(this,hs({pointers:1},e))||this}ds(e,t);var i=e.prototype;return i.attrTest=function(t){var e=this.options.pointers;return 0===e||t.pointers.length===e},i.process=function(t){var e=this.state,i=t.eventType,o=e&(Nr|Ar),n=this.attrTest(t);return o&&(i&As||!n)?e|jr:o||n?i&Ns?e|Rr:e&Nr?e|Ar:Nr:32},e}(qr),ta=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,hs({event:"tap",pointers:1,taps:1,interval:300,time:250,threshold:9,posThreshold:10},e))||this).pTime=!1,i.pCenter=!1,i._timer=null,i._input=null,i.count=0,i}ds(e,t);var i=e.prototype;return i.getTouchAction=function(){return[xs]},i.process=function(t){var e=this,i=this.options,o=t.pointers.length===i.pointers,n=t.distance<i.threshold,s=t.deltaTime<i.time;if(this.reset(),t.eventType&Bs&&0===this.count)return this.failTimeout();if(n&&s&&o){if(t.eventType!==Ns)return this.failTimeout();var r=!this.pTime||t.timeStamp-this.pTime<i.interval,a=!this.pCenter||er(this.pCenter,t.center)<i.posThreshold;if(this.pTime=t.timeStamp,this.pCenter=t.center,a&&r?this.count+=1:this.count=1,this._input=t,0===this.count%i.taps)return this.hasRequireFailures()?(this._timer=Io((function(){e.state=Lr,e.tryEmit()}),i.interval),Nr):Lr}return 32},i.failTimeout=function(){var t=this;return this._timer=Io((function(){t.state=32}),this.options.interval),32},i.reset=function(){clearTimeout(this._timer)},i.emit=function(){this.state===Lr&&(this._input.tapCount=this.count,this.manager.emit(this.options.event,this._input))},e}(qr);function ea(t){return t===Ws?"down":t===Hs?"up":t===Ls?"left":t===js?"right":""}var ia=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,hs({event:"pan",threshold:10,pointers:1,direction:Us},e))||this).pX=null,i.pY=null,i}ds(e,t);var i=e.prototype;return i.getTouchAction=function(){var t=this.options.direction,e=[];return t&Vs&&e.push(Cs),t&qs&&e.push(Os),e},i.directionTest=function(t){var e=this.options,i=!0,o=t.distance,n=t.direction,s=t.deltaX,r=t.deltaY;return n&e.direction||(e.direction&Vs?(n=0===s?Rs:s<0?Ls:js,i=s!==this.pX,o=Math.abs(t.deltaX)):(n=0===r?Rs:r<0?Hs:Ws,i=r!==this.pY,o=Math.abs(t.deltaY))),t.direction=n,i&&o>e.threshold&&n&e.direction},i.attrTest=function(t){return Qr.prototype.attrTest.call(this,t)&&(this.state&Nr||!(this.state&Nr)&&this.directionTest(t))},i.emit=function(e){this.pX=e.deltaX,this.pY=e.deltaY;var i=ea(e.direction);i&&(e.additionalEvent=this.options.event+i),t.prototype.emit.call(this,e)},e}(Qr),oa=function(t){function e(e){return void 0===e&&(e={}),t.call(this,hs({event:"swipe",threshold:10,velocity:.3,direction:Vs|qs,pointers:1},e))||this}ds(e,t);var i=e.prototype;return i.getTouchAction=function(){return ia.prototype.getTouchAction.call(this)},i.attrTest=function(e){var i,o=this.options.direction;return o&(Vs|qs)?i=e.overallVelocity:o&Vs?i=e.overallVelocityX:o&qs&&(i=e.overallVelocityY),t.prototype.attrTest.call(this,e)&&o&e.offsetDirection&&e.distance>this.options.threshold&&e.maxPointers===this.options.pointers&&ys(i)>this.options.velocity&&e.eventType&Ns},i.emit=function(t){var e=ea(t.offsetDirection);e&&this.manager.emit(this.options.event+e,t),this.manager.emit(this.options.event,t)},e}(Qr),na=function(t){function e(e){return void 0===e&&(e={}),t.call(this,hs({event:"pinch",threshold:0,pointers:2},e))||this}ds(e,t);var i=e.prototype;return i.getTouchAction=function(){return[Es]},i.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.scale-1)>this.options.threshold||this.state&Nr)},i.emit=function(e){if(1!==e.scale){var i=e.scale<1?"in":"out";e.additionalEvent=this.options.event+i}t.prototype.emit.call(this,e)},e}(Qr),sa=function(t){function e(e){return void 0===e&&(e={}),t.call(this,hs({event:"rotate",threshold:0,pointers:2},e))||this}ds(e,t);var i=e.prototype;return i.getTouchAction=function(){return[Es]},i.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.rotation)>this.options.threshold||this.state&Nr)},e}(Qr),ra=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,hs({event:"press",pointers:1,time:251,threshold:9},e))||this)._timer=null,i._input=null,i}ds(e,t);var i=e.prototype;return i.getTouchAction=function(){return[_s]},i.process=function(t){var e=this,i=this.options,o=t.pointers.length===i.pointers,n=t.distance<i.threshold,s=t.deltaTime>i.time;if(this._input=t,!n||!o||t.eventType&(Ns|As)&&!s)this.reset();else if(t.eventType&Bs)this.reset(),this._timer=Io((function(){e.state=Lr,e.tryEmit()}),i.time);else if(t.eventType&Ns)return Lr;return 32},i.reset=function(){clearTimeout(this._timer)},i.emit=function(t){this.state===Lr&&(t&&t.eventType&Ns?this.manager.emit(this.options.event+"up",t):(this._input.timeStamp=ms(),this.manager.emit(this.options.event,this._input)))},e}(qr);function aa(t,e,i){var o="DEPRECATED METHOD: "+e+"\n"+i+" AT \n";return function(){var e=new Error("get-stack-trace"),i=e&&e.stack?e.stack.replace(/^[^\(]+?[\n$]/gm,"").replace(/^\s+at\s+/gm,"").replace(/^Object.<anonymous>\s*\(/gm,"{anonymous}()@"):"Unknown Stack Trace",n=window.console&&(window.console.warn||window.console.log);return n&&n.call(window.console,o,i),t.apply(this,arguments)}}var ha=aa((function(t,e,i){for(var o=To(e),n=0;n<o.length;)(!i||i&&void 0===t[o[n]])&&(t[o[n]]=e[o[n]]),n++;return t}),"extend","Use `assign`."),da=aa((function(t,e){return ha(t,e,!0)}),"merge","Use `assign`.");function la(t,e,i){var o,n=e.prototype;(o=t.prototype=Ri(n)).constructor=t,o._super=n,i&&us(o,i)}function ca(t,e){return function(){return t.apply(e,arguments)}}var ua=function(){var t=function(t,e){return void 0===e&&(e={}),new Xr(t,hs({recognizers:[[sa,{enable:!1}],[na,{enable:!1},["rotate"]],[oa,{direction:Vs}],[ia,{direction:Vs},["swipe"]],[ta],[ta,{event:"doubletap",taps:2},["tap"]],[ra]]},e))};return t.VERSION="2.0.16",t.DIRECTION_ALL=Us,t.DIRECTION_DOWN=Ws,t.DIRECTION_LEFT=Ls,t.DIRECTION_RIGHT=js,t.DIRECTION_UP=Hs,t.DIRECTION_HORIZONTAL=Vs,t.DIRECTION_VERTICAL=qs,t.DIRECTION_NONE=Rs,t.DIRECTION_DOWN=Ws,t.INPUT_START=Bs,t.INPUT_MOVE=zs,t.INPUT_END=Ns,t.INPUT_CANCEL=As,t.STATE_POSSIBLE=zr,t.STATE_BEGAN=Nr,t.STATE_CHANGED=Ar,t.STATE_ENDED=Rr,t.STATE_RECOGNIZED=Lr,t.STATE_CANCELLED=jr,t.STATE_FAILED=32,t.Manager=Xr,t.Input=cr,t.TouchAction=$s,t.TouchInput=_r,t.MouseInput=Tr,t.PointerEventInput=yr,t.TouchMouseInput=Fr,t.SingleTouchInput=$r,t.Recognizer=qr,t.AttrRecognizer=Qr,t.Tap=ta,t.Pan=ia,t.Swipe=oa,t.Pinch=na,t.Rotate=sa,t.Press=ra,t.on=hr,t.off=dr,t.each=Gs,t.merge=da,t.extend=ha,t.bindFn=ca,t.assign=us,t.inherit=la,t.bindFn=ca,t.prefixed=bs,t.toArray=mr,t.inArray=ur,t.uniqueArray=br,t.splitStr=ar,t.boolOrFn=Ks,t.hasParent=Js,t.addEventListeners=hr,t.removeEventListeners=dr,t.defaults=Ur,t}(),pa=a(Object.freeze({__proto__:null,default:ua,INPUT_START:Bs,INPUT_MOVE:zs,INPUT_END:Ns,INPUT_CANCEL:As,STATE_POSSIBLE:zr,STATE_BEGAN:Nr,STATE_CHANGED:Ar,STATE_ENDED:Rr,STATE_RECOGNIZED:Lr,STATE_CANCELLED:jr,STATE_FAILED:32,DIRECTION_NONE:Rs,DIRECTION_LEFT:Ls,DIRECTION_RIGHT:js,DIRECTION_UP:Hs,DIRECTION_DOWN:Ws,DIRECTION_HORIZONTAL:Vs,DIRECTION_VERTICAL:qs,DIRECTION_ALL:Us,Manager:Xr,Input:cr,TouchAction:$s,TouchInput:_r,MouseInput:Tr,PointerEventInput:yr,TouchMouseInput:Fr,SingleTouchInput:$r,Recognizer:qr,AttrRecognizer:Qr,Tap:ta,Pan:ia,Swipe:oa,Pinch:na,Rotate:sa,Press:ra,on:hr,off:dr,each:Gs,merge:da,extend:ha,assign:us,inherit:la,bindFn:ca,prefixed:bs,toArray:mr,inArray:ur,uniqueArray:br,splitStr:ar,boolOrFn:Ks,hasParent:Js,addEventListeners:hr,removeEventListeners:dr,defaults:Ur})),fa=r((function(t){if("undefined"!=typeof window){var e=window.Hammer||pa;t.exports=e}else t.exports=function(){return{on:t=function(){},off:t,destroy:t,emit:t,get:function(e){return{set:t}}};var t}}));function va(t){var e,o,n=this;this.active=!1,this.dom={container:t},this.dom.overlay=document.createElement("div"),this.dom.overlay.className="vis-overlay",this.dom.container.appendChild(this.dom.overlay),this.hammer=fa(this.dom.overlay),this.hammer.on("tap",it(e=this._onTapOverlay).call(e,this));var s=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];yi(s).call(s,(function(t){n.hammer.on(t,(function(t){t.srcEvent.stopPropagation()}))})),document&&document.body&&(this.onClick=function(e){(function(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1})(e.target,t)||n.deactivate()},document.body.addEventListener("click",this.onClick)),void 0!==this.keycharm&&this.keycharm.destroy(),this.keycharm=i(),this.escListener=it(o=this.deactivate).call(o,this)}a(Oo),ie(va.prototype),va.current=null,va.prototype.destroy=function(){this.deactivate(),this.dom.overlay.parentNode.removeChild(this.dom.overlay),this.onClick&&document.body.removeEventListener("click",this.onClick),void 0!==this.keycharm&&this.keycharm.destroy(),this.keycharm=null,this.hammer.destroy(),this.hammer=null},va.prototype.activate=function(){var t;va.current&&va.current.deactivate(),va.current=this,this.active=!0,this.dom.overlay.style.display="none",n.addClassName(this.dom.container,"vis-active"),this.emit("change"),this.emit("activate"),it(t=this.keycharm).call(t,"esc",this.escListener)},va.prototype.deactivate=function(){this.active=!1,this.dom.overlay.style.display="block",n.removeClassName(this.dom.container,"vis-active"),this.keycharm.unbind("esc",this.escListener),this.emit("change"),this.emit("deactivate")},va.prototype._onTapOverlay=function(t){this.activate(),t.srcEvent.stopPropagation()};var ga=va,ya=r((function(t,e){e.en={edit:"Edit",del:"Delete selected",back:"Back",addNode:"Add Node",addEdge:"Add Edge",editNode:"Edit Node",editEdge:"Edit Edge",addDescription:"Click in an empty space to place a new node.",edgeDescription:"Click on a node and drag the edge to another node to connect them.",editEdgeDescription:"Click on the control points and drag them to a node to connect to it.",createEdgeError:"Cannot link edges to a cluster.",deleteClusterError:"Clusters cannot be deleted.",editClusterError:"Clusters cannot be edited."},e.en_EN=e.en,e.en_US=e.en,e.de={edit:"Editieren",del:"Lösche Auswahl",back:"Zurück",addNode:"Knoten hinzufügen",addEdge:"Kante hinzufügen",editNode:"Knoten editieren",editEdge:"Kante editieren",addDescription:"Klicke auf eine freie Stelle, um einen neuen Knoten zu plazieren.",edgeDescription:"Klicke auf einen Knoten und ziehe die Kante zu einem anderen Knoten, um diese zu verbinden.",editEdgeDescription:"Klicke auf die Verbindungspunkte und ziehe diese auf einen Knoten, um sie zu verbinden.",createEdgeError:"Es ist nicht möglich, Kanten mit Clustern zu verbinden.",deleteClusterError:"Cluster können nicht gelöscht werden.",editClusterError:"Cluster können nicht editiert werden."},e.de_DE=e.de,e.es={edit:"Editar",del:"Eliminar selección",back:"Atrás",addNode:"Añadir nodo",addEdge:"Añadir arista",editNode:"Editar nodo",editEdge:"Editar arista",addDescription:"Haga clic en un lugar vacío para colocar un nuevo nodo.",edgeDescription:"Haga clic en un nodo y arrastre la arista hacia otro nodo para conectarlos.",editEdgeDescription:"Haga clic en un punto de control y arrastrelo a un nodo para conectarlo.",createEdgeError:"No se puede conectar una arista a un grupo.",deleteClusterError:"No es posible eliminar grupos.",editClusterError:"No es posible editar grupos."},e.es_ES=e.es,e.it={edit:"Modifica",del:"Cancella la selezione",back:"Indietro",addNode:"Aggiungi un nodo",addEdge:"Aggiungi un vertice",editNode:"Modifica il nodo",editEdge:"Modifica il vertice",addDescription:"Clicca per aggiungere un nuovo nodo",edgeDescription:"Clicca su un nodo e trascinalo ad un altro nodo per connetterli.",editEdgeDescription:"Clicca sui Punti di controllo e trascinali ad un nodo per connetterli.",createEdgeError:"Non si possono collegare vertici ad un cluster",deleteClusterError:"I cluster non possono essere cancellati",editClusterError:"I clusters non possono essere modificati."},e.it_IT=e.it,e.nl={edit:"Wijzigen",del:"Selectie verwijderen",back:"Terug",addNode:"Node toevoegen",addEdge:"Link toevoegen",editNode:"Node wijzigen",editEdge:"Link wijzigen",addDescription:"Klik op een leeg gebied om een nieuwe node te maken.",edgeDescription:"Klik op een node en sleep de link naar een andere node om ze te verbinden.",editEdgeDescription:"Klik op de verbindingspunten en sleep ze naar een node om daarmee te verbinden.",createEdgeError:"Kan geen link maken naar een cluster.",deleteClusterError:"Clusters kunnen niet worden verwijderd.",editClusterError:"Clusters kunnen niet worden aangepast."},e.nl_NL=e.nl,e.nl_BE=e.nl,e["pt-br"]={edit:"Editar",del:"Remover selecionado",back:"Voltar",addNode:"Adicionar nó",addEdge:"Adicionar aresta",editNode:"Editar nó",editEdge:"Editar aresta",addDescription:"Clique em um espaço em branco para adicionar um novo nó",edgeDescription:"Clique em um nó e arraste a aresta até outro nó para conectá-los",editEdgeDescription:"Clique nos pontos de controle e os arraste para um nó para conectá-los",createEdgeError:"Não foi possível linkar arestas a um cluster.",deleteClusterError:"Clusters não puderam ser removidos.",editClusterError:"Clusters não puderam ser editados."},e["pt-BR"]=e["pt-br"],e.pt_BR=e["pt-br"],e.pt_br=e["pt-br"],e.ru={edit:"Редактировать",del:"Удалить выбранное",back:"Назад",addNode:"Добавить узел",addEdge:"Добавить ребро",editNode:"Редактировать узел",editEdge:"Редактировать ребро",addDescription:"Кликните в свободное место, чтобы добавить новый узел.",edgeDescription:"Кликните на узел и протяните ребро к другому узлу, чтобы соединить их.",editEdgeDescription:"Кликните на контрольные точки и перетащите их в узел, чтобы подключиться к нему.",createEdgeError:"Невозможно соединить ребра в кластер.",deleteClusterError:"Кластеры не могут быть удалены",editClusterError:"Кластеры недоступны для редактирования."},e.ru_RU=e.ru,e.cn={edit:"编辑",del:"删除选定",back:"返回",addNode:"添加节点",addEdge:"添加连接线",editNode:"编辑节点",editEdge:"编辑连接线",addDescription:"单击空白处放置新节点。",edgeDescription:"单击某个节点并将该连接线拖动到另一个节点以连接它们。",editEdgeDescription:"单击控制节点并将它们拖到节点上连接。",createEdgeError:"无法将连接线连接到群集。",deleteClusterError:"无法删除群集。",editClusterError:"无法编辑群集。"},e.zh_CN=e.cn,e.uk={edit:"Редагувати",del:"Видалити обране",back:"Назад",addNode:"Додати вузол",addEdge:"Додати край",editNode:"Редагувати вузол",editEdge:"Редагувати край",addDescription:"Kлікніть на вільне місце, щоб додати новий вузол.",edgeDescription:"Клікніть на вузол і перетягніть край до іншого вузла, щоб їх з'єднати.",editEdgeDescription:"Клікніть на контрольні точки і перетягніть їх у вузол, щоб підключитися до нього.",createEdgeError:"Не можливо об'єднати краї в групу.",deleteClusterError:"Групи не можуть бути видалені.",editClusterError:"Групи недоступні для редагування."},e.uk_UA=e.uk,e.fr={edit:"Editer",del:"Effacer la selection",back:"Retour",addNode:"Ajouter un noeud",addEdge:"Ajouter un lien",editNode:"Editer le noeud",editEdge:"Editer le lien",addDescription:"Cliquez dans un endroit vide pour placer un noeud.",edgeDescription:"Cliquez sur un noeud et glissez le lien vers un autre noeud pour les connecter.",editEdgeDescription:"Cliquez sur les points de contrôle et glissez-les pour connecter un noeud.",createEdgeError:"Impossible de créer un lien vers un cluster.",deleteClusterError:"Les clusters ne peuvent pas être éffacés.",editClusterError:"Les clusters ne peuvent pas être édites."},e.fr_FR=e.fr,e.cs={edit:"Upravit",del:"Smazat výběr",back:"Zpět",addNode:"Přidat vrchol",addEdge:"Přidat hranu",editNode:"Upravit vrchol",editEdge:"Upravit hranu",addDescription:"Kluknutím do prázdného prostoru můžete přidat nový vrchol.",edgeDescription:"Přetažením z jednoho vrcholu do druhého můžete spojit tyto vrcholy novou hranou.",editEdgeDescription:"Přetažením kontrolního vrcholu hrany ji můžete připojit k jinému vrcholu.",createEdgeError:"Nelze připojit hranu ke shluku.",deleteClusterError:"Nelze mazat shluky.",editClusterError:"Nelze upravovat shluky."},e.cs_CZ=e.cs}));var ma=function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")};G({target:"Object",stat:!0,forced:!c,sham:!c},{defineProperty:q.f});var ba=r((function(t){var e=L.Object,i=t.exports=function(t,i,o){return e.defineProperty(t,i,o)};e.defineProperty.sham&&(i.sham=!0)})),wa=ba;function ka(t,e){for(var i=0;i<e.length;i++){var o=e[i];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),wa(t,o.key,o)}}var _a=function(t,e,i){return e&&ka(t.prototype,e),i&&ka(t,i),t},xa=function(){function t(){ma(this,t),this.NUM_ITERATIONS=4,this.image=new Image,this.canvas=document.createElement("canvas")}return _a(t,[{key:"init",value:function(){if(!this.initialized()){this.src=this.image.src;var t=this.image.width,e=this.image.height;this.width=t,this.height=e;var i=Math.floor(e/2),o=Math.floor(e/4),n=Math.floor(e/8),s=Math.floor(e/16),r=Math.floor(t/2),a=Math.floor(t/4),h=Math.floor(t/8),d=Math.floor(t/16);this.canvas.width=3*a,this.canvas.height=i,this.coordinates=[[0,0,r,i],[r,0,a,o],[r,o,h,n],[5*h,o,d,s]],this._fillMipMap()}}},{key:"initialized",value:function(){return void 0!==this.coordinates}},{key:"_fillMipMap",value:function(){var t=this.canvas.getContext("2d"),e=this.coordinates[0];t.drawImage(this.image,e[0],e[1],e[2],e[3]);for(var i=1;i<this.NUM_ITERATIONS;i++){var o=this.coordinates[i-1],n=this.coordinates[i];t.drawImage(this.canvas,o[0],o[1],o[2],o[3],n[0],n[1],n[2],n[3])}}},{key:"drawImageAtPosition",value:function(t,e,i,o,n,s){if(this.initialized())if(e>2){e*=.5;for(var r=0;e>2&&r<this.NUM_ITERATIONS;)e*=.5,r+=1;r>=this.NUM_ITERATIONS&&(r=this.NUM_ITERATIONS-1);var a=this.coordinates[r];t.drawImage(this.canvas,a[0],a[1],a[2],a[3],i,o,n,s)}else t.drawImage(this.image,i,o,n,s)}}]),t}(),Ea=function(){function t(e){ma(this,t),this.images={},this.imageBroken={},this.callback=e}return _a(t,[{key:"_tryloadBrokenUrl",value:function(t,e,i){void 0!==t&&void 0!==i&&(void 0!==e?(i.image.onerror=function(){console.error("Could not load brokenImage:",e)},i.image.src=e):console.warn("No broken url image defined"))}},{key:"_redrawWithImage",value:function(t){this.callback&&this.callback(t)}},{key:"load",value:function(t,e){var i=this,o=this.images[t];if(o)return o;var n=new xa;return this.images[t]=n,n.image.onload=function(){i._fixImageCoordinates(n.image),n.init(),i._redrawWithImage(n)},n.image.onerror=function(){console.error("Could not load image:",t),i._tryloadBrokenUrl(t,e,n)},n.image.src=t,n}},{key:"_fixImageCoordinates",value:function(t){0===t.width&&(document.body.appendChild(t),t.width=t.offsetWidth,t.height=t.offsetHeight,document.body.removeChild(t))}}]),t}(),Oa=function(){function t(){ma(this,t),this.clear(),this.defaultIndex=0,this.groupsArray=[],this.groupIndex=0,this.defaultGroups=[{border:"#2B7CE9",background:"#97C2FC",highlight:{border:"#2B7CE9",background:"#D2E5FF"},hover:{border:"#2B7CE9",background:"#D2E5FF"}},{border:"#FFA500",background:"#FFFF00",highlight:{border:"#FFA500",background:"#FFFFA3"},hover:{border:"#FFA500",background:"#FFFFA3"}},{border:"#FA0A10",background:"#FB7E81",highlight:{border:"#FA0A10",background:"#FFAFB1"},hover:{border:"#FA0A10",background:"#FFAFB1"}},{border:"#41A906",background:"#7BE141",highlight:{border:"#41A906",background:"#A1EC76"},hover:{border:"#41A906",background:"#A1EC76"}},{border:"#E129F0",background:"#EB7DF4",highlight:{border:"#E129F0",background:"#F0B3F5"},hover:{border:"#E129F0",background:"#F0B3F5"}},{border:"#7C29F0",background:"#AD85E4",highlight:{border:"#7C29F0",background:"#D3BDF0"},hover:{border:"#7C29F0",background:"#D3BDF0"}},{border:"#C37F00",background:"#FFA807",highlight:{border:"#C37F00",background:"#FFCA66"},hover:{border:"#C37F00",background:"#FFCA66"}},{border:"#4220FB",background:"#6E6EFD",highlight:{border:"#4220FB",background:"#9B9BFD"},hover:{border:"#4220FB",background:"#9B9BFD"}},{border:"#FD5A77",background:"#FFC0CB",highlight:{border:"#FD5A77",background:"#FFD1D9"},hover:{border:"#FD5A77",background:"#FFD1D9"}},{border:"#4AD63A",background:"#C2FABC",highlight:{border:"#4AD63A",background:"#E6FFE3"},hover:{border:"#4AD63A",background:"#E6FFE3"}},{border:"#990000",background:"#EE0000",highlight:{border:"#BB0000",background:"#FF3333"},hover:{border:"#BB0000",background:"#FF3333"}},{border:"#FF6000",background:"#FF6000",highlight:{border:"#FF6000",background:"#FF6000"},hover:{border:"#FF6000",background:"#FF6000"}},{border:"#97C2FC",background:"#2B7CE9",highlight:{border:"#D2E5FF",background:"#2B7CE9"},hover:{border:"#D2E5FF",background:"#2B7CE9"}},{border:"#399605",background:"#255C03",highlight:{border:"#399605",background:"#255C03"},hover:{border:"#399605",background:"#255C03"}},{border:"#B70054",background:"#FF007E",highlight:{border:"#B70054",background:"#FF007E"},hover:{border:"#B70054",background:"#FF007E"}},{border:"#AD85E4",background:"#7C29F0",highlight:{border:"#D3BDF0",background:"#7C29F0"},hover:{border:"#D3BDF0",background:"#7C29F0"}},{border:"#4557FA",background:"#000EA1",highlight:{border:"#6E6EFD",background:"#000EA1"},hover:{border:"#6E6EFD",background:"#000EA1"}},{border:"#FFC0CB",background:"#FD5A77",highlight:{border:"#FFD1D9",background:"#FD5A77"},hover:{border:"#FFD1D9",background:"#FD5A77"}},{border:"#C2FABC",background:"#74D66A",highlight:{border:"#E6FFE3",background:"#74D66A"},hover:{border:"#E6FFE3",background:"#74D66A"}},{border:"#EE0000",background:"#990000",highlight:{border:"#FF3333",background:"#BB0000"},hover:{border:"#FF3333",background:"#BB0000"}}],this.options={},this.defaultOptions={useDefaultGroups:!0},e.extend(this.options,this.defaultOptions)}return _a(t,[{key:"setOptions",value:function(t){var e=["useDefaultGroups"];if(void 0!==t)for(var i in t)if(t.hasOwnProperty(i)&&-1===zi(e).call(e,i)){var o=t[i];this.add(i,o)}}},{key:"clear",value:function(){this.groups={},this.groupsArray=[]}},{key:"get",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],i=this.groups[t];if(void 0===i&&e)if(!1===this.options.useDefaultGroups&&this.groupsArray.length>0){var o=this.groupIndex%this.groupsArray.length;this.groupIndex++,(i={}).color=this.groups[this.groupsArray[o]],this.groups[t]=i}else{var n=this.defaultIndex%this.defaultGroups.length;this.defaultIndex++,(i={}).color=this.defaultGroups[n],this.groups[t]=i}return i}},{key:"add",value:function(t,e){return this.groups[t]=e,this.groupsArray.push(t),e}}]),t}(),Ca=Dt("iterator"),Ta=function(t){if(null!=t)return t[Ca]||t["@@iterator"]||oe[je(t)]},Sa=function(t){var e=Ta(t);if("function"!=typeof e)throw TypeError(String(t)+" is not iterable");return W(e.call(t))},Da=li.some;G({target:"Array",proto:!0,forced:ci("some")},{some:function(t){return Da(this,t,arguments.length>1?arguments[1]:void 0)}});var Ma=Q("Array").some,Ia=Array.prototype,Pa=function(t){var e=t.some;return t===Ia||t instanceof Array&&e===Ia.some?Ma:e},Fa=ba;G({target:"Object",stat:!0,forced:!c,sham:!c},{defineProperties:Pe});var Ba=r((function(t){var e=L.Object,i=t.exports=function(t,i){return e.defineProperties(t,i)};e.defineProperties.sham&&(i.sham=!0)})),za=It("Reflect","ownKeys")||function(t){var e=bn.f(W(t)),i=En.f;return i?e.concat(i(t)):e};G({target:"Object",stat:!0,sham:!c},{getOwnPropertyDescriptors:function(t){for(var e,i,o=k(t),n=I.f,s=za(o),r={},a=0;s.length>a;)void 0!==(i=n(o,e=s[a++]))&&wt(r,e,i);return r}});var Na=L.Object.getOwnPropertyDescriptors,Aa=I.f,Ra=l((function(){Aa(1)}));G({target:"Object",stat:!0,forced:!c||Ra,sham:!c},{getOwnPropertyDescriptor:function(t,e){return Aa(k(t),e)}});var La=r((function(t){var e=L.Object,i=t.exports=function(t,i){return e.getOwnPropertyDescriptor(t,i)};e.getOwnPropertyDescriptor.sham&&(i.sham=!0)})),ja=La,Ha=L.Object.getOwnPropertySymbols;var Wa=function(t,e,i){return e in t?wa(t,e,{value:i,enumerable:!0,configurable:!0,writable:!0}):t[e]=i,t},Va=nn.trim,qa=d.parseFloat,Ua=1/qa(Jo+"-0")!=-1/0?function(t){var e=Va(String(t)),i=qa(e);return 0===i&&"-"==e.charAt(0)?-0:i}:qa;G({global:!0,forced:parseFloat!=Ua},{parseFloat:Ua});var Ya=L.parseFloat,Xa=nn.trim,Ga=d.parseInt,Ka=/^[+-]?0[Xx]/,Za=8!==Ga(Jo+"08")||22!==Ga(Jo+"0x16")?function(t,e){var i=Xa(String(t));return Ga(i,e>>>0||(Ka.test(i)?16:10))}:Ga;G({global:!0,forced:parseInt!=Za},{parseInt:Za});var $a=L.parseInt,Ja=mi;var Qa=function(t){if(Ja(t))return t},th=Dt("iterator"),eh=function(t){var e=Object(t);return void 0!==e[th]||"@@iterator"in e||oe.hasOwnProperty(je(e))};var ih=function(t,e){if(eh(Object(t))||"[object Arguments]"===Object.prototype.toString.call(t)){var i=[],o=!0,n=!1,s=void 0;try{for(var r,a=Sa(t);!(o=(r=a.next()).done)&&(i.push(r.value),!e||i.length!==e);o=!0);}catch(t){n=!0,s=t}finally{try{o||null==a.return||a.return()}finally{if(n)throw s}}return i}};var oh=function(){throw new TypeError("Invalid attempt to destructure non-iterable instance")};var nh=function(t,e){return Qa(t)||ih(t,e)||oh()},sh=function(){function t(){ma(this,t)}return _a(t,null,[{key:"choosify",value:function(t,i){var o=["node","edge","label"],n=!0,s=e.topMost(i,"chosen");if("boolean"==typeof s)n=s;else if("object"===os(s)){if(-1===zi(o).call(o,t))throw new Error("choosify: subOption '"+t+"' should be one of '"+o.join("', '")+"'");var r=e.topMost(i,["chosen",t]);"boolean"!=typeof r&&"function"!=typeof r||(n=r)}return n}},{key:"pointInRect",value:function(t,e,i){if(t.width<=0||t.height<=0)return!1;if(void 0!==i){var o={x:e.x-i.x,y:e.y-i.y};if(0!==i.angle){var n=-i.angle;e={x:Math.cos(n)*o.x-Math.sin(n)*o.y,y:Math.sin(n)*o.x+Math.cos(n)*o.y}}else e=o}var s=t.x+t.width,r=t.y+t.width;return t.left<e.x&&s>e.x&&t.top<e.y&&r>e.y}},{key:"isValidLabel",value:function(t){return"string"==typeof t&&""!==t}}]),t}(),rh=Q("Array").values,ah=Array.prototype,hh={DOMTokenList:!0,NodeList:!0},dh=function(t){var e=t.values;return t===ah||t instanceof Array&&e===ah.values||hh.hasOwnProperty(je(t))?rh:e},lh=function(){function t(e){ma(this,t),this.measureText=e,this.current=0,this.width=0,this.height=0,this.lines=[]}return _a(t,[{key:"_add",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:"normal";void 0===this.lines[t]&&(this.lines[t]={width:0,height:0,blocks:[]});var o=e;void 0!==e&&""!==e||(o=" ");var n=this.measureText(o,i),s=as({},dh(n));s.text=e,s.width=n.width,s.mod=i,void 0!==e&&""!==e||(s.width=0),this.lines[t].blocks.push(s),this.lines[t].width+=s.width}},{key:"curWidth",value:function(){var t=this.lines[this.current];return void 0===t?0:t.width}},{key:"append",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"normal";this._add(this.current,t,e)}},{key:"newLine",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"normal";this._add(this.current,t,e),this.current++}},{key:"determineLineHeights",value:function(){for(var t=0;t<this.lines.length;t++){var e=this.lines[t],i=0;if(void 0!==e.blocks)for(var o=0;o<e.blocks.length;o++){var n=e.blocks[o];i<n.height&&(i=n.height)}e.height=i}}},{key:"determineLabelSize",value:function(){for(var t=0,e=0,i=0;i<this.lines.length;i++){var o=this.lines[i];o.width>t&&(t=o.width),e+=o.height}this.width=t,this.height=e}},{key:"removeEmptyBlocks",value:function(){for(var t=[],e=0;e<this.lines.length;e++){var i=this.lines[e];if(0!==i.blocks.length&&(e!==this.lines.length-1||0!==i.width)){var o={};as(o,i),o.blocks=[];for(var n=void 0,s=[],r=0;r<i.blocks.length;r++){var a=i.blocks[r];0!==a.width?s.push(a):void 0===n&&(n=a)}0===s.length&&void 0!==n&&s.push(n),o.blocks=s,t.push(o)}}return t}},{key:"finalize",value:function(){this.determineLineHeights(),this.determineLabelSize();var t=this.removeEmptyBlocks();return{width:this.width,height:this.height,lines:t}}}]),t}(),ch={"<b>":/<b>/,"<i>":/<i>/,"<code>":/<code>/,"</b>":/<\/b>/,"</i>":/<\/i>/,"</code>":/<\/code>/,"*":/\*/,_:/\_/,"`":/`/,afterBold:/[^\*]/,afterItal:/[^_]/,afterMono:/[^`]/},uh=function(){function t(e){ma(this,t),this.text=e,this.bold=!1,this.ital=!1,this.mono=!1,this.spacing=!1,this.position=0,this.buffer="",this.modStack=[],this.blocks=[]}return _a(t,[{key:"mod",value:function(){return 0===this.modStack.length?"normal":this.modStack[0]}},{key:"modName",value:function(){return 0===this.modStack.length?"normal":"mono"===this.modStack[0]?"mono":this.bold&&this.ital?"boldital":this.bold?"bold":this.ital?"ital":void 0}},{key:"emitBlock",value:function(){this.spacing&&(this.add(" "),this.spacing=!1),this.buffer.length>0&&(this.blocks.push({text:this.buffer,mod:this.modName()}),this.buffer="")}},{key:"add",value:function(t){" "===t&&(this.spacing=!0),this.spacing&&(this.buffer+=" ",this.spacing=!1)," "!=t&&(this.buffer+=t)}},{key:"parseWS",value:function(t){return!!/[ \t]/.test(t)&&(this.mono?this.add(t):this.spacing=!0,!0)}},{key:"setTag",value:function(t){this.emitBlock(),this[t]=!0,this.modStack.unshift(t)}},{key:"unsetTag",value:function(t){this.emitBlock(),this[t]=!1,this.modStack.shift()}},{key:"parseStartTag",value:function(t,e){return!(this.mono||this[t]||!this.match(e))&&(this.setTag(t),!0)}},{key:"match",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],i=this.prepareRegExp(t),o=nh(i,2),n=o[0],s=o[1],r=n.test(this.text.substr(this.position,s));return r&&e&&(this.position+=s-1),r}},{key:"parseEndTag",value:function(t,e,i){var o=this.mod()===t;return!(!(o="mono"===t?o&&this.mono:o&&!this.mono)||!this.match(e))&&(void 0!==i?(this.position===this.text.length-1||this.match(i,!1))&&this.unsetTag(t):this.unsetTag(t),!0)}},{key:"replace",value:function(t,e){return!!this.match(t)&&(this.add(e),this.position+=length-1,!0)}},{key:"prepareRegExp",value:function(t){var e,i;if(t instanceof RegExp)i=t,e=1;else{var o=ch[t];i=void 0!==o?o:new RegExp(t),e=t.length}return[i,e]}}]),t}(),ph=function(){function t(e,i,o,n){var s=this;ma(this,t),this.ctx=e,this.parent=i,this.selected=o,this.hover=n;this.lines=new lh((function(t,i){if(void 0===t)return 0;var r=s.parent.getFormattingValues(e,o,n,i),a=0;""!==t&&(a=s.ctx.measureText(t).width);return{width:a,values:r}}))}return _a(t,[{key:"process",value:function(t){if(!sh.isValidLabel(t))return this.lines.finalize();var e=this.parent.fontOptions;t=(t=t.replace(/\r\n/g,"\n")).replace(/\r/g,"\n");var i=String(t).split("\n"),o=i.length;if(e.multi)for(var n=0;n<o;n++){var s=this.splitBlocks(i[n],e.multi);if(void 0!==s)if(0!==s.length){if(e.maxWdt>0)for(var r=0;r<s.length;r++){var a=s[r].mod,h=s[r].text;this.splitStringIntoLines(h,a,!0)}else for(var d=0;d<s.length;d++){var l=s[d].mod,c=s[d].text;this.lines.append(c,l)}this.lines.newLine()}else this.lines.newLine("")}else if(e.maxWdt>0)for(var u=0;u<o;u++)this.splitStringIntoLines(i[u]);else for(var p=0;p<o;p++)this.lines.newLine(i[p]);return this.lines.finalize()}},{key:"decodeMarkupSystem",value:function(t){var e="none";return"markdown"===t||"md"===t?e="markdown":!0!==t&&"html"!==t||(e="html"),e}},{key:"splitHtmlBlocks",value:function(t){for(var e=new uh(t),i=function(t){return!!/&/.test(t)&&(e.replace(e.text,"&lt;","<")||e.replace(e.text,"&amp;","&")||e.add("&"),!0)};e.position<e.text.length;){var o=e.text.charAt(e.position);e.parseWS(o)||/</.test(o)&&(e.parseStartTag("bold","<b>")||e.parseStartTag("ital","<i>")||e.parseStartTag("mono","<code>")||e.parseEndTag("bold","</b>")||e.parseEndTag("ital","</i>")||e.parseEndTag("mono","</code>"))||i(o)||e.add(o),e.position++}return e.emitBlock(),e.blocks}},{key:"splitMarkdownBlocks",value:function(t){for(var e=this,i=new uh(t),o=!0,n=function(t){return!!/\\/.test(t)&&(i.position<e.text.length+1&&(i.position++,t=e.text.charAt(i.position),/ \t/.test(t)?i.spacing=!0:(i.add(t),o=!1)),!0)};i.position<i.text.length;){var s=i.text.charAt(i.position);i.parseWS(s)||n(s)||(o||i.spacing)&&(i.parseStartTag("bold","*")||i.parseStartTag("ital","_")||i.parseStartTag("mono","`"))||i.parseEndTag("bold","*","afterBold")||i.parseEndTag("ital","_","afterItal")||i.parseEndTag("mono","`","afterMono")||(i.add(s),o=!1),i.position++}return i.emitBlock(),i.blocks}},{key:"splitBlocks",value:function(t,e){var i=this.decodeMarkupSystem(e);return"none"===i?[{text:t,mod:"normal"}]:"markdown"===i?this.splitMarkdownBlocks(t):"html"===i?this.splitHtmlBlocks(t):void 0}},{key:"overMaxWidth",value:function(t){var e=this.ctx.measureText(t).width;return this.lines.curWidth()+e>this.parent.fontOptions.maxWdt}},{key:"getLongestFit",value:function(t){for(var e="",i=0;i<t.length;){var o=e+(""===e?"":" ")+t[i];if(this.overMaxWidth(o))break;e=o,i++}return i}},{key:"getLongestFitWord",value:function(t){for(var e=0;e<t.length&&!this.overMaxWidth(qt(t).call(t,0,e));)e++;return e}},{key:"splitStringIntoLines",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"normal",i=arguments.length>2&&void 0!==arguments[2]&&arguments[2];this.parent.getFormattingValues(this.ctx,this.selected,this.hover,e);for(var o=(t=(t=t.replace(/^( +)/g,"$1\r")).replace(/([^\r][^ ]*)( +)/g,"$1\r$2\r")).split("\r");o.length>0;){var n=this.getLongestFit(o);if(0===n){var s=o[0],r=this.getLongestFitWord(s);this.lines.newLine(qt(s).call(s,0,r),e),o[0]=qt(s).call(s,r)}else{var a=n;" "===o[n-1]?n--:" "===o[a]&&a++;var h=qt(o).call(o,0,n).join("");n==o.length&&i?this.lines.append(h,e):this.lines.newLine(h,e),o=qt(o).call(o,a)}}}}]),t}(),fh=["bold","ital","boldital","mono"],vh=function(){function t(e,i){var o=arguments.length>2&&void 0!==arguments[2]&&arguments[2];ma(this,t),this.body=e,this.pointToSelf=!1,this.baseSize=void 0,this.fontOptions={},this.setOptions(i),this.size={top:0,left:0,width:0,height:0,yLine:0},this.isEdgeLabel=o}return _a(t,[{key:"setOptions",value:function(t){if(this.elementOptions=t,this.initFontOptions(t.font),sh.isValidLabel(t.label)?this.labelDirty=!0:t.label=void 0,void 0!==t.font&&null!==t.font)if("string"==typeof t.font)this.baseSize=this.fontOptions.size;else if("object"===os(t.font)){var e=t.font.size;void 0!==e&&(this.baseSize=e)}}},{key:"initFontOptions",value:function(i){var o=this;e.forEach(fh,(function(t){o.fontOptions[t]={}})),t.parseFontString(this.fontOptions,i)?this.fontOptions.vadjust=0:e.forEach(i,(function(t,e){null!=t&&"object"!==os(t)&&(o.fontOptions[e]=t)}))}},{key:"constrain",value:function(t){var i={constrainWidth:!1,maxWdt:-1,minWdt:-1,constrainHeight:!1,minHgt:-1,valign:"middle"},o=e.topMost(t,"widthConstraint");if("number"==typeof o)i.maxWdt=Number(o),i.minWdt=Number(o);else if("object"===os(o)){var n=e.topMost(t,["widthConstraint","maximum"]);"number"==typeof n&&(i.maxWdt=Number(n));var s=e.topMost(t,["widthConstraint","minimum"]);"number"==typeof s&&(i.minWdt=Number(s))}var r=e.topMost(t,"heightConstraint");if("number"==typeof r)i.minHgt=Number(r);else if("object"===os(r)){var a=e.topMost(t,["heightConstraint","minimum"]);"number"==typeof a&&(i.minHgt=Number(a));var h=e.topMost(t,["heightConstraint","valign"]);"string"==typeof h&&("top"!==h&&"bottom"!==h||(i.valign=h))}return i}},{key:"update",value:function(t,i){this.setOptions(t,!0),this.propagateFonts(i),e.deepExtend(this.fontOptions,this.constrain(i)),this.fontOptions.chooser=sh.choosify("label",i)}},{key:"adjustSizes",value:function(t){var e=t?t.right+t.left:0;this.fontOptions.constrainWidth&&(this.fontOptions.maxWdt-=e,this.fontOptions.minWdt-=e);var i=t?t.top+t.bottom:0;this.fontOptions.constrainHeight&&(this.fontOptions.minHgt-=i)}},{key:"addFontOptionsToPile",value:function(t,e){for(var i=0;i<e.length;++i)this.addFontToPile(t,e[i])}},{key:"addFontToPile",value:function(t,e){if(void 0!==e&&void 0!==e.font&&null!==e.font){var i=e.font;t.push(i)}}},{key:"getBasicOptions",value:function(i){for(var o={},n=0;n<i.length;++n){var s=i[n],r={};t.parseFontString(r,s)&&(s=r),e.forEach(s,(function(t,e){void 0!==t&&(o.hasOwnProperty(e)||(-1!==zi(fh).call(fh,e)?o[e]={}:o[e]=t))}))}return o}},{key:"getFontOption",value:function(e,i,o){for(var n,s=0;s<e.length;++s){var r=e[s];if(r.hasOwnProperty(i)){if(null==(n=r[i]))continue;var a={};if(t.parseFontString(a,n)&&(n=a),n.hasOwnProperty(o))return n[o]}}if(this.fontOptions.hasOwnProperty(o))return this.fontOptions[o];throw new Error("Did not find value for multi-font for property: '"+o+"'")}},{key:"getFontOptions",value:function(t,e){for(var i={},o=["color","size","face","mod","vadjust"],n=0;n<o.length;++n){var s=o[n];i[s]=this.getFontOption(t,e,s)}return i}},{key:"propagateFonts",value:function(t){var i=this,o=[];this.addFontOptionsToPile(o,t),this.fontOptions=this.getBasicOptions(o);for(var n=function(t){var n=fh[t],s=i.fontOptions[n],r=i.getFontOptions(o,n);e.forEach(r,(function(t,e){s[e]=t})),s.size=Number(s.size),s.vadjust=Number(s.vadjust)},s=0;s<fh.length;++s)n(s)}},{key:"draw",value:function(t,e,i,o,n){var s=arguments.length>5&&void 0!==arguments[5]?arguments[5]:"middle";if(void 0!==this.elementOptions.label){var r=this.fontOptions.size*this.body.view.scale;this.elementOptions.label&&r<this.elementOptions.scaling.label.drawThreshold-1||(r>=this.elementOptions.scaling.label.maxVisible&&(r=Number(this.elementOptions.scaling.label.maxVisible)/this.body.view.scale),this.calculateLabelSize(t,o,n,e,i,s),this._drawBackground(t),this._drawText(t,e,this.size.yLine,s,r))}}},{key:"_drawBackground",value:function(t){if(void 0!==this.fontOptions.background&&"none"!==this.fontOptions.background){t.fillStyle=this.fontOptions.background;var e=this.getSize();t.fillRect(e.left,e.top,e.width,e.height)}}},{key:"_drawText",value:function(t,e,i){var o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:"middle",n=arguments.length>4?arguments[4]:void 0,s=this._setAlignment(t,e,i,o),r=nh(s,2);e=r[0],i=r[1],t.textAlign="left",e-=this.size.width/2,this.fontOptions.valign&&this.size.height>this.size.labelHeight&&("top"===this.fontOptions.valign&&(i-=(this.size.height-this.size.labelHeight)/2),"bottom"===this.fontOptions.valign&&(i+=(this.size.height-this.size.labelHeight)/2));for(var a=0;a<this.lineCount;a++){var h=this.lines[a];if(h&&h.blocks){var d=0;this.isEdgeLabel||"center"===this.fontOptions.align?d+=(this.size.width-h.width)/2:"right"===this.fontOptions.align&&(d+=this.size.width-h.width);for(var l=0;l<h.blocks.length;l++){var c=h.blocks[l];t.font=c.font;var u=this._getColor(c.color,n,c.strokeColor),p=nh(u,2),f=p[0],v=p[1];c.strokeWidth>0&&(t.lineWidth=c.strokeWidth,t.strokeStyle=v,t.lineJoin="round"),t.fillStyle=f,c.strokeWidth>0&&t.strokeText(c.text,e+d,i+c.vadjust),t.fillText(c.text,e+d,i+c.vadjust),d+=c.width}i+=h.height}}}},{key:"_setAlignment",value:function(t,e,i,o){if(this.isEdgeLabel&&"horizontal"!==this.fontOptions.align&&!1===this.pointToSelf){e=0,i=0;"top"===this.fontOptions.align?(t.textBaseline="alphabetic",i-=4):"bottom"===this.fontOptions.align?(t.textBaseline="hanging",i+=4):t.textBaseline="middle"}else t.textBaseline=o;return[e,i]}},{key:"_getColor",value:function(t,i,o){var n=t||"#000000",s=o||"#ffffff";if(i<=this.elementOptions.scaling.label.drawThreshold){var r=Math.max(0,Math.min(1,1-(this.elementOptions.scaling.label.drawThreshold-i)));n=e.overrideOpacity(n,r),s=e.overrideOpacity(s,r)}return[n,s]}},{key:"getTextSize",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=arguments.length>2&&void 0!==arguments[2]&&arguments[2];return this._processLabel(t,e,i),{width:this.size.width,height:this.size.height,lineCount:this.lineCount}}},{key:"getSize",value:function(){var t=this.size.left,e=this.size.top-1;if(this.isEdgeLabel){var i=.5*-this.size.width;switch(this.fontOptions.align){case"middle":t=i,e=.5*-this.size.height;break;case"top":t=i,e=-(this.size.height+2);break;case"bottom":t=i,e=2}}return{left:t,top:e,width:this.size.width,height:this.size.height}}},{key:"calculateLabelSize",value:function(t,e,i){var o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:0,n=arguments.length>4&&void 0!==arguments[4]?arguments[4]:0,s=arguments.length>5&&void 0!==arguments[5]?arguments[5]:"middle";this._processLabel(t,e,i),this.size.left=o-.5*this.size.width,this.size.top=n-.5*this.size.height,this.size.yLine=n+.5*(1-this.lineCount)*this.fontOptions.size,"hanging"===s&&(this.size.top+=.5*this.fontOptions.size,this.size.top+=4,this.size.yLine+=4)}},{key:"getFormattingValues",value:function(t,e,i,o){var n=function(t,e,i){return"normal"===e?"mod"===i?"":t[i]:void 0!==t[e][i]?t[e][i]:t[i]},s={color:n(this.fontOptions,o,"color"),size:n(this.fontOptions,o,"size"),face:n(this.fontOptions,o,"face"),mod:n(this.fontOptions,o,"mod"),vadjust:n(this.fontOptions,o,"vadjust"),strokeWidth:this.fontOptions.strokeWidth,strokeColor:this.fontOptions.strokeColor};(e||i)&&("normal"===o&&!0===this.fontOptions.chooser&&this.elementOptions.labelHighlightBold?s.mod="bold":"function"==typeof this.fontOptions.chooser&&this.fontOptions.chooser(s,this.elementOptions.id,e,i));var r="";return void 0!==s.mod&&""!==s.mod&&(r+=s.mod+" "),r+=s.size+"px "+s.face,t.font=r.replace(/"/g,""),s.font=t.font,s.height=s.size,s}},{key:"differentState",value:function(t,e){return t!==this.selectedState||e!==this.hoverState}},{key:"_processLabelText",value:function(t,e,i,o){return new ph(t,this,e,i).process(o)}},{key:"_processLabel",value:function(t,e,i){if(!1!==this.labelDirty||this.differentState(e,i)){var o=this._processLabelText(t,e,i,this.elementOptions.label);this.fontOptions.minWdt>0&&o.width<this.fontOptions.minWdt&&(o.width=this.fontOptions.minWdt),this.size.labelHeight=o.height,this.fontOptions.minHgt>0&&o.height<this.fontOptions.minHgt&&(o.height=this.fontOptions.minHgt),this.lines=o.lines,this.lineCount=o.lines.length,this.size.width=o.width,this.size.height=o.height,this.selectedState=e,this.hoverState=i,this.labelDirty=!1}}},{key:"visible",value:function(){return 0!==this.size.width&&0!==this.size.height&&void 0!==this.elementOptions.label&&!(this.fontOptions.size*this.body.view.scale<this.elementOptions.scaling.label.drawThreshold-1)}}],[{key:"parseFontString",value:function(t,e){if(!e||"string"!=typeof e)return!1;var i=e.split(" ");return t.size=+i[0].replace("px",""),t.face=i[1],t.color=i[2],!0}}]),t}();var gh=function(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t};var yh=function(t,e){return!e||"object"!==os(e)&&"function"!=typeof e?gh(t):e},mh=l((function(){xe(1)}));G({target:"Object",stat:!0,forced:mh,sham:!we},{getPrototypeOf:function(t){return xe(Ut(t))}});var bh=L.Object.getPrototypeOf;G({target:"Object",stat:!0},{setPrototypeOf:Ke});var wh=L.Object.setPrototypeOf,kh=r((function(t){function e(i){return t.exports=e=wh?bh:function(t){return t.__proto__||bh(t)},e(i)}t.exports=e})),_h=Ai,xh=r((function(t){function e(i,o){return t.exports=e=wh||function(t,e){return t.__proto__=e,t},e(i,o)}t.exports=e}));var Eh=function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=_h(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&xh(t,e)};G({target:"Array",proto:!0},{fill:function(t){for(var e=Ut(this),i=bt(e.length),o=arguments.length,n=yt(o>1?arguments[1]:void 0,i),s=o>2?arguments[2]:void 0,r=void 0===s?i:yt(s,i);r>n;)e[n++]=t;return e}});var Oh=Q("Array").fill,Ch=Array.prototype,Th=function(t){var e=t.fill;return t===Ch||t instanceof Array&&e===Ch.fill?Oh:e},Sh=function(){function t(e,i,o){ma(this,t),this.body=i,this.labelModule=o,this.setOptions(e),this.top=void 0,this.left=void 0,this.height=void 0,this.width=void 0,this.radius=void 0,this.margin=void 0,this.refreshNeeded=!0,this.boundingBox={top:0,left:0,right:0,bottom:0}}return _a(t,[{key:"setOptions",value:function(t){this.options=t}},{key:"_setMargins",value:function(t){this.margin={},this.options.margin&&("object"==os(this.options.margin)?(this.margin.top=this.options.margin.top,this.margin.right=this.options.margin.right,this.margin.bottom=this.options.margin.bottom,this.margin.left=this.options.margin.left):(this.margin.top=this.options.margin,this.margin.right=this.options.margin,this.margin.bottom=this.options.margin,this.margin.left=this.options.margin)),t.adjustSizes(this.margin)}},{key:"_distanceToBorder",value:function(t,e){var i=this.options.borderWidth;return this.resize(t),Math.min(Math.abs(this.width/2/Math.cos(e)),Math.abs(this.height/2/Math.sin(e)))+i}},{key:"enableShadow",value:function(t,e){e.shadow&&(t.shadowColor=e.shadowColor,t.shadowBlur=e.shadowSize,t.shadowOffsetX=e.shadowX,t.shadowOffsetY=e.shadowY)}},{key:"disableShadow",value:function(t,e){e.shadow&&(t.shadowColor="rgba(0,0,0,0)",t.shadowBlur=0,t.shadowOffsetX=0,t.shadowOffsetY=0)}},{key:"enableBorderDashes",value:function(t,e){if(!1!==e.borderDashes)if(void 0!==t.setLineDash){var i=e.borderDashes;!0===i&&(i=[5,15]),t.setLineDash(i)}else console.warn("setLineDash is not supported in this browser. The dashed borders cannot be used."),this.options.shapeProperties.borderDashes=!1,e.borderDashes=!1}},{key:"disableBorderDashes",value:function(t,e){!1!==e.borderDashes&&(void 0!==t.setLineDash?t.setLineDash([0]):(console.warn("setLineDash is not supported in this browser. The dashed borders cannot be used."),this.options.shapeProperties.borderDashes=!1,e.borderDashes=!1))}},{key:"needsRefresh",value:function(t,e){return!0===this.refreshNeeded?(this.refreshNeeded=!1,!0):void 0===this.width||this.labelModule.differentState(t,e)}},{key:"initContextForDraw",value:function(t,e){var i=e.borderWidth/this.body.view.scale;t.lineWidth=Math.min(this.width,i),t.strokeStyle=e.borderColor,t.fillStyle=e.color}},{key:"performStroke",value:function(t,e){var i=e.borderWidth/this.body.view.scale;t.save(),i>0&&(this.enableBorderDashes(t,e),t.stroke(),this.disableBorderDashes(t,e)),t.restore()}},{key:"performFill",value:function(t,e){this.enableShadow(t,e),Th(t).call(t),this.disableShadow(t,e),this.performStroke(t,e)}},{key:"_addBoundingBoxMargin",value:function(t){this.boundingBox.left-=t,this.boundingBox.top-=t,this.boundingBox.bottom+=t,this.boundingBox.right+=t}},{key:"_updateBoundingBox",value:function(t,e,i,o,n){void 0!==i&&this.resize(i,o,n),this.left=t-this.width/2,this.top=e-this.height/2,this.boundingBox.left=this.left,this.boundingBox.top=this.top,this.boundingBox.bottom=this.top+this.height,this.boundingBox.right=this.left+this.width}},{key:"updateBoundingBox",value:function(t,e,i,o,n){this._updateBoundingBox(t,e,i,o,n)}},{key:"getDimensionsFromLabel",value:function(t,e,i){this.textSize=this.labelModule.getTextSize(t,e,i);var o=this.textSize.width,n=this.textSize.height;return 0===o&&(o=14,n=14),{width:o,height:n}}}]),t}(),Dh=function(t){function e(t,i,o){var n;return ma(this,e),(n=yh(this,kh(e).call(this,t,i,o)))._setMargins(o),n}return Eh(e,t),_a(e,[{key:"resize",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover;if(this.needsRefresh(e,i)){var o=this.getDimensionsFromLabel(t,e,i);this.width=o.width+this.margin.right+this.margin.left,this.height=o.height+this.margin.top+this.margin.bottom,this.radius=this.width/2}}},{key:"draw",value:function(t,e,i,o,n,s){this.resize(t,o,n),this.left=e-this.width/2,this.top=i-this.height/2,this.initContextForDraw(t,s),nt(t,this.left,this.top,this.width,this.height,s.borderRadius),this.performFill(t,s),this.updateBoundingBox(e,i,t,o,n),this.labelModule.draw(t,this.left+this.textSize.width/2+this.margin.left,this.top+this.textSize.height/2+this.margin.top,o,n)}},{key:"updateBoundingBox",value:function(t,e,i,o,n){this._updateBoundingBox(t,e,i,o,n);var s=this.options.shapeProperties.borderRadius;this._addBoundingBoxMargin(s)}},{key:"distanceToBorder",value:function(t,e){this.resize(t);var i=this.options.borderWidth;return Math.min(Math.abs(this.width/2/Math.cos(e)),Math.abs(this.height/2/Math.sin(e)))+i}}]),e}(Sh),Mh=function(t){function e(t,i,o){var n;return ma(this,e),(n=yh(this,kh(e).call(this,t,i,o))).labelOffset=0,n.selected=!1,n}return Eh(e,t),_a(e,[{key:"setOptions",value:function(t,e,i){this.options=t,void 0===e&&void 0===i||this.setImages(e,i)}},{key:"setImages",value:function(t,e){e&&this.selected?(this.imageObj=e,this.imageObjAlt=t):(this.imageObj=t,this.imageObjAlt=e)}},{key:"switchImages",value:function(t){var e=t&&!this.selected||!t&&this.selected;if(this.selected=t,void 0!==this.imageObjAlt&&e){var i=this.imageObj;this.imageObj=this.imageObjAlt,this.imageObjAlt=i}}},{key:"_getImagePadding",value:function(){var t={top:0,right:0,bottom:0,left:0};if(this.options.imagePadding){var e=this.options.imagePadding;"object"==os(e)?(t.top=e.top,t.right=e.right,t.bottom=e.bottom,t.left=e.left):(t.top=e,t.right=e,t.bottom=e,t.left=e)}return t}},{key:"_resizeImage",value:function(){var t,e;if(!1===this.options.shapeProperties.useImageSize){var i=1,o=1;this.imageObj.width&&this.imageObj.height&&(this.imageObj.width>this.imageObj.height?i=this.imageObj.width/this.imageObj.height:o=this.imageObj.height/this.imageObj.width),t=2*this.options.size*i,e=2*this.options.size*o}else{var n=this._getImagePadding();t=this.imageObj.width+n.left+n.right,e=this.imageObj.height+n.top+n.bottom}this.width=t,this.height=e,this.radius=.5*this.width}},{key:"_drawRawCircle",value:function(t,e,i,o){this.initContextForDraw(t,o),ot(t,e,i,o.size),this.performFill(t,o)}},{key:"_drawImageAtPosition",value:function(t,e){if(0!=this.imageObj.width){t.globalAlpha=1,this.enableShadow(t,e);var i=1;!0===this.options.shapeProperties.interpolation&&(i=this.imageObj.width/this.width/this.body.view.scale);var o=this._getImagePadding(),n=this.left+o.left,s=this.top+o.top,r=this.width-o.left-o.right,a=this.height-o.top-o.bottom;this.imageObj.drawImageAtPosition(t,i,n,s,r,a),this.disableShadow(t,e)}}},{key:"_drawImageLabel",value:function(t,e,i,o,n){var s,r=0;if(void 0!==this.height){r=.5*this.height;var a=this.labelModule.getTextSize(t,o,n);a.lineCount>=1&&(r+=a.height/2)}s=i+r,this.options.label&&(this.labelOffset=r),this.labelModule.draw(t,e,s,o,n,"hanging")}}]),e}(Sh),Ih=function(t){function e(t,i,o){var n;return ma(this,e),(n=yh(this,kh(e).call(this,t,i,o)))._setMargins(o),n}return Eh(e,t),_a(e,[{key:"resize",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover;if(this.needsRefresh(e,i)){var o=this.getDimensionsFromLabel(t,e,i),n=Math.max(o.width+this.margin.right+this.margin.left,o.height+this.margin.top+this.margin.bottom);this.options.size=n/2,this.width=n,this.height=n,this.radius=this.width/2}}},{key:"draw",value:function(t,e,i,o,n,s){this.resize(t,o,n),this.left=e-this.width/2,this.top=i-this.height/2,this._drawRawCircle(t,e,i,s),this.updateBoundingBox(e,i),this.labelModule.draw(t,this.left+this.textSize.width/2+this.margin.left,i,o,n)}},{key:"updateBoundingBox",value:function(t,e){this.boundingBox.top=e-this.options.size,this.boundingBox.left=t-this.options.size,this.boundingBox.right=t+this.options.size,this.boundingBox.bottom=e+this.options.size}},{key:"distanceToBorder",value:function(t,e){return this.resize(t),.5*this.width}}]),e}(Mh),Ph=function(t){function e(t,i,o,n,s){var r;return ma(this,e),(r=yh(this,kh(e).call(this,t,i,o))).setImages(n,s),r}return Eh(e,t),_a(e,[{key:"resize",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover,o=void 0===this.imageObj.src||void 0===this.imageObj.width||void 0===this.imageObj.height;if(o){var n=2*this.options.size;return this.width=n,this.height=n,void(this.radius=.5*this.width)}this.needsRefresh(e,i)&&this._resizeImage()}},{key:"draw",value:function(t,e,i,o,n,s){this.switchImages(o),this.resize(),this.left=e-this.width/2,this.top=i-this.height/2,this._drawRawCircle(t,e,i,s),t.save(),t.clip(),this._drawImageAtPosition(t,s),t.restore(),this._drawImageLabel(t,e,i,o,n),this.updateBoundingBox(e,i)}},{key:"updateBoundingBox",value:function(t,e){this.boundingBox.top=e-this.options.size,this.boundingBox.left=t-this.options.size,this.boundingBox.right=t+this.options.size,this.boundingBox.bottom=e+this.options.size,this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelOffset)}},{key:"distanceToBorder",value:function(t,e){return this.resize(t),.5*this.width}}]),e}(Mh),Fh=function(t){function e(t,i,o){var n;return ma(this,e),(n=yh(this,kh(e).call(this,t,i,o)))._setMargins(o),n}return Eh(e,t),_a(e,[{key:"resize",value:function(t,e,i){if(this.needsRefresh(e,i)){var o=this.getDimensionsFromLabel(t,e,i).width+this.margin.right+this.margin.left;this.width=o,this.height=o,this.radius=this.width/2}}},{key:"draw",value:function(t,e,i,o,n,s){this.resize(t,o,n),this.left=e-this.width/2,this.top=i-this.height/2,this.initContextForDraw(t,s),rt(t,e-this.width/2,i-this.height/2,this.width,this.height),this.performFill(t,s),this.updateBoundingBox(e,i,t,o,n),this.labelModule.draw(t,this.left+this.textSize.width/2+this.margin.left,this.top+this.textSize.height/2+this.margin.top,o,n)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),e}(Sh),Bh=function(t){function e(t,i,o){return ma(this,e),yh(this,kh(e).call(this,t,i,o))}return Eh(e,t),_a(e,[{key:"resize",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{size:this.options.size};if(this.needsRefresh(e,i)){this.labelModule.getTextSize(t,e,i);var n=2*o.size;this.width=n,this.height=n,this.radius=.5*this.width}}},{key:"_drawShape",value:function(t,e,i,o,n,s,r,a){var h;if(this.resize(t,s,r,a),this.left=o-this.width/2,this.top=n-this.height/2,this.initContextForDraw(t,a),(h=e,Object.prototype.hasOwnProperty.call(ht,h)?ht[h]:function(t){for(var e=arguments.length,i=new Array(e>1?e-1:0),o=1;o<e;o++)i[o-1]=arguments[o];CanvasRenderingContext2D.prototype[h].call(t,i)})(t,o,n,a.size),this.performFill(t,a),void 0!==this.options.icon&&void 0!==this.options.icon.code&&(t.font=(s?"bold ":"")+this.height/2+"px "+(this.options.icon.face||"FontAwesome"),t.fillStyle=this.options.icon.color||"black",t.textAlign="center",t.textBaseline="middle",t.fillText(this.options.icon.code,o,n)),void 0!==this.options.label){this.labelModule.calculateLabelSize(t,s,r,o,n,"hanging");var d=n+.5*this.height+.5*this.labelModule.size.height;this.labelModule.draw(t,o,d,s,r,"hanging")}this.updateBoundingBox(o,n)}},{key:"updateBoundingBox",value:function(t,e){this.boundingBox.top=e-this.options.size,this.boundingBox.left=t-this.options.size,this.boundingBox.right=t+this.options.size,this.boundingBox.bottom=e+this.options.size,void 0!==this.options.label&&this.labelModule.size.width>0&&(this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelModule.size.height))}}]),e}(Sh),zh=function(t){function e(t,i,o){return ma(this,e),yh(this,kh(e).call(this,t,i,o))}return Eh(e,t),_a(e,[{key:"draw",value:function(t,e,i,o,n,s){this._drawShape(t,"diamond",4,e,i,o,n,s)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),e}(Bh),Nh=function(t){function e(t,i,o){return ma(this,e),yh(this,kh(e).call(this,t,i,o))}return Eh(e,t),_a(e,[{key:"draw",value:function(t,e,i,o,n,s){this._drawShape(t,"circle",2,e,i,o,n,s)}},{key:"distanceToBorder",value:function(t,e){return this.resize(t),this.options.size}}]),e}(Bh),Ah=function(t){function e(t,i,o){return ma(this,e),yh(this,kh(e).call(this,t,i,o))}return Eh(e,t),_a(e,[{key:"resize",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover;if(this.needsRefresh(e,i)){var o=this.getDimensionsFromLabel(t,e,i);this.height=2*o.height,this.width=o.width+o.height,this.radius=.5*this.width}}},{key:"draw",value:function(t,e,i,o,n,s){this.resize(t,o,n),this.left=e-.5*this.width,this.top=i-.5*this.height,this.initContextForDraw(t,s),st(t,this.left,this.top,this.width,this.height),this.performFill(t,s),this.updateBoundingBox(e,i,t,o,n),this.labelModule.draw(t,e,i,o,n)}},{key:"distanceToBorder",value:function(t,e){this.resize(t);var i=.5*this.width,o=.5*this.height,n=Math.sin(e)*i,s=Math.cos(e)*o;return i*o/Math.sqrt(n*n+s*s)}}]),e}(Sh),Rh=function(t){function e(t,i,o){var n;return ma(this,e),(n=yh(this,kh(e).call(this,t,i,o)))._setMargins(o),n}return Eh(e,t),_a(e,[{key:"resize",value:function(t,e,i){this.needsRefresh(e,i)&&(this.iconSize={width:Number(this.options.icon.size),height:Number(this.options.icon.size)},this.width=this.iconSize.width+this.margin.right+this.margin.left,this.height=this.iconSize.height+this.margin.top+this.margin.bottom,this.radius=.5*this.width)}},{key:"draw",value:function(t,e,i,o,n,s){if(this.resize(t,o,n),this.options.icon.size=this.options.icon.size||50,this.left=e-this.width/2,this.top=i-this.height/2,this._icon(t,e,i,o,n,s),void 0!==this.options.label){this.labelModule.draw(t,this.left+this.iconSize.width/2+this.margin.left,i+this.height/2+5,o)}this.updateBoundingBox(e,i)}},{key:"updateBoundingBox",value:function(t,e){if(this.boundingBox.top=e-.5*this.options.icon.size,this.boundingBox.left=t-.5*this.options.icon.size,this.boundingBox.right=t+.5*this.options.icon.size,this.boundingBox.bottom=e+.5*this.options.icon.size,void 0!==this.options.label&&this.labelModule.size.width>0){this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelModule.size.height+5)}}},{key:"_icon",value:function(t,e,i,o,n,s){var r=Number(this.options.icon.size);void 0!==this.options.icon.code?(t.font=[null!=this.options.icon.weight?this.options.icon.weight:o?"bold":"",(null!=this.options.icon.weight&&o?5:0)+r+"px",this.options.icon.face].join(" "),t.fillStyle=this.options.icon.color||"black",t.textAlign="center",t.textBaseline="middle",this.enableShadow(t,s),t.fillText(this.options.icon.code,e,i),this.disableShadow(t,s)):console.error("When using the icon shape, you need to define the code in the icon options object. This can be done per node or globally.")}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),e}(Sh),Lh=function(t){function e(t,i,o,n,s){var r;return ma(this,e),(r=yh(this,kh(e).call(this,t,i,o))).setImages(n,s),r}return Eh(e,t),_a(e,[{key:"resize",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover,o=void 0===this.imageObj.src||void 0===this.imageObj.width||void 0===this.imageObj.height;if(o){var n=2*this.options.size;return this.width=n,void(this.height=n)}this.needsRefresh(e,i)&&this._resizeImage()}},{key:"draw",value:function(t,e,i,o,n,s){if(this.switchImages(o),this.resize(),this.left=e-this.width/2,this.top=i-this.height/2,!0===this.options.shapeProperties.useBorderWithImage){var r=this.options.borderWidth,a=this.options.borderWidthSelected||2*this.options.borderWidth,h=(o?a:r)/this.body.view.scale;t.lineWidth=Math.min(this.width,h),t.beginPath(),t.strokeStyle=o?this.options.color.highlight.border:n?this.options.color.hover.border:this.options.color.border,t.fillStyle=o?this.options.color.highlight.background:n?this.options.color.hover.background:this.options.color.background,t.rect(this.left-.5*t.lineWidth,this.top-.5*t.lineWidth,this.width+t.lineWidth,this.height+t.lineWidth),Th(t).call(t),this.performStroke(t,s),t.closePath()}this._drawImageAtPosition(t,s),this._drawImageLabel(t,e,i,o,n),this.updateBoundingBox(e,i)}},{key:"updateBoundingBox",value:function(t,e){this.resize(),this._updateBoundingBox(t,e),void 0!==this.options.label&&this.labelModule.size.width>0&&(this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelOffset))}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),e}(Mh),jh=function(t){function e(t,i,o){return ma(this,e),yh(this,kh(e).call(this,t,i,o))}return Eh(e,t),_a(e,[{key:"draw",value:function(t,e,i,o,n,s){this._drawShape(t,"square",2,e,i,o,n,s)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),e}(Bh),Hh=function(t){function e(t,i,o){return ma(this,e),yh(this,kh(e).call(this,t,i,o))}return Eh(e,t),_a(e,[{key:"draw",value:function(t,e,i,o,n,s){this._drawShape(t,"hexagon",4,e,i,o,n,s)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),e}(Bh),Wh=function(t){function e(t,i,o){return ma(this,e),yh(this,kh(e).call(this,t,i,o))}return Eh(e,t),_a(e,[{key:"draw",value:function(t,e,i,o,n,s){this._drawShape(t,"star",4,e,i,o,n,s)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),e}(Bh),Vh=function(t){function e(t,i,o){var n;return ma(this,e),(n=yh(this,kh(e).call(this,t,i,o)))._setMargins(o),n}return Eh(e,t),_a(e,[{key:"resize",value:function(t,e,i){this.needsRefresh(e,i)&&(this.textSize=this.labelModule.getTextSize(t,e,i),this.width=this.textSize.width+this.margin.right+this.margin.left,this.height=this.textSize.height+this.margin.top+this.margin.bottom,this.radius=.5*this.width)}},{key:"draw",value:function(t,e,i,o,n,s){this.resize(t,o,n),this.left=e-this.width/2,this.top=i-this.height/2,this.enableShadow(t,s),this.labelModule.draw(t,this.left+this.textSize.width/2+this.margin.left,this.top+this.textSize.height/2+this.margin.top,o,n),this.disableShadow(t,s),this.updateBoundingBox(e,i,t,o,n)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),e}(Sh),qh=function(t){function e(t,i,o){return ma(this,e),yh(this,kh(e).call(this,t,i,o))}return Eh(e,t),_a(e,[{key:"draw",value:function(t,e,i,o,n,s){this._drawShape(t,"triangle",3,e,i,o,n,s)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),e}(Bh),Uh=function(t){function e(t,i,o){return ma(this,e),yh(this,kh(e).call(this,t,i,o))}return Eh(e,t),_a(e,[{key:"draw",value:function(t,e,i,o,n,s){this._drawShape(t,"triangleDown",3,e,i,o,n,s)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),e}(Bh),Yh=It("JSON","stringify"),Xh=/[\uD800-\uDFFF]/g,Gh=/^[\uD800-\uDBFF]$/,Kh=/^[\uDC00-\uDFFF]$/,Zh=function(t,e,i){var o=i.charAt(e-1),n=i.charAt(e+1);return Gh.test(t)&&!Kh.test(n)||Kh.test(t)&&!Gh.test(o)?"\\u"+t.charCodeAt(0).toString(16):t},$h=l((function(){return'"\\udf06\\ud834"'!==Yh("\udf06\ud834")||'"\\udead"'!==Yh("\udead")}));Yh&&G({target:"JSON",stat:!0,forced:$h},{stringify:function(t,e,i){var o=Yh.apply(null,arguments);return"string"==typeof o?o.replace(Xh,Zh):o}}),L.JSON||(L.JSON={stringify:JSON.stringify});var Jh,Qh=function(t,e,i){return L.JSON.stringify.apply(null,arguments)},td=!1,ed="background: #FFeeee; color: #dd0000",id=function(){function t(){ma(this,t)}return _a(t,null,[{key:"validate",value:function(e,i,o){td=!1,Jh=i;var n=i;return void 0!==o&&(n=i[o]),t.parse(e,n,[]),td}},{key:"parse",value:function(e,i,o){for(var n in e)e.hasOwnProperty(n)&&t.check(n,e,i,o)}},{key:"check",value:function(e,i,o,n){if(void 0!==o[e]||void 0!==o.__any__){var s=e,r=!0;void 0===o[e]&&void 0!==o.__any__&&(s="__any__",r="object"===t.getType(i[e]));var a=o[s];r&&void 0!==a.__type__&&(a=a.__type__),t.checkFields(e,i,o,s,a,n)}else t.getSuggestion(e,o,n)}},{key:"checkFields",value:function(i,o,n,s,r,a){var h=function(e){console.log("%c"+e+t.printLocation(a,i),ed)},d=t.getType(o[i]),l=r[d];void 0!==l?"array"===t.getType(l)&&-1===zi(l).call(l,o[i])?(h('Invalid option detected in "'+i+'". Allowed values are:'+t.print(l)+' not "'+o[i]+'". '),td=!0):"object"===d&&"__any__"!==s&&(a=e.copyAndExtendArray(a,i),t.parse(o[i],n[s],a)):void 0===r.any&&(h('Invalid type received for "'+i+'". Expected: '+t.print(To(r))+". Received ["+d+'] "'+o[i]+'"'),td=!0)}},{key:"getType",value:function(t){var e=os(t);return"object"===e?null===t?"null":t instanceof Boolean?"boolean":t instanceof Number?"number":t instanceof String?"string":bi(t)?"array":t instanceof Date?"date":void 0!==t.nodeType?"dom":!0===t._isAMomentObject?"moment":"object":"number"===e?"number":"boolean"===e?"boolean":"string"===e?"string":void 0===e?"undefined":e}},{key:"getSuggestion",value:function(e,i,o){var n,s=t.findInOptions(e,i,o,!1),r=t.findInOptions(e,Jh,[],!0);n=void 0!==s.indexMatch?" in "+t.printLocation(s.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+s.indexMatch+'"?\n\n':r.distance<=4&&s.distance>r.distance?" in "+t.printLocation(s.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+t.printLocation(r.path,r.closestMatch,""):s.distance<=8?'. Did you mean "'+s.closestMatch+'"?'+t.printLocation(s.path,e):". Did you mean one of these: "+t.print(To(i))+t.printLocation(o,e),console.log('%cUnknown option detected: "'+e+'"'+n,ed),td=!0}},{key:"findInOptions",value:function(i,o,n){var s=arguments.length>3&&void 0!==arguments[3]&&arguments[3],r=1e9,a="",h=[],d=i.toLowerCase(),l=void 0;for(var c in o){var u=void 0;if(void 0!==o[c].__type__&&!0===s){var p=t.findInOptions(i,o[c],e.copyAndExtendArray(n,c));r>p.distance&&(a=p.closestMatch,h=p.path,r=p.distance,l=p.indexMatch)}else{var f;-1!==zi(f=c.toLowerCase()).call(f,d)&&(l=c),r>(u=t.levenshteinDistance(i,c))&&(a=c,h=e.copyArray(n),r=u)}}return{closestMatch:a,path:h,distance:r,indexMatch:l}}},{key:"printLocation",value:function(t,e){for(var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n",o="\n\n"+i+"options = {\n",n=0;n<t.length;n++){for(var s=0;s<n+1;s++)o+="  ";o+=t[n]+": {\n"}for(var r=0;r<t.length+1;r++)o+="  ";o+=e+"\n";for(var a=0;a<t.length+1;a++){for(var h=0;h<t.length-a;h++)o+="  ";o+="}\n"}return o+"\n\n"}},{key:"print",value:function(t){return Qh(t).replace(/(\")|(\[)|(\])|(,"__type__")/g,"").replace(/(\,)/g,", ")}},{key:"levenshteinDistance",value:function(t,e){if(0===t.length)return e.length;if(0===e.length)return t.length;var i,o,n=[];for(i=0;i<=e.length;i++)n[i]=[i];for(o=0;o<=t.length;o++)n[0][o]=o;for(i=1;i<=e.length;i++)for(o=1;o<=t.length;o++)e.charAt(i-1)==t.charAt(o-1)?n[i][o]=n[i-1][o-1]:n[i][o]=Math.min(n[i-1][o-1]+1,Math.min(n[i][o-1]+1,n[i-1][o]+1));return n[e.length][t.length]}}]),t}();function od(t,e){var i=To(t);if(Ha){var o=Ha(t);e&&(o=zo(o).call(o,(function(e){return ja(t,e).enumerable}))),i.push.apply(i,o)}return i}var nd=function(){function t(i,o,n,s,r,a){ma(this,t),this.options=e.bridgeObject(r),this.globalOptions=r,this.defaultOptions=a,this.body=o,this.edges=[],this.id=void 0,this.imagelist=n,this.grouplist=s,this.x=void 0,this.y=void 0,this.baseSize=this.options.size,this.baseFontSize=this.options.font.size,this.predefinedPosition=!1,this.selected=!1,this.hover=!1,this.labelModule=new vh(this.body,this.options,!1),this.setOptions(i)}return _a(t,[{key:"attachEdge",value:function(t){var e;-1===zi(e=this.edges).call(e,t)&&this.edges.push(t)}},{key:"detachEdge",value:function(t){var e,i,o=zi(e=this.edges).call(e,t);-1!=o&&ee(i=this.edges).call(i,o,1)}},{key:"setOptions",value:function(e){var i=this.options.shape;if(e){if(void 0!==e.color&&(this._localColor=e.color),void 0!==e.id&&(this.id=e.id),void 0===this.id)throw new Error("Node must have an id");t.checkMass(e,this.id),void 0!==e.x&&(null===e.x?(this.x=void 0,this.predefinedPosition=!1):(this.x=$a(e.x),this.predefinedPosition=!0)),void 0!==e.y&&(null===e.y?(this.y=void 0,this.predefinedPosition=!1):(this.y=$a(e.y),this.predefinedPosition=!0)),void 0!==e.size&&(this.baseSize=e.size),void 0!==e.value&&(e.value=Ya(e.value)),t.parseOptions(this.options,e,!0,this.globalOptions,this.grouplist);var o=[e,this.options,this.defaultOptions];return this.chooser=sh.choosify("node",o),this._load_images(),this.updateLabelModule(e),this.updateShape(i),void 0!==e.hidden||void 0!==e.physics}}},{key:"_load_images",value:function(){if(("circularImage"===this.options.shape||"image"===this.options.shape)&&void 0===this.options.image)throw new Error("Option image must be defined for node type '"+this.options.shape+"'");if(void 0!==this.options.image){if(void 0===this.imagelist)throw new Error("Internal Error: No images provided");if("string"==typeof this.options.image)this.imageObj=this.imagelist.load(this.options.image,this.options.brokenImage,this.id);else{if(void 0===this.options.image.unselected)throw new Error("No unselected image provided");this.imageObj=this.imagelist.load(this.options.image.unselected,this.options.brokenImage,this.id),void 0!==this.options.image.selected?this.imageObjAlt=this.imagelist.load(this.options.image.selected,this.options.brokenImage,this.id):this.imageObjAlt=void 0}}}},{key:"getFormattingValues",value:function(){var t={color:this.options.color.background,borderWidth:this.options.borderWidth,borderColor:this.options.color.border,size:this.options.size,borderDashes:this.options.shapeProperties.borderDashes,borderRadius:this.options.shapeProperties.borderRadius,shadow:this.options.shadow.enabled,shadowColor:this.options.shadow.color,shadowSize:this.options.shadow.size,shadowX:this.options.shadow.x,shadowY:this.options.shadow.y};return this.selected||this.hover?!0===this.chooser?this.selected?(t.borderWidth*=2,t.color=this.options.color.highlight.background,t.borderColor=this.options.color.highlight.border,t.shadow=this.options.shadow.enabled):this.hover&&(t.color=this.options.color.hover.background,t.borderColor=this.options.color.hover.border,t.shadow=this.options.shadow.enabled):"function"==typeof this.chooser&&(this.chooser(t,this.options.id,this.selected,this.hover),!1===t.shadow&&(t.shadowColor===this.options.shadow.color&&t.shadowSize===this.options.shadow.size&&t.shadowX===this.options.shadow.x&&t.shadowY===this.options.shadow.y||(t.shadow=!0))):t.shadow=this.options.shadow.enabled,t}},{key:"updateLabelModule",value:function(e){void 0!==this.options.label&&null!==this.options.label||(this.options.label=""),t.updateGroupOptions(this.options,function(t){for(var e=1;e<arguments.length;e++){var i,o=null!=arguments[e]?arguments[e]:{};if(e%2)yi(i=od(o,!0)).call(i,(function(e){Wa(t,e,o[e])}));else if(Na)Ba(t,Na(o));else{var n;yi(n=od(o)).call(n,(function(e){Fa(t,e,ja(o,e))}))}}return t}({},e,{color:e&&e.color||this._localColor||void 0}),this.grouplist);var i=this.grouplist.get(this.options.group,!1),o=[e,this.options,i,this.globalOptions,this.defaultOptions];this.labelModule.update(this.options,o),void 0!==this.labelModule.baseSize&&(this.baseFontSize=this.labelModule.baseSize)}},{key:"updateShape",value:function(t){if(t===this.options.shape&&this.shape)this.shape.setOptions(this.options,this.imageObj,this.imageObjAlt);else switch(this.options.shape){case"box":this.shape=new Dh(this.options,this.body,this.labelModule);break;case"circle":this.shape=new Ih(this.options,this.body,this.labelModule);break;case"circularImage":this.shape=new Ph(this.options,this.body,this.labelModule,this.imageObj,this.imageObjAlt);break;case"database":this.shape=new Fh(this.options,this.body,this.labelModule);break;case"diamond":this.shape=new zh(this.options,this.body,this.labelModule);break;case"dot":this.shape=new Nh(this.options,this.body,this.labelModule);break;case"ellipse":this.shape=new Ah(this.options,this.body,this.labelModule);break;case"icon":this.shape=new Rh(this.options,this.body,this.labelModule);break;case"image":this.shape=new Lh(this.options,this.body,this.labelModule,this.imageObj,this.imageObjAlt);break;case"square":this.shape=new jh(this.options,this.body,this.labelModule);break;case"hexagon":this.shape=new Hh(this.options,this.body,this.labelModule);break;case"star":this.shape=new Wh(this.options,this.body,this.labelModule);break;case"text":this.shape=new Vh(this.options,this.body,this.labelModule);break;case"triangle":this.shape=new qh(this.options,this.body,this.labelModule);break;case"triangleDown":this.shape=new Uh(this.options,this.body,this.labelModule);break;default:this.shape=new Ah(this.options,this.body,this.labelModule)}this.needsRefresh()}},{key:"select",value:function(){this.selected=!0,this.needsRefresh()}},{key:"unselect",value:function(){this.selected=!1,this.needsRefresh()}},{key:"needsRefresh",value:function(){this.shape.refreshNeeded=!0}},{key:"getTitle",value:function(){return this.options.title}},{key:"distanceToBorder",value:function(t,e){return this.shape.distanceToBorder(t,e)}},{key:"isFixed",value:function(){return this.options.fixed.x&&this.options.fixed.y}},{key:"isSelected",value:function(){return this.selected}},{key:"getValue",value:function(){return this.options.value}},{key:"getLabelSize",value:function(){return this.labelModule.size()}},{key:"setValueRange",value:function(t,e,i){if(void 0!==this.options.value){var o=this.options.scaling.customScalingFunction(t,e,i,this.options.value),n=this.options.scaling.max-this.options.scaling.min;if(!0===this.options.scaling.label.enabled){var s=this.options.scaling.label.max-this.options.scaling.label.min;this.options.font.size=this.options.scaling.label.min+o*s}this.options.size=this.options.scaling.min+o*n}else this.options.size=this.baseSize,this.options.font.size=this.baseFontSize;this.updateLabelModule()}},{key:"draw",value:function(t){var e=this.getFormattingValues();this.shape.draw(t,this.x,this.y,this.selected,this.hover,e)}},{key:"updateBoundingBox",value:function(t){this.shape.updateBoundingBox(this.x,this.y,t)}},{key:"resize",value:function(t){var e=this.getFormattingValues();this.shape.resize(t,this.selected,this.hover,e)}},{key:"getItemsOnPoint",value:function(t){var e=[];return this.labelModule.visible()&&sh.pointInRect(this.labelModule.getSize(),t)&&e.push({nodeId:this.id,labelId:0}),sh.pointInRect(this.shape.boundingBox,t)&&e.push({nodeId:this.id}),e}},{key:"isOverlappingWith",value:function(t){return this.shape.left<t.right&&this.shape.left+this.shape.width>t.left&&this.shape.top<t.bottom&&this.shape.top+this.shape.height>t.top}},{key:"isBoundingBoxOverlappingWith",value:function(t){return this.shape.boundingBox.left<t.right&&this.shape.boundingBox.right>t.left&&this.shape.boundingBox.top<t.bottom&&this.shape.boundingBox.bottom>t.top}}],[{key:"updateGroupOptions",value:function(t,i,o){if(void 0!==o){var n=t.group;if(void 0!==i&&void 0!==i.group&&n!==i.group)throw new Error("updateGroupOptions: group values in options don't match.");if("number"==typeof n||"string"==typeof n&&""!=n){var s=o.get(n),r=["font"];void 0!==i&&void 0!==i.color&&null!=i.color&&r.push("color"),e.selectiveNotDeepExtend(r,t,s),t.color=e.parseColor(t.color)}}}},{key:"parseOptions",value:function(i,o){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2],s=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},r=arguments.length>4?arguments[4]:void 0,a=["color","fixed","shadow"];if(e.selectiveNotDeepExtend(a,i,o,n),t.checkMass(o),e.mergeOptions(i,o,"shadow",s),void 0!==o.color&&null!==o.color){var h=e.parseColor(o.color);e.fillIfDefined(i.color,h)}else!0===n&&null===o.color&&(i.color=e.bridgeObject(s.color));void 0!==o.fixed&&null!==o.fixed&&("boolean"==typeof o.fixed?(i.fixed.x=o.fixed,i.fixed.y=o.fixed):(void 0!==o.fixed.x&&"boolean"==typeof o.fixed.x&&(i.fixed.x=o.fixed.x),void 0!==o.fixed.y&&"boolean"==typeof o.fixed.y&&(i.fixed.y=o.fixed.y))),!0===n&&null===o.font&&(i.font=e.bridgeObject(s.font)),t.updateGroupOptions(i,o,r),void 0!==o.scaling&&e.mergeOptions(i.scaling,o.scaling,"label",s.scaling)}},{key:"checkMass",value:function(t,e){if(void 0!==t.mass&&t.mass<=0){var i="";void 0!==e&&(i=" in node id: "+e),console.log("%cNegative or zero mass disallowed"+i+", setting mass to 1.",ed),t.mass=1}}}]),t}(),sd=function(){function t(i,o,n,s){var r,a=this;if(ma(this,t),this.body=i,this.images=o,this.groups=n,this.layoutEngine=s,this.body.functions.createNode=it(r=this.create).call(r,this),this.nodesListeners={add:function(t,e){a.add(e.items)},update:function(t,e){a.update(e.items,e.data,e.oldData)},remove:function(t,e){a.remove(e.items)}},this.defaultOptions={borderWidth:1,borderWidthSelected:2,brokenImage:void 0,color:{border:"#2B7CE9",background:"#97C2FC",highlight:{border:"#2B7CE9",background:"#D2E5FF"},hover:{border:"#2B7CE9",background:"#D2E5FF"}},fixed:{x:!1,y:!1},font:{color:"#343434",size:14,face:"arial",background:"none",strokeWidth:0,strokeColor:"#ffffff",align:"center",vadjust:0,multi:!1,bold:{mod:"bold"},boldital:{mod:"bold italic"},ital:{mod:"italic"},mono:{mod:"",size:15,face:"monospace",vadjust:2}},group:void 0,hidden:!1,icon:{face:"FontAwesome",code:void 0,size:50,color:"#2B7CE9"},image:void 0,imagePadding:{top:0,right:0,bottom:0,left:0},label:void 0,labelHighlightBold:!0,level:void 0,margin:{top:5,right:5,bottom:5,left:5},mass:1,physics:!0,scaling:{min:10,max:30,label:{enabled:!1,min:14,max:30,maxVisible:30,drawThreshold:5},customScalingFunction:function(t,e,i,o){if(e===t)return.5;var n=1/(e-t);return Math.max(0,(o-t)*n)}},shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:10,x:5,y:5},shape:"ellipse",shapeProperties:{borderDashes:!1,borderRadius:6,interpolation:!0,useImageSize:!1,useBorderWithImage:!1},size:25,title:void 0,value:void 0,x:void 0,y:void 0},this.defaultOptions.mass<=0)throw"Internal error: mass in defaultOptions of NodesHandler may not be zero or negative";this.options=e.bridgeObject(this.defaultOptions),this.bindEventListeners()}return _a(t,[{key:"bindEventListeners",value:function(){var t,i,o=this;this.body.emitter.on("refreshNodes",it(t=this.refresh).call(t,this)),this.body.emitter.on("refresh",it(i=this.refresh).call(i,this)),this.body.emitter.on("destroy",(function(){e.forEach(o.nodesListeners,(function(t,e){o.body.data.nodes&&o.body.data.nodes.off(e,t)})),delete o.body.functions.createNode,delete o.nodesListeners.add,delete o.nodesListeners.update,delete o.nodesListeners.remove,delete o.nodesListeners}))}},{key:"setOptions",value:function(t){if(void 0!==t){if(nd.parseOptions(this.options,t),void 0!==t.shape)for(var e in this.body.nodes)this.body.nodes.hasOwnProperty(e)&&this.body.nodes[e].updateShape();if(void 0!==t.font)for(var i in this.body.nodes)this.body.nodes.hasOwnProperty(i)&&(this.body.nodes[i].updateLabelModule(),this.body.nodes[i].needsRefresh());if(void 0!==t.size)for(var o in this.body.nodes)this.body.nodes.hasOwnProperty(o)&&this.body.nodes[o].needsRefresh();void 0===t.hidden&&void 0===t.physics||this.body.emitter.emit("_dataChanged")}}},{key:"setData",value:function(t){var i=arguments.length>1&&void 0!==arguments[1]&&arguments[1],n=this.body.data.nodes;if(t instanceof o.DataSet||t instanceof o.DataView)this.body.data.nodes=t;else if(bi(t))this.body.data.nodes=new o.DataSet,this.body.data.nodes.add(t);else{if(t)throw new TypeError("Array or DataSet expected");this.body.data.nodes=new o.DataSet}if(n&&e.forEach(this.nodesListeners,(function(t,e){n.off(e,t)})),this.body.nodes={},this.body.data.nodes){var s=this;e.forEach(this.nodesListeners,(function(t,e){s.body.data.nodes.on(e,t)}));var r=this.body.data.nodes.getIds();this.add(r,!0)}!1===i&&this.body.emitter.emit("_dataChanged")}},{key:"add",value:function(t){for(var e,i=arguments.length>1&&void 0!==arguments[1]&&arguments[1],o=[],n=0;n<t.length;n++){e=t[n];var s=this.body.data.nodes.get(e),r=this.create(s);o.push(r),this.body.nodes[e]=r}this.layoutEngine.positionInitially(o),!1===i&&this.body.emitter.emit("_dataChanged")}},{key:"update",value:function(t,e,i){for(var o=this.body.nodes,n=!1,s=0;s<t.length;s++){var r=t[s],a=o[r],h=e[s];void 0!==a?a.setOptions(h)&&(n=!0):(n=!0,a=this.create(h),o[r]=a)}n||void 0===i||(n=Pa(e).call(e,(function(t,e){var o=i[e];return o&&o.level!==t.level}))),!0===n?this.body.emitter.emit("_dataChanged"):this.body.emitter.emit("_dataUpdated")}},{key:"remove",value:function(t){for(var e=this.body.nodes,i=0;i<t.length;i++){delete e[t[i]]}this.body.emitter.emit("_dataChanged")}},{key:"create",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:nd;return new e(t,this.body,this.images,this.groups,this.options,this.defaultOptions)}},{key:"refresh",value:function(){var t=this,i=arguments.length>0&&void 0!==arguments[0]&&arguments[0];e.forEach(this.body.nodes,(function(e,o){var n=t.body.data.nodes.get(o);void 0!==n&&(!0===i&&e.setOptions({x:null,y:null}),e.setOptions({fixed:!1}),e.setOptions(n))}))}},{key:"getPositions",value:function(t){var e={};if(void 0!==t){if(!0===bi(t)){for(var i=0;i<t.length;i++)if(void 0!==this.body.nodes[t[i]]){var o=this.body.nodes[t[i]];e[t[i]]={x:Math.round(o.x),y:Math.round(o.y)}}}else if(void 0!==this.body.nodes[t]){var n=this.body.nodes[t];e[t]={x:Math.round(n.x),y:Math.round(n.y)}}}else for(var s=0;s<this.body.nodeIndices.length;s++){var r=this.body.nodes[this.body.nodeIndices[s]];e[this.body.nodeIndices[s]]={x:Math.round(r.x),y:Math.round(r.y)}}return e}},{key:"storePositions",value:function(){var t=[],e=this.body.data.nodes.getDataSet(),i=!0,o=!1,n=void 0;try{for(var s,r=Sa(e.get());!(i=(s=r.next()).done);i=!0){var a=s.value,h=a.id,d=this.body.nodes[h],l=Math.round(d.x),c=Math.round(d.y);a.x===l&&a.y===c||t.push({id:h,x:l,y:c})}}catch(t){o=!0,n=t}finally{try{i||null==r.return||r.return()}finally{if(o)throw n}}e.update(t)}},{key:"getBoundingBox",value:function(t){if(void 0!==this.body.nodes[t])return this.body.nodes[t].shape.boundingBox}},{key:"getConnectedNodes",value:function(t,e){var i=[];if(void 0!==this.body.nodes[t])for(var o=this.body.nodes[t],n={},s=0;s<o.edges.length;s++){var r=o.edges[s];"to"!==e&&r.toId==o.id?void 0===n[r.fromId]&&(i.push(r.fromId),n[r.fromId]=!0):"from"!==e&&r.fromId==o.id&&void 0===n[r.toId]&&(i.push(r.toId),n[r.toId]=!0)}return i}},{key:"getConnectedEdges",value:function(t){var e=[];if(void 0!==this.body.nodes[t])for(var i=this.body.nodes[t],o=0;o<i.edges.length;o++)e.push(i.edges[o].id);else console.log("NodeId provided for getConnectedEdges does not exist. Provided: ",t);return e}},{key:"moveNode",value:function(t,e,i){var o=this;void 0!==this.body.nodes[t]?(this.body.nodes[t].x=Number(e),this.body.nodes[t].y=Number(i),Io((function(){o.body.emitter.emit("startSimulation")}),0)):console.log("Node id supplied to moveNode does not exist. Provided: ",t)}}]),t}(),rd=La;G({target:"Reflect",stat:!0},{get:function t(e,i){var o,n,s=arguments.length<3?e:arguments[2];return W(e)===s?e[i]:(o=I.f(e,i))?O(o,"value")?o.value:void 0===o.get?void 0:o.get.call(s):_(n=xe(e))?t(n,i,s):void 0}});var ad=L.Reflect.get;var hd=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=kh(t)););return t},dd=r((function(t){function e(i,o,n){return"undefined"!=typeof Reflect&&ad?t.exports=e=ad:t.exports=e=function(t,e,i){var o=hd(t,e);if(o){var n=rd(o,e);return n.get?n.get.call(i):n.value}},e(i,o,n||i)}t.exports=e})),ld=Math.hypot,cd=Math.abs,ud=Math.sqrt,pd=!!ld&&ld(1/0,NaN)!==1/0;G({target:"Math",stat:!0,forced:pd},{hypot:function(t,e){for(var i,o,n=0,s=0,r=arguments.length,a=0;s<r;)a<(i=cd(arguments[s++]))?(n=n*(o=a/i)*o+1,a=i):n+=i>0?(o=i/a)*o:i;return a===1/0?1/0:a*ud(n)}});var fd=L.Math.hypot,vd=function(){function t(){ma(this,t)}return _a(t,null,[{key:"transform",value:function(t,e){bi(t)||(t=[t]);for(var i=e.point.x,o=e.point.y,n=e.angle,s=e.length,r=0;r<t.length;++r){var a=t[r],h=a.x*Math.cos(n)-a.y*Math.sin(n),d=a.x*Math.sin(n)+a.y*Math.cos(n);a.x=i+s*h,a.y=o+s*d}}},{key:"drawPath",value:function(t,e){t.beginPath(),t.moveTo(e[0].x,e[0].y);for(var i=1;i<e.length;++i)t.lineTo(e[i].x,e[i].y);t.closePath()}}]),t}(),gd=function(t){function e(){return ma(this,e),yh(this,kh(e).apply(this,arguments))}return Eh(e,t),_a(e,null,[{key:"draw",value:function(t,e){if(e.image){t.save(),t.translate(e.point.x,e.point.y),t.rotate(Math.PI/2+e.angle);var i=null!=e.imageWidth?e.imageWidth:e.image.width,o=null!=e.imageHeight?e.imageHeight:e.image.height;e.image.drawImageAtPosition(t,1,-i/2,0,i,o),t.restore()}return!1}}]),e}(vd),yd=function(t){function e(){return ma(this,e),yh(this,kh(e).apply(this,arguments))}return Eh(e,t),_a(e,null,[{key:"draw",value:function(t,e){var i=[{x:0,y:0},{x:-1,y:.3},{x:-.9,y:0},{x:-1,y:-.3}];return vd.transform(i,e),vd.drawPath(t,i),!0}}]),e}(vd),md=function(){function t(){ma(this,t)}return _a(t,null,[{key:"draw",value:function(t,e){var i=[{x:-1,y:0},{x:0,y:.3},{x:-.4,y:0},{x:0,y:-.3}];return vd.transform(i,e),vd.drawPath(t,i),!0}}]),t}(),bd=function(){function t(){ma(this,t)}return _a(t,null,[{key:"draw",value:function(t,e){var i={x:-.4,y:0};vd.transform(i,e),t.strokeStyle=t.fillStyle,t.fillStyle="rgba(0, 0, 0, 0)";var o=Math.PI,n=e.angle-o/2,s=e.angle+o/2;return t.beginPath(),t.arc(i.x,i.y,.4*e.length,n,s,!1),t.stroke(),!0}}]),t}(),wd=function(){function t(){ma(this,t)}return _a(t,null,[{key:"draw",value:function(t,e){var i={x:-.3,y:0};vd.transform(i,e),t.strokeStyle=t.fillStyle,t.fillStyle="rgba(0, 0, 0, 0)";var o=Math.PI,n=e.angle+o/2,s=e.angle+3*o/2;return t.beginPath(),t.arc(i.x,i.y,.4*e.length,n,s,!1),t.stroke(),!0}}]),t}(),kd=function(){function t(){ma(this,t)}return _a(t,null,[{key:"draw",value:function(t,e){var i=[{x:.02,y:0},{x:-1,y:.3},{x:-1,y:-.3}];return vd.transform(i,e),vd.drawPath(t,i),!0}}]),t}(),_d=function(){function t(){ma(this,t)}return _a(t,null,[{key:"draw",value:function(t,e){var i=[{x:0,y:.3},{x:0,y:-.3},{x:-1,y:0}];return vd.transform(i,e),vd.drawPath(t,i),!0}}]),t}(),xd=function(){function t(){ma(this,t)}return _a(t,null,[{key:"draw",value:function(t,e){var i={x:-.4,y:0};return vd.transform(i,e),ot(t,i.x,i.y,.4*e.length),!0}}]),t}(),Ed=function(){function t(){ma(this,t)}return _a(t,null,[{key:"draw",value:function(t,e){var i=[{x:0,y:.5},{x:0,y:-.5},{x:-.15,y:-.5},{x:-.15,y:.5}];return vd.transform(i,e),vd.drawPath(t,i),!0}}]),t}(),Od=function(){function t(){ma(this,t)}return _a(t,null,[{key:"draw",value:function(t,e){var i=[{x:0,y:.3},{x:0,y:-.3},{x:-.6,y:-.3},{x:-.6,y:.3}];return vd.transform(i,e),vd.drawPath(t,i),!0}}]),t}(),Cd=function(){function t(){ma(this,t)}return _a(t,null,[{key:"draw",value:function(t,e){var i=[{x:0,y:0},{x:-.5,y:-.3},{x:-1,y:0},{x:-.5,y:.3}];return vd.transform(i,e),vd.drawPath(t,i),!0}}]),t}(),Td=function(){function t(){ma(this,t)}return _a(t,null,[{key:"draw",value:function(t,e){var i=[{x:-1,y:.3},{x:-.5,y:0},{x:-1,y:-.3},{x:0,y:0}];return vd.transform(i,e),vd.drawPath(t,i),!0}}]),t}(),Sd=function(){function t(){ma(this,t)}return _a(t,null,[{key:"draw",value:function(t,e){var i;switch(e.type&&(i=e.type.toLowerCase()),i){case"image":return gd.draw(t,e);case"circle":return xd.draw(t,e);case"box":return Od.draw(t,e);case"crow":return md.draw(t,e);case"curve":return bd.draw(t,e);case"diamond":return Cd.draw(t,e);case"inv_curve":return wd.draw(t,e);case"triangle":return kd.draw(t,e);case"inv_triangle":return _d.draw(t,e);case"bar":return Ed.draw(t,e);case"vee":return Td.draw(t,e);case"arrow":default:return yd.draw(t,e)}}}]),t}();function Dd(t,e){var i=To(t);if(Ha){var o=Ha(t);e&&(o=zo(o).call(o,(function(e){return ja(t,e).enumerable}))),i.push.apply(i,o)}return i}var Md=function(){function t(e,i,o){ma(this,t),this._body=i,this._labelModule=o,this.color={},this.colorDirty=!0,this.hoverWidth=1.5,this.selectionWidth=2,this.setOptions(e),this.fromPoint=this.from,this.toPoint=this.to}return _a(t,[{key:"connect",value:function(){this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to]}},{key:"cleanup",value:function(){return!1}},{key:"setOptions",value:function(t){this.options=t,this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to],this.id=this.options.id}},{key:"drawLine",value:function(t,e,i,o){var n=arguments.length>4&&void 0!==arguments[4]?arguments[4]:this.getViaNode();t.strokeStyle=this.getColor(t,e),t.lineWidth=e.width,!1!==e.dashes?this._drawDashedLine(t,e,n):this._drawLine(t,e,n)}},{key:"_drawLine",value:function(t,e,i,o,n){if(this.from!=this.to)this._line(t,e,i,o,n);else{var s=this._getCircleData(t),r=nh(s,3),a=r[0],h=r[1],d=r[2];this._circle(t,e,a,h,d)}}},{key:"_drawDashedLine",value:function(t,e,i,o,n){t.lineCap="round";var s=bi(e.dashes)?e.dashes:[5,5];if(void 0!==t.setLineDash){if(t.save(),t.setLineDash(s),t.lineDashOffset=0,this.from!=this.to)this._line(t,e,i);else{var r=this._getCircleData(t),a=nh(r,3),h=a[0],d=a[1],l=a[2];this._circle(t,e,h,d,l)}t.setLineDash([0]),t.lineDashOffset=0,t.restore()}else{if(this.from!=this.to)at(t,this.from.x,this.from.y,this.to.x,this.to.y,s);else{var c=this._getCircleData(t),u=nh(c,3),p=u[0],f=u[1],v=u[2];this._circle(t,e,p,f,v)}this.enableShadow(t,e),t.stroke(),this.disableShadow(t,e)}}},{key:"findBorderPosition",value:function(t,e,i){return this.from!=this.to?this._findBorderPosition(t,e,i):this._findBorderPositionCircle(t,e,i)}},{key:"findBorderPositions",value:function(t){if(this.from!=this.to)return{from:this._findBorderPosition(this.from,t),to:this._findBorderPosition(this.to,t)};var e,i=qt(e=this._getCircleData(t)).call(e,0,2),o=nh(i,2),n=o[0],s=o[1];return{from:this._findBorderPositionCircle(this.from,t,{x:n,y:s,low:.25,high:.6,direction:-1}),to:this._findBorderPositionCircle(this.from,t,{x:n,y:s,low:.6,high:.8,direction:1})}}},{key:"_getCircleData",value:function(t){var e,i,o=this.from,n=this.options.selfReferenceSize;return void 0!==t&&void 0===o.shape.width&&o.shape.resize(t),o.shape.width>o.shape.height?(e=o.x+.5*o.shape.width,i=o.y-n):(e=o.x+n,i=o.y-.5*o.shape.height),[e,i,n]}},{key:"_pointOnCircle",value:function(t,e,i,o){var n=2*o*Math.PI;return{x:t+i*Math.cos(n),y:e-i*Math.sin(n)}}},{key:"_findBorderPositionCircle",value:function(t,e,i){var o,n=i.x,s=i.y,r=i.low,a=i.high,h=i.direction,d=this.options.selfReferenceSize,l=.5*(r+a),c=0;do{l=.5*(r+a),o=this._pointOnCircle(n,s,d,l);var u=Math.atan2(t.y-o.y,t.x-o.x),p=t.distanceToBorder(e,u)-Math.sqrt(Math.pow(o.x-t.x,2)+Math.pow(o.y-t.y,2));if(Math.abs(p)<.05)break;p>0?h>0?r=l:a=l:h>0?a=l:r=l,++c}while(r<=a&&c<10);return function(t){for(var e=1;e<arguments.length;e++){var i,o=null!=arguments[e]?arguments[e]:{};if(e%2)yi(i=Dd(o,!0)).call(i,(function(e){Wa(t,e,o[e])}));else if(Na)Ba(t,Na(o));else{var n;yi(n=Dd(o)).call(n,(function(e){Fa(t,e,ja(o,e))}))}}return t}({},o,{t:l})}},{key:"getLineWidth",value:function(t,e){return!0===t?Math.max(this.selectionWidth,.3/this._body.view.scale):!0===e?Math.max(this.hoverWidth,.3/this._body.view.scale):Math.max(this.options.width,.3/this._body.view.scale)}},{key:"getColor",value:function(t,i){if(!1!==i.inheritsColor){if("both"===i.inheritsColor&&this.from.id!==this.to.id){var o=t.createLinearGradient(this.from.x,this.from.y,this.to.x,this.to.y),n=this.from.options.color.highlight.border,s=this.to.options.color.highlight.border;return!1===this.from.selected&&!1===this.to.selected?(n=e.overrideOpacity(this.from.options.color.border,i.opacity),s=e.overrideOpacity(this.to.options.color.border,i.opacity)):!0===this.from.selected&&!1===this.to.selected?s=this.to.options.color.border:!1===this.from.selected&&!0===this.to.selected&&(n=this.from.options.color.border),o.addColorStop(0,n),o.addColorStop(1,s),o}return"to"===i.inheritsColor?e.overrideOpacity(this.to.options.color.border,i.opacity):e.overrideOpacity(this.from.options.color.border,i.opacity)}return e.overrideOpacity(i.color,i.opacity)}},{key:"_circle",value:function(t,e,i,o,n){this.enableShadow(t,e),t.beginPath(),t.arc(i,o,n,0,2*Math.PI,!1),t.stroke(),this.disableShadow(t,e)}},{key:"getDistanceToEdge",value:function(t,e,i,o,n,s){if(this.from!=this.to)return this._getDistanceToEdge(t,e,i,o,n,s);var r=this._getCircleData(void 0),a=nh(r,3),h=a[0],d=a[1],l=a[2],c=h-n,u=d-s;return Math.abs(Math.sqrt(c*c+u*u)-l)}},{key:"_getDistanceToLine",value:function(t,e,i,o,n,s){var r=i-t,a=o-e,h=((n-t)*r+(s-e)*a)/(r*r+a*a);h>1?h=1:h<0&&(h=0);var d=t+h*r-n,l=e+h*a-s;return Math.sqrt(d*d+l*l)}},{key:"getArrowData",value:function(t,e,i,o,n,s){var r,a,h,d,l,c,u,p=s.width;"from"===e?(h=this.from,d=this.to,l=s.fromArrowScale<0,c=Math.abs(s.fromArrowScale),u=s.fromArrowType):"to"===e?(h=this.to,d=this.from,l=s.toArrowScale<0,c=Math.abs(s.toArrowScale),u=s.toArrowType):(h=this.to,d=this.from,l=s.middleArrowScale<0,c=Math.abs(s.middleArrowScale),u=s.middleArrowType);var f=15*c+3*p;if(h!=d){var v=f/fd(h.x-d.x,h.y-d.y);if("middle"!==e)if(!0===this.options.smooth.enabled){var g=this._findBorderPosition(h,t,{via:i}),y=this.getPoint(g.t+v*("from"===e?1:-1),i);r=Math.atan2(g.y-y.y,g.x-y.x),a=g}else r=Math.atan2(h.y-d.y,h.x-d.x),a=this._findBorderPosition(h,t);else{var m=(l?-v:v)/2,b=this.getPoint(.5+m,i),w=this.getPoint(.5-m,i);r=Math.atan2(b.y-w.y,b.x-w.x),a=this.getPoint(.5,i)}}else{var k=this._getCircleData(t),_=nh(k,3),x=_[0],E=_[1],O=_[2];if("from"===e){var C=this._findBorderPositionCircle(this.from,t,{x:x,y:E,low:.25,high:.6,direction:-1});r=-2*C.t*Math.PI+1.5*Math.PI+.1*Math.PI,a=C}else if("to"===e){var T=this._findBorderPositionCircle(this.from,t,{x:x,y:E,low:.6,high:1,direction:1});r=-2*T.t*Math.PI+1.5*Math.PI-1.1*Math.PI,a=T}else a=this._pointOnCircle(x,E,O,.175),r=3.9269908169872414}return{point:a,core:{x:a.x-.9*f*Math.cos(r),y:a.y-.9*f*Math.sin(r)},angle:r,length:f,type:u}}},{key:"drawArrowHead",value:function(t,e,i,o,n){t.strokeStyle=this.getColor(t,e),t.fillStyle=t.strokeStyle,t.lineWidth=e.width,Sd.draw(t,n)&&(this.enableShadow(t,e),Th(t).call(t),this.disableShadow(t,e))}},{key:"enableShadow",value:function(t,e){!0===e.shadow&&(t.shadowColor=e.shadowColor,t.shadowBlur=e.shadowSize,t.shadowOffsetX=e.shadowX,t.shadowOffsetY=e.shadowY)}},{key:"disableShadow",value:function(t,e){!0===e.shadow&&(t.shadowColor="rgba(0,0,0,0)",t.shadowBlur=0,t.shadowOffsetX=0,t.shadowOffsetY=0)}},{key:"drawBackground",value:function(t,e){if(!1!==e.background){var i={strokeStyle:t.strokeStyle,lineWidth:t.lineWidth,dashes:t.dashes};t.strokeStyle=e.backgroundColor,t.lineWidth=e.backgroundSize,this.setStrokeDashed(t,e.backgroundDashes),t.stroke(),t.strokeStyle=i.strokeStyle,t.lineWidth=i.lineWidth,t.dashes=i.dashes,this.setStrokeDashed(t,e.dashes)}}},{key:"setStrokeDashed",value:function(t,e){if(!1!==e)if(void 0!==t.setLineDash){var i=bi(e)?e:[5,5];t.setLineDash(i)}else console.warn("setLineDash is not supported in this browser. The dashed stroke cannot be used.");else void 0!==t.setLineDash?t.setLineDash([]):console.warn("setLineDash is not supported in this browser. The dashed stroke cannot be used.")}}]),t}();function Id(t,e){var i=To(t);if(Ha){var o=Ha(t);e&&(o=zo(o).call(o,(function(e){return ja(t,e).enumerable}))),i.push.apply(i,o)}return i}function Pd(t){for(var e=1;e<arguments.length;e++){var i,o=null!=arguments[e]?arguments[e]:{};if(e%2)yi(i=Id(o,!0)).call(i,(function(e){Wa(t,e,o[e])}));else if(Na)Ba(t,Na(o));else{var n;yi(n=Id(o)).call(n,(function(e){Fa(t,e,ja(o,e))}))}}return t}var Fd=function(t){function e(t,i,o){return ma(this,e),yh(this,kh(e).call(this,t,i,o))}return Eh(e,t),_a(e,[{key:"_findBorderPositionBezier",value:function(t,e){var i,o,n=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this._getViaCoordinates(),s=10,r=.2,a=!1,h=1,d=0,l=this.to;t.id===this.from.id&&(l=this.from,a=!0);var c=0;do{o=.5*(d+h),i=this.getPoint(o,n);var u=Math.atan2(l.y-i.y,l.x-i.x),p=l.distanceToBorder(e,u),f=Math.sqrt(Math.pow(i.x-l.x,2)+Math.pow(i.y-l.y,2)),v=p-f;if(Math.abs(v)<r)break;v<0?!1===a?d=o:h=o:!1===a?h=o:d=o,++c}while(d<=h&&c<s);return Pd({},i,{t:o})}},{key:"_getDistanceToBezierEdge",value:function(t,e,i,o,n,s,r){var a,h,d,l,c,u=1e9,p=t,f=e;for(h=1;h<10;h++)d=.1*h,l=Math.pow(1-d,2)*t+2*d*(1-d)*r.x+Math.pow(d,2)*i,c=Math.pow(1-d,2)*e+2*d*(1-d)*r.y+Math.pow(d,2)*o,h>0&&(u=(a=this._getDistanceToLine(p,f,l,c,n,s))<u?a:u),p=l,f=c;return u}},{key:"_bezierCurve",value:function(t,e,i,o){t.beginPath(),t.moveTo(this.fromPoint.x,this.fromPoint.y),null!=i&&null!=i.x?null!=o&&null!=o.x?t.bezierCurveTo(i.x,i.y,o.x,o.y,this.toPoint.x,this.toPoint.y):t.quadraticCurveTo(i.x,i.y,this.toPoint.x,this.toPoint.y):t.lineTo(this.toPoint.x,this.toPoint.y),this.drawBackground(t,e),this.enableShadow(t,e),t.stroke(),this.disableShadow(t,e)}},{key:"getViaNode",value:function(){return this._getViaCoordinates()}}]),e}(Md),Bd=function(t){function e(t,i,o){var n;return ma(this,e),(n=yh(this,kh(e).call(this,t,i,o))).via=n.via,n._boundFunction=function(){n.positionBezierNode()},n._body.emitter.on("_repositionBezierNodes",n._boundFunction),n}return Eh(e,t),_a(e,[{key:"setOptions",value:function(t){dd(kh(e.prototype),"setOptions",this).call(this,t);var i=!1;this.options.physics!==t.physics&&(i=!0),this.options=t,this.id=this.options.id,this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to],this.setupSupportNode(),this.connect(),!0===i&&(this.via.setOptions({physics:this.options.physics}),this.positionBezierNode())}},{key:"connect",value:function(){this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to],void 0===this.from||void 0===this.to||!1===this.options.physics?this.via.setOptions({physics:!1}):this.from.id===this.to.id?this.via.setOptions({physics:!1}):this.via.setOptions({physics:!0})}},{key:"cleanup",value:function(){return this._body.emitter.off("_repositionBezierNodes",this._boundFunction),void 0!==this.via&&(delete this._body.nodes[this.via.id],this.via=void 0,!0)}},{key:"setupSupportNode",value:function(){if(void 0===this.via){var t="edgeId:"+this.id,e=this._body.functions.createNode({id:t,shape:"circle",physics:!0,hidden:!0});this._body.nodes[t]=e,this.via=e,this.via.parentEdgeId=this.id,this.positionBezierNode()}}},{key:"positionBezierNode",value:function(){void 0!==this.via&&void 0!==this.from&&void 0!==this.to?(this.via.x=.5*(this.from.x+this.to.x),this.via.y=.5*(this.from.y+this.to.y)):void 0!==this.via&&(this.via.x=0,this.via.y=0)}},{key:"_line",value:function(t,e,i){this._bezierCurve(t,e,i)}},{key:"_getViaCoordinates",value:function(){return this.via}},{key:"getViaNode",value:function(){return this.via}},{key:"getPoint",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.via;if(this.from===this.to){var i=this._getCircleData(),o=nh(i,3),n=o[0],s=o[1],r=o[2],a=2*Math.PI*(1-t);return{x:n+r*Math.sin(a),y:s+r-r*(1-Math.cos(a))}}return{x:Math.pow(1-t,2)*this.fromPoint.x+2*t*(1-t)*e.x+Math.pow(t,2)*this.toPoint.x,y:Math.pow(1-t,2)*this.fromPoint.y+2*t*(1-t)*e.y+Math.pow(t,2)*this.toPoint.y}}},{key:"_findBorderPosition",value:function(t,e){return this._findBorderPositionBezier(t,e,this.via)}},{key:"_getDistanceToEdge",value:function(t,e,i,o,n,s){return this._getDistanceToBezierEdge(t,e,i,o,n,s,this.via)}}]),e}(Fd),zd=function(t){function e(t,i,o){return ma(this,e),yh(this,kh(e).call(this,t,i,o))}return Eh(e,t),_a(e,[{key:"_line",value:function(t,e,i){this._bezierCurve(t,e,i)}},{key:"getViaNode",value:function(){return this._getViaCoordinates()}},{key:"_getViaCoordinates",value:function(){var t,e,i=this.options.smooth.roundness,o=this.options.smooth.type,n=Math.abs(this.from.x-this.to.x),s=Math.abs(this.from.y-this.to.y);if("discrete"===o||"diagonalCross"===o){var r,a;r=a=n<=s?i*s:i*n,this.from.x>this.to.x&&(r=-r),this.from.y>=this.to.y&&(a=-a);var h=this.from.x+r,d=this.from.y+a;return"discrete"===o&&(n<=s?h=n<i*s?this.from.x:h:d=s<i*n?this.from.y:d),{x:h,y:d}}if("straightCross"===o){var l=(1-i)*n,c=(1-i)*s;return n<=s?(l=0,this.from.y<this.to.y&&(c=-c)):(this.from.x<this.to.x&&(l=-l),c=0),{x:this.to.x+l,y:this.to.y+c}}if("horizontal"===o){var u=(1-i)*n;return this.from.x<this.to.x&&(u=-u),{x:this.to.x+u,y:this.from.y}}if("vertical"===o){var p=(1-i)*s;return this.from.y<this.to.y&&(p=-p),{x:this.from.x,y:this.to.y+p}}if("curvedCW"===o){n=this.to.x-this.from.x,s=this.from.y-this.to.y;var f=Math.sqrt(n*n+s*s),v=Math.PI,g=(Math.atan2(s,n)+(.5*i+.5)*v)%(2*v);return{x:this.from.x+(.5*i+.5)*f*Math.sin(g),y:this.from.y+(.5*i+.5)*f*Math.cos(g)}}if("curvedCCW"===o){n=this.to.x-this.from.x,s=this.from.y-this.to.y;var y=Math.sqrt(n*n+s*s),m=Math.PI,b=(Math.atan2(s,n)+(.5*-i+.5)*m)%(2*m);return{x:this.from.x+(.5*i+.5)*y*Math.sin(b),y:this.from.y+(.5*i+.5)*y*Math.cos(b)}}t=e=n<=s?i*s:i*n,this.from.x>this.to.x&&(t=-t),this.from.y>=this.to.y&&(e=-e);var w=this.from.x+t,k=this.from.y+e;return n<=s?w=this.from.x<=this.to.x?this.to.x<w?this.to.x:w:this.to.x>w?this.to.x:w:k=this.from.y>=this.to.y?this.to.y>k?this.to.y:k:this.to.y<k?this.to.y:k,{x:w,y:k}}},{key:"_findBorderPosition",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};return this._findBorderPositionBezier(t,e,i.via)}},{key:"_getDistanceToEdge",value:function(t,e,i,o,n,s){var r=arguments.length>6&&void 0!==arguments[6]?arguments[6]:this._getViaCoordinates();return this._getDistanceToBezierEdge(t,e,i,o,n,s,r)}},{key:"getPoint",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this._getViaCoordinates(),i=t,o=Math.pow(1-i,2)*this.fromPoint.x+2*i*(1-i)*e.x+Math.pow(i,2)*this.toPoint.x,n=Math.pow(1-i,2)*this.fromPoint.y+2*i*(1-i)*e.y+Math.pow(i,2)*this.toPoint.y;return{x:o,y:n}}}]),e}(Fd),Nd=function(t){function e(t,i,o){return ma(this,e),yh(this,kh(e).call(this,t,i,o))}return Eh(e,t),_a(e,[{key:"_line",value:function(t,e,i){var o=i[0],n=i[1];this._bezierCurve(t,e,o,n)}},{key:"_getViaCoordinates",value:function(){var t,e,i,o,n=this.from.x-this.to.x,s=this.from.y-this.to.y,r=this.options.smooth.roundness;return(Math.abs(n)>Math.abs(s)||!0===this.options.smooth.forceDirection||"horizontal"===this.options.smooth.forceDirection)&&"vertical"!==this.options.smooth.forceDirection?(e=this.from.y,o=this.to.y,t=this.from.x-r*n,i=this.to.x+r*n):(e=this.from.y-r*s,o=this.to.y+r*s,t=this.from.x,i=this.to.x),[{x:t,y:e},{x:i,y:o}]}},{key:"getViaNode",value:function(){return this._getViaCoordinates()}},{key:"_findBorderPosition",value:function(t,e){return this._findBorderPositionBezier(t,e)}},{key:"_getDistanceToEdge",value:function(t,e,i,o,n,s){var r=arguments.length>6&&void 0!==arguments[6]?arguments[6]:this._getViaCoordinates(),a=nh(r,2),h=a[0],d=a[1];return this._getDistanceToBezierEdge2(t,e,i,o,n,s,h,d)}},{key:"getPoint",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this._getViaCoordinates(),i=nh(e,2),o=i[0],n=i[1],s=t,r=[Math.pow(1-s,3),3*s*Math.pow(1-s,2),3*Math.pow(s,2)*(1-s),Math.pow(s,3)],a=r[0]*this.fromPoint.x+r[1]*o.x+r[2]*n.x+r[3]*this.toPoint.x,h=r[0]*this.fromPoint.y+r[1]*o.y+r[2]*n.y+r[3]*this.toPoint.y;return{x:a,y:h}}}]),e}(function(t){function e(t,i,o){return ma(this,e),yh(this,kh(e).call(this,t,i,o))}return Eh(e,t),_a(e,[{key:"_getDistanceToBezierEdge2",value:function(t,e,i,o,n,s,r,a){for(var h=1e9,d=t,l=e,c=[0,0,0,0],u=1;u<10;u++){var p=.1*u;c[0]=Math.pow(1-p,3),c[1]=3*p*Math.pow(1-p,2),c[2]=3*Math.pow(p,2)*(1-p),c[3]=Math.pow(p,3);var f=c[0]*t+c[1]*r.x+c[2]*a.x+c[3]*i,v=c[0]*e+c[1]*r.y+c[2]*a.y+c[3]*o;if(u>0){var g=this._getDistanceToLine(d,l,f,v,n,s);h=g<h?g:h}d=f,l=v}return h}}]),e}(Fd)),Ad=function(t){function e(t,i,o){return ma(this,e),yh(this,kh(e).call(this,t,i,o))}return Eh(e,t),_a(e,[{key:"_line",value:function(t,e){t.beginPath(),t.moveTo(this.fromPoint.x,this.fromPoint.y),t.lineTo(this.toPoint.x,this.toPoint.y),this.enableShadow(t,e),t.stroke(),this.disableShadow(t,e)}},{key:"getViaNode",value:function(){}},{key:"getPoint",value:function(t){return{x:(1-t)*this.fromPoint.x+t*this.toPoint.x,y:(1-t)*this.fromPoint.y+t*this.toPoint.y}}},{key:"_findBorderPosition",value:function(t,e){var i=this.to,o=this.from;t.id===this.from.id&&(i=this.from,o=this.to);var n=Math.atan2(i.y-o.y,i.x-o.x),s=i.x-o.x,r=i.y-o.y,a=Math.sqrt(s*s+r*r),h=(a-t.distanceToBorder(e,n))/a;return{x:(1-h)*o.x+h*i.x,y:(1-h)*o.y+h*i.y,t:0}}},{key:"_getDistanceToEdge",value:function(t,e,i,o,n,s){return this._getDistanceToLine(t,e,i,o,n,s)}}]),e}(Md),Rd=function(){function t(i,o,n,s,r){if(ma(this,t),void 0===o)throw new Error("No body provided");this.options=e.bridgeObject(s),this.globalOptions=s,this.defaultOptions=r,this.body=o,this.imagelist=n,this.id=void 0,this.fromId=void 0,this.toId=void 0,this.selected=!1,this.hover=!1,this.labelDirty=!0,this.baseWidth=this.options.width,this.baseFontSize=this.options.font.size,this.from=void 0,this.to=void 0,this.edgeType=void 0,this.connected=!1,this.labelModule=new vh(this.body,this.options,!0),this.setOptions(i)}return _a(t,[{key:"setOptions",value:function(e){if(e){var i=void 0!==e.physics&&this.options.physics!==e.physics||void 0!==e.hidden&&(this.options.hidden||!1)!==(e.hidden||!1)||void 0!==e.from&&this.options.from!==e.from||void 0!==e.to&&this.options.to!==e.to;t.parseOptions(this.options,e,!0,this.globalOptions),void 0!==e.id&&(this.id=e.id),void 0!==e.from&&(this.fromId=e.from),void 0!==e.to&&(this.toId=e.to),void 0!==e.title&&(this.title=e.title),void 0!==e.value&&(e.value=Ya(e.value));var o=[e,this.options,this.defaultOptions];return this.chooser=sh.choosify("edge",o),this.updateLabelModule(e),i=this.updateEdgeType()||i,this._setInteractionWidths(),this.connect(),i}}},{key:"getFormattingValues",value:function(){var t=!0===this.options.arrows.to||!0===this.options.arrows.to.enabled,e=!0===this.options.arrows.from||!0===this.options.arrows.from.enabled,i=!0===this.options.arrows.middle||!0===this.options.arrows.middle.enabled,o=this.options.color.inherit,n={toArrow:t,toArrowScale:this.options.arrows.to.scaleFactor,toArrowType:this.options.arrows.to.type,toArrowSrc:this.options.arrows.to.src,toArrowImageWidth:this.options.arrows.to.imageWidth,toArrowImageHeight:this.options.arrows.to.imageHeight,middleArrow:i,middleArrowScale:this.options.arrows.middle.scaleFactor,middleArrowType:this.options.arrows.middle.type,middleArrowSrc:this.options.arrows.middle.src,middleArrowImageWidth:this.options.arrows.middle.imageWidth,middleArrowImageHeight:this.options.arrows.middle.imageHeight,fromArrow:e,fromArrowScale:this.options.arrows.from.scaleFactor,fromArrowType:this.options.arrows.from.type,fromArrowSrc:this.options.arrows.from.src,fromArrowImageWidth:this.options.arrows.from.imageWidth,fromArrowImageHeight:this.options.arrows.from.imageHeight,arrowStrikethrough:this.options.arrowStrikethrough,color:o?void 0:this.options.color.color,inheritsColor:o,opacity:this.options.color.opacity,hidden:this.options.hidden,length:this.options.length,shadow:this.options.shadow.enabled,shadowColor:this.options.shadow.color,shadowSize:this.options.shadow.size,shadowX:this.options.shadow.x,shadowY:this.options.shadow.y,dashes:this.options.dashes,width:this.options.width,background:this.options.background.enabled,backgroundColor:this.options.background.color,backgroundSize:this.options.background.size,backgroundDashes:this.options.background.dashes};if(this.selected||this.hover)if(!0===this.chooser){if(this.selected){var s=this.options.selectionWidth;"function"==typeof s?n.width=s(n.width):"number"==typeof s&&(n.width+=s),n.width=Math.max(n.width,.3/this.body.view.scale),n.color=this.options.color.highlight,n.shadow=this.options.shadow.enabled}else if(this.hover){var r=this.options.hoverWidth;"function"==typeof r?n.width=r(n.width):"number"==typeof r&&(n.width+=r),n.width=Math.max(n.width,.3/this.body.view.scale),n.color=this.options.color.hover,n.shadow=this.options.shadow.enabled}}else"function"==typeof this.chooser&&(this.chooser(n,this.options.id,this.selected,this.hover),void 0!==n.color&&(n.inheritsColor=!1),!1===n.shadow&&(n.shadowColor===this.options.shadow.color&&n.shadowSize===this.options.shadow.size&&n.shadowX===this.options.shadow.x&&n.shadowY===this.options.shadow.y||(n.shadow=!0)));else n.shadow=this.options.shadow.enabled,n.width=Math.max(n.width,.3/this.body.view.scale);return n}},{key:"updateLabelModule",value:function(t){var e=[t,this.options,this.globalOptions,this.defaultOptions];this.labelModule.update(this.options,e),void 0!==this.labelModule.baseSize&&(this.baseFontSize=this.labelModule.baseSize)}},{key:"updateEdgeType",value:function(){var t=this.options.smooth,e=!1,i=!0;return void 0!==this.edgeType&&((this.edgeType instanceof Bd&&!0===t.enabled&&"dynamic"===t.type||this.edgeType instanceof Nd&&!0===t.enabled&&"cubicBezier"===t.type||this.edgeType instanceof zd&&!0===t.enabled&&"dynamic"!==t.type&&"cubicBezier"!==t.type||this.edgeType instanceof Ad&&!1===t.type.enabled)&&(i=!1),!0===i&&(e=this.cleanup())),!0===i?!0===t.enabled?"dynamic"===t.type?(e=!0,this.edgeType=new Bd(this.options,this.body,this.labelModule)):"cubicBezier"===t.type?this.edgeType=new Nd(this.options,this.body,this.labelModule):this.edgeType=new zd(this.options,this.body,this.labelModule):this.edgeType=new Ad(this.options,this.body,this.labelModule):this.edgeType.setOptions(this.options),e}},{key:"connect",value:function(){this.disconnect(),this.from=this.body.nodes[this.fromId]||void 0,this.to=this.body.nodes[this.toId]||void 0,this.connected=void 0!==this.from&&void 0!==this.to,!0===this.connected?(this.from.attachEdge(this),this.to.attachEdge(this)):(this.from&&this.from.detachEdge(this),this.to&&this.to.detachEdge(this)),this.edgeType.connect()}},{key:"disconnect",value:function(){this.from&&(this.from.detachEdge(this),this.from=void 0),this.to&&(this.to.detachEdge(this),this.to=void 0),this.connected=!1}},{key:"getTitle",value:function(){return this.title}},{key:"isSelected",value:function(){return this.selected}},{key:"getValue",value:function(){return this.options.value}},{key:"setValueRange",value:function(t,e,i){if(void 0!==this.options.value){var o=this.options.scaling.customScalingFunction(t,e,i,this.options.value),n=this.options.scaling.max-this.options.scaling.min;if(!0===this.options.scaling.label.enabled){var s=this.options.scaling.label.max-this.options.scaling.label.min;this.options.font.size=this.options.scaling.label.min+o*s}this.options.width=this.options.scaling.min+o*n}else this.options.width=this.baseWidth,this.options.font.size=this.baseFontSize;this._setInteractionWidths(),this.updateLabelModule()}},{key:"_setInteractionWidths",value:function(){"function"==typeof this.options.hoverWidth?this.edgeType.hoverWidth=this.options.hoverWidth(this.options.width):this.edgeType.hoverWidth=this.options.hoverWidth+this.options.width,"function"==typeof this.options.selectionWidth?this.edgeType.selectionWidth=this.options.selectionWidth(this.options.width):this.edgeType.selectionWidth=this.options.selectionWidth+this.options.width}},{key:"draw",value:function(t){var e=this.getFormattingValues();if(!e.hidden){var i=this.edgeType.getViaNode(),o={};this.edgeType.fromPoint=this.edgeType.from,this.edgeType.toPoint=this.edgeType.to,e.fromArrow&&(o.from=this.edgeType.getArrowData(t,"from",i,this.selected,this.hover,e),!1===e.arrowStrikethrough&&(this.edgeType.fromPoint=o.from.core),e.fromArrowSrc&&(o.from.image=this.imagelist.load(e.fromArrowSrc)),e.fromArrowImageWidth&&(o.from.imageWidth=e.fromArrowImageWidth),e.fromArrowImageHeight&&(o.from.imageHeight=e.fromArrowImageHeight)),e.toArrow&&(o.to=this.edgeType.getArrowData(t,"to",i,this.selected,this.hover,e),!1===e.arrowStrikethrough&&(this.edgeType.toPoint=o.to.core),e.toArrowSrc&&(o.to.image=this.imagelist.load(e.toArrowSrc)),e.toArrowImageWidth&&(o.to.imageWidth=e.toArrowImageWidth),e.toArrowImageHeight&&(o.to.imageHeight=e.toArrowImageHeight)),e.middleArrow&&(o.middle=this.edgeType.getArrowData(t,"middle",i,this.selected,this.hover,e),e.middleArrowSrc&&(o.middle.image=this.imagelist.load(e.middleArrowSrc)),e.middleArrowImageWidth&&(o.middle.imageWidth=e.middleArrowImageWidth),e.middleArrowImageHeight&&(o.middle.imageHeight=e.middleArrowImageHeight)),this.edgeType.drawLine(t,e,this.selected,this.hover,i),this.drawArrows(t,o,e),this.drawLabel(t,i)}}},{key:"drawArrows",value:function(t,e,i){i.fromArrow&&this.edgeType.drawArrowHead(t,i,this.selected,this.hover,e.from),i.middleArrow&&this.edgeType.drawArrowHead(t,i,this.selected,this.hover,e.middle),i.toArrow&&this.edgeType.drawArrowHead(t,i,this.selected,this.hover,e.to)}},{key:"drawLabel",value:function(t,e){if(void 0!==this.options.label){var i=this.from,o=this.to;if(this.labelModule.differentState(this.selected,this.hover)&&this.labelModule.getTextSize(t,this.selected,this.hover),i.id!=o.id){this.labelModule.pointToSelf=!1;var n=this.edgeType.getPoint(.5,e);t.save();var s=this._getRotation(t);0!=s.angle&&(t.translate(s.x,s.y),t.rotate(s.angle)),this.labelModule.draw(t,n.x,n.y,this.selected,this.hover),t.restore()}else{var r,a;this.labelModule.pointToSelf=!0;var h=this.options.selfReferenceSize;i.shape.width>i.shape.height?(r=i.x+.5*i.shape.width,a=i.y-h):(r=i.x+h,a=i.y-.5*i.shape.height),n=this._pointOnCircle(r,a,h,.125),this.labelModule.draw(t,n.x,n.y,this.selected,this.hover)}}}},{key:"getItemsOnPoint",value:function(t){var e=[];if(this.labelModule.visible()){var i=this._getRotation();sh.pointInRect(this.labelModule.getSize(),t,i)&&e.push({edgeId:this.id,labelId:0})}var o={left:t.x,top:t.y};return this.isOverlappingWith(o)&&e.push({edgeId:this.id}),e}},{key:"isOverlappingWith",value:function(t){if(this.connected){var e=this.from.x,i=this.from.y,o=this.to.x,n=this.to.y,s=t.left,r=t.top;return this.edgeType.getDistanceToEdge(e,i,o,n,s,r)<10}return!1}},{key:"_getRotation",value:function(t){var e=this.edgeType.getViaNode(),i=this.edgeType.getPoint(.5,e);void 0!==t&&this.labelModule.calculateLabelSize(t,this.selected,this.hover,i.x,i.y);var o={x:i.x,y:this.labelModule.size.yLine,angle:0};if(!this.labelModule.visible())return o;if("horizontal"===this.options.font.align)return o;var n=this.from.y-this.to.y,s=this.from.x-this.to.x,r=Math.atan2(n,s);return(r<-1&&s<0||r>0&&s<0)&&(r+=Math.PI),o.angle=r,o}},{key:"_pointOnCircle",value:function(t,e,i,o){var n=2*o*Math.PI;return{x:t+i*Math.cos(n),y:e-i*Math.sin(n)}}},{key:"select",value:function(){this.selected=!0}},{key:"unselect",value:function(){this.selected=!1}},{key:"cleanup",value:function(){return this.edgeType.cleanup()}},{key:"remove",value:function(){this.cleanup(),this.disconnect(),delete this.body.edges[this.id]}},{key:"endPointsValid",value:function(){return void 0!==this.body.nodes[this.fromId]&&void 0!==this.body.nodes[this.toId]}}],[{key:"parseOptions",value:function(t,i){var o=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},s=arguments.length>4&&void 0!==arguments[4]&&arguments[4],r=["arrowStrikethrough","id","from","hidden","hoverWidth","labelHighlightBold","length","line","opacity","physics","scaling","selectionWidth","selfReferenceSize","to","title","value","width","font","chosen","widthConstraint"];if(e.selectiveDeepExtend(r,t,i,o),sh.isValidLabel(i.label)?t.label=i.label:sh.isValidLabel(t.label)||(t.label=void 0),e.mergeOptions(t,i,"smooth",n),e.mergeOptions(t,i,"shadow",n),e.mergeOptions(t,i,"background",n),void 0!==i.dashes&&null!==i.dashes?t.dashes=i.dashes:!0===o&&null===i.dashes&&(t.dashes=Ri(n.dashes)),void 0!==i.scaling&&null!==i.scaling?(void 0!==i.scaling.min&&(t.scaling.min=i.scaling.min),void 0!==i.scaling.max&&(t.scaling.max=i.scaling.max),e.mergeOptions(t.scaling,i.scaling,"label",n.scaling)):!0===o&&null===i.scaling&&(t.scaling=Ri(n.scaling)),void 0!==i.arrows&&null!==i.arrows)if("string"==typeof i.arrows){var a=i.arrows.toLowerCase();t.arrows.to.enabled=-1!=zi(a).call(a,"to"),t.arrows.middle.enabled=-1!=zi(a).call(a,"middle"),t.arrows.from.enabled=-1!=zi(a).call(a,"from")}else{if("object"!==os(i.arrows))throw new Error("The arrow newOptions can only be an object or a string. Refer to the documentation. You used:"+Qh(i.arrows));e.mergeOptions(t.arrows,i.arrows,"to",n.arrows),e.mergeOptions(t.arrows,i.arrows,"middle",n.arrows),e.mergeOptions(t.arrows,i.arrows,"from",n.arrows)}else!0===o&&null===i.arrows&&(t.arrows=Ri(n.arrows));if(void 0!==i.color&&null!==i.color){var h=e.isString(i.color)?{color:i.color,highlight:i.color,hover:i.color,inherit:!1,opacity:1}:i.color,d=t.color;if(s)e.deepExtend(d,n.color,!1,o);else for(var l in d)d.hasOwnProperty(l)&&delete d[l];if(e.isString(d))d.color=d,d.highlight=d,d.hover=d,d.inherit=!1,void 0===h.opacity&&(d.opacity=1);else{var c=!1;void 0!==h.color&&(d.color=h.color,c=!0),void 0!==h.highlight&&(d.highlight=h.highlight,c=!0),void 0!==h.hover&&(d.hover=h.hover,c=!0),void 0!==h.inherit&&(d.inherit=h.inherit),void 0!==h.opacity&&(d.opacity=Math.min(1,Math.max(0,h.opacity))),!0===c?d.inherit=!1:void 0===d.inherit&&(d.inherit="from")}}else!0===o&&null===i.color&&(t.color=e.bridgeObject(n.color));!0===o&&null===i.font&&(t.font=e.bridgeObject(n.font))}}]),t}(),Ld=function(){function t(i,o,n){var s,r=this;ma(this,t),this.body=i,this.images=o,this.groups=n,this.body.functions.createEdge=it(s=this.create).call(s,this),this.edgesListeners={add:function(t,e){r.add(e.items)},update:function(t,e){r.update(e.items)},remove:function(t,e){r.remove(e.items)}},this.options={},this.defaultOptions={arrows:{to:{enabled:!1,scaleFactor:1,type:"arrow"},middle:{enabled:!1,scaleFactor:1,type:"arrow"},from:{enabled:!1,scaleFactor:1,type:"arrow"}},arrowStrikethrough:!0,color:{color:"#848484",highlight:"#848484",hover:"#848484",inherit:"from",opacity:1},dashes:!1,font:{color:"#343434",size:14,face:"arial",background:"none",strokeWidth:2,strokeColor:"#ffffff",align:"horizontal",multi:!1,vadjust:0,bold:{mod:"bold"},boldital:{mod:"bold italic"},ital:{mod:"italic"},mono:{mod:"",size:15,face:"courier new",vadjust:2}},hidden:!1,hoverWidth:1.5,label:void 0,labelHighlightBold:!0,length:void 0,physics:!0,scaling:{min:1,max:15,label:{enabled:!0,min:14,max:30,maxVisible:30,drawThreshold:5},customScalingFunction:function(t,e,i,o){if(e===t)return.5;var n=1/(e-t);return Math.max(0,(o-t)*n)}},selectionWidth:1.5,selfReferenceSize:20,shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:10,x:5,y:5},background:{enabled:!1,color:"rgba(111,111,111,1)",size:10,dashes:!1},smooth:{enabled:!0,type:"dynamic",forceDirection:"none",roundness:.5},title:void 0,width:1,value:void 0},e.deepExtend(this.options,this.defaultOptions),this.bindEventListeners()}return _a(t,[{key:"bindEventListeners",value:function(){var t,i,o=this;this.body.emitter.on("_forceDisableDynamicCurves",(function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];"dynamic"===t&&(t="continuous");var i=!1;for(var n in o.body.edges)if(o.body.edges.hasOwnProperty(n)){var s=o.body.edges[n],r=o.body.data.edges.get(n);if(void 0!==r){var a=r.smooth;void 0!==a&&!0===a.enabled&&"dynamic"===a.type&&(void 0===t?s.setOptions({smooth:!1}):s.setOptions({smooth:{type:t}}),i=!0)}}!0===e&&!0===i&&o.body.emitter.emit("_dataChanged")})),this.body.emitter.on("_dataUpdated",(function(){o.reconnectEdges()})),this.body.emitter.on("refreshEdges",it(t=this.refresh).call(t,this)),this.body.emitter.on("refresh",it(i=this.refresh).call(i,this)),this.body.emitter.on("destroy",(function(){e.forEach(o.edgesListeners,(function(t,e){o.body.data.edges&&o.body.data.edges.off(e,t)})),delete o.body.functions.createEdge,delete o.edgesListeners.add,delete o.edgesListeners.update,delete o.edgesListeners.remove,delete o.edgesListeners}))}},{key:"setOptions",value:function(t){if(void 0!==t){Rd.parseOptions(this.options,t,!0,this.defaultOptions,!0);var e=!1;if(void 0!==t.smooth)for(var i in this.body.edges)this.body.edges.hasOwnProperty(i)&&(e=this.body.edges[i].updateEdgeType()||e);if(void 0!==t.font)for(var o in this.body.edges)this.body.edges.hasOwnProperty(o)&&this.body.edges[o].updateLabelModule();void 0===t.hidden&&void 0===t.physics&&!0!==e||this.body.emitter.emit("_dataChanged")}}},{key:"setData",value:function(t){var i=this,n=arguments.length>1&&void 0!==arguments[1]&&arguments[1],s=this.body.data.edges;if(t instanceof o.DataSet||t instanceof o.DataView)this.body.data.edges=t;else if(bi(t))this.body.data.edges=new o.DataSet,this.body.data.edges.add(t);else{if(t)throw new TypeError("Array or DataSet expected");this.body.data.edges=new o.DataSet}if(s&&e.forEach(this.edgesListeners,(function(t,e){s.off(e,t)})),this.body.edges={},this.body.data.edges){e.forEach(this.edgesListeners,(function(t,e){i.body.data.edges.on(e,t)}));var r=this.body.data.edges.getIds();this.add(r,!0)}this.body.emitter.emit("_adjustEdgesForHierarchicalLayout"),!1===n&&this.body.emitter.emit("_dataChanged")}},{key:"add",value:function(t){for(var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=this.body.edges,o=this.body.data.edges,n=0;n<t.length;n++){var s=t[n],r=i[s];r&&r.disconnect();var a=o.get(s,{showInternalIds:!0});i[s]=this.create(a)}this.body.emitter.emit("_adjustEdgesForHierarchicalLayout"),!1===e&&this.body.emitter.emit("_dataChanged")}},{key:"update",value:function(t){for(var e=this.body.edges,i=this.body.data.edges,o=!1,n=0;n<t.length;n++){var s=t[n],r=i.get(s),a=e[s];void 0!==a?(a.disconnect(),o=a.setOptions(r)||o,a.connect()):(this.body.edges[s]=this.create(r),o=!0)}!0===o?(this.body.emitter.emit("_adjustEdgesForHierarchicalLayout"),this.body.emitter.emit("_dataChanged")):this.body.emitter.emit("_dataUpdated")}},{key:"remove",value:function(t){var i=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if(0!==t.length){var o=this.body.edges;e.forEach(t,(function(t){var e=o[t];void 0!==e&&e.remove()})),i&&this.body.emitter.emit("_dataChanged")}}},{key:"refresh",value:function(){var t=this;e.forEach(this.body.edges,(function(e,i){var o=t.body.data.edges.get(i);void 0!==o&&e.setOptions(o)}))}},{key:"create",value:function(t){return new Rd(t,this.body,this.images,this.options,this.defaultOptions)}},{key:"reconnectEdges",value:function(){var t,e=this.body.nodes,i=this.body.edges;for(t in e)e.hasOwnProperty(t)&&(e[t].edges=[]);for(t in i)if(i.hasOwnProperty(t)){var o=i[t];o.from=null,o.to=null,o.connect()}}},{key:"getConnectedNodes",value:function(t){var e=[];if(void 0!==this.body.edges[t]){var i=this.body.edges[t];void 0!==i.fromId&&e.push(i.fromId),void 0!==i.toId&&e.push(i.toId)}return e}},{key:"_updateState",value:function(){this._addMissingEdges(),this._removeInvalidEdges()}},{key:"_removeInvalidEdges",value:function(){var t=this,i=[];e.forEach(this.body.edges,(function(e,o){var n=t.body.nodes[e.toId],s=t.body.nodes[e.fromId];void 0!==n&&!0===n.isCluster||void 0!==s&&!0===s.isCluster||void 0!==n&&void 0!==s||i.push(o)})),this.remove(i,!1)}},{key:"_addMissingEdges",value:function(){var t=this.body.data.edges;if(null!=t){var e=this.body.edges,i=[];yi(t).call(t,(function(t,o){void 0===e[o]&&i.push(o)})),this.add(i,!0)}}}]),t}(),jd=function(){function t(e,i,o){ma(this,t),this.body=e,this.physicsBody=i,this.barnesHutTree,this.setOptions(o),this.randomSeed=5}return _a(t,[{key:"setOptions",value:function(t){this.options=t,this.thetaInversed=1/this.options.theta,this.overlapAvoidanceFactor=1-Math.max(0,Math.min(1,this.options.avoidOverlap))}},{key:"seededRandom",value:function(){var t=1e4*Math.sin(this.randomSeed++);return t-Math.floor(t)}},{key:"solve",value:function(){if(0!==this.options.gravitationalConstant&&this.physicsBody.physicsNodeIndices.length>0){var t,e=this.body.nodes,i=this.physicsBody.physicsNodeIndices,o=i.length,n=this._formBarnesHutTree(e,i);this.barnesHutTree=n;for(var s=0;s<o;s++)(t=e[i[s]]).options.mass>0&&this._getForceContributions(n.root,t)}}},{key:"_getForceContributions",value:function(t,e){this._getForceContribution(t.children.NW,e),this._getForceContribution(t.children.NE,e),this._getForceContribution(t.children.SW,e),this._getForceContribution(t.children.SE,e)}},{key:"_getForceContribution",value:function(t,e){var i,o,n;t.childrenCount>0&&(i=t.centerOfMass.x-e.x,o=t.centerOfMass.y-e.y,(n=Math.sqrt(i*i+o*o))*t.calcSize>this.thetaInversed?this._calculateForces(n,i,o,e,t):4===t.childrenCount?this._getForceContributions(t,e):t.children.data.id!=e.id&&this._calculateForces(n,i,o,e,t))}},{key:"_calculateForces",value:function(t,e,i,o,n){0===t&&(e=t=.1),this.overlapAvoidanceFactor<1&&o.shape.radius&&(t=Math.max(.1+this.overlapAvoidanceFactor*o.shape.radius,t-o.shape.radius));var s=this.options.gravitationalConstant*n.mass*o.options.mass/Math.pow(t,3),r=e*s,a=i*s;this.physicsBody.forces[o.id].x+=r,this.physicsBody.forces[o.id].y+=a}},{key:"_formBarnesHutTree",value:function(t,e){for(var i,o=e.length,n=t[e[0]].x,s=t[e[0]].y,r=t[e[0]].x,a=t[e[0]].y,h=1;h<o;h++){var d=t[e[h]],l=d.x,c=d.y;d.options.mass>0&&(l<n&&(n=l),l>r&&(r=l),c<s&&(s=c),c>a&&(a=c))}var u=Math.abs(r-n)-Math.abs(a-s);u>0?(s-=.5*u,a+=.5*u):(n+=.5*u,r-=.5*u);var p=Math.max(1e-5,Math.abs(r-n)),f=.5*p,v=.5*(n+r),g=.5*(s+a),y={root:{centerOfMass:{x:0,y:0},mass:0,range:{minX:v-f,maxX:v+f,minY:g-f,maxY:g+f},size:p,calcSize:1/p,children:{data:null},maxWidth:0,level:0,childrenCount:4}};this._splitBranch(y.root);for(var m=0;m<o;m++)(i=t[e[m]]).options.mass>0&&this._placeInTree(y.root,i);return y}},{key:"_updateBranchMass",value:function(t,e){var i=t.centerOfMass,o=t.mass+e.options.mass,n=1/o;i.x=i.x*t.mass+e.x*e.options.mass,i.x*=n,i.y=i.y*t.mass+e.y*e.options.mass,i.y*=n,t.mass=o;var s=Math.max(Math.max(e.height,e.radius),e.width);t.maxWidth=t.maxWidth<s?s:t.maxWidth}},{key:"_placeInTree",value:function(t,e,i){1==i&&void 0!==i||this._updateBranchMass(t,e);var o,n=t.children.NW.range;o=n.maxX>e.x?n.maxY>e.y?"NW":"SW":n.maxY>e.y?"NE":"SE",this._placeInRegion(t,e,o)}},{key:"_placeInRegion",value:function(t,e,i){var o=t.children[i];switch(o.childrenCount){case 0:o.children.data=e,o.childrenCount=1,this._updateBranchMass(o,e);break;case 1:o.children.data.x===e.x&&o.children.data.y===e.y?(e.x+=this.seededRandom(),e.y+=this.seededRandom()):(this._splitBranch(o),this._placeInTree(o,e));break;case 4:this._placeInTree(o,e)}}},{key:"_splitBranch",value:function(t){var e=null;1===t.childrenCount&&(e=t.children.data,t.mass=0,t.centerOfMass.x=0,t.centerOfMass.y=0),t.childrenCount=4,t.children.data=null,this._insertRegion(t,"NW"),this._insertRegion(t,"NE"),this._insertRegion(t,"SW"),this._insertRegion(t,"SE"),null!=e&&this._placeInTree(t,e)}},{key:"_insertRegion",value:function(t,e){var i,o,n,s,r=.5*t.size;switch(e){case"NW":i=t.range.minX,o=t.range.minX+r,n=t.range.minY,s=t.range.minY+r;break;case"NE":i=t.range.minX+r,o=t.range.maxX,n=t.range.minY,s=t.range.minY+r;break;case"SW":i=t.range.minX,o=t.range.minX+r,n=t.range.minY+r,s=t.range.maxY;break;case"SE":i=t.range.minX+r,o=t.range.maxX,n=t.range.minY+r,s=t.range.maxY}t.children[e]={centerOfMass:{x:0,y:0},mass:0,range:{minX:i,maxX:o,minY:n,maxY:s},size:.5*t.size,calcSize:2*t.calcSize,children:{data:null},maxWidth:0,level:t.level+1,childrenCount:0}}},{key:"_debug",value:function(t,e){void 0!==this.barnesHutTree&&(t.lineWidth=1,this._drawBranch(this.barnesHutTree.root,t,e))}},{key:"_drawBranch",value:function(t,e,i){void 0===i&&(i="#FF0000"),4===t.childrenCount&&(this._drawBranch(t.children.NW,e),this._drawBranch(t.children.NE,e),this._drawBranch(t.children.SE,e),this._drawBranch(t.children.SW,e)),e.strokeStyle=i,e.beginPath(),e.moveTo(t.range.minX,t.range.minY),e.lineTo(t.range.maxX,t.range.minY),e.stroke(),e.beginPath(),e.moveTo(t.range.maxX,t.range.minY),e.lineTo(t.range.maxX,t.range.maxY),e.stroke(),e.beginPath(),e.moveTo(t.range.maxX,t.range.maxY),e.lineTo(t.range.minX,t.range.maxY),e.stroke(),e.beginPath(),e.moveTo(t.range.minX,t.range.maxY),e.lineTo(t.range.minX,t.range.minY),e.stroke()}}]),t}(),Hd=function(){function t(e,i,o){ma(this,t),this.body=e,this.physicsBody=i,this.setOptions(o)}return _a(t,[{key:"setOptions",value:function(t){this.options=t}},{key:"solve",value:function(){for(var t,e,i,o,n,s,r,a,h=this.body.nodes,d=this.physicsBody.physicsNodeIndices,l=this.physicsBody.forces,c=this.options.nodeDistance,u=-2/3/c,p=0;p<d.length-1;p++){r=h[d[p]];for(var f=p+1;f<d.length;f++)t=(a=h[d[f]]).x-r.x,e=a.y-r.y,0===(i=Math.sqrt(t*t+e*e))&&(t=i=.1*Math.random()),i<2*c&&(s=i<.5*c?1:u*i+4/3,o=t*(s/=i),n=e*s,l[r.id].x-=o,l[r.id].y-=n,l[a.id].x+=o,l[a.id].y+=n)}}}]),t}();var Wd=function(t){throw new Error('"'+t+'" is read-only')},Vd=function(){function t(e,i,o){ma(this,t),this.body=e,this.physicsBody=i,this.setOptions(o)}return _a(t,[{key:"setOptions",value:function(t){this.options=t,this.overlapAvoidanceFactor=Math.max(0,Math.min(1,this.options.avoidOverlap||0))}},{key:"solve",value:function(){for(var t=this.body.nodes,e=this.physicsBody.physicsNodeIndices,i=this.physicsBody.forces,o=this.options.nodeDistance,n=0;n<e.length-1;n++)for(var s=t[e[n]],r=n+1;r<e.length;r++){var a=t[e[r]];if(s.level===a.level){var h=o+this.overlapAvoidanceFactor*((s.shape.radius||0)/2+(a.shape.radius||0)/2),d=a.x-s.x,l=a.y-s.y,c=Math.sqrt(d*d+l*l),u=void 0;u=c<h?-Math.pow(.05*c,2)+Math.pow(.05*h,2):0,0===c?(Wd("distance"),c=.01):u/=c;var p=d*u,f=l*u;i[s.id].x-=p,i[s.id].y-=f,i[a.id].x+=p,i[a.id].y+=f}}}}]),t}(),qd=function(){function t(e,i,o){ma(this,t),this.body=e,this.physicsBody=i,this.setOptions(o)}return _a(t,[{key:"setOptions",value:function(t){this.options=t}},{key:"solve",value:function(){for(var t,e,i,o,n,s=this.physicsBody.physicsEdgeIndices,r=this.body.edges,a=0;a<s.length;a++)!0===(e=r[s[a]]).connected&&e.toId!==e.fromId&&void 0!==this.body.nodes[e.toId]&&void 0!==this.body.nodes[e.fromId]&&(void 0!==e.edgeType.via?(t=void 0===e.options.length?this.options.springLength:e.options.length,i=e.to,o=e.edgeType.via,n=e.from,this._calculateSpringForce(i,o,.5*t),this._calculateSpringForce(o,n,.5*t)):(t=void 0===e.options.length?1.5*this.options.springLength:e.options.length,this._calculateSpringForce(e.from,e.to,t)))}},{key:"_calculateSpringForce",value:function(t,e,i){var o=t.x-e.x,n=t.y-e.y,s=Math.max(Math.sqrt(o*o+n*n),.01),r=this.options.springConstant*(i-s)/s,a=o*r,h=n*r;void 0!==this.physicsBody.forces[t.id]&&(this.physicsBody.forces[t.id].x+=a,this.physicsBody.forces[t.id].y+=h),void 0!==this.physicsBody.forces[e.id]&&(this.physicsBody.forces[e.id].x-=a,this.physicsBody.forces[e.id].y-=h)}}]),t}(),Ud=function(){function t(e,i,o){ma(this,t),this.body=e,this.physicsBody=i,this.setOptions(o)}return _a(t,[{key:"setOptions",value:function(t){this.options=t}},{key:"solve",value:function(){for(var t,e,i,o,n,s,r,a,h,d,l=this.body.edges,c=this.physicsBody.physicsEdgeIndices,u=this.physicsBody.physicsNodeIndices,p=this.physicsBody.forces,f=0;f<u.length;f++){var v=u[f];p[v].springFx=0,p[v].springFy=0}for(var g=0;g<c.length;g++)!0===(e=l[c[g]]).connected&&(t=void 0===e.options.length?this.options.springLength:e.options.length,i=e.from.x-e.to.x,o=e.from.y-e.to.y,a=0===(a=Math.sqrt(i*i+o*o))?.01:a,n=i*(r=this.options.springConstant*(t-a)/a),s=o*r,e.to.level!=e.from.level?(void 0!==p[e.toId]&&(p[e.toId].springFx-=n,p[e.toId].springFy-=s),void 0!==p[e.fromId]&&(p[e.fromId].springFx+=n,p[e.fromId].springFy+=s)):(void 0!==p[e.toId]&&(p[e.toId].x-=.5*n,p[e.toId].y-=.5*s),void 0!==p[e.fromId]&&(p[e.fromId].x+=.5*n,p[e.fromId].y+=.5*s)));r=1;for(var y=0;y<u.length;y++){var m=u[y];h=Math.min(r,Math.max(-r,p[m].springFx)),d=Math.min(r,Math.max(-r,p[m].springFy)),p[m].x+=h,p[m].y+=d}for(var b=0,w=0,k=0;k<u.length;k++){var _=u[k];b+=p[_].x,w+=p[_].y}for(var x=b/u.length,E=w/u.length,O=0;O<u.length;O++){var C=u[O];p[C].x-=x,p[C].y-=E}}}]),t}(),Yd=function(){function t(e,i,o){ma(this,t),this.body=e,this.physicsBody=i,this.setOptions(o)}return _a(t,[{key:"setOptions",value:function(t){this.options=t}},{key:"solve",value:function(){for(var t,e,i,o,n=this.body.nodes,s=this.physicsBody.physicsNodeIndices,r=this.physicsBody.forces,a=0;a<s.length;a++){t=-(o=n[s[a]]).x,e=-o.y,i=Math.sqrt(t*t+e*e),this._calculateForces(i,t,e,r,o)}}},{key:"_calculateForces",value:function(t,e,i,o,n){var s=0===t?0:this.options.centralGravity/t;o[n.id].x=e*s,o[n.id].y=i*s}}]),t}(),Xd=function(t){function e(t,i,o){return ma(this,e),yh(this,kh(e).call(this,t,i,o))}return Eh(e,t),_a(e,[{key:"_calculateForces",value:function(t,e,i,o,n){0===t&&(e=t=.1*Math.random()),this.overlapAvoidanceFactor<1&&o.shape.radius&&(t=Math.max(.1+this.overlapAvoidanceFactor*o.shape.radius,t-o.shape.radius));var s=o.edges.length+1,r=this.options.gravitationalConstant*n.mass*o.options.mass*s/Math.pow(t,2),a=e*r,h=i*r;this.physicsBody.forces[o.id].x+=a,this.physicsBody.forces[o.id].y+=h}}]),e}(jd),Gd=function(t){function e(t,i,o){return ma(this,e),yh(this,kh(e).call(this,t,i,o))}return Eh(e,t),_a(e,[{key:"_calculateForces",value:function(t,e,i,o,n){if(t>0){var s=n.edges.length+1,r=this.options.centralGravity*s*n.options.mass;o[n.id].x=e*r,o[n.id].y=i*r}}}]),e}(Yd),Kd=function(){function t(i){ma(this,t),this.body=i,this.physicsBody={physicsNodeIndices:[],physicsEdgeIndices:[],forces:{},velocities:{}},this.physicsEnabled=!0,this.simulationInterval=1e3/60,this.requiresTimeout=!0,this.previousStates={},this.referenceState={},this.freezeCache={},this.renderTimer=void 0,this.adaptiveTimestep=!1,this.adaptiveTimestepEnabled=!1,this.adaptiveCounter=0,this.adaptiveInterval=3,this.stabilized=!1,this.startedStabilization=!1,this.stabilizationIterations=0,this.ready=!1,this.options={},this.defaultOptions={enabled:!0,barnesHut:{theta:.5,gravitationalConstant:-2e3,centralGravity:.3,springLength:95,springConstant:.04,damping:.09,avoidOverlap:0},forceAtlas2Based:{theta:.5,gravitationalConstant:-50,centralGravity:.01,springConstant:.08,springLength:100,damping:.4,avoidOverlap:0},repulsion:{centralGravity:.2,springLength:200,springConstant:.05,nodeDistance:100,damping:.09,avoidOverlap:0},hierarchicalRepulsion:{centralGravity:0,springLength:100,springConstant:.01,nodeDistance:120,damping:.09},maxVelocity:50,minVelocity:.75,solver:"barnesHut",stabilization:{enabled:!0,iterations:1e3,updateInterval:50,onlyDynamicEdges:!1,fit:!0},timestep:.5,adaptiveTimestep:!0},e.extend(this.options,this.defaultOptions),this.timestep=.5,this.layoutFailed=!1,this.bindEventListeners()}return _a(t,[{key:"bindEventListeners",value:function(){var t=this;this.body.emitter.on("initPhysics",(function(){t.initPhysics()})),this.body.emitter.on("_layoutFailed",(function(){t.layoutFailed=!0})),this.body.emitter.on("resetPhysics",(function(){t.stopSimulation(),t.ready=!1})),this.body.emitter.on("disablePhysics",(function(){t.physicsEnabled=!1,t.stopSimulation()})),this.body.emitter.on("restorePhysics",(function(){t.setOptions(t.options),!0===t.ready&&t.startSimulation()})),this.body.emitter.on("startSimulation",(function(){!0===t.ready&&t.startSimulation()})),this.body.emitter.on("stopSimulation",(function(){t.stopSimulation()})),this.body.emitter.on("destroy",(function(){t.stopSimulation(!1),t.body.emitter.off()})),this.body.emitter.on("_dataChanged",(function(){t.updatePhysicsData()}))}},{key:"setOptions",value:function(t){void 0!==t&&(!1===t?(this.options.enabled=!1,this.physicsEnabled=!1,this.stopSimulation()):!0===t?(this.options.enabled=!0,this.physicsEnabled=!0,this.startSimulation()):(this.physicsEnabled=!0,e.selectiveNotDeepExtend(["stabilization"],this.options,t),e.mergeOptions(this.options,t,"stabilization"),void 0===t.enabled&&(this.options.enabled=!0),!1===this.options.enabled&&(this.physicsEnabled=!1,this.stopSimulation()),this.timestep=this.options.timestep)),this.init()}},{key:"init",value:function(){var t;"forceAtlas2Based"===this.options.solver?(t=this.options.forceAtlas2Based,this.nodesSolver=new Xd(this.body,this.physicsBody,t),this.edgesSolver=new qd(this.body,this.physicsBody,t),this.gravitySolver=new Gd(this.body,this.physicsBody,t)):"repulsion"===this.options.solver?(t=this.options.repulsion,this.nodesSolver=new Hd(this.body,this.physicsBody,t),this.edgesSolver=new qd(this.body,this.physicsBody,t),this.gravitySolver=new Yd(this.body,this.physicsBody,t)):"hierarchicalRepulsion"===this.options.solver?(t=this.options.hierarchicalRepulsion,this.nodesSolver=new Vd(this.body,this.physicsBody,t),this.edgesSolver=new Ud(this.body,this.physicsBody,t),this.gravitySolver=new Yd(this.body,this.physicsBody,t)):(t=this.options.barnesHut,this.nodesSolver=new jd(this.body,this.physicsBody,t),this.edgesSolver=new qd(this.body,this.physicsBody,t),this.gravitySolver=new Yd(this.body,this.physicsBody,t)),this.modelOptions=t}},{key:"initPhysics",value:function(){!0===this.physicsEnabled&&!0===this.options.enabled?!0===this.options.stabilization.enabled?this.stabilize():(this.stabilized=!1,this.ready=!0,this.body.emitter.emit("fit",{},this.layoutFailed),this.startSimulation()):(this.ready=!0,this.body.emitter.emit("fit"))}},{key:"startSimulation",value:function(){var t;!0===this.physicsEnabled&&!0===this.options.enabled?(this.stabilized=!1,this.adaptiveTimestep=!1,this.body.emitter.emit("_resizeNodes"),void 0===this.viewFunction&&(this.viewFunction=it(t=this.simulationStep).call(t,this),this.body.emitter.on("initRedraw",this.viewFunction),this.body.emitter.emit("_startRendering"))):this.body.emitter.emit("_redraw")}},{key:"stopSimulation",value:function(){var t=!(arguments.length>0&&void 0!==arguments[0])||arguments[0];this.stabilized=!0,!0===t&&this._emitStabilized(),void 0!==this.viewFunction&&(this.body.emitter.off("initRedraw",this.viewFunction),this.viewFunction=void 0,!0===t&&this.body.emitter.emit("_stopRendering"))}},{key:"simulationStep",value:function(){var t=ns();this.physicsTick(),(ns()-t<.4*this.simulationInterval||!0===this.runDoubleSpeed)&&!1===this.stabilized&&(this.physicsTick(),this.runDoubleSpeed=!0),!0===this.stabilized&&this.stopSimulation()}},{key:"_emitStabilized",value:function(){var t=this,e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.stabilizationIterations;(this.stabilizationIterations>1||!0===this.startedStabilization)&&Io((function(){t.body.emitter.emit("stabilized",{iterations:e}),t.startedStabilization=!1,t.stabilizationIterations=0}),0)}},{key:"physicsStep",value:function(){this.gravitySolver.solve(),this.nodesSolver.solve(),this.edgesSolver.solve(),this.moveNodes()}},{key:"adjustTimeStep",value:function(){!0===this._evaluateStepQuality()?this.timestep=1.2*this.timestep:this.timestep/1.2<this.options.timestep?this.timestep=this.options.timestep:(this.adaptiveCounter=-1,this.timestep=Math.max(this.options.timestep,this.timestep/1.2))}},{key:"physicsTick",value:function(){if(this._startStabilizing(),!0!==this.stabilized){if(!0===this.adaptiveTimestep&&!0===this.adaptiveTimestepEnabled)this.adaptiveCounter%this.adaptiveInterval==0?(this.timestep=2*this.timestep,this.physicsStep(),this.revert(),this.timestep=.5*this.timestep,this.physicsStep(),this.physicsStep(),this.adjustTimeStep()):this.physicsStep(),this.adaptiveCounter+=1;else this.timestep=this.options.timestep,this.physicsStep();!0===this.stabilized&&this.revert(),this.stabilizationIterations++}}},{key:"updatePhysicsData",value:function(){this.physicsBody.forces={},this.physicsBody.physicsNodeIndices=[],this.physicsBody.physicsEdgeIndices=[];var t=this.body.nodes,e=this.body.edges;for(var i in t)t.hasOwnProperty(i)&&!0===t[i].options.physics&&this.physicsBody.physicsNodeIndices.push(t[i].id);for(var o in e)e.hasOwnProperty(o)&&!0===e[o].options.physics&&this.physicsBody.physicsEdgeIndices.push(e[o].id);for(var n=0;n<this.physicsBody.physicsNodeIndices.length;n++){var s=this.physicsBody.physicsNodeIndices[n];this.physicsBody.forces[s]={x:0,y:0},void 0===this.physicsBody.velocities[s]&&(this.physicsBody.velocities[s]={x:0,y:0})}for(var r in this.physicsBody.velocities)void 0===t[r]&&delete this.physicsBody.velocities[r]}},{key:"revert",value:function(){var t=To(this.previousStates),e=this.body.nodes,i=this.physicsBody.velocities;this.referenceState={};for(var o=0;o<t.length;o++){var n=t[o];void 0!==e[n]?!0===e[n].options.physics&&(this.referenceState[n]={positions:{x:e[n].x,y:e[n].y}},i[n].x=this.previousStates[n].vx,i[n].y=this.previousStates[n].vy,e[n].x=this.previousStates[n].x,e[n].y=this.previousStates[n].y):delete this.previousStates[n]}}},{key:"_evaluateStepQuality",value:function(){var t,e,i=this.body.nodes,o=this.referenceState;for(var n in this.referenceState)if(this.referenceState.hasOwnProperty(n)&&void 0!==i[n]&&(t=i[n].x-o[n].positions.x,e=i[n].y-o[n].positions.y,Math.sqrt(Math.pow(t,2)+Math.pow(e,2))>.3))return!1;return!0}},{key:"moveNodes",value:function(){for(var t=this.physicsBody.physicsNodeIndices,e=0,i=0,o=0;o<t.length;o++){var n=t[o],s=this._performStep(n);e=Math.max(e,s),i+=s}this.adaptiveTimestepEnabled=i/t.length<5,this.stabilized=e<this.options.minVelocity}},{key:"calculateComponentVelocity",value:function(t,e,i){t+=(e-this.modelOptions.damping*t)/i*this.timestep;var o=this.options.maxVelocity||1e9;return Math.abs(t)>o&&(t=t>0?o:-o),t}},{key:"_performStep",value:function(t){var e=this.body.nodes[t],i=this.physicsBody.forces[t],o=this.physicsBody.velocities[t];return this.previousStates[t]={x:e.x,y:e.y,vx:o.x,vy:o.y},!1===e.options.fixed.x?(o.x=this.calculateComponentVelocity(o.x,i.x,e.options.mass),e.x+=o.x*this.timestep):(i.x=0,o.x=0),!1===e.options.fixed.y?(o.y=this.calculateComponentVelocity(o.y,i.y,e.options.mass),e.y+=o.y*this.timestep):(i.y=0,o.y=0),Math.sqrt(Math.pow(o.x,2)+Math.pow(o.y,2))}},{key:"_freezeNodes",value:function(){var t=this.body.nodes;for(var e in t)if(t.hasOwnProperty(e)&&t[e].x&&t[e].y){var i=t[e].options.fixed;this.freezeCache[e]={x:i.x,y:i.y},i.x=!0,i.y=!0}}},{key:"_restoreFrozenNodes",value:function(){var t=this.body.nodes;for(var e in t)t.hasOwnProperty(e)&&void 0!==this.freezeCache[e]&&(t[e].options.fixed.x=this.freezeCache[e].x,t[e].options.fixed.y=this.freezeCache[e].y);this.freezeCache={}}},{key:"stabilize",value:function(){var t=this,e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.options.stabilization.iterations;"number"!=typeof e&&(e=this.options.stabilization.iterations,console.log("The stabilize method needs a numeric amount of iterations. Switching to default: ",e)),0!==this.physicsBody.physicsNodeIndices.length?(this.adaptiveTimestep=this.options.adaptiveTimestep,this.body.emitter.emit("_resizeNodes"),this.stopSimulation(),this.stabilized=!1,this.body.emitter.emit("_blockRedraw"),this.targetIterations=e,!0===this.options.stabilization.onlyDynamicEdges&&this._freezeNodes(),this.stabilizationIterations=0,Io((function(){return t._stabilizationBatch()}),0)):this.ready=!0}},{key:"_startStabilizing",value:function(){return!0!==this.startedStabilization&&(this.body.emitter.emit("startStabilizing"),this.startedStabilization=!0,!0)}},{key:"_stabilizationBatch",value:function(){var t=this,e=function(){return!1===t.stabilized&&t.stabilizationIterations<t.targetIterations},i=function(){t.body.emitter.emit("stabilizationProgress",{iterations:t.stabilizationIterations,total:t.targetIterations})};this._startStabilizing()&&i();for(var o,n=0;e()&&n<this.options.stabilization.updateInterval;)this.physicsTick(),n++;(i(),e())?Io(it(o=this._stabilizationBatch).call(o,this),0):this._finalizeStabilization()}},{key:"_finalizeStabilization",value:function(){this.body.emitter.emit("_allowRedraw"),!0===this.options.stabilization.fit&&this.body.emitter.emit("fit"),!0===this.options.stabilization.onlyDynamicEdges&&this._restoreFrozenNodes(),this.body.emitter.emit("stabilizationIterationsDone"),this.body.emitter.emit("_requestRedraw"),!0===this.stabilized?this._emitStabilized():this.startSimulation(),this.ready=!0}},{key:"_drawForces",value:function(t){for(var i=0;i<this.physicsBody.physicsNodeIndices.length;i++){var o=this.physicsBody.physicsNodeIndices[i],n=this.body.nodes[o],s=this.physicsBody.forces[o],r=Math.sqrt(Math.pow(s.x,2)+Math.pow(s.x,2)),a=Math.min(Math.max(5,r),15),h=3*a,d=e.HSVToHex((180-180*Math.min(1,Math.max(0,.03*r)))/360,1,1),l={x:n.x+20*s.x,y:n.y+20*s.y};t.lineWidth=a,t.strokeStyle=d,t.beginPath(),t.moveTo(n.x,n.y),t.lineTo(l.x,l.y),t.stroke();var c=Math.atan2(s.y,s.x);t.fillStyle=d,Sd.draw(t,{type:"arrow",point:l,angle:c,length:h}),Th(t).call(t)}}}]),t}(),Zd=[].reverse,$d=[1,2];G({target:"Array",proto:!0,forced:String($d)===String($d.reverse())},{reverse:function(){return ct(this)&&(this.length=this.length),Zd.call(this)}});var Jd=Q("Array").reverse,Qd=Array.prototype,tl=function(t){var e=t.reverse;return t===Qd||t instanceof Array&&e===Qd.reverse?Jd:e},el=function(){function t(){ma(this,t)}return _a(t,null,[{key:"getRange",value:function(t){var e,i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],o=1e9,n=-1e9,s=1e9,r=-1e9;if(i.length>0)for(var a=0;a<i.length;a++)s>(e=t[i[a]]).shape.boundingBox.left&&(s=e.shape.boundingBox.left),r<e.shape.boundingBox.right&&(r=e.shape.boundingBox.right),o>e.shape.boundingBox.top&&(o=e.shape.boundingBox.top),n<e.shape.boundingBox.bottom&&(n=e.shape.boundingBox.bottom);return 1e9===s&&-1e9===r&&1e9===o&&-1e9===n&&(o=0,n=0,s=0,r=0),{minX:s,maxX:r,minY:o,maxY:n}}},{key:"getRangeCore",value:function(t){var e,i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],o=1e9,n=-1e9,s=1e9,r=-1e9;if(i.length>0)for(var a=0;a<i.length;a++)s>(e=t[i[a]]).x&&(s=e.x),r<e.x&&(r=e.x),o>e.y&&(o=e.y),n<e.y&&(n=e.y);return 1e9===s&&-1e9===r&&1e9===o&&-1e9===n&&(o=0,n=0,s=0,r=0),{minX:s,maxX:r,minY:o,maxY:n}}},{key:"findCenter",value:function(t){return{x:.5*(t.maxX+t.minX),y:.5*(t.maxY+t.minY)}}},{key:"cloneOptions",value:function(t,i){var o={};return void 0===i||"node"===i?(e.deepExtend(o,t.options,!0),o.x=t.x,o.y=t.y,o.amountOfConnections=t.edges.length):e.deepExtend(o,t.options,!0),o}}]),t}(),il=function(t){function i(t,e,o,n,s,r){var a;return ma(this,i),(a=yh(this,kh(i).call(this,t,e,o,n,s,r))).isCluster=!0,a.containedNodes={},a.containedEdges={},a}return Eh(i,t),_a(i,[{key:"_openChildCluster",value:function(t){var i=this,o=this.body.nodes[t];if(void 0===this.containedNodes[t])throw new Error("node with id: "+t+" not in current cluster");if(!o.isCluster)throw new Error("node with id: "+t+" is not a cluster");delete this.containedNodes[t],e.forEach(o.edges,(function(t){delete i.containedEdges[t.id]})),e.forEach(o.containedNodes,(function(t,e){i.containedNodes[e]=t})),o.containedNodes={},e.forEach(o.containedEdges,(function(t,e){i.containedEdges[e]=t})),o.containedEdges={},e.forEach(o.edges,(function(t){e.forEach(i.edges,(function(o){var n,s,r=zi(n=o.clusteringEdgeReplacingIds).call(n,t.id);-1!==r&&(e.forEach(t.clusteringEdgeReplacingIds,(function(t){o.clusteringEdgeReplacingIds.push(t),i.body.edges[t].edgeReplacedById=o.id})),ee(s=o.clusteringEdgeReplacingIds).call(s,r,1))}))})),o.edges=[]}}]),i}(nd),ol=function(){function t(i){var o=this;ma(this,t),this.body=i,this.clusteredNodes={},this.clusteredEdges={},this.options={},this.defaultOptions={},e.extend(this.options,this.defaultOptions),this.body.emitter.on("_resetData",(function(){o.clusteredNodes={},o.clusteredEdges={}}))}return _a(t,[{key:"clusterByHubsize",value:function(t,e){void 0===t?t=this._getHubSize():"object"===os(t)&&(e=this._checkOptions(t),t=this._getHubSize());for(var i=[],o=0;o<this.body.nodeIndices.length;o++){var n=this.body.nodes[this.body.nodeIndices[o]];n.edges.length>=t&&i.push(n.id)}for(var s=0;s<i.length;s++)this.clusterByConnection(i[s],e,!0);this.body.emitter.emit("_dataChanged")}},{key:"cluster",value:function(){var t=this,i=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},o=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if(void 0===i.joinCondition)throw new Error("Cannot call clusterByNodeData without a joinCondition function in the options.");i=this._checkOptions(i);var n={},s={};e.forEach(this.body.nodes,(function(o,r){o.options&&!0===i.joinCondition(o.options)&&(n[r]=o,e.forEach(o.edges,(function(e){void 0===t.clusteredEdges[e.id]&&(s[e.id]=e)})))})),this._cluster(n,s,i,o)}},{key:"clusterByEdgeCount",value:function(t,e){var i=this,o=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];e=this._checkOptions(e);for(var n,s,r,a=[],h={},d=function(o){var d={},l={},p=i.body.nodeIndices[o],f=i.body.nodes[p];if(void 0===h[p]){r=0,s=[];for(var v=0;v<f.edges.length;v++)n=f.edges[v],void 0===i.clusteredEdges[n.id]&&(n.toId!==n.fromId&&r++,s.push(n));if(r===t){c=function(t){if(void 0===e.joinCondition||null===e.joinCondition)return!0;var i=el.cloneOptions(t);return e.joinCondition(i)};for(var g=!0,y=0;y<s.length;y++){n=s[y];var m=i._getConnectedId(n,p);if(!c(f)){g=!1;break}l[n.id]=n,d[p]=f,d[m]=i.body.nodes[m],h[p]=!0}if(To(d).length>0&&To(l).length>0&&!0===g)if(void 0!==(u=function(){for(var t=0;t<a.length;++t)for(var e in d)if(void 0!==a[t].nodes[e])return a[t]}())){for(var b in d)void 0===u.nodes[b]&&(u.nodes[b]=d[b]);for(var w in l)void 0===u.edges[w]&&(u.edges[w]=l[w])}else a.push({nodes:d,edges:l})}}},l=0;l<this.body.nodeIndices.length;l++){var c,u;d(l)}for(var p=0;p<a.length;p++)this._cluster(a[p].nodes,a[p].edges,e,!1);!0===o&&this.body.emitter.emit("_dataChanged")}},{key:"clusterOutliers",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];this.clusterByEdgeCount(1,t,e)}},{key:"clusterBridges",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];this.clusterByEdgeCount(2,t,e)}},{key:"clusterByConnection",value:function(t,e){var i,o=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];if(void 0===t)throw new Error("No nodeId supplied to clusterByConnection!");if(void 0===this.body.nodes[t])throw new Error("The nodeId given to clusterByConnection does not exist!");var n=this.body.nodes[t];void 0===(e=this._checkOptions(e,n)).clusterNodeProperties.x&&(e.clusterNodeProperties.x=n.x),void 0===e.clusterNodeProperties.y&&(e.clusterNodeProperties.y=n.y),void 0===e.clusterNodeProperties.fixed&&(e.clusterNodeProperties.fixed={},e.clusterNodeProperties.fixed.x=n.options.fixed.x,e.clusterNodeProperties.fixed.y=n.options.fixed.y);var s={},r={},a=n.id,h=el.cloneOptions(n);s[a]=n;for(var d=0;d<n.edges.length;d++){var l=n.edges[d];if(void 0===this.clusteredEdges[l.id]){var c=this._getConnectedId(l,a);if(void 0===this.clusteredNodes[c])if(c!==a)if(void 0===e.joinCondition)r[l.id]=l,s[c]=this.body.nodes[c];else{var u=el.cloneOptions(this.body.nodes[c]);!0===e.joinCondition(h,u)&&(r[l.id]=l,s[c]=this.body.nodes[c])}else r[l.id]=l}}var p=_o(i=To(s)).call(i,(function(t){return s[t].id}));for(f in s)if(s.hasOwnProperty(f))for(var f=s[f],v=0;v<f.edges.length;v++){var g=f.edges[v];zi(p).call(p,this._getConnectedId(g,f.id))>-1&&(r[g.id]=g)}this._cluster(s,r,e,o)}},{key:"_createClusterEdges",value:function(t,e,i,o){for(var n,s,r,a,h,d,l=To(t),c=[],u=0;u<l.length;u++){r=t[s=l[u]];for(var p=0;p<r.edges.length;p++)n=r.edges[p],void 0===this.clusteredEdges[n.id]&&(n.toId==n.fromId?e[n.id]=n:n.toId==s?(a=i.id,d=h=n.fromId):(a=n.toId,h=i.id,d=a),void 0===t[d]&&c.push({edge:n,fromId:h,toId:a}))}for(var f=[],v=function(t){for(var e=0;e<f.length;e++){var i=f[e],o=t.fromId===i.fromId&&t.toId===i.toId,n=t.fromId===i.toId&&t.toId===i.fromId;if(o||n)return i}return null},g=0;g<c.length;g++){var y=c[g],m=y.edge,b=v(y);null===b?(b=this._createClusteredEdge(y.fromId,y.toId,m,o),f.push(b)):b.clusteringEdgeReplacingIds.push(m.id),this.body.edges[m.id].edgeReplacedById=b.id,this._backupEdgeOptions(m),m.setOptions({physics:!1})}}},{key:"_checkOptions",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};return void 0===t.clusterEdgeProperties&&(t.clusterEdgeProperties={}),void 0===t.clusterNodeProperties&&(t.clusterNodeProperties={}),t}},{key:"_cluster",value:function(t,i,o){var n=!(arguments.length>3&&void 0!==arguments[3])||arguments[3],s=[];for(var r in t)t.hasOwnProperty(r)&&void 0!==this.clusteredNodes[r]&&s.push(r);for(var a=0;a<s.length;++a)delete t[s[a]];if(0!=To(t).length&&(1!=To(t).length||1==o.clusterNodeProperties.allowSingleNodeCluster)){var h=e.deepExtend({},o.clusterNodeProperties);if(void 0!==o.processProperties){var d=[];for(var l in t)if(t.hasOwnProperty(l)){var c=el.cloneOptions(t[l]);d.push(c)}var u=[];for(var p in i)if(i.hasOwnProperty(p)&&"clusterEdge:"!==p.substr(0,12)){var f=el.cloneOptions(i[p],"edge");u.push(f)}if(!(h=o.processProperties(h,d,u)))throw new Error("The processProperties function does not return properties!")}void 0===h.id&&(h.id="cluster:"+e.randomUUID());var v=h.id;void 0===h.label&&(h.label="cluster");var g=void 0;void 0===h.x&&(g=this._getClusterPosition(t),h.x=g.x),void 0===h.y&&(void 0===g&&(g=this._getClusterPosition(t)),h.y=g.y),h.id=v;var y=this.body.functions.createNode(h,il);y.containedNodes=t,y.containedEdges=i,y.clusterEdgeProperties=o.clusterEdgeProperties,this.body.nodes[h.id]=y,this._clusterEdges(t,i,h,o.clusterEdgeProperties),h.id=void 0,!0===n&&this.body.emitter.emit("_dataChanged")}}},{key:"_backupEdgeOptions",value:function(t){void 0===this.clusteredEdges[t.id]&&(this.clusteredEdges[t.id]={physics:t.options.physics})}},{key:"_restoreEdge",value:function(t){var e=this.clusteredEdges[t.id];void 0!==e&&(t.setOptions({physics:e.physics}),delete this.clusteredEdges[t.id])}},{key:"isCluster",value:function(t){return void 0!==this.body.nodes[t]?!0===this.body.nodes[t].isCluster:(console.log("Node does not exist."),!1)}},{key:"_getClusterPosition",value:function(t){for(var e,i=To(t),o=t[i[0]].x,n=t[i[0]].x,s=t[i[0]].y,r=t[i[0]].y,a=1;a<i.length;a++)o=(e=t[i[a]]).x<o?e.x:o,n=e.x>n?e.x:n,s=e.y<s?e.y:s,r=e.y>r?e.y:r;return{x:.5*(o+n),y:.5*(s+r)}}},{key:"openCluster",value:function(t,i){var o=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];if(void 0===t)throw new Error("No clusterNodeId supplied to openCluster.");var n=this.body.nodes[t];if(void 0===n)throw new Error("The clusterNodeId supplied to openCluster does not exist.");if(!0!==n.isCluster||void 0===n.containedNodes||void 0===n.containedEdges)throw new Error("The node:"+t+" is not a valid cluster.");var s=this.findNode(t),r=zi(s).call(s,t)-1;if(r>=0){var a=s[r],h=this.body.nodes[a];return h._openChildCluster(t),delete this.body.nodes[t],void(!0===o&&this.body.emitter.emit("_dataChanged"))}var d=n.containedNodes,l=n.containedEdges;if(void 0!==i&&void 0!==i.releaseFunction&&"function"==typeof i.releaseFunction){var c={},u={x:n.x,y:n.y};for(var p in d)if(d.hasOwnProperty(p)){var f=this.body.nodes[p];c[p]={x:f.x,y:f.y}}var v=i.releaseFunction(u,c);for(var g in d)if(d.hasOwnProperty(g)){var y=this.body.nodes[g];void 0!==v[g]&&(y.x=void 0===v[g].x?n.x:v[g].x,y.y=void 0===v[g].y?n.y:v[g].y)}}else e.forEach(d,(function(t){!1===t.options.fixed.x&&(t.x=n.x),!1===t.options.fixed.y&&(t.y=n.y)}));for(var m in d)if(d.hasOwnProperty(m)){var b=this.body.nodes[m];b.vx=n.vx,b.vy=n.vy,b.setOptions({physics:!0}),delete this.clusteredNodes[m]}for(var w=[],k=0;k<n.edges.length;k++)w.push(n.edges[k]);for(var _=0;_<w.length;_++){for(var x=w[_],E=this._getConnectedId(x,t),O=this.clusteredNodes[E],C=0;C<x.clusteringEdgeReplacingIds.length;C++){var T=x.clusteringEdgeReplacingIds[C],S=this.body.edges[T];if(void 0!==S)if(void 0!==O){var D=this.body.nodes[O.clusterId];D.containedEdges[S.id]=S,delete l[S.id];var M=S.fromId,I=S.toId;S.toId==E?I=O.clusterId:M=O.clusterId,this._createClusteredEdge(M,I,S,D.clusterEdgeProperties,{hidden:!1,physics:!0})}else this._restoreEdge(S)}x.remove()}for(var P in l)l.hasOwnProperty(P)&&this._restoreEdge(l[P]);delete this.body.nodes[t],!0===o&&this.body.emitter.emit("_dataChanged")}},{key:"getNodesInCluster",value:function(t){var e=[];if(!0===this.isCluster(t)){var i=this.body.nodes[t].containedNodes;for(var o in i)i.hasOwnProperty(o)&&e.push(this.body.nodes[o].id)}return e}},{key:"findNode",value:function(t){for(var e,i=[],o=0;void 0!==this.clusteredNodes[t]&&o<100;){if(void 0===(e=this.body.nodes[t]))return[];i.push(e.id),t=this.clusteredNodes[t].clusterId,o++}return void 0===(e=this.body.nodes[t])?[]:(i.push(e.id),tl(i).call(i),i)}},{key:"updateClusteredNode",value:function(t,e){if(void 0===t)throw new Error("No clusteredNodeId supplied to updateClusteredNode.");if(void 0===e)throw new Error("No newOptions supplied to updateClusteredNode.");if(void 0===this.body.nodes[t])throw new Error("The clusteredNodeId supplied to updateClusteredNode does not exist.");this.body.nodes[t].setOptions(e),this.body.emitter.emit("_dataChanged")}},{key:"updateEdge",value:function(t,e){if(void 0===t)throw new Error("No startEdgeId supplied to updateEdge.");if(void 0===e)throw new Error("No newOptions supplied to updateEdge.");if(void 0===this.body.edges[t])throw new Error("The startEdgeId supplied to updateEdge does not exist.");for(var i=this.getClusteredEdges(t),o=0;o<i.length;o++){this.body.edges[i[o]].setOptions(e)}this.body.emitter.emit("_dataChanged")}},{key:"getClusteredEdges",value:function(t){for(var e=[],i=0;void 0!==t&&void 0!==this.body.edges[t]&&i<100;)e.push(this.body.edges[t].id),t=this.body.edges[t].edgeReplacedById,i++;return tl(e).call(e),e}},{key:"getBaseEdge",value:function(t){return this.getBaseEdges(t)[0]}},{key:"getBaseEdges",value:function(t){for(var e=[t],i=[],o=[],n=0;e.length>0&&n<100;){var s=e.pop();if(void 0!==s){var r=this.body.edges[s];if(void 0!==r){n++;var a=r.clusteringEdgeReplacingIds;if(void 0===a)o.push(s);else for(var h=0;h<a.length;++h){var d=a[h];-1===zi(e).call(e,a)&&-1===zi(i).call(i,a)&&e.push(d)}i.push(s)}}}return o}},{key:"_getConnectedId",value:function(t,e){return t.toId!=e?t.toId:(t.fromId,t.fromId)}},{key:"_getHubSize",value:function(){for(var t=0,e=0,i=0,o=0,n=0;n<this.body.nodeIndices.length;n++){var s=this.body.nodes[this.body.nodeIndices[n]];s.edges.length>o&&(o=s.edges.length),t+=s.edges.length,e+=Math.pow(s.edges.length,2),i+=1}t/=i;var r=(e/=i)-Math.pow(t,2),a=Math.sqrt(r),h=Math.floor(t+2*a);return h>o&&(h=o),h}},{key:"_createClusteredEdge",value:function(t,i,o,n,s){var r=el.cloneOptions(o,"edge");e.deepExtend(r,n),r.from=t,r.to=i,r.id="clusterEdge:"+e.randomUUID(),void 0!==s&&e.deepExtend(r,s);var a=this.body.functions.createEdge(r);return a.clusteringEdgeReplacingIds=[o.id],a.connect(),this.body.edges[a.id]=a,a}},{key:"_clusterEdges",value:function(t,e,i,o){if(e instanceof Rd){var n=e,s={};s[n.id]=n,e=s}if(t instanceof nd){var r=t,a={};a[r.id]=r,t=a}if(null==i)throw new Error("_clusterEdges: parameter clusterNode required");for(var h in void 0===o&&(o=i.clusterEdgeProperties),this._createClusterEdges(t,e,i,o),e)if(e.hasOwnProperty(h)&&void 0!==this.body.edges[h]){var d=this.body.edges[h];this._backupEdgeOptions(d),d.setOptions({physics:!1})}for(var l in t)t.hasOwnProperty(l)&&(this.clusteredNodes[l]={clusterId:i.id,node:this.body.nodes[l]},this.body.nodes[l].setOptions({physics:!1}))}},{key:"_getClusterNodeForNode",value:function(t){if(void 0!==t){var e=this.clusteredNodes[t];if(void 0!==e){var i=e.clusterId;if(void 0!==i)return this.body.nodes[i]}}}},{key:"_filter",value:function(t,i){var o=[];return e.forEach(t,(function(t){i(t)&&o.push(t)})),o}},{key:"_updateState",value:function(){var t,i=this,o=[],n={},s=function(t){e.forEach(i.body.nodes,(function(e){!0===e.isCluster&&t(e)}))};for(t in this.clusteredNodes){if(this.clusteredNodes.hasOwnProperty(t))void 0===this.body.nodes[t]&&o.push(t)}s((function(t){for(var e=0;e<o.length;e++)delete t.containedNodes[o[e]]}));for(var r=0;r<o.length;r++)delete this.clusteredNodes[o[r]];e.forEach(this.clusteredEdges,(function(t){var e=i.body.edges[t];void 0!==e&&e.endPointsValid()||(n[t]=t)})),s((function(t){e.forEach(t.containedEdges,(function(t,e){t.endPointsValid()||n[e]||(n[e]=e)}))})),e.forEach(this.body.edges,(function(t,o){var s=!0,r=t.clusteringEdgeReplacingIds;if(void 0!==r){var a=0;e.forEach(r,(function(t){var e=i.body.edges[t];void 0!==e&&e.endPointsValid()&&(a+=1)})),s=a>0}t.endPointsValid()&&s||(n[o]=o)})),s((function(t){e.forEach(n,(function(o){delete t.containedEdges[o],e.forEach(t.edges,(function(e,s){e.id!==o?e.clusteringEdgeReplacingIds=i._filter(e.clusteringEdgeReplacingIds,(function(t){return!n[t]})):t.edges[s]=null})),t.edges=i._filter(t.edges,(function(t){return null!==t}))}))})),e.forEach(n,(function(t){delete i.clusteredEdges[t]})),e.forEach(n,(function(t){delete i.body.edges[t]}));var a=To(this.body.edges);e.forEach(a,(function(t){var e=i.body.edges[t],o=i._isClusteredNode(e.fromId)||i._isClusteredNode(e.toId);if(o!==i._isClusteredEdge(e.id))if(o){var n=i._getClusterNodeForNode(e.fromId);void 0!==n&&i._clusterEdges(i.body.nodes[e.fromId],e,n);var s=i._getClusterNodeForNode(e.toId);void 0!==s&&i._clusterEdges(i.body.nodes[e.toId],e,s)}else delete i._clusterEdges[t],i._restoreEdge(e)}));for(var h=!1,d=!0,l=function(){var t=[];s((function(e){var i=To(e.containedNodes).length,o=!0===e.options.allowSingleNodeCluster;(o&&i<1||!o&&i<2)&&t.push(e.id)}));for(var e=0;e<t.length;++e)i.openCluster(t[e],{},!1);d=t.length>0,h=h||d};d;)l();h&&this._updateState()}},{key:"_isClusteredNode",value:function(t){return void 0!==this.clusteredNodes[t]}},{key:"_isClusteredEdge",value:function(t){return void 0!==this.clusteredEdges[t]}}]),t}();var nl=function(){function t(i,o){var n;ma(this,t),void 0!==window&&(n=window.requestAnimationFrame||window.mozRequestAnimationFrame||window.webkitRequestAnimationFrame||window.msRequestAnimationFrame),window.requestAnimationFrame=void 0===n?function(t){t()}:n,this.body=i,this.canvas=o,this.redrawRequested=!1,this.renderTimer=void 0,this.requiresTimeout=!0,this.renderingActive=!1,this.renderRequests=0,this.allowRedraw=!0,this.dragging=!1,this.zooming=!1,this.options={},this.defaultOptions={hideEdgesOnDrag:!1,hideEdgesOnZoom:!1,hideNodesOnDrag:!1},e.extend(this.options,this.defaultOptions),this._determineBrowserMethod(),this.bindEventListeners()}return _a(t,[{key:"bindEventListeners",value:function(){var t,e=this;this.body.emitter.on("dragStart",(function(){e.dragging=!0})),this.body.emitter.on("dragEnd",(function(){e.dragging=!1})),this.body.emitter.on("zoom",(function(){e.zooming=!0,window.clearTimeout(e.zoomTimeoutId),e.zoomTimeoutId=window.setTimeout((function(){var t;e.zooming=!1,it(t=e._requestRedraw).call(t,e)()}),250)})),this.body.emitter.on("_resizeNodes",(function(){e._resizeNodes()})),this.body.emitter.on("_redraw",(function(){!1===e.renderingActive&&e._redraw()})),this.body.emitter.on("_blockRedraw",(function(){e.allowRedraw=!1})),this.body.emitter.on("_allowRedraw",(function(){e.allowRedraw=!0,e.redrawRequested=!1})),this.body.emitter.on("_requestRedraw",it(t=this._requestRedraw).call(t,this)),this.body.emitter.on("_startRendering",(function(){e.renderRequests+=1,e.renderingActive=!0,e._startRendering()})),this.body.emitter.on("_stopRendering",(function(){e.renderRequests-=1,e.renderingActive=e.renderRequests>0,e.renderTimer=void 0})),this.body.emitter.on("destroy",(function(){e.renderRequests=0,e.allowRedraw=!1,e.renderingActive=!1,!0===e.requiresTimeout?clearTimeout(e.renderTimer):window.cancelAnimationFrame(e.renderTimer),e.body.emitter.off()}))}},{key:"setOptions",value:function(t){if(void 0!==t){e.selectiveDeepExtend(["hideEdgesOnDrag","hideEdgesOnZoom","hideNodesOnDrag"],this.options,t)}}},{key:"_requestNextFrame",value:function(t,e){if("undefined"!=typeof window){var i,o=window;return!0===this.requiresTimeout?i=o.setTimeout(t,e):o.requestAnimationFrame&&(i=o.requestAnimationFrame(t)),i}}},{key:"_startRendering",value:function(){var t;!0===this.renderingActive&&(void 0===this.renderTimer&&(this.renderTimer=this._requestNextFrame(it(t=this._renderStep).call(t,this),this.simulationInterval)))}},{key:"_renderStep",value:function(){!0===this.renderingActive&&(this.renderTimer=void 0,!0===this.requiresTimeout&&this._startRendering(),this._redraw(),!1===this.requiresTimeout&&this._startRendering())}},{key:"redraw",value:function(){this.body.emitter.emit("setSize"),this._redraw()}},{key:"_requestRedraw",value:function(){var t=this;!0!==this.redrawRequested&&!1===this.renderingActive&&!0===this.allowRedraw&&(this.redrawRequested=!0,this._requestNextFrame((function(){t._redraw(!1)}),0))}},{key:"_redraw",value:function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];if(!0===this.allowRedraw){this.body.emitter.emit("initRedraw"),this.redrawRequested=!1,0!==this.canvas.frame.canvas.width&&0!==this.canvas.frame.canvas.height||this.canvas.setSize(),this.canvas.setTransform();var e=this.canvas.getContext(),i=this.canvas.frame.canvas.clientWidth,o=this.canvas.frame.canvas.clientHeight;if(e.clearRect(0,0,i,o),0===this.canvas.frame.clientWidth)return;e.save(),e.translate(this.body.view.translation.x,this.body.view.translation.y),e.scale(this.body.view.scale,this.body.view.scale),e.beginPath(),this.body.emitter.emit("beforeDrawing",e),e.closePath(),!1===t&&(!1===this.dragging||!0===this.dragging&&!1===this.options.hideEdgesOnDrag)&&(!1===this.zooming||!0===this.zooming&&!1===this.options.hideEdgesOnZoom)&&this._drawEdges(e),(!1===this.dragging||!0===this.dragging&&!1===this.options.hideNodesOnDrag)&&this._drawNodes(e,t),e.beginPath(),this.body.emitter.emit("afterDrawing",e),e.closePath(),e.restore(),!0===t&&e.clearRect(0,0,i,o)}}},{key:"_resizeNodes",value:function(){this.canvas.setTransform();var t=this.canvas.getContext();t.save(),t.translate(this.body.view.translation.x,this.body.view.translation.y),t.scale(this.body.view.scale,this.body.view.scale);var e,i=this.body.nodes;for(var o in i)i.hasOwnProperty(o)&&((e=i[o]).resize(t),e.updateBoundingBox(t,e.selected));t.restore()}},{key:"_drawNodes",value:function(t){for(var e,i=arguments.length>1&&void 0!==arguments[1]&&arguments[1],o=this.body.nodes,n=this.body.nodeIndices,s=[],r=20,a=this.canvas.DOMtoCanvas({x:-r,y:-r}),h=this.canvas.DOMtoCanvas({x:this.canvas.frame.canvas.clientWidth+r,y:this.canvas.frame.canvas.clientHeight+r}),d={top:a.y,left:a.x,bottom:h.y,right:h.x},l=0;l<n.length;l++)(e=o[n[l]]).isSelected()?s.push(n[l]):!0===i?e.draw(t):!0===e.isBoundingBoxOverlappingWith(d)?e.draw(t):e.updateBoundingBox(t,e.selected);for(var c=0;c<s.length;c++)(e=o[s[c]]).draw(t)}},{key:"_drawEdges",value:function(t){for(var e,i=this.body.edges,o=this.body.edgeIndices,n=0;n<o.length;n++)!0===(e=i[o[n]]).connected&&e.draw(t)}},{key:"_determineBrowserMethod",value:function(){if("undefined"!=typeof window){var t=navigator.userAgent.toLowerCase();this.requiresTimeout=!1,-1!=zi(t).call(t,"msie 9.0")?this.requiresTimeout=!0:-1!=zi(t).call(t,"safari")&&zi(t).call(t,"chrome")<=-1&&(this.requiresTimeout=!0)}else this.requiresTimeout=!0}}]),t}(),sl=L.setInterval,rl=r((function(t,e){e.onTouch=function(t,e){e.inputHandler=function(t){t.isFirst&&e(t)},t.on("hammer.input",e.inputHandler)},e.onRelease=function(t,e){return e.inputHandler=function(t){t.isFinal&&e(t)},t.on("hammer.input",e.inputHandler)},e.offTouch=function(t,e){t.off("hammer.input",e.inputHandler)},e.offRelease=e.offTouch,e.disablePreventDefaultVertically=function(t){return t.getTouchAction=function(){return["pan-y"]},t}})),al=(rl.onTouch,rl.onRelease,rl.offTouch,rl.offRelease,rl.disablePreventDefaultVertically,function(){function t(i){var o;ma(this,t),this.body=i,this.pixelRatio=1,this.resizeTimer=void 0,this.resizeFunction=it(o=this._onResize).call(o,this),this.cameraState={},this.initialized=!1,this.canvasViewCenter={},this.options={},this.defaultOptions={autoResize:!0,height:"100%",width:"100%"},e.extend(this.options,this.defaultOptions),this.bindEventListeners()}return _a(t,[{key:"bindEventListeners",value:function(){var t,e=this;this.body.emitter.once("resize",(function(t){0!==t.width&&(e.body.view.translation.x=.5*t.width),0!==t.height&&(e.body.view.translation.y=.5*t.height)})),this.body.emitter.on("setSize",it(t=this.setSize).call(t,this)),this.body.emitter.on("destroy",(function(){e.hammerFrame.destroy(),e.hammer.destroy(),e._cleanUp()}))}},{key:"setOptions",value:function(t){var i,o=this;if(void 0!==t){e.selectiveDeepExtend(["width","height","autoResize"],this.options,t)}!0===this.options.autoResize&&(this._cleanUp(),this.resizeTimer=sl((function(){!0===o.setSize()&&o.body.emitter.emit("_requestRedraw")}),1e3),this.resizeFunction=it(i=this._onResize).call(i,this),e.addEventListener(window,"resize",this.resizeFunction))}},{key:"_cleanUp",value:function(){void 0!==this.resizeTimer&&clearInterval(this.resizeTimer),e.removeEventListener(window,"resize",this.resizeFunction),this.resizeFunction=void 0}},{key:"_onResize",value:function(){this.setSize(),this.body.emitter.emit("_redraw")}},{key:"_getCameraState",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.pixelRatio;!0===this.initialized&&(this.cameraState.previousWidth=this.frame.canvas.width/t,this.cameraState.previousHeight=this.frame.canvas.height/t,this.cameraState.scale=this.body.view.scale,this.cameraState.position=this.DOMtoCanvas({x:.5*this.frame.canvas.width/t,y:.5*this.frame.canvas.height/t}))}},{key:"_setCameraState",value:function(){if(void 0!==this.cameraState.scale&&0!==this.frame.canvas.clientWidth&&0!==this.frame.canvas.clientHeight&&0!==this.pixelRatio&&this.cameraState.previousWidth>0){var t=this.frame.canvas.width/this.pixelRatio/this.cameraState.previousWidth,e=this.frame.canvas.height/this.pixelRatio/this.cameraState.previousHeight,i=this.cameraState.scale;1!=t&&1!=e?i=.5*this.cameraState.scale*(t+e):1!=t?i=this.cameraState.scale*t:1!=e&&(i=this.cameraState.scale*e),this.body.view.scale=i;var o=this.DOMtoCanvas({x:.5*this.frame.canvas.clientWidth,y:.5*this.frame.canvas.clientHeight}),n={x:o.x-this.cameraState.position.x,y:o.y-this.cameraState.position.y};this.body.view.translation.x+=n.x*this.body.view.scale,this.body.view.translation.y+=n.y*this.body.view.scale}}},{key:"_prepareValue",value:function(t){if("number"==typeof t)return t+"px";if("string"==typeof t){if(-1!==zi(t).call(t,"%")||-1!==zi(t).call(t,"px"))return t;if(-1===zi(t).call(t,"%"))return t+"px"}throw new Error("Could not use the value supplied for width or height:"+t)}},{key:"_create",value:function(){for(;this.body.container.hasChildNodes();)this.body.container.removeChild(this.body.container.firstChild);if(this.frame=document.createElement("div"),this.frame.className="vis-network",this.frame.style.position="relative",this.frame.style.overflow="hidden",this.frame.tabIndex=900,this.frame.canvas=document.createElement("canvas"),this.frame.canvas.style.position="relative",this.frame.appendChild(this.frame.canvas),this.frame.canvas.getContext)this._setPixelRatio(),this.setTransform();else{var t=document.createElement("DIV");t.style.color="red",t.style.fontWeight="bold",t.style.padding="10px",t.innerHTML="Error: your browser does not support HTML canvas",this.frame.canvas.appendChild(t)}this.body.container.appendChild(this.frame),this.body.view.scale=1,this.body.view.translation={x:.5*this.frame.canvas.clientWidth,y:.5*this.frame.canvas.clientHeight},this._bindHammer()}},{key:"_bindHammer",value:function(){var t=this;void 0!==this.hammer&&this.hammer.destroy(),this.drag={},this.pinch={},this.hammer=new fa(this.frame.canvas),this.hammer.get("pinch").set({enable:!0}),this.hammer.get("pan").set({threshold:5,direction:fa.DIRECTION_ALL}),rl.onTouch(this.hammer,(function(e){t.body.eventListeners.onTouch(e)})),this.hammer.on("tap",(function(e){t.body.eventListeners.onTap(e)})),this.hammer.on("doubletap",(function(e){t.body.eventListeners.onDoubleTap(e)})),this.hammer.on("press",(function(e){t.body.eventListeners.onHold(e)})),this.hammer.on("panstart",(function(e){t.body.eventListeners.onDragStart(e)})),this.hammer.on("panmove",(function(e){t.body.eventListeners.onDrag(e)})),this.hammer.on("panend",(function(e){t.body.eventListeners.onDragEnd(e)})),this.hammer.on("pinch",(function(e){t.body.eventListeners.onPinch(e)})),this.frame.canvas.addEventListener("wheel",(function(e){t.body.eventListeners.onMouseWheel(e)})),this.frame.canvas.addEventListener("mousemove",(function(e){t.body.eventListeners.onMouseMove(e)})),this.frame.canvas.addEventListener("contextmenu",(function(e){t.body.eventListeners.onContext(e)})),this.hammerFrame=new fa(this.frame),rl.onRelease(this.hammerFrame,(function(e){t.body.eventListeners.onRelease(e)}))}},{key:"setSize",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.options.width,e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.options.height;t=this._prepareValue(t),e=this._prepareValue(e);var i=!1,o=this.frame.canvas.width,n=this.frame.canvas.height,s=this.pixelRatio;if(this._setPixelRatio(),t!=this.options.width||e!=this.options.height||this.frame.style.width!=t||this.frame.style.height!=e)this._getCameraState(s),this.frame.style.width=t,this.frame.style.height=e,this.frame.canvas.style.width="100%",this.frame.canvas.style.height="100%",this.frame.canvas.width=Math.round(this.frame.canvas.clientWidth*this.pixelRatio),this.frame.canvas.height=Math.round(this.frame.canvas.clientHeight*this.pixelRatio),this.options.width=t,this.options.height=e,this.canvasViewCenter={x:.5*this.frame.clientWidth,y:.5*this.frame.clientHeight},i=!0;else{var r=Math.round(this.frame.canvas.clientWidth*this.pixelRatio),a=Math.round(this.frame.canvas.clientHeight*this.pixelRatio);this.frame.canvas.width===r&&this.frame.canvas.height===a||this._getCameraState(s),this.frame.canvas.width!==r&&(this.frame.canvas.width=r,i=!0),this.frame.canvas.height!==a&&(this.frame.canvas.height=a,i=!0)}return!0===i&&(this.body.emitter.emit("resize",{width:Math.round(this.frame.canvas.width/this.pixelRatio),height:Math.round(this.frame.canvas.height/this.pixelRatio),oldWidth:Math.round(o/this.pixelRatio),oldHeight:Math.round(n/this.pixelRatio)}),this._setCameraState()),this.initialized=!0,i}},{key:"getContext",value:function(){return this.frame.canvas.getContext("2d")}},{key:"_determinePixelRatio",value:function(){var t=this.getContext();if(void 0===t)throw new Error("Could not get canvax context");var e=1;return"undefined"!=typeof window&&(e=window.devicePixelRatio||1),e/(t.webkitBackingStorePixelRatio||t.mozBackingStorePixelRatio||t.msBackingStorePixelRatio||t.oBackingStorePixelRatio||t.backingStorePixelRatio||1)}},{key:"_setPixelRatio",value:function(){this.pixelRatio=this._determinePixelRatio()}},{key:"setTransform",value:function(){var t=this.getContext();if(void 0===t)throw new Error("Could not get canvax context");t.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0)}},{key:"_XconvertDOMtoCanvas",value:function(t){return(t-this.body.view.translation.x)/this.body.view.scale}},{key:"_XconvertCanvasToDOM",value:function(t){return t*this.body.view.scale+this.body.view.translation.x}},{key:"_YconvertDOMtoCanvas",value:function(t){return(t-this.body.view.translation.y)/this.body.view.scale}},{key:"_YconvertCanvasToDOM",value:function(t){return t*this.body.view.scale+this.body.view.translation.y}},{key:"canvasToDOM",value:function(t){return{x:this._XconvertCanvasToDOM(t.x),y:this._YconvertCanvasToDOM(t.y)}}},{key:"DOMtoCanvas",value:function(t){return{x:this._XconvertDOMtoCanvas(t.x),y:this._YconvertDOMtoCanvas(t.y)}}}]),t}()),hl=d.isFinite,dl=Number.isFinite||function(t){return"number"==typeof t&&hl(t)};G({target:"Number",stat:!0},{isFinite:dl});var ll,cl=L.Number.isFinite,ul=function(){function t(e,i){var o,n,s=this;ma(this,t),this.body=e,this.canvas=i,this.animationSpeed=1/this.renderRefreshRate,this.animationEasingFunction="easeInOutQuint",this.easingTime=0,this.sourceScale=0,this.targetScale=0,this.sourceTranslation=0,this.targetTranslation=0,this.lockedOnNodeId=void 0,this.lockedOnNodeOffset=void 0,this.touchTime=0,this.viewFunction=void 0,this.body.emitter.on("fit",it(o=this.fit).call(o,this)),this.body.emitter.on("animationFinished",(function(){s.body.emitter.emit("_stopRendering")})),this.body.emitter.on("unlockNode",it(n=this.releaseNode).call(n,this))}return _a(t,[{key:"setOptions",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};this.options=t}},{key:"fit",value:function(){var t,e,i=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{nodes:[]},o=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if(void 0!==(i=as({},i)).nodes&&0!==i.nodes.length||(i.nodes=this.body.nodeIndices),!0===o){var n=0;for(var s in this.body.nodes)if(this.body.nodes.hasOwnProperty(s)){var r=this.body.nodes[s];!0===r.predefinedPosition&&(n+=1)}if(n>.5*this.body.nodeIndices.length)return void this.fit(i,!1);t=el.getRange(this.body.nodes,i.nodes);var a=this.body.nodeIndices.length;e=12.662/(a+7.4147)+.0964822;var h=Math.min(this.canvas.frame.canvas.clientWidth/600,this.canvas.frame.canvas.clientHeight/600);e*=h}else{this.body.emitter.emit("_resizeNodes"),t=el.getRange(this.body.nodes,i.nodes);var d=1.1*Math.abs(t.maxX-t.minX),l=1.1*Math.abs(t.maxY-t.minY),c=this.canvas.frame.canvas.clientWidth/d,u=this.canvas.frame.canvas.clientHeight/l;e=c<=u?c:u}e>1?e=1:0===e&&(e=1);var p=el.findCenter(t),f={position:p,scale:e,animation:i.animation};this.moveTo(f)}},{key:"focus",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(void 0!==this.body.nodes[t]){var i={x:this.body.nodes[t].x,y:this.body.nodes[t].y};e.position=i,e.lockedOnNode=t,this.moveTo(e)}else console.log("Node: "+t+" cannot be found.")}},{key:"moveTo",value:function(t){if(void 0!==t){if(null!=t.offset){if(null!=t.offset.x){if(t.offset.x=+t.offset.x,!cl(t.offset.x))throw new TypeError('The option "offset.x" has to be a finite number.')}else t.offset.x=0;if(null!=t.offset.y){if(t.offset.y=+t.offset.y,!cl(t.offset.y))throw new TypeError('The option "offset.y" has to be a finite number.')}else t.offset.x=0}else t.offset={x:0,y:0};if(null!=t.position){if(null!=t.position.x){if(t.position.x=+t.position.x,!cl(t.position.x))throw new TypeError('The option "position.x" has to be a finite number.')}else t.position.x=0;if(null!=t.position.y){if(t.position.y=+t.position.y,!cl(t.position.y))throw new TypeError('The option "position.y" has to be a finite number.')}else t.position.x=0}else t.position=this.getViewPosition();if(null!=t.scale){if(t.scale=+t.scale,!(t.scale>0))throw new TypeError('The option "scale" has to be a number greater than zero.')}else t.scale=this.body.view.scale;void 0===t.animation&&(t.animation={duration:0}),!1===t.animation&&(t.animation={duration:0}),!0===t.animation&&(t.animation={}),void 0===t.animation.duration&&(t.animation.duration=1e3),void 0===t.animation.easingFunction&&(t.animation.easingFunction="easeInOutQuad"),this.animateView(t)}else t={}}},{key:"animateView",value:function(t){if(void 0!==t){this.animationEasingFunction=t.animation.easingFunction,this.releaseNode(),!0===t.locked&&(this.lockedOnNodeId=t.lockedOnNode,this.lockedOnNodeOffset=t.offset),0!=this.easingTime&&this._transitionRedraw(!0),this.sourceScale=this.body.view.scale,this.sourceTranslation=this.body.view.translation,this.targetScale=t.scale,this.body.view.scale=this.targetScale;var e,i,o=this.canvas.DOMtoCanvas({x:.5*this.canvas.frame.canvas.clientWidth,y:.5*this.canvas.frame.canvas.clientHeight}),n=o.x-t.position.x,s=o.y-t.position.y;if(this.targetTranslation={x:this.sourceTranslation.x+n*this.targetScale+t.offset.x,y:this.sourceTranslation.y+s*this.targetScale+t.offset.y},0===t.animation.duration)if(null!=this.lockedOnNodeId)this.viewFunction=it(e=this._lockedRedraw).call(e,this),this.body.emitter.on("initRedraw",this.viewFunction);else this.body.view.scale=this.targetScale,this.body.view.translation=this.targetTranslation,this.body.emitter.emit("_requestRedraw");else this.animationSpeed=1/(60*t.animation.duration*.001)||1/60,this.animationEasingFunction=t.animation.easingFunction,this.viewFunction=it(i=this._transitionRedraw).call(i,this),this.body.emitter.on("initRedraw",this.viewFunction),this.body.emitter.emit("_startRendering")}}},{key:"_lockedRedraw",value:function(){var t=this.body.nodes[this.lockedOnNodeId].x,e=this.body.nodes[this.lockedOnNodeId].y,i=this.canvas.DOMtoCanvas({x:.5*this.canvas.frame.canvas.clientWidth,y:.5*this.canvas.frame.canvas.clientHeight}),o=i.x-t,n=i.y-e,s=this.body.view.translation,r={x:s.x+o*this.body.view.scale+this.lockedOnNodeOffset.x,y:s.y+n*this.body.view.scale+this.lockedOnNodeOffset.y};this.body.view.translation=r}},{key:"releaseNode",value:function(){void 0!==this.lockedOnNodeId&&void 0!==this.viewFunction&&(this.body.emitter.off("initRedraw",this.viewFunction),this.lockedOnNodeId=void 0,this.lockedOnNodeOffset=void 0)}},{key:"_transitionRedraw",value:function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];this.easingTime+=this.animationSpeed,this.easingTime=!0===t?1:this.easingTime;var i=e.easingFunctions[this.animationEasingFunction](this.easingTime);if(this.body.view.scale=this.sourceScale+(this.targetScale-this.sourceScale)*i,this.body.view.translation={x:this.sourceTranslation.x+(this.targetTranslation.x-this.sourceTranslation.x)*i,y:this.sourceTranslation.y+(this.targetTranslation.y-this.sourceTranslation.y)*i},this.easingTime>=1){var o;if(this.body.emitter.off("initRedraw",this.viewFunction),this.easingTime=0,null!=this.lockedOnNodeId)this.viewFunction=it(o=this._lockedRedraw).call(o,this),this.body.emitter.on("initRedraw",this.viewFunction);this.body.emitter.emit("animationFinished")}}},{key:"getScale",value:function(){return this.body.view.scale}},{key:"getViewPosition",value:function(){return this.canvas.DOMtoCanvas({x:.5*this.canvas.frame.canvas.clientWidth,y:.5*this.canvas.frame.canvas.clientHeight})}}]),t}(),pl=function(){function t(e,i){var o=this;ma(this,t),this.body=e,this.canvas=i,this.iconsCreated=!1,this.navigationHammers=[],this.boundFunctions={},this.touchTime=0,this.activated=!1,this.body.emitter.on("activate",(function(){o.activated=!0,o.configureKeyboardBindings()})),this.body.emitter.on("deactivate",(function(){o.activated=!1,o.configureKeyboardBindings()})),this.body.emitter.on("destroy",(function(){void 0!==o.keycharm&&o.keycharm.destroy()})),this.options={}}return _a(t,[{key:"setOptions",value:function(t){void 0!==t&&(this.options=t,this.create())}},{key:"create",value:function(){!0===this.options.navigationButtons?!1===this.iconsCreated&&this.loadNavigationElements():!0===this.iconsCreated&&this.cleanNavigation(),this.configureKeyboardBindings()}},{key:"cleanNavigation",value:function(){if(0!=this.navigationHammers.length){for(var t=0;t<this.navigationHammers.length;t++)this.navigationHammers[t].destroy();this.navigationHammers=[]}this.navigationDOM&&this.navigationDOM.wrapper&&this.navigationDOM.wrapper.parentNode&&this.navigationDOM.wrapper.parentNode.removeChild(this.navigationDOM.wrapper),this.iconsCreated=!1}},{key:"loadNavigationElements",value:function(){var t=this;this.cleanNavigation(),this.navigationDOM={};var e=["up","down","left","right","zoomIn","zoomOut","zoomExtends"],i=["_moveUp","_moveDown","_moveLeft","_moveRight","_zoomIn","_zoomOut","_fit"];this.navigationDOM.wrapper=document.createElement("div"),this.navigationDOM.wrapper.className="vis-navigation",this.canvas.frame.appendChild(this.navigationDOM.wrapper);for(var o=0;o<e.length;o++){this.navigationDOM[e[o]]=document.createElement("div"),this.navigationDOM[e[o]].className="vis-button vis-"+e[o],this.navigationDOM.wrapper.appendChild(this.navigationDOM[e[o]]);var n,s,r=new fa(this.navigationDOM[e[o]]);if("_fit"===i[o])rl.onTouch(r,it(n=this._fit).call(n,this));else rl.onTouch(r,it(s=this.bindToRedraw).call(s,this,i[o]));this.navigationHammers.push(r)}var a=new fa(this.canvas.frame);rl.onRelease(a,(function(){t._stopMovement()})),this.navigationHammers.push(a),this.iconsCreated=!0}},{key:"bindToRedraw",value:function(t){var e;void 0===this.boundFunctions[t]&&(this.boundFunctions[t]=it(e=this[t]).call(e,this),this.body.emitter.on("initRedraw",this.boundFunctions[t]),this.body.emitter.emit("_startRendering"))}},{key:"unbindFromRedraw",value:function(t){void 0!==this.boundFunctions[t]&&(this.body.emitter.off("initRedraw",this.boundFunctions[t]),this.body.emitter.emit("_stopRendering"),delete this.boundFunctions[t])}},{key:"_fit",value:function(){(new Date).valueOf()-this.touchTime>700&&(this.body.emitter.emit("fit",{duration:700}),this.touchTime=(new Date).valueOf())}},{key:"_stopMovement",value:function(){for(var t in this.boundFunctions)this.boundFunctions.hasOwnProperty(t)&&(this.body.emitter.off("initRedraw",this.boundFunctions[t]),this.body.emitter.emit("_stopRendering"));this.boundFunctions={}}},{key:"_moveUp",value:function(){this.body.view.translation.y+=this.options.keyboard.speed.y}},{key:"_moveDown",value:function(){this.body.view.translation.y-=this.options.keyboard.speed.y}},{key:"_moveLeft",value:function(){this.body.view.translation.x+=this.options.keyboard.speed.x}},{key:"_moveRight",value:function(){this.body.view.translation.x-=this.options.keyboard.speed.x}},{key:"_zoomIn",value:function(){var t=this.body.view.scale,e=this.body.view.scale*(1+this.options.keyboard.speed.zoom),i=this.body.view.translation,o=e/t,n=(1-o)*this.canvas.canvasViewCenter.x+i.x*o,s=(1-o)*this.canvas.canvasViewCenter.y+i.y*o;this.body.view.scale=e,this.body.view.translation={x:n,y:s},this.body.emitter.emit("zoom",{direction:"+",scale:this.body.view.scale,pointer:null})}},{key:"_zoomOut",value:function(){var t=this.body.view.scale,e=this.body.view.scale/(1+this.options.keyboard.speed.zoom),i=this.body.view.translation,o=e/t,n=(1-o)*this.canvas.canvasViewCenter.x+i.x*o,s=(1-o)*this.canvas.canvasViewCenter.y+i.y*o;this.body.view.scale=e,this.body.view.translation={x:n,y:s},this.body.emitter.emit("zoom",{direction:"-",scale:this.body.view.scale,pointer:null})}},{key:"configureKeyboardBindings",value:function(){var t,e,o,n,s,r,a,h,d,l,c,u,p,f,v,g,y,m,b,w,k,_,x,E,O=this;(void 0!==this.keycharm&&this.keycharm.destroy(),!0===this.options.keyboard.enabled)&&(!0===this.options.keyboard.bindToWindow?this.keycharm=i({container:window,preventDefault:!0}):this.keycharm=i({container:this.canvas.frame,preventDefault:!0}),this.keycharm.reset(),!0===this.activated&&(it(t=this.keycharm).call(t,"up",(function(){O.bindToRedraw("_moveUp")}),"keydown"),it(e=this.keycharm).call(e,"down",(function(){O.bindToRedraw("_moveDown")}),"keydown"),it(o=this.keycharm).call(o,"left",(function(){O.bindToRedraw("_moveLeft")}),"keydown"),it(n=this.keycharm).call(n,"right",(function(){O.bindToRedraw("_moveRight")}),"keydown"),it(s=this.keycharm).call(s,"=",(function(){O.bindToRedraw("_zoomIn")}),"keydown"),it(r=this.keycharm).call(r,"num+",(function(){O.bindToRedraw("_zoomIn")}),"keydown"),it(a=this.keycharm).call(a,"num-",(function(){O.bindToRedraw("_zoomOut")}),"keydown"),it(h=this.keycharm).call(h,"-",(function(){O.bindToRedraw("_zoomOut")}),"keydown"),it(d=this.keycharm).call(d,"[",(function(){O.bindToRedraw("_zoomOut")}),"keydown"),it(l=this.keycharm).call(l,"]",(function(){O.bindToRedraw("_zoomIn")}),"keydown"),it(c=this.keycharm).call(c,"pageup",(function(){O.bindToRedraw("_zoomIn")}),"keydown"),it(u=this.keycharm).call(u,"pagedown",(function(){O.bindToRedraw("_zoomOut")}),"keydown"),it(p=this.keycharm).call(p,"up",(function(){O.unbindFromRedraw("_moveUp")}),"keyup"),it(f=this.keycharm).call(f,"down",(function(){O.unbindFromRedraw("_moveDown")}),"keyup"),it(v=this.keycharm).call(v,"left",(function(){O.unbindFromRedraw("_moveLeft")}),"keyup"),it(g=this.keycharm).call(g,"right",(function(){O.unbindFromRedraw("_moveRight")}),"keyup"),it(y=this.keycharm).call(y,"=",(function(){O.unbindFromRedraw("_zoomIn")}),"keyup"),it(m=this.keycharm).call(m,"num+",(function(){O.unbindFromRedraw("_zoomIn")}),"keyup"),it(b=this.keycharm).call(b,"num-",(function(){O.unbindFromRedraw("_zoomOut")}),"keyup"),it(w=this.keycharm).call(w,"-",(function(){O.unbindFromRedraw("_zoomOut")}),"keyup"),it(k=this.keycharm).call(k,"[",(function(){O.unbindFromRedraw("_zoomOut")}),"keyup"),it(_=this.keycharm).call(_,"]",(function(){O.unbindFromRedraw("_zoomIn")}),"keyup"),it(x=this.keycharm).call(x,"pageup",(function(){O.unbindFromRedraw("_zoomIn")}),"keyup"),it(E=this.keycharm).call(E,"pagedown",(function(){O.unbindFromRedraw("_zoomOut")}),"keyup")))}}]),t}(),fl=function(){function t(e,i){ma(this,t),this.container=e,this.overflowMethod=i||"cap",this.x=0,this.y=0,this.padding=5,this.hidden=!1,this.frame=document.createElement("div"),this.frame.className="vis-tooltip",this.container.appendChild(this.frame)}return _a(t,[{key:"setPosition",value:function(t,e){this.x=$a(t),this.y=$a(e)}},{key:"setText",value:function(t){t instanceof Element?(this.frame.innerHTML="",this.frame.appendChild(t)):this.frame.innerHTML=t}},{key:"show",value:function(t){if(void 0===t&&(t=!0),!0===t){var e=this.frame.clientHeight,i=this.frame.clientWidth,o=this.frame.parentNode.clientHeight,n=this.frame.parentNode.clientWidth,s=0,r=0;if("flip"==this.overflowMethod){var a=!1,h=!0;this.y-e<this.padding&&(h=!1),this.x+i>n-this.padding&&(a=!0),s=a?this.x-i:this.x,r=h?this.y-e:this.y}else(r=this.y-e)+e+this.padding>o&&(r=o-e-this.padding),r<this.padding&&(r=this.padding),(s=this.x)+i+this.padding>n&&(s=n-i-this.padding),s<this.padding&&(s=this.padding);this.frame.style.left=s+"px",this.frame.style.top=r+"px",this.frame.style.visibility="visible",this.hidden=!1}else this.hide()}},{key:"hide",value:function(){this.hidden=!0,this.frame.style.left="0",this.frame.style.top="0",this.frame.style.visibility="hidden"}},{key:"destroy",value:function(){this.frame.parentNode.removeChild(this.frame)}}]),t}(),vl=function(){function t(i,o,n){var s,r,a,h,d,l,c,u,p,f,v,g,y;ma(this,t),this.body=i,this.canvas=o,this.selectionHandler=n,this.navigationHandler=new pl(i,o),this.body.eventListeners.onTap=it(s=this.onTap).call(s,this),this.body.eventListeners.onTouch=it(r=this.onTouch).call(r,this),this.body.eventListeners.onDoubleTap=it(a=this.onDoubleTap).call(a,this),this.body.eventListeners.onHold=it(h=this.onHold).call(h,this),this.body.eventListeners.onDragStart=it(d=this.onDragStart).call(d,this),this.body.eventListeners.onDrag=it(l=this.onDrag).call(l,this),this.body.eventListeners.onDragEnd=it(c=this.onDragEnd).call(c,this),this.body.eventListeners.onMouseWheel=it(u=this.onMouseWheel).call(u,this),this.body.eventListeners.onPinch=it(p=this.onPinch).call(p,this),this.body.eventListeners.onMouseMove=it(f=this.onMouseMove).call(f,this),this.body.eventListeners.onRelease=it(v=this.onRelease).call(v,this),this.body.eventListeners.onContext=it(g=this.onContext).call(g,this),this.touchTime=0,this.drag={},this.pinch={},this.popup=void 0,this.popupObj=void 0,this.popupTimer=void 0,this.body.functions.getPointer=it(y=this.getPointer).call(y,this),this.options={},this.defaultOptions={dragNodes:!0,dragView:!0,hover:!1,keyboard:{enabled:!1,speed:{x:10,y:10,zoom:.02},bindToWindow:!0},navigationButtons:!1,tooltipDelay:300,zoomView:!0,zoomSpeed:1},e.extend(this.options,this.defaultOptions),this.bindEventListeners()}return _a(t,[{key:"bindEventListeners",value:function(){var t=this;this.body.emitter.on("destroy",(function(){clearTimeout(t.popupTimer),delete t.body.functions.getPointer}))}},{key:"setOptions",value:function(t){if(void 0!==t){e.selectiveNotDeepExtend(["hideEdgesOnDrag","hideEdgesOnZoom","hideNodesOnDrag","keyboard","multiselect","selectable","selectConnectedEdges"],this.options,t),e.mergeOptions(this.options,t,"keyboard"),t.tooltip&&(e.extend(this.options.tooltip,t.tooltip),t.tooltip.color&&(this.options.tooltip.color=e.parseColor(t.tooltip.color)))}this.navigationHandler.setOptions(this.options)}},{key:"getPointer",value:function(t){return{x:t.x-e.getAbsoluteLeft(this.canvas.frame.canvas),y:t.y-e.getAbsoluteTop(this.canvas.frame.canvas)}}},{key:"onTouch",value:function(t){(new Date).valueOf()-this.touchTime>50&&(this.drag.pointer=this.getPointer(t.center),this.drag.pinched=!1,this.pinch.scale=this.body.view.scale,this.touchTime=(new Date).valueOf())}},{key:"onTap",value:function(t){var e=this.getPointer(t.center),i=this.selectionHandler.options.multiselect&&(t.changedPointers[0].ctrlKey||t.changedPointers[0].metaKey);this.checkSelectionChanges(e,t,i),this.selectionHandler._generateClickEvent("click",t,e)}},{key:"onDoubleTap",value:function(t){var e=this.getPointer(t.center);this.selectionHandler._generateClickEvent("doubleClick",t,e)}},{key:"onHold",value:function(t){var e=this.getPointer(t.center),i=this.selectionHandler.options.multiselect;this.checkSelectionChanges(e,t,i),this.selectionHandler._generateClickEvent("click",t,e),this.selectionHandler._generateClickEvent("hold",t,e)}},{key:"onRelease",value:function(t){if((new Date).valueOf()-this.touchTime>10){var e=this.getPointer(t.center);this.selectionHandler._generateClickEvent("release",t,e),this.touchTime=(new Date).valueOf()}}},{key:"onContext",value:function(t){var e=this.getPointer({x:t.clientX,y:t.clientY});this.selectionHandler._generateClickEvent("oncontext",t,e)}},{key:"checkSelectionChanges",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],o=this.selectionHandler.getSelection(),n=!1;n=!0===i?this.selectionHandler.selectAdditionalOnPoint(t):this.selectionHandler.selectOnPoint(t);var s=this.selectionHandler.getSelection(),r=this._determineDifference(o,s),a=this._determineDifference(s,o);r.edges.length>0&&(this.selectionHandler._generateClickEvent("deselectEdge",e,t,o),n=!0),r.nodes.length>0&&(this.selectionHandler._generateClickEvent("deselectNode",e,t,o),n=!0),a.nodes.length>0&&(this.selectionHandler._generateClickEvent("selectNode",e,t),n=!0),a.edges.length>0&&(this.selectionHandler._generateClickEvent("selectEdge",e,t),n=!0),!0===n&&this.selectionHandler._generateClickEvent("select",e,t)}},{key:"_determineDifference",value:function(t,e){var i=function(t,e){for(var i=[],o=0;o<t.length;o++){var n=t[o];-1===zi(e).call(e,n)&&i.push(n)}return i};return{nodes:i(t.nodes,e.nodes),edges:i(t.edges,e.edges)}}},{key:"onDragStart",value:function(t){void 0===this.drag.pointer&&this.onTouch(t);var i=this.selectionHandler.getNodeAt(this.drag.pointer);if(this.drag.dragging=!0,this.drag.selection=[],this.drag.translation=e.extend({},this.body.view.translation),this.drag.nodeId=void 0,void 0!==i&&!0===this.options.dragNodes){this.drag.nodeId=i.id,!1===i.isSelected()&&(this.selectionHandler.unselectAll(),this.selectionHandler.selectObject(i)),this.selectionHandler._generateClickEvent("dragStart",t,this.drag.pointer);var o=this.selectionHandler.selectionObj.nodes;for(var n in o)if(o.hasOwnProperty(n)){var s=o[n],r={id:s.id,node:s,x:s.x,y:s.y,xFixed:s.options.fixed.x,yFixed:s.options.fixed.y};s.options.fixed.x=!0,s.options.fixed.y=!0,this.drag.selection.push(r)}}else this.selectionHandler._generateClickEvent("dragStart",t,this.drag.pointer,void 0,!0)}},{key:"onDrag",value:function(t){var e=this;if(!0!==this.drag.pinched){this.body.emitter.emit("unlockNode");var i=this.getPointer(t.center),o=this.drag.selection;if(o&&o.length&&!0===this.options.dragNodes){this.selectionHandler._generateClickEvent("dragging",t,i);var n=i.x-this.drag.pointer.x,s=i.y-this.drag.pointer.y;yi(o).call(o,(function(t){var i=t.node;!1===t.xFixed&&(i.x=e.canvas._XconvertDOMtoCanvas(e.canvas._XconvertCanvasToDOM(t.x)+n)),!1===t.yFixed&&(i.y=e.canvas._YconvertDOMtoCanvas(e.canvas._YconvertCanvasToDOM(t.y)+s))})),this.body.emitter.emit("startSimulation")}else if(!0===this.options.dragView){if(this.selectionHandler._generateClickEvent("dragging",t,i,void 0,!0),void 0===this.drag.pointer)return void this.onDragStart(t);var r=i.x-this.drag.pointer.x,a=i.y-this.drag.pointer.y;this.body.view.translation={x:this.drag.translation.x+r,y:this.drag.translation.y+a},this.body.emitter.emit("_requestRedraw")}}}},{key:"onDragEnd",value:function(t){this.drag.dragging=!1;var e=this.drag.selection;e&&e.length?(yi(e).call(e,(function(t){t.node.options.fixed.x=t.xFixed,t.node.options.fixed.y=t.yFixed})),this.selectionHandler._generateClickEvent("dragEnd",t,this.getPointer(t.center)),this.body.emitter.emit("startSimulation")):(this.selectionHandler._generateClickEvent("dragEnd",t,this.getPointer(t.center),void 0,!0),this.body.emitter.emit("_requestRedraw"))}},{key:"onPinch",value:function(t){var e=this.getPointer(t.center);this.drag.pinched=!0,void 0===this.pinch.scale&&(this.pinch.scale=1);var i=this.pinch.scale*t.scale;this.zoom(i,e)}},{key:"zoom",value:function(t,e){if(!0===this.options.zoomView){var i=this.body.view.scale;t<1e-5&&(t=1e-5),t>10&&(t=10);var o=void 0;void 0!==this.drag&&!0===this.drag.dragging&&(o=this.canvas.DOMtoCanvas(this.drag.pointer));var n=this.body.view.translation,s=t/i,r=(1-s)*e.x+n.x*s,a=(1-s)*e.y+n.y*s;if(this.body.view.scale=t,this.body.view.translation={x:r,y:a},null!=o){var h=this.canvas.canvasToDOM(o);this.drag.pointer.x=h.x,this.drag.pointer.y=h.y}this.body.emitter.emit("_requestRedraw"),i<t?this.body.emitter.emit("zoom",{direction:"+",scale:this.body.view.scale,pointer:e}):this.body.emitter.emit("zoom",{direction:"-",scale:this.body.view.scale,pointer:e})}}},{key:"onMouseWheel",value:function(t){if(!0===this.options.zoomView){if(0!==t.deltaY){var e=this.body.view.scale;e*=1+(t.deltaY<0?1:-1)*(.1*this.options.zoomSpeed);var i=this.getPointer({x:t.clientX,y:t.clientY});this.zoom(e,i)}t.preventDefault()}}},{key:"onMouseMove",value:function(t){var e=this,i=this.getPointer({x:t.clientX,y:t.clientY}),o=!1;void 0!==this.popup&&(!1===this.popup.hidden&&this._checkHidePopup(i),!1===this.popup.hidden&&(o=!0,this.popup.setPosition(i.x+3,i.y-5),this.popup.show())),!1===this.options.keyboard.bindToWindow&&!0===this.options.keyboard.enabled&&this.canvas.frame.focus(),!1===o&&(void 0!==this.popupTimer&&(clearInterval(this.popupTimer),this.popupTimer=void 0),this.drag.dragging||(this.popupTimer=Io((function(){return e._checkShowPopup(i)}),this.options.tooltipDelay))),!0===this.options.hover&&this.selectionHandler.hoverObject(t,i)}},{key:"_checkShowPopup",value:function(t){var e=this.canvas._XconvertDOMtoCanvas(t.x),i=this.canvas._YconvertDOMtoCanvas(t.y),o={left:e,top:i,right:e,bottom:i},n=void 0===this.popupObj?void 0:this.popupObj.id,s=!1,r="node";if(void 0===this.popupObj){for(var a,h=this.body.nodeIndices,d=this.body.nodes,l=[],c=0;c<h.length;c++)!0===(a=d[h[c]]).isOverlappingWith(o)&&(s=!0,void 0!==a.getTitle()&&l.push(h[c]));l.length>0&&(this.popupObj=d[l[l.length-1]],s=!0)}if(void 0===this.popupObj&&!1===s){for(var u,p=this.body.edgeIndices,f=this.body.edges,v=[],g=0;g<p.length;g++)!0===(u=f[p[g]]).isOverlappingWith(o)&&!0===u.connected&&void 0!==u.getTitle()&&v.push(p[g]);v.length>0&&(this.popupObj=f[v[v.length-1]],r="edge")}void 0!==this.popupObj?this.popupObj.id!==n&&(void 0===this.popup&&(this.popup=new fl(this.canvas.frame)),this.popup.popupTargetType=r,this.popup.popupTargetId=this.popupObj.id,this.popup.setPosition(t.x+3,t.y-5),this.popup.setText(this.popupObj.getTitle()),this.popup.show(),this.body.emitter.emit("showPopup",this.popupObj.id)):void 0!==this.popup&&(this.popup.hide(),this.body.emitter.emit("hidePopup"))}},{key:"_checkHidePopup",value:function(t){var e=this.selectionHandler._pointerToPositionObject(t),i=!1;if("node"===this.popup.popupTargetType){if(void 0!==this.body.nodes[this.popup.popupTargetId]&&!0===(i=this.body.nodes[this.popup.popupTargetId].isOverlappingWith(e))){var o=this.selectionHandler.getNodeAt(t);i=void 0!==o&&o.id===this.popup.popupTargetId}}else void 0===this.selectionHandler.getNodeAt(t)&&void 0!==this.body.edges[this.popup.popupTargetId]&&(i=this.body.edges[this.popup.popupTargetId].isOverlappingWith(e));!1===i&&(this.popupObj=void 0,this.popup.hide(),this.body.emitter.emit("hidePopup"))}}]),t}(),gl=function(){function t(i,o){var n=this;ma(this,t),this.body=i,this.canvas=o,this.selectionObj={nodes:[],edges:[]},this.hoverObj={nodes:{},edges:{}},this.options={},this.defaultOptions={multiselect:!1,selectable:!0,selectConnectedEdges:!0,hoverConnectedEdges:!0},e.extend(this.options,this.defaultOptions),this.body.emitter.on("_dataChanged",(function(){n.updateSelection()}))}return _a(t,[{key:"setOptions",value:function(t){if(void 0!==t){e.selectiveDeepExtend(["multiselect","hoverConnectedEdges","selectable","selectConnectedEdges"],this.options,t)}}},{key:"selectOnPoint",value:function(t){var e=!1;if(!0===this.options.selectable){var i=this.getNodeAt(t)||this.getEdgeAt(t);this.unselectAll(),void 0!==i&&(e=this.selectObject(i)),this.body.emitter.emit("_requestRedraw")}return e}},{key:"selectAdditionalOnPoint",value:function(t){var e=!1;if(!0===this.options.selectable){var i=this.getNodeAt(t)||this.getEdgeAt(t);void 0!==i&&(e=!0,!0===i.isSelected()?this.deselectObject(i):this.selectObject(i),this.body.emitter.emit("_requestRedraw"))}return e}},{key:"_initBaseEvent",value:function(t,e){var i={};return i.pointer={DOM:{x:e.x,y:e.y},canvas:this.canvas.DOMtoCanvas(e)},i.event=t,i}},{key:"_generateClickEvent",value:function(t,e,i,o){var n=arguments.length>4&&void 0!==arguments[4]&&arguments[4],s=this._initBaseEvent(e,i);if(!0===n)s.nodes=[],s.edges=[];else{var r=this.getSelection();s.nodes=r.nodes,s.edges=r.edges}void 0!==o&&(s.previousSelection=o),"click"==t&&(s.items=this.getClickedItems(i)),void 0!==e.controlEdge&&(s.controlEdge=e.controlEdge),this.body.emitter.emit(t,s)}},{key:"selectObject",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.options.selectConnectedEdges;return void 0!==t&&(t instanceof nd&&!0===e&&this._selectConnectedEdges(t),t.select(),this._addToSelection(t),!0)}},{key:"deselectObject",value:function(t){!0===t.isSelected()&&(t.selected=!1,this._removeFromSelection(t))}},{key:"_getAllNodesOverlappingWith",value:function(t){for(var e=[],i=this.body.nodes,o=0;o<this.body.nodeIndices.length;o++){var n=this.body.nodeIndices[o];i[n].isOverlappingWith(t)&&e.push(n)}return e}},{key:"_pointerToPositionObject",value:function(t){var e=this.canvas.DOMtoCanvas(t);return{left:e.x-1,top:e.y+1,right:e.x+1,bottom:e.y-1}}},{key:"getNodeAt",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],i=this._pointerToPositionObject(t),o=this._getAllNodesOverlappingWith(i);return o.length>0?!0===e?this.body.nodes[o[o.length-1]]:o[o.length-1]:void 0}},{key:"_getEdgesOverlappingWith",value:function(t,e){for(var i=this.body.edges,o=0;o<this.body.edgeIndices.length;o++){var n=this.body.edgeIndices[o];i[n].isOverlappingWith(t)&&e.push(n)}}},{key:"_getAllEdgesOverlappingWith",value:function(t){var e=[];return this._getEdgesOverlappingWith(t,e),e}},{key:"getEdgeAt",value:function(t){for(var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],i=this.canvas.DOMtoCanvas(t),o=10,n=null,s=this.body.edges,r=0;r<this.body.edgeIndices.length;r++){var a=this.body.edgeIndices[r],h=s[a];if(h.connected){var d=h.from.x,l=h.from.y,c=h.to.x,u=h.to.y,p=h.edgeType.getDistanceToEdge(d,l,c,u,i.x,i.y);p<o&&(n=a,o=p)}}return null!==n?!0===e?this.body.edges[n]:n:void 0}},{key:"_addToSelection",value:function(t){t instanceof nd?this.selectionObj.nodes[t.id]=t:this.selectionObj.edges[t.id]=t}},{key:"_addToHover",value:function(t){t instanceof nd?this.hoverObj.nodes[t.id]=t:this.hoverObj.edges[t.id]=t}},{key:"_removeFromSelection",value:function(t){t instanceof nd?(delete this.selectionObj.nodes[t.id],this._unselectConnectedEdges(t)):delete this.selectionObj.edges[t.id]}},{key:"unselectAll",value:function(){for(var t in this.selectionObj.nodes)this.selectionObj.nodes.hasOwnProperty(t)&&this.selectionObj.nodes[t].unselect();for(var e in this.selectionObj.edges)this.selectionObj.edges.hasOwnProperty(e)&&this.selectionObj.edges[e].unselect();this.selectionObj={nodes:{},edges:{}}}},{key:"_getSelectedNodeCount",value:function(){var t=0;for(var e in this.selectionObj.nodes)this.selectionObj.nodes.hasOwnProperty(e)&&(t+=1);return t}},{key:"_getSelectedNode",value:function(){for(var t in this.selectionObj.nodes)if(this.selectionObj.nodes.hasOwnProperty(t))return this.selectionObj.nodes[t]}},{key:"_getSelectedEdge",value:function(){for(var t in this.selectionObj.edges)if(this.selectionObj.edges.hasOwnProperty(t))return this.selectionObj.edges[t]}},{key:"_getSelectedEdgeCount",value:function(){var t=0;for(var e in this.selectionObj.edges)this.selectionObj.edges.hasOwnProperty(e)&&(t+=1);return t}},{key:"_getSelectedObjectCount",value:function(){var t=0;for(var e in this.selectionObj.nodes)this.selectionObj.nodes.hasOwnProperty(e)&&(t+=1);for(var i in this.selectionObj.edges)this.selectionObj.edges.hasOwnProperty(i)&&(t+=1);return t}},{key:"_selectionIsEmpty",value:function(){for(var t in this.selectionObj.nodes)if(this.selectionObj.nodes.hasOwnProperty(t))return!1;for(var e in this.selectionObj.edges)if(this.selectionObj.edges.hasOwnProperty(e))return!1;return!0}},{key:"_clusterInSelection",value:function(){for(var t in this.selectionObj.nodes)if(this.selectionObj.nodes.hasOwnProperty(t)&&this.selectionObj.nodes[t].clusterSize>1)return!0;return!1}},{key:"_selectConnectedEdges",value:function(t){for(var e=0;e<t.edges.length;e++){var i=t.edges[e];i.select(),this._addToSelection(i)}}},{key:"_hoverConnectedEdges",value:function(t){for(var e=0;e<t.edges.length;e++){var i=t.edges[e];i.hover=!0,this._addToHover(i)}}},{key:"_unselectConnectedEdges",value:function(t){for(var e=0;e<t.edges.length;e++){var i=t.edges[e];i.unselect(),this._removeFromSelection(i)}}},{key:"emitBlurEvent",value:function(t,e,i){var o=this._initBaseEvent(t,e);!0===i.hover&&(i.hover=!1,i instanceof nd?(o.node=i.id,this.body.emitter.emit("blurNode",o)):(o.edge=i.id,this.body.emitter.emit("blurEdge",o)))}},{key:"emitHoverEvent",value:function(t,e,i){var o=this._initBaseEvent(t,e),n=!1;return!1===i.hover&&(i.hover=!0,this._addToHover(i),n=!0,i instanceof nd?(o.node=i.id,this.body.emitter.emit("hoverNode",o)):(o.edge=i.id,this.body.emitter.emit("hoverEdge",o))),n}},{key:"hoverObject",value:function(t,e){var i=this.getNodeAt(e);void 0===i&&(i=this.getEdgeAt(e));var o=!1;for(var n in this.hoverObj.nodes)this.hoverObj.nodes.hasOwnProperty(n)&&(void 0===i||i instanceof nd&&i.id!=n||i instanceof Rd)&&(this.emitBlurEvent(t,e,this.hoverObj.nodes[n]),delete this.hoverObj.nodes[n],o=!0);for(var s in this.hoverObj.edges)this.hoverObj.edges.hasOwnProperty(s)&&(!0===o?(this.hoverObj.edges[s].hover=!1,delete this.hoverObj.edges[s]):(void 0===i||i instanceof Rd&&i.id!=s||i instanceof nd&&!i.hover)&&(this.emitBlurEvent(t,e,this.hoverObj.edges[s]),delete this.hoverObj.edges[s],o=!0));if(void 0!==i){var r=To(this.hoverObj.edges).length,a=To(this.hoverObj.nodes).length;(o||i instanceof Rd&&0===r&&0===a||i instanceof nd&&0===r&&0===a)&&(o=this.emitHoverEvent(t,e,i)),i instanceof nd&&!0===this.options.hoverConnectedEdges&&this._hoverConnectedEdges(i)}!0===o&&this.body.emitter.emit("_requestRedraw")}},{key:"getSelection",value:function(){return{nodes:this.getSelectedNodes(),edges:this.getSelectedEdges()}}},{key:"getSelectedNodes",value:function(){var t=[];if(!0===this.options.selectable)for(var e in this.selectionObj.nodes)this.selectionObj.nodes.hasOwnProperty(e)&&t.push(this.selectionObj.nodes[e].id);return t}},{key:"getSelectedEdges",value:function(){var t=[];if(!0===this.options.selectable)for(var e in this.selectionObj.edges)this.selectionObj.edges.hasOwnProperty(e)&&t.push(this.selectionObj.edges[e].id);return t}},{key:"setSelection",value:function(t){var e,i,o=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(!t||!t.nodes&&!t.edges)throw"Selection must be an object with nodes and/or edges properties";if((o.unselectAll||void 0===o.unselectAll)&&this.unselectAll(),t.nodes)for(e=0;e<t.nodes.length;e++){i=t.nodes[e];var n=this.body.nodes[i];if(!n)throw new RangeError('Node with id "'+i+'" not found');this.selectObject(n,o.highlightEdges)}if(t.edges)for(e=0;e<t.edges.length;e++){i=t.edges[e];var s=this.body.edges[i];if(!s)throw new RangeError('Edge with id "'+i+'" not found');this.selectObject(s)}this.body.emitter.emit("_requestRedraw")}},{key:"selectNodes",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if(!t||void 0===t.length)throw"Selection must be an array with ids";this.setSelection({nodes:t},{highlightEdges:e})}},{key:"selectEdges",value:function(t){if(!t||void 0===t.length)throw"Selection must be an array with ids";this.setSelection({edges:t})}},{key:"updateSelection",value:function(){for(var t in this.selectionObj.nodes)this.selectionObj.nodes.hasOwnProperty(t)&&(this.body.nodes.hasOwnProperty(t)||delete this.selectionObj.nodes[t]);for(var e in this.selectionObj.edges)this.selectionObj.edges.hasOwnProperty(e)&&(this.body.edges.hasOwnProperty(e)||delete this.selectionObj.edges[e])}},{key:"getClickedItems",value:function(t){for(var e=this.canvas.DOMtoCanvas(t),i=[],o=this.body.nodeIndices,n=this.body.nodes,s=o.length-1;s>=0;s--){var r=n[o[s]].getItemsOnPoint(e);i.push.apply(i,r)}for(var a=this.body.edgeIndices,h=this.body.edges,d=a.length-1;d>=0;d--){var l=h[a[d]].getItemsOnPoint(e);i.push.apply(i,l)}return i}}]),t}(),yl=r((function(t,e){!function(t){t.__esModule=!0,t.sort=function(t,i,o,n){if(!bi(t))throw new TypeError("Can only sort arrays");i?"function"!=typeof i&&(n=o,o=i,i=r):i=r,o||(o=0),n||(n=t.length);var s=n-o;if(!(s<2)){var d=0;if(s<e)return d=a(t,o,n,i),void h(t,o,n,o+d,i);var l=new c(t,i),u=function(t){for(var i=0;t>=e;)i|=1&t,t>>=1;return t+i}(s);do{if((d=a(t,o,n,i))<u){var p=s;p>u&&(p=u),h(t,o,o+p,o+d,i),d=p}l.pushRun(o,d),l.mergeRuns(),s-=d,o+=d}while(0!==s);l.forceMergeRuns()}};var e=32,i=7,o=256,n=[1,10,100,1e3,1e4,1e5,1e6,1e7,1e8,1e9];function s(t){return t<1e5?t<100?t<10?0:1:t<1e4?t<1e3?2:3:4:t<1e7?t<1e6?5:6:t<1e9?t<1e8?7:8:9}function r(t,e){if(t===e)return 0;if(~~t===t&&~~e===e){if(0===t||0===e)return t<e?-1:1;if(t<0||e<0){if(e>=0)return-1;if(t>=0)return 1;t=-t,e=-e}var i=s(t),o=s(e),r=0;return i<o?(t*=n[o-i-1],e/=10,r=-1):i>o&&(e*=n[i-o-1],t/=10,r=1),t===e?r:t<e?-1:1}var a=String(t),h=String(e);return a===h?0:a<h?-1:1}function a(t,e,i,o){var n=e+1;if(n===i)return 1;if(o(t[n++],t[e])<0){for(;n<i&&o(t[n],t[n-1])<0;)n++;!function(t,e,i){for(i--;e<i;){var o=t[e];t[e++]=t[i],t[i--]=o}}(t,e,n)}else for(;n<i&&o(t[n],t[n-1])>=0;)n++;return n-e}function h(t,e,i,o,n){for(o===e&&o++;o<i;o++){for(var s=t[o],r=e,a=o;r<a;){var h=r+a>>>1;n(s,t[h])<0?a=h:r=h+1}var d=o-r;switch(d){case 3:t[r+3]=t[r+2];case 2:t[r+2]=t[r+1];case 1:t[r+1]=t[r];break;default:for(;d>0;)t[r+d]=t[r+d-1],d--}t[r]=s}}function d(t,e,i,o,n,s){var r=0,a=0,h=1;if(s(t,e[i+n])>0){for(a=o-n;h<a&&s(t,e[i+n+h])>0;)r=h,(h=1+(h<<1))<=0&&(h=a);h>a&&(h=a),r+=n,h+=n}else{for(a=n+1;h<a&&s(t,e[i+n-h])<=0;)r=h,(h=1+(h<<1))<=0&&(h=a);h>a&&(h=a);var d=r;r=n-h,h=n-d}for(r++;r<h;){var l=r+(h-r>>>1);s(t,e[i+l])>0?r=l+1:h=l}return h}function l(t,e,i,o,n,s){var r=0,a=0,h=1;if(s(t,e[i+n])<0){for(a=n+1;h<a&&s(t,e[i+n-h])<0;)r=h,(h=1+(h<<1))<=0&&(h=a);h>a&&(h=a);var d=r;r=n-h,h=n-d}else{for(a=o-n;h<a&&s(t,e[i+n+h])>=0;)r=h,(h=1+(h<<1))<=0&&(h=a);h>a&&(h=a),r+=n,h+=n}for(r++;r<h;){var l=r+(h-r>>>1);s(t,e[i+l])<0?h=l:r=l+1}return h}var c=function(){function t(e,n){!function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,t),this.array=null,this.compare=null,this.minGallop=i,this.length=0,this.tmpStorageLength=o,this.stackLength=0,this.runStart=null,this.runLength=null,this.stackSize=0,this.array=e,this.compare=n,this.length=e.length,this.length<2*o&&(this.tmpStorageLength=this.length>>>1),this.tmp=new Array(this.tmpStorageLength),this.stackLength=this.length<120?5:this.length<1542?10:this.length<119151?19:40,this.runStart=new Array(this.stackLength),this.runLength=new Array(this.stackLength)}return t.prototype.pushRun=function(t,e){this.runStart[this.stackSize]=t,this.runLength[this.stackSize]=e,this.stackSize+=1},t.prototype.mergeRuns=function(){for(;this.stackSize>1;){var t=this.stackSize-2;if(t>=1&&this.runLength[t-1]<=this.runLength[t]+this.runLength[t+1]||t>=2&&this.runLength[t-2]<=this.runLength[t]+this.runLength[t-1])this.runLength[t-1]<this.runLength[t+1]&&t--;else if(this.runLength[t]>this.runLength[t+1])break;this.mergeAt(t)}},t.prototype.forceMergeRuns=function(){for(;this.stackSize>1;){var t=this.stackSize-2;t>0&&this.runLength[t-1]<this.runLength[t+1]&&t--,this.mergeAt(t)}},t.prototype.mergeAt=function(t){var e=this.compare,i=this.array,o=this.runStart[t],n=this.runLength[t],s=this.runStart[t+1],r=this.runLength[t+1];this.runLength[t]=n+r,t===this.stackSize-3&&(this.runStart[t+1]=this.runStart[t+2],this.runLength[t+1]=this.runLength[t+2]),this.stackSize--;var a=l(i[s],i,o,n,0,e);o+=a,0!=(n-=a)&&0!==(r=d(i[o+n-1],i,s,r,r-1,e))&&(n<=r?this.mergeLow(o,n,s,r):this.mergeHigh(o,n,s,r))},t.prototype.mergeLow=function(t,e,o,n){var s=this.compare,r=this.array,a=this.tmp,h=0;for(h=0;h<e;h++)a[h]=r[t+h];var c=0,u=o,p=t;if(r[p++]=r[u++],0!=--n)if(1!==e){for(var f=this.minGallop;;){var v=0,g=0,y=!1;do{if(s(r[u],a[c])<0){if(r[p++]=r[u++],g++,v=0,0==--n){y=!0;break}}else if(r[p++]=a[c++],v++,g=0,1==--e){y=!0;break}}while((v|g)<f);if(y)break;do{if(0!==(v=l(r[u],a,c,e,0,s))){for(h=0;h<v;h++)r[p+h]=a[c+h];if(p+=v,c+=v,(e-=v)<=1){y=!0;break}}if(r[p++]=r[u++],0==--n){y=!0;break}if(0!==(g=d(a[c],r,u,n,0,s))){for(h=0;h<g;h++)r[p+h]=r[u+h];if(p+=g,u+=g,0==(n-=g)){y=!0;break}}if(r[p++]=a[c++],1==--e){y=!0;break}f--}while(v>=i||g>=i);if(y)break;f<0&&(f=0),f+=2}if(this.minGallop=f,f<1&&(this.minGallop=1),1===e){for(h=0;h<n;h++)r[p+h]=r[u+h];r[p+n]=a[c]}else{if(0===e)throw new Error("mergeLow preconditions were not respected");for(h=0;h<e;h++)r[p+h]=a[c+h]}}else{for(h=0;h<n;h++)r[p+h]=r[u+h];r[p+n]=a[c]}else for(h=0;h<e;h++)r[p+h]=a[c+h]},t.prototype.mergeHigh=function(t,e,o,n){var s=this.compare,r=this.array,a=this.tmp,h=0;for(h=0;h<n;h++)a[h]=r[o+h];var c=t+e-1,u=n-1,p=o+n-1,f=0,v=0;if(r[p--]=r[c--],0!=--e)if(1!==n){for(var g=this.minGallop;;){var y=0,m=0,b=!1;do{if(s(a[u],r[c])<0){if(r[p--]=r[c--],y++,m=0,0==--e){b=!0;break}}else if(r[p--]=a[u--],m++,y=0,1==--n){b=!0;break}}while((y|m)<g);if(b)break;do{if(0!=(y=e-l(a[u],r,t,e,e-1,s))){for(e-=y,v=1+(p-=y),f=1+(c-=y),h=y-1;h>=0;h--)r[v+h]=r[f+h];if(0===e){b=!0;break}}if(r[p--]=a[u--],1==--n){b=!0;break}if(0!=(m=n-d(r[c],a,0,n,n-1,s))){for(n-=m,v=1+(p-=m),f=1+(u-=m),h=0;h<m;h++)r[v+h]=a[f+h];if(n<=1){b=!0;break}}if(r[p--]=r[c--],0==--e){b=!0;break}g--}while(y>=i||m>=i);if(b)break;g<0&&(g=0),g+=2}if(this.minGallop=g,g<1&&(this.minGallop=1),1===n){for(v=1+(p-=e),f=1+(c-=e),h=e-1;h>=0;h--)r[v+h]=r[f+h];r[p]=a[u]}else{if(0===n)throw new Error("mergeHigh preconditions were not respected");for(f=p-(n-1),h=0;h<n;h++)r[f+h]=a[h]}}else{for(v=1+(p-=e),f=1+(c-=e),h=e-1;h>=0;h--)r[v+h]=r[f+h];r[p]=a[u]}else for(f=p-(n-1),h=0;h<n;h++)r[f+h]=a[h]},t}()}(e)}));(ll=yl)&&ll.__esModule&&Object.prototype.hasOwnProperty.call(ll,"default")&&ll.default;var ml=yl,bl=Vo(ml),wl=function(){function t(){ma(this,t)}return _a(t,[{key:"abstract",value:function(){throw new Error("Can't instantiate abstract class!")}},{key:"fake_use",value:function(){}},{key:"curveType",value:function(){return this.abstract()}},{key:"getPosition",value:function(t){return this.fake_use(t),this.abstract()}},{key:"setPosition",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:void 0;this.fake_use(t,e,i),this.abstract()}},{key:"getTreeSize",value:function(t){return this.fake_use(t),this.abstract()}},{key:"sort",value:function(t){this.fake_use(t),this.abstract()}},{key:"fix",value:function(t,e){this.fake_use(t,e),this.abstract()}},{key:"shift",value:function(t,e){this.fake_use(t,e),this.abstract()}}]),t}(),kl=function(t){function e(t){var i;return ma(this,e),(i=yh(this,kh(e).call(this))).layout=t,i}return Eh(e,t),_a(e,[{key:"curveType",value:function(){return"horizontal"}},{key:"getPosition",value:function(t){return t.x}},{key:"setPosition",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:void 0;void 0!==i&&this.layout.hierarchical.addToOrdering(t,i),t.x=e}},{key:"getTreeSize",value:function(t){var e=this.layout.hierarchical.getTreeSize(this.layout.body.nodes,t);return{min:e.min_x,max:e.max_x}}},{key:"sort",value:function(t){bl(t,(function(t,e){return t.x-e.x}))}},{key:"fix",value:function(t,e){t.y=this.layout.options.hierarchical.levelSeparation*e,t.options.fixed.y=!0}},{key:"shift",value:function(t,e){this.layout.body.nodes[t].x+=e}}]),e}(wl),_l=function(t){function e(t){var i;return ma(this,e),(i=yh(this,kh(e).call(this))).layout=t,i}return Eh(e,t),_a(e,[{key:"curveType",value:function(){return"vertical"}},{key:"getPosition",value:function(t){return t.y}},{key:"setPosition",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:void 0;void 0!==i&&this.layout.hierarchical.addToOrdering(t,i),t.y=e}},{key:"getTreeSize",value:function(t){var e=this.layout.hierarchical.getTreeSize(this.layout.body.nodes,t);return{min:e.min_y,max:e.max_y}}},{key:"sort",value:function(t){bl(t,(function(t,e){return t.y-e.y}))}},{key:"fix",value:function(t,e){t.x=this.layout.options.hierarchical.levelSeparation*e,t.options.fixed.x=!0}},{key:"shift",value:function(t,e){this.layout.body.nodes[t].y+=e}}]),e}(wl),xl=li.every;G({target:"Array",proto:!0,forced:ci("every")},{every:function(t){return xl(this,t,arguments.length>1?arguments[1]:void 0)}});var El=Q("Array").every,Ol=Array.prototype,Cl=function(t){var e=t.every;return t===Ol||t instanceof Array&&e===Ol.every?El:e},Tl=!l((function(){return Object.isExtensible(Object.preventExtensions({}))})),Sl=r((function(t){var e=q.f,i=Ot("meta"),o=0,n=Object.isExtensible||function(){return!0},s=function(t){e(t,i,{value:{objectID:"O"+ ++o,weakData:{}}})},r=t.exports={REQUIRED:!1,fastKey:function(t,e){if(!_(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!O(t,i)){if(!n(t))return"F";if(!e)return"E";s(t)}return t[i].objectID},getWeakData:function(t,e){if(!O(t,i)){if(!n(t))return!0;if(!e)return!1;s(t)}return t[i].weakData},onFreeze:function(t){return Tl&&r.REQUIRED&&n(t)&&!O(t,i)&&s(t),t}};de[i]=!0})),Dl=(Sl.REQUIRED,Sl.fastKey,Sl.getWeakData,Sl.onFreeze,Dt("iterator")),Ml=Array.prototype,Il=function(t,e,i,o){try{return o?e(W(i)[0],i[1]):e(i)}catch(e){var n=t.return;throw void 0!==n&&W(n.call(t)),e}},Pl=r((function(t){var e=function(t,e){this.stopped=t,this.result=e};(t.exports=function(t,i,o,n,s){var r,a,h,d,l,c,u,p,f=H(i,o,n?2:1);if(s)r=t;else{if("function"!=typeof(a=Ta(t)))throw TypeError("Target is not iterable");if(void 0!==(p=a)&&(oe.Array===p||Ml[Dl]===p)){for(h=0,d=bt(t.length);d>h;h++)if((l=n?f(W(u=t[h])[0],u[1]):f(t[h]))&&l instanceof e)return l;return new e(!1)}r=a.call(t)}for(c=r.next;!(u=c.call(r)).done;)if("object"==typeof(l=Il(r,f,u.value,n))&&l&&l instanceof e)return l;return new e(!1)}).stop=function(t){return new e(!0,t)}})),Fl=function(t,e,i){if(!(t instanceof e))throw TypeError("Incorrect "+(i?i+" ":"")+"invocation");return t},Bl=q.f,zl=li.forEach,Nl=be.set,Al=be.getterFor,Rl=function(t,e,i){for(var o in e)i&&i.unsafe&&t[o]?t[o]=e[o]:Ze(t,o,e[o],i);return t},Ll=Dt("species"),jl=q.f,Hl=Sl.fastKey,Wl=be.set,Vl=be.getterFor,ql=(function(t,e,i,o,n){var s,r=d[t],a=r&&r.prototype,h=o?"set":"add",u={};if(c&&"function"==typeof r&&(n||a.forEach&&!l((function(){(new r).entries().next()})))){s=e((function(e,i){Nl(Fl(e,s,t),{type:t,collection:new r}),null!=i&&Pl(i,e[h],e,o)}));var p=Al(t);zl(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;t in a&&(!n||"clear"!=t)&&U(s.prototype,t,(function(i,o){var s=p(this).collection;if(!e&&n&&!_(i))return"get"==t&&void 0;var r=s[t](0===i?0:i,o);return e?this:r}))})),n||Bl(s.prototype,"size",{get:function(){return p(this).collection.size}})}else s=i.getConstructor(e,t,o,h),Sl.REQUIRED=!0;Ye(s,t,!1,!0),u[t]=s,G({global:!0,forced:!0},u),n||i.setStrong(s,t,o)}("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),{getConstructor:function(t,e,i,o){var n=t((function(t,s){Fl(t,n,e),Wl(t,{type:e,index:Ae(null),first:void 0,last:void 0,size:0}),c||(t.size=0),null!=s&&Pl(s,t[o],t,i)})),s=Vl(e),r=function(t,e,i){var o,n,r=s(t),h=a(t,e);return h?h.value=i:(r.last=h={index:n=Hl(e,!0),key:e,value:i,previous:o=r.last,next:void 0,removed:!1},r.first||(r.first=h),o&&(o.next=h),c?r.size++:t.size++,"F"!==n&&(r.index[n]=h)),t},a=function(t,e){var i,o=s(t),n=Hl(e);if("F"!==n)return o.index[n];for(i=o.first;i;i=i.next)if(i.key==e)return i};return Rl(n.prototype,{clear:function(){for(var t=s(this),e=t.index,i=t.first;i;)i.removed=!0,i.previous&&(i.previous=i.previous.next=void 0),delete e[i.index],i=i.next;t.first=t.last=void 0,c?t.size=0:this.size=0},delete:function(t){var e=s(this),i=a(this,t);if(i){var o=i.next,n=i.previous;delete e.index[i.index],i.removed=!0,n&&(n.next=o),o&&(o.previous=n),e.first==i&&(e.first=o),e.last==i&&(e.last=n),c?e.size--:this.size--}return!!i},forEach:function(t){for(var e,i=s(this),o=H(t,arguments.length>1?arguments[1]:void 0,3);e=e?e.next:i.first;)for(o(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!a(this,t)}}),Rl(n.prototype,i?{get:function(t){var e=a(this,t);return e&&e.value},set:function(t,e){return r(this,0===t?0:t,e)}}:{add:function(t){return r(this,t=0===t?0:t,t)}}),c&&jl(n.prototype,"size",{get:function(){return s(this).size}}),n},setStrong:function(t,e,i){var o=e+" Iterator",n=Vl(e),s=Vl(o);ei(t,e,(function(t,e){Wl(this,{type:o,target:t,state:n(t),kind:e,last:void 0})}),(function(){for(var t=s(this),e=t.kind,i=t.last;i&&i.removed;)i=i.previous;return t.target&&(t.last=i=i?i.next:t.state.first)?"keys"==e?{value:i.key,done:!1}:"values"==e?{value:i.value,done:!1}:{value:[i.key,i.value],done:!1}:(t.target=void 0,{value:void 0,done:!0})}),i?"entries":"values",!i,!0),function(t){var e=It(t),i=q.f;c&&e&&!e[Ll]&&i(e,Ll,{configurable:!0,get:function(){return this}})}(e)}}),L.Set);function Ul(t,e){var i=new ql;return yi(t).call(t,(function(t){var e;yi(e=t.edges).call(e,(function(t){t.connected&&i.add(t)}))})),yi(i).call(i,(function(t){var i=t.from.id,o=t.to.id;null==e[i]&&(e[i]=0),(null==e[o]||e[i]>=e[o])&&(e[o]=e[i]+1)})),e}function Yl(t,e,i,o,n){var s=o.length,r=i+"Id",a="to"===i?1:-1,h=!0,d=!1,l=void 0;try{for(var c,u=function(){var h=c.value;if(t(h))return"continue";n[h.id]=0;for(var d=[h],l=0,u=void 0,p=function(){var t,h,c=n[u.id]+a;if(yi(t=zo(h=u.edges).call(h,(function(t){return t.connected&&t.to!==t.from&&t[i]!==u}))).call(t,(function(t){var o=t[r],s=n[o];(null==s||e(c,s))&&(n[o]=c,d.push(t[i]))})),l>s)return{v:{v:Ul(o,n)}};++l};u=d.pop();){var f=p();if("object"===os(f))return f.v}},p=Sa(o);!(h=(c=p.next()).done);h=!0){var f=u();switch(f){case"continue":continue;default:if("object"===os(f))return f.v}}}catch(t){d=!0,l=t}finally{try{h||null==p.return||p.return()}finally{if(d)throw l}}return n}var Xl=function(){function t(){ma(this,t),this.childrenReference={},this.parentReference={},this.trees={},this.distributionOrdering={},this.levels={},this.distributionIndex={},this.isTree=!1,this.treeIndex=-1}return _a(t,[{key:"addRelation",value:function(t,e){void 0===this.childrenReference[t]&&(this.childrenReference[t]=[]),this.childrenReference[t].push(e),void 0===this.parentReference[e]&&(this.parentReference[e]=[]),this.parentReference[e].push(t)}},{key:"checkIfTree",value:function(){for(var t in this.parentReference)if(this.parentReference[t].length>1)return void(this.isTree=!1);this.isTree=!0}},{key:"numTrees",value:function(){return this.treeIndex+1}},{key:"setTreeIndex",value:function(t,e){void 0!==e&&void 0===this.trees[t.id]&&(this.trees[t.id]=e,this.treeIndex=Math.max(e,this.treeIndex))}},{key:"ensureLevel",value:function(t){void 0===this.levels[t]&&(this.levels[t]=0)}},{key:"getMaxLevel",value:function(t){var e=this,i={};return function t(o){if(void 0!==i[o])return i[o];var n=e.levels[o];if(e.childrenReference[o]){var s=e.childrenReference[o];if(s.length>0)for(var r=0;r<s.length;r++)n=Math.max(n,t(s[r]))}return i[o]=n,n}(t)}},{key:"levelDownstream",value:function(t,e){void 0===this.levels[e.id]&&(void 0===this.levels[t.id]&&(this.levels[t.id]=0),this.levels[e.id]=this.levels[t.id]+1)}},{key:"setMinLevelToZero",value:function(t){var e=1e9;for(var i in t)t.hasOwnProperty(i)&&void 0!==this.levels[i]&&(e=Math.min(this.levels[i],e));for(var o in t)t.hasOwnProperty(o)&&void 0!==this.levels[o]&&(this.levels[o]-=e)}},{key:"getTreeSize",value:function(t,e){var i=1e9,o=-1e9,n=1e9,s=-1e9;for(var r in this.trees)if(this.trees.hasOwnProperty(r)&&this.trees[r]===e){var a=t[r];i=Math.min(a.x,i),o=Math.max(a.x,o),n=Math.min(a.y,n),s=Math.max(a.y,s)}return{min_x:i,max_x:o,min_y:n,max_y:s}}},{key:"hasSameParent",value:function(t,e){var i=this.parentReference[t.id],o=this.parentReference[e.id];if(void 0===i||void 0===o)return!1;for(var n=0;n<i.length;n++)for(var s=0;s<o.length;s++)if(i[n]==o[s])return!0;return!1}},{key:"inSameSubNetwork",value:function(t,e){return this.trees[t.id]===this.trees[e.id]}},{key:"getLevels",value:function(){return To(this.distributionOrdering)}},{key:"addToOrdering",value:function(t,e){void 0===this.distributionOrdering[e]&&(this.distributionOrdering[e]=[]);var i=!1,o=this.distributionOrdering[e];for(var n in o)if(o[n]===t){i=!0;break}i||(this.distributionOrdering[e].push(t),this.distributionIndex[t.id]=this.distributionOrdering[e].length-1)}}]),t}(),Gl=function(){function t(i){ma(this,t),this.body=i,this.initialRandomSeed=Math.round(1e6*Math.random()),this.randomSeed=this.initialRandomSeed,this.setPhysics=!1,this.options={},this.optionsBackup={physics:{}},this.defaultOptions={randomSeed:void 0,improvedLayout:!0,clusterThreshold:150,hierarchical:{enabled:!1,levelSeparation:150,nodeSpacing:100,treeSpacing:200,blockShifting:!0,edgeMinimization:!0,parentCentralization:!0,direction:"UD",sortMethod:"hubsize"}},e.extend(this.options,this.defaultOptions),this.bindEventListeners()}return _a(t,[{key:"bindEventListeners",value:function(){var t=this;this.body.emitter.on("_dataChanged",(function(){t.setupHierarchicalLayout()})),this.body.emitter.on("_dataLoaded",(function(){t.layoutNetwork()})),this.body.emitter.on("_resetHierarchicalLayout",(function(){t.setupHierarchicalLayout()})),this.body.emitter.on("_adjustEdgesForHierarchicalLayout",(function(){if(!0===t.options.hierarchical.enabled){var e=t.direction.curveType();t.body.emitter.emit("_forceDisableDynamicCurves",e,!1)}}))}},{key:"setOptions",value:function(t,i){if(void 0!==t){var o=this.options.hierarchical,n=o.enabled;if(e.selectiveDeepExtend(["randomSeed","improvedLayout","clusterThreshold"],this.options,t),e.mergeOptions(this.options,t,"hierarchical"),void 0!==t.randomSeed&&(this.initialRandomSeed=t.randomSeed),!0===o.enabled)return!0===n&&this.body.emitter.emit("refresh",!0),"RL"===o.direction||"DU"===o.direction?o.levelSeparation>0&&(o.levelSeparation*=-1):o.levelSeparation<0&&(o.levelSeparation*=-1),this.setDirectionStrategy(),this.body.emitter.emit("_resetHierarchicalLayout"),this.adaptAllOptionsForHierarchicalLayout(i);if(!0===n)return this.body.emitter.emit("refresh"),e.deepExtend(i,this.optionsBackup)}return i}},{key:"adaptAllOptionsForHierarchicalLayout",value:function(t){if(!0===this.options.hierarchical.enabled){var e=this.optionsBackup.physics;void 0===t.physics||!0===t.physics?(t.physics={enabled:void 0===e.enabled||e.enabled,solver:"hierarchicalRepulsion"},e.enabled=void 0===e.enabled||e.enabled,e.solver=e.solver||"barnesHut"):"object"===os(t.physics)?(e.enabled=void 0===t.physics.enabled||t.physics.enabled,e.solver=t.physics.solver||"barnesHut",t.physics.solver="hierarchicalRepulsion"):!1!==t.physics&&(e.solver="barnesHut",t.physics={solver:"hierarchicalRepulsion"});var i=this.direction.curveType();if(void 0===t.edges)this.optionsBackup.edges={smooth:{enabled:!0,type:"dynamic"}},t.edges={smooth:!1};else if(void 0===t.edges.smooth)this.optionsBackup.edges={smooth:{enabled:!0,type:"dynamic"}},t.edges.smooth=!1;else if("boolean"==typeof t.edges.smooth)this.optionsBackup.edges={smooth:t.edges.smooth},t.edges.smooth={enabled:t.edges.smooth,type:i};else{var o=t.edges.smooth;void 0!==o.type&&"dynamic"!==o.type&&(i=o.type),this.optionsBackup.edges={smooth:void 0===o.enabled||o.enabled,type:void 0===o.type?"dynamic":o.type,roundness:void 0===o.roundness?.5:o.roundness,forceDirection:void 0!==o.forceDirection&&o.forceDirection},t.edges.smooth={enabled:void 0===o.enabled||o.enabled,type:i,roundness:void 0===o.roundness?.5:o.roundness,forceDirection:void 0!==o.forceDirection&&o.forceDirection}}this.body.emitter.emit("_forceDisableDynamicCurves",i)}return t}},{key:"seededRandom",value:function(){var t=1e4*Math.sin(this.randomSeed++);return t-Math.floor(t)}},{key:"positionInitially",value:function(t){if(!0!==this.options.hierarchical.enabled){this.randomSeed=this.initialRandomSeed;for(var e=t.length+50,i=0;i<t.length;i++){var o=t[i],n=2*Math.PI*this.seededRandom();void 0===o.x&&(o.x=e*Math.cos(n)),void 0===o.y&&(o.y=e*Math.sin(n))}}}},{key:"layoutNetwork",value:function(){if(!0!==this.options.hierarchical.enabled&&!0===this.options.improvedLayout){for(var t=this.body.nodeIndices,e=0,i=0;i<t.length;i++){!0===this.body.nodes[t[i]].predefinedPosition&&(e+=1)}if(e<.5*t.length){var o=0,n=this.options.clusterThreshold,s={clusterNodeProperties:{shape:"ellipse",label:"",group:"",font:{multi:!1}},clusterEdgeProperties:{label:"",font:{multi:!1},smooth:{enabled:!1}}};if(t.length>n){for(var r=t.length;t.length>n&&o<=10;){o+=1;var a=t.length;if(o%3==0?this.body.modules.clustering.clusterBridges(s):this.body.modules.clustering.clusterOutliers(s),a==t.length&&o%3!=0)return this._declusterAll(),this.body.emitter.emit("_layoutFailed"),void console.info("This network could not be positioned by this version of the improved layout algorithm. Please disable improvedLayout for better performance.")}this.body.modules.kamadaKawai.setOptions({springLength:Math.max(150,2*r)})}o>10&&console.info("The clustering didn't succeed within the amount of interations allowed, progressing with partial result."),this.body.modules.kamadaKawai.solve(t,this.body.edgeIndices,!0),this._shiftToCenter();for(var h=0;h<t.length;h++){var d=this.body.nodes[t[h]];!1===d.predefinedPosition&&(d.x+=70*(.5-this.seededRandom()),d.y+=70*(.5-this.seededRandom()))}this._declusterAll(),this.body.emitter.emit("_repositionBezierNodes")}}}},{key:"_shiftToCenter",value:function(){for(var t=el.getRangeCore(this.body.nodes,this.body.nodeIndices),e=el.findCenter(t),i=0;i<this.body.nodeIndices.length;i++){var o=this.body.nodes[this.body.nodeIndices[i]];o.x-=e.x,o.y-=e.y}}},{key:"_declusterAll",value:function(){for(var t=!0;!0===t;){t=!1;for(var e=0;e<this.body.nodeIndices.length;e++)!0===this.body.nodes[this.body.nodeIndices[e]].isCluster&&(t=!0,this.body.modules.clustering.openCluster(this.body.nodeIndices[e],{},!1));!0===t&&this.body.emitter.emit("_dataChanged")}}},{key:"getSeed",value:function(){return this.initialRandomSeed}},{key:"setupHierarchicalLayout",value:function(){if(!0===this.options.hierarchical.enabled&&this.body.nodeIndices.length>0){var t,e,i=!1,o=!1;for(e in this.lastNodeOnLevel={},this.hierarchical=new Xl,this.body.nodes)this.body.nodes.hasOwnProperty(e)&&(void 0!==(t=this.body.nodes[e]).options.level?(i=!0,this.hierarchical.levels[e]=t.options.level):o=!0);if(!0===o&&!0===i)throw new Error("To use the hierarchical layout, nodes require either no predefined levels or levels have to be defined for all nodes.");if(!0===o){var n=this.options.hierarchical.sortMethod;"hubsize"===n?this._determineLevelsByHubsize():"directed"===n?this._determineLevelsDirected():"custom"===n&&this._determineLevelsCustomCallback()}for(var s in this.body.nodes)this.body.nodes.hasOwnProperty(s)&&this.hierarchical.ensureLevel(s);var r=this._getDistribution();this._generateMap(),this._placeNodesByHierarchy(r),this._condenseHierarchy(),this._shiftToCenter()}}},{key:"_condenseHierarchy",value:function(){var t=this,e=!1,i={},o=function(e,i){var o=t.hierarchical.trees;for(var n in o)o.hasOwnProperty(n)&&o[n]===e&&t.direction.shift(n,i)},n=function(){for(var e=[],i=0;i<t.hierarchical.numTrees();i++)e.push(t.direction.getTreeSize(i));return e},s=function e(i,o){if(!o[i.id]&&(o[i.id]=!0,t.hierarchical.childrenReference[i.id])){var n=t.hierarchical.childrenReference[i.id];if(n.length>0)for(var s=0;s<n.length;s++)e(t.body.nodes[n[s]],o)}},r=function(e){var i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1e9,o=1e9,n=1e9,s=1e9,r=-1e9;for(var a in e)if(e.hasOwnProperty(a)){var h=t.body.nodes[a],d=t.hierarchical.levels[h.id],l=t.direction.getPosition(h),c=t._getSpaceAroundNode(h,e),u=nh(c,2),p=u[0],f=u[1];o=Math.min(p,o),n=Math.min(f,n),d<=i&&(s=Math.min(l,s),r=Math.max(l,r))}return[s,r,o,n]},a=function(e,i){var o=t.hierarchical.getMaxLevel(e.id),n=t.hierarchical.getMaxLevel(i.id);return Math.min(o,n)},h=function(e,i,o){for(var n=t.hierarchical,s=0;s<i.length;s++){var r=i[s],a=n.distributionOrdering[r];if(a.length>1)for(var h=0;h<a.length-1;h++){var d=a[h],l=a[h+1];n.hasSameParent(d,l)&&n.inSameSubNetwork(d,l)&&e(d,l,o)}}},d=function(i,o){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2],h=t.direction.getPosition(i),d=t.direction.getPosition(o),l=Math.abs(d-h),c=t.options.hierarchical.nodeSpacing;if(l>c){var u={},p={};s(i,u),s(o,p);var f=a(i,o),v=r(u,f),g=r(p,f),y=v[1],m=g[0],b=g[2],w=Math.abs(y-m);if(w>c){var k=y-m+c;k<-b+c&&(k=-b+c),k<0&&(t._shiftBlock(o.id,k),e=!0,!0===n&&t._centerParent(o))}}},l=function(o,n){for(var a=n.id,h=n.edges,d=t.hierarchical.levels[n.id],l=t.options.hierarchical.levelSeparation*t.options.hierarchical.levelSeparation,c={},u=[],p=0;p<h.length;p++){var f=h[p];if(f.toId!=f.fromId){var v=f.toId==a?f.from:f.to;c[h[p].id]=v,t.hierarchical.levels[v.id]<d&&u.push(f)}}var g=function(e,i){for(var o=0,n=0;n<i.length;n++)if(void 0!==c[i[n].id]){var s=t.direction.getPosition(c[i[n].id])-e;o+=s/Math.sqrt(s*s+l)}return o},y=function(e,i){for(var o=0,n=0;n<i.length;n++)if(void 0!==c[i[n].id]){var s=t.direction.getPosition(c[i[n].id])-e;o-=l*Math.pow(s*s+l,-1.5)}return o},m=function(e,i){for(var o=t.direction.getPosition(n),s={},r=0;r<e;r++){var a=g(o,i),h=y(o,i);if(void 0!==s[o-=Math.max(-40,Math.min(40,Math.round(a/h)))])break;s[o]=r}return o},b=m(o,u);!function(o){var a=t.direction.getPosition(n);if(void 0===i[n.id]){var h={};s(n,h),i[n.id]=h}var d=r(i[n.id]),l=d[2],c=d[3],u=o-a,p=0;u>0?p=Math.min(u,c-t.options.hierarchical.nodeSpacing):u<0&&(p=-Math.min(-u,l-t.options.hierarchical.nodeSpacing)),0!=p&&(t._shiftBlock(n.id,p),e=!0)}(b),function(i){var o=t.direction.getPosition(n),s=t._getSpaceAroundNode(n),r=nh(s,2),a=r[0],h=r[1],d=i-o,l=o;d>0?l=Math.min(o+(h-t.options.hierarchical.nodeSpacing),i):d<0&&(l=Math.max(o-(a-t.options.hierarchical.nodeSpacing),i)),l!==o&&(t.direction.setPosition(n,l),e=!0)}(b=m(o,h))};!0===this.options.hierarchical.blockShifting&&(function(i){var o=t.hierarchical.getLevels();o=tl(o).call(o);for(var n=0;n<i&&(e=!1,h(d,o,!0),!0===e);n++);}(5),function(){for(var e in t.body.nodes)t.body.nodes.hasOwnProperty(e)&&t._centerParent(t.body.nodes[e])}()),!0===this.options.hierarchical.edgeMinimization&&function(i){var o=t.hierarchical.getLevels();o=tl(o).call(o);for(var n=0;n<i;n++){e=!1;for(var s=0;s<o.length;s++)for(var r=o[s],a=t.hierarchical.distributionOrdering[r],h=0;h<a.length;h++)l(1e3,a[h]);if(!0!==e)break}}(20),!0===this.options.hierarchical.parentCentralization&&function(){var e=t.hierarchical.getLevels();e=tl(e).call(e);for(var i=0;i<e.length;i++)for(var o=e[i],n=t.hierarchical.distributionOrdering[o],s=0;s<n.length;s++)t._centerParent(n[s])}(),function(){for(var e=n(),i=0,s=0;s<e.length-1;s++){i+=e[s].max-e[s+1].min+t.options.hierarchical.treeSpacing,o(s+1,i)}}()}},{key:"_getSpaceAroundNode",value:function(t,e){var i=!0;void 0===e&&(i=!1);var o=this.hierarchical.levels[t.id];if(void 0!==o){var n=this.hierarchical.distributionIndex[t.id],s=this.direction.getPosition(t),r=this.hierarchical.distributionOrdering[o],a=1e9,h=1e9;if(0!==n){var d=r[n-1];if(!0===i&&void 0===e[d.id]||!1===i)a=s-this.direction.getPosition(d)}if(n!=r.length-1){var l=r[n+1];if(!0===i&&void 0===e[l.id]||!1===i){var c=this.direction.getPosition(l);h=Math.min(h,c-s)}}return[a,h]}return[0,0]}},{key:"_centerParent",value:function(t){if(this.hierarchical.parentReference[t.id])for(var e=this.hierarchical.parentReference[t.id],i=0;i<e.length;i++){var o=e[i],n=this.body.nodes[o],s=this.hierarchical.childrenReference[o];if(void 0!==s){var r=this._getCenterPosition(s),a=this.direction.getPosition(n),h=this._getSpaceAroundNode(n),d=nh(h,2),l=d[0],c=d[1],u=a-r;(u<0&&Math.abs(u)<c-this.options.hierarchical.nodeSpacing||u>0&&Math.abs(u)<l-this.options.hierarchical.nodeSpacing)&&this.direction.setPosition(n,r)}}}},{key:"_placeNodesByHierarchy",value:function(t){for(var e in this.positionedNodes={},t)if(t.hasOwnProperty(e)){var i,o=To(t[e]);o=this._indexArrayToNodes(o),Vo(i=this.direction).call(i,o);for(var n=0,s=0;s<o.length;s++){var r=o[s];if(void 0===this.positionedNodes[r.id]){var a=this.options.hierarchical.nodeSpacing,h=a*n;n>0&&(h=this.direction.getPosition(o[s-1])+a),this.direction.setPosition(r,h,e),this._validatePositionAndContinue(r,e,h),n++}}}}},{key:"_placeBranchNodes",value:function(t,e){var i,o=this.hierarchical.childrenReference[t];if(void 0!==o){for(var n=[],s=0;s<o.length;s++)n.push(this.body.nodes[o[s]]);Vo(i=this.direction).call(i,n);for(var r=0;r<n.length;r++){var a=n[r],h=this.hierarchical.levels[a.id];if(!(h>e&&void 0===this.positionedNodes[a.id]))return;var d=this.options.hierarchical.nodeSpacing,l=void 0;l=0===r?this.direction.getPosition(this.body.nodes[t]):this.direction.getPosition(n[r-1])+d,this.direction.setPosition(a,l,h),this._validatePositionAndContinue(a,h,l)}var c=this._getCenterPosition(n);this.direction.setPosition(this.body.nodes[t],c,e)}}},{key:"_validatePositionAndContinue",value:function(t,e,i){if(this.hierarchical.isTree){if(void 0!==this.lastNodeOnLevel[e]){var o=this.direction.getPosition(this.body.nodes[this.lastNodeOnLevel[e]]);if(i-o<this.options.hierarchical.nodeSpacing){var n=o+this.options.hierarchical.nodeSpacing-i,s=this._findCommonParent(this.lastNodeOnLevel[e],t.id);this._shiftBlock(s.withChild,n)}}this.lastNodeOnLevel[e]=t.id,this.positionedNodes[t.id]=!0,this._placeBranchNodes(t.id,e)}}},{key:"_indexArrayToNodes",value:function(t){for(var e=[],i=0;i<t.length;i++)e.push(this.body.nodes[t[i]]);return e}},{key:"_getDistribution",value:function(){var t,e,i={};for(t in this.body.nodes)if(this.body.nodes.hasOwnProperty(t)){e=this.body.nodes[t];var o=void 0===this.hierarchical.levels[t]?0:this.hierarchical.levels[t];this.direction.fix(e,o),void 0===i[o]&&(i[o]={}),i[o][t]=e}return i}},{key:"_getActiveEdges",value:function(t){var i=this,o=[];return e.forEach(t.edges,(function(t){var e;-1!==zi(e=i.body.edgeIndices).call(e,t.id)&&o.push(t)})),o}},{key:"_getHubSizes",value:function(){var t=this,i={},o=this.body.nodeIndices;e.forEach(o,(function(e){var o=t.body.nodes[e],n=t._getActiveEdges(o).length;i[n]=!0}));var n=[];return e.forEach(i,(function(t){n.push(Number(t))})),Vo(ml).call(ml,n,(function(t,e){return e-t})),n}},{key:"_determineLevelsByHubsize",value:function(){for(var t=this,i=function(e,i){t.hierarchical.levelDownstream(e,i)},o=this._getHubSizes(),n=function(n){var s=o[n];if(0===s)return"break";e.forEach(t.body.nodeIndices,(function(e){var o=t.body.nodes[e];s===t._getActiveEdges(o).length&&t._crawlNetwork(i,e)}))},s=0;s<o.length;++s){if("break"===n(s))break}}},{key:"_determineLevelsCustomCallback",value:function(){var t=this;this._crawlNetwork((function(e,i,o){var n=t.hierarchical.levels[e.id];void 0===n&&(n=t.hierarchical.levels[e.id]=1e5);var s=(el.cloneOptions(e,"node"),el.cloneOptions(i,"node"),void el.cloneOptions(o,"edge"));t.hierarchical.levels[i.id]=n+s})),this.hierarchical.setMinLevelToZero(this.body.nodes)}},{key:"_determineLevelsDirected",value:function(){var t,e=this,i=_o(t=this.body.nodeIndices).call(t,(function(t){return e.body.nodes[t]}));this.hierarchical.levels;"roots"===this.options.hierarchical.shakeTowards?this.hierarchical.levels=function(t){return Yl((function(t){var e;return!Cl(e=t.edges).call(e,(function(e){return e.from===t}))}),(function(t,e){return e<t}),"to",t,arguments.length>1&&void 0!==arguments[1]?arguments[1]:Ri(null))}(i,this.hierarchical.levels):this.hierarchical.levels=function(t){return Yl((function(t){var e;return!Cl(e=t.edges).call(e,(function(e){return e.to===t}))}),(function(t,e){return e>t}),"from",t,arguments.length>1&&void 0!==arguments[1]?arguments[1]:Ri(null))}(i,this.hierarchical.levels),this.hierarchical.setMinLevelToZero(this.body.nodes)}},{key:"_generateMap",value:function(){var t=this;this._crawlNetwork((function(e,i){t.hierarchical.levels[i.id]>t.hierarchical.levels[e.id]&&t.hierarchical.addRelation(e.id,i.id)})),this.hierarchical.checkIfTree()}},{key:"_crawlNetwork",value:function(){var t=this,e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:function(){},i=arguments.length>1?arguments[1]:void 0,o={},n=function i(n,s){if(void 0===o[n.id]){var r;t.hierarchical.setTreeIndex(n,s),o[n.id]=!0;for(var a=t._getActiveEdges(n),h=0;h<a.length;h++){var d=a[h];!0===d.connected&&(r=d.toId==n.id?d.from:d.to,n.id!=r.id&&(e(n,r,d),i(r,s)))}}};if(void 0===i)for(var s=0,r=0;r<this.body.nodeIndices.length;r++){var a=this.body.nodeIndices[r];if(void 0===o[a]){var h=this.body.nodes[a];n(h,s),s+=1}}else{var d=this.body.nodes[i];if(void 0===d)return void console.error("Node not found:",i);n(d)}}},{key:"_shiftBlock",value:function(t,e){var i=this,o={};!function t(n){if(!o[n]){o[n]=!0,i.direction.shift(n,e);var s=i.hierarchical.childrenReference[n];if(void 0!==s)for(var r=0;r<s.length;r++)t(s[r])}}(t)}},{key:"_findCommonParent",value:function(t,e){var i=this,o={};return function t(e,o){var n=i.hierarchical.parentReference[o];if(void 0!==n)for(var s=0;s<n.length;s++){var r=n[s];e[r]=!0,t(e,r)}}(o,t),function t(e,o){var n=i.hierarchical.parentReference[o];if(void 0!==n)for(var s=0;s<n.length;s++){var r=n[s];if(void 0!==e[r])return{foundParent:r,withChild:o};var a=t(e,r);if(null!==a.foundParent)return a}return{foundParent:null,withChild:o}}(o,e)}},{key:"setDirectionStrategy",value:function(){var t="UD"===this.options.hierarchical.direction||"DU"===this.options.hierarchical.direction;this.direction=t?new kl(this):new _l(this)}},{key:"_getCenterPosition",value:function(t){for(var e=1e9,i=-1e9,o=0;o<t.length;o++){var n=void 0;if(void 0!==t[o].id)n=t[o];else{var s=t[o];n=this.body.nodes[s]}var r=this.direction.getPosition(n);e=Math.min(e,r),i=Math.max(i,r)}return.5*(e+i)}}]),t}(),Kl=function(){function t(i,o,n,s){var r,a,h=this;ma(this,t),this.body=i,this.canvas=o,this.selectionHandler=n,this.interactionHandler=s,this.editMode=!1,this.manipulationDiv=void 0,this.editModeDiv=void 0,this.closeDiv=void 0,this.manipulationHammers=[],this.temporaryUIFunctions={},this.temporaryEventFunctions=[],this.touchTime=0,this.temporaryIds={nodes:[],edges:[]},this.guiEnabled=!1,this.inMode=!1,this.selectedControlNode=void 0,this.options={},this.defaultOptions={enabled:!1,initiallyActive:!1,addNode:!0,addEdge:!0,editNode:void 0,editEdge:!0,deleteNode:!0,deleteEdge:!0,controlNodeStyle:{shape:"dot",size:6,color:{background:"#ff0000",border:"#3c3c3c",highlight:{background:"#07f968",border:"#3c3c3c"}},borderWidth:2,borderWidthSelected:2}},e.extend(this.options,this.defaultOptions),this.body.emitter.on("destroy",(function(){h._clean()})),this.body.emitter.on("_dataChanged",it(r=this._restore).call(r,this)),this.body.emitter.on("_resetData",it(a=this._restore).call(a,this))}return _a(t,[{key:"_restore",value:function(){!1!==this.inMode&&(!0===this.options.initiallyActive?this.enableEditMode():this.disableEditMode())}},{key:"setOptions",value:function(t,i,o){void 0!==i&&(void 0!==i.locale?this.options.locale=i.locale:this.options.locale=o.locale,void 0!==i.locales?this.options.locales=i.locales:this.options.locales=o.locales),void 0!==t&&("boolean"==typeof t?this.options.enabled=t:(this.options.enabled=!0,e.deepExtend(this.options,t)),!0===this.options.initiallyActive&&(this.editMode=!0),this._setup())}},{key:"toggleEditMode",value:function(){!0===this.editMode?this.disableEditMode():this.enableEditMode()}},{key:"enableEditMode",value:function(){this.editMode=!0,this._clean(),!0===this.guiEnabled&&(this.manipulationDiv.style.display="block",this.closeDiv.style.display="block",this.editModeDiv.style.display="none",this.showManipulatorToolbar())}},{key:"disableEditMode",value:function(){this.editMode=!1,this._clean(),!0===this.guiEnabled&&(this.manipulationDiv.style.display="none",this.closeDiv.style.display="none",this.editModeDiv.style.display="block",this._createEditButton())}},{key:"showManipulatorToolbar",value:function(){if(this._clean(),this.manipulationDOM={},!0===this.guiEnabled){var t,e;this.editMode=!0,this.manipulationDiv.style.display="block",this.closeDiv.style.display="block";var i=this.selectionHandler._getSelectedNodeCount(),o=this.selectionHandler._getSelectedEdgeCount(),n=i+o,s=this.options.locales[this.options.locale],r=!1;!1!==this.options.addNode&&(this._createAddNodeButton(s),r=!0),!1!==this.options.addEdge&&(!0===r?this._createSeperator(1):r=!0,this._createAddEdgeButton(s)),1===i&&"function"==typeof this.options.editNode?(!0===r?this._createSeperator(2):r=!0,this._createEditNodeButton(s)):1===o&&0===i&&!1!==this.options.editEdge&&(!0===r?this._createSeperator(3):r=!0,this._createEditEdgeButton(s)),0!==n&&(i>0&&!1!==this.options.deleteNode?(!0===r&&this._createSeperator(4),this._createDeleteButton(s)):0===i&&!1!==this.options.deleteEdge&&(!0===r&&this._createSeperator(4),this._createDeleteButton(s))),this._bindHammerToDiv(this.closeDiv,it(t=this.toggleEditMode).call(t,this)),this._temporaryBindEvent("select",it(e=this.showManipulatorToolbar).call(e,this))}this.body.emitter.emit("_redraw")}},{key:"addNodeMode",value:function(){var t;if(!0!==this.editMode&&this.enableEditMode(),this._clean(),this.inMode="addNode",!0===this.guiEnabled){var e,i=this.options.locales[this.options.locale];this.manipulationDOM={},this._createBackButton(i),this._createSeperator(),this._createDescription(i.addDescription||this.options.locales.en.addDescription),this._bindHammerToDiv(this.closeDiv,it(e=this.toggleEditMode).call(e,this))}this._temporaryBindEvent("click",it(t=this._performAddNode).call(t,this))}},{key:"editNode",value:function(){var t=this;!0!==this.editMode&&this.enableEditMode(),this._clean();var i=this.selectionHandler._getSelectedNode();if(void 0!==i){if(this.inMode="editNode","function"!=typeof this.options.editNode)throw new Error("No function has been configured to handle the editing of nodes.");if(!0!==i.isCluster){var o=e.deepExtend({},i.options,!1);if(o.x=i.x,o.y=i.y,2!==this.options.editNode.length)throw new Error("The function for edit does not support two arguments (data, callback)");this.options.editNode(o,(function(e){null!=e&&"editNode"===t.inMode&&t.body.data.nodes.getDataSet().update(e),t.showManipulatorToolbar()}))}else alert(this.options.locales[this.options.locale].editClusterError||this.options.locales.en.editClusterError)}else this.showManipulatorToolbar()}},{key:"addEdgeMode",value:function(){var t,e,i,o,n;if(!0!==this.editMode&&this.enableEditMode(),this._clean(),this.inMode="addEdge",!0===this.guiEnabled){var s,r=this.options.locales[this.options.locale];this.manipulationDOM={},this._createBackButton(r),this._createSeperator(),this._createDescription(r.edgeDescription||this.options.locales.en.edgeDescription),this._bindHammerToDiv(this.closeDiv,it(s=this.toggleEditMode).call(s,this))}this._temporaryBindUI("onTouch",it(t=this._handleConnect).call(t,this)),this._temporaryBindUI("onDragEnd",it(e=this._finishConnect).call(e,this)),this._temporaryBindUI("onDrag",it(i=this._dragControlNode).call(i,this)),this._temporaryBindUI("onRelease",it(o=this._finishConnect).call(o,this)),this._temporaryBindUI("onDragStart",it(n=this._dragStartEdge).call(n,this)),this._temporaryBindUI("onHold",(function(){}))}},{key:"editEdgeMode",value:function(){if(!0!==this.editMode&&this.enableEditMode(),this._clean(),this.inMode="editEdge","object"!==os(this.options.editEdge)||"function"!=typeof this.options.editEdge.editWithoutDrag||(this.edgeBeingEditedId=this.selectionHandler.getSelectedEdges()[0],void 0===this.edgeBeingEditedId)){if(!0===this.guiEnabled){var t,e=this.options.locales[this.options.locale];this.manipulationDOM={},this._createBackButton(e),this._createSeperator(),this._createDescription(e.editEdgeDescription||this.options.locales.en.editEdgeDescription),this._bindHammerToDiv(this.closeDiv,it(t=this.toggleEditMode).call(t,this))}if(this.edgeBeingEditedId=this.selectionHandler.getSelectedEdges()[0],void 0!==this.edgeBeingEditedId){var i,o,n,s,r=this.body.edges[this.edgeBeingEditedId],a=this._getNewTargetNode(r.from.x,r.from.y),h=this._getNewTargetNode(r.to.x,r.to.y);this.temporaryIds.nodes.push(a.id),this.temporaryIds.nodes.push(h.id),this.body.nodes[a.id]=a,this.body.nodeIndices.push(a.id),this.body.nodes[h.id]=h,this.body.nodeIndices.push(h.id),this._temporaryBindUI("onTouch",it(i=this._controlNodeTouch).call(i,this)),this._temporaryBindUI("onTap",(function(){})),this._temporaryBindUI("onHold",(function(){})),this._temporaryBindUI("onDragStart",it(o=this._controlNodeDragStart).call(o,this)),this._temporaryBindUI("onDrag",it(n=this._controlNodeDrag).call(n,this)),this._temporaryBindUI("onDragEnd",it(s=this._controlNodeDragEnd).call(s,this)),this._temporaryBindUI("onMouseMove",(function(){})),this._temporaryBindEvent("beforeDrawing",(function(t){var e=r.edgeType.findBorderPositions(t);!1===a.selected&&(a.x=e.from.x,a.y=e.from.y),!1===h.selected&&(h.x=e.to.x,h.y=e.to.y)})),this.body.emitter.emit("_redraw")}else this.showManipulatorToolbar()}else{var d=this.body.edges[this.edgeBeingEditedId];this._performEditEdge(d.from.id,d.to.id)}}},{key:"deleteSelected",value:function(){var t=this;!0!==this.editMode&&this.enableEditMode(),this._clean(),this.inMode="delete";var e=this.selectionHandler.getSelectedNodes(),i=this.selectionHandler.getSelectedEdges(),o=void 0;if(e.length>0){for(var n=0;n<e.length;n++)if(!0===this.body.nodes[e[n]].isCluster)return void alert(this.options.locales[this.options.locale].deleteClusterError||this.options.locales.en.deleteClusterError);"function"==typeof this.options.deleteNode&&(o=this.options.deleteNode)}else i.length>0&&"function"==typeof this.options.deleteEdge&&(o=this.options.deleteEdge);if("function"==typeof o){var s={nodes:e,edges:i};if(2!==o.length)throw new Error("The function for delete does not support two arguments (data, callback)");o(s,(function(e){null!=e&&"delete"===t.inMode?(t.body.data.edges.getDataSet().remove(e.edges),t.body.data.nodes.getDataSet().remove(e.nodes),t.body.emitter.emit("startSimulation"),t.showManipulatorToolbar()):(t.body.emitter.emit("startSimulation"),t.showManipulatorToolbar())}))}else this.body.data.edges.getDataSet().remove(i),this.body.data.nodes.getDataSet().remove(e),this.body.emitter.emit("startSimulation"),this.showManipulatorToolbar()}},{key:"_setup",value:function(){!0===this.options.enabled?(this.guiEnabled=!0,this._createWrappers(),!1===this.editMode?this._createEditButton():this.showManipulatorToolbar()):(this._removeManipulationDOM(),this.guiEnabled=!1)}},{key:"_createWrappers",value:function(){void 0===this.manipulationDiv&&(this.manipulationDiv=document.createElement("div"),this.manipulationDiv.className="vis-manipulation",!0===this.editMode?this.manipulationDiv.style.display="block":this.manipulationDiv.style.display="none",this.canvas.frame.appendChild(this.manipulationDiv)),void 0===this.editModeDiv&&(this.editModeDiv=document.createElement("div"),this.editModeDiv.className="vis-edit-mode",!0===this.editMode?this.editModeDiv.style.display="none":this.editModeDiv.style.display="block",this.canvas.frame.appendChild(this.editModeDiv)),void 0===this.closeDiv&&(this.closeDiv=document.createElement("div"),this.closeDiv.className="vis-close",this.closeDiv.style.display=this.manipulationDiv.style.display,this.canvas.frame.appendChild(this.closeDiv))}},{key:"_getNewTargetNode",value:function(t,i){var o=e.deepExtend({},this.options.controlNodeStyle);o.id="targetNode"+e.randomUUID(),o.hidden=!1,o.physics=!1,o.x=t,o.y=i;var n=this.body.functions.createNode(o);return n.shape.boundingBox={left:t,right:t,top:i,bottom:i},n}},{key:"_createEditButton",value:function(){var t;this._clean(),this.manipulationDOM={},e.recursiveDOMDelete(this.editModeDiv);var i=this.options.locales[this.options.locale],o=this._createButton("editMode","vis-button vis-edit vis-edit-mode",i.edit||this.options.locales.en.edit);this.editModeDiv.appendChild(o),this._bindHammerToDiv(o,it(t=this.toggleEditMode).call(t,this))}},{key:"_clean",value:function(){this.inMode=!1,!0===this.guiEnabled&&(e.recursiveDOMDelete(this.editModeDiv),e.recursiveDOMDelete(this.manipulationDiv),this._cleanManipulatorHammers()),this._cleanupTemporaryNodesAndEdges(),this._unbindTemporaryUIs(),this._unbindTemporaryEvents(),this.body.emitter.emit("restorePhysics")}},{key:"_cleanManipulatorHammers",value:function(){if(0!=this.manipulationHammers.length){for(var t=0;t<this.manipulationHammers.length;t++)this.manipulationHammers[t].destroy();this.manipulationHammers=[]}}},{key:"_removeManipulationDOM",value:function(){this._clean(),e.recursiveDOMDelete(this.manipulationDiv),e.recursiveDOMDelete(this.editModeDiv),e.recursiveDOMDelete(this.closeDiv),this.manipulationDiv&&this.canvas.frame.removeChild(this.manipulationDiv),this.editModeDiv&&this.canvas.frame.removeChild(this.editModeDiv),this.closeDiv&&this.canvas.frame.removeChild(this.closeDiv),this.manipulationDiv=void 0,this.editModeDiv=void 0,this.closeDiv=void 0}},{key:"_createSeperator",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;this.manipulationDOM["seperatorLineDiv"+t]=document.createElement("div"),this.manipulationDOM["seperatorLineDiv"+t].className="vis-separator-line",this.manipulationDiv.appendChild(this.manipulationDOM["seperatorLineDiv"+t])}},{key:"_createAddNodeButton",value:function(t){var e,i=this._createButton("addNode","vis-button vis-add",t.addNode||this.options.locales.en.addNode);this.manipulationDiv.appendChild(i),this._bindHammerToDiv(i,it(e=this.addNodeMode).call(e,this))}},{key:"_createAddEdgeButton",value:function(t){var e,i=this._createButton("addEdge","vis-button vis-connect",t.addEdge||this.options.locales.en.addEdge);this.manipulationDiv.appendChild(i),this._bindHammerToDiv(i,it(e=this.addEdgeMode).call(e,this))}},{key:"_createEditNodeButton",value:function(t){var e,i=this._createButton("editNode","vis-button vis-edit",t.editNode||this.options.locales.en.editNode);this.manipulationDiv.appendChild(i),this._bindHammerToDiv(i,it(e=this.editNode).call(e,this))}},{key:"_createEditEdgeButton",value:function(t){var e,i=this._createButton("editEdge","vis-button vis-edit",t.editEdge||this.options.locales.en.editEdge);this.manipulationDiv.appendChild(i),this._bindHammerToDiv(i,it(e=this.editEdgeMode).call(e,this))}},{key:"_createDeleteButton",value:function(t){var e,i;i=this.options.rtl?"vis-button vis-delete-rtl":"vis-button vis-delete";var o=this._createButton("delete",i,t.del||this.options.locales.en.del);this.manipulationDiv.appendChild(o),this._bindHammerToDiv(o,it(e=this.deleteSelected).call(e,this))}},{key:"_createBackButton",value:function(t){var e,i=this._createButton("back","vis-button vis-back",t.back||this.options.locales.en.back);this.manipulationDiv.appendChild(i),this._bindHammerToDiv(i,it(e=this.showManipulatorToolbar).call(e,this))}},{key:"_createButton",value:function(t,e,i){var o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:"vis-label";return this.manipulationDOM[t+"Div"]=document.createElement("div"),this.manipulationDOM[t+"Div"].className=e,this.manipulationDOM[t+"Label"]=document.createElement("div"),this.manipulationDOM[t+"Label"].className=o,this.manipulationDOM[t+"Label"].innerHTML=i,this.manipulationDOM[t+"Div"].appendChild(this.manipulationDOM[t+"Label"]),this.manipulationDOM[t+"Div"]}},{key:"_createDescription",value:function(t){this.manipulationDiv.appendChild(this._createButton("description","vis-button vis-none",t))}},{key:"_temporaryBindEvent",value:function(t,e){this.temporaryEventFunctions.push({event:t,boundFunction:e}),this.body.emitter.on(t,e)}},{key:"_temporaryBindUI",value:function(t,e){if(void 0===this.body.eventListeners[t])throw new Error("This UI function does not exist. Typo? You tried: "+t+" possible are: "+Qh(To(this.body.eventListeners)));this.temporaryUIFunctions[t]=this.body.eventListeners[t],this.body.eventListeners[t]=e}},{key:"_unbindTemporaryUIs",value:function(){for(var t in this.temporaryUIFunctions)this.temporaryUIFunctions.hasOwnProperty(t)&&(this.body.eventListeners[t]=this.temporaryUIFunctions[t],delete this.temporaryUIFunctions[t]);this.temporaryUIFunctions={}}},{key:"_unbindTemporaryEvents",value:function(){for(var t=0;t<this.temporaryEventFunctions.length;t++){var e=this.temporaryEventFunctions[t].event,i=this.temporaryEventFunctions[t].boundFunction;this.body.emitter.off(e,i)}this.temporaryEventFunctions=[]}},{key:"_bindHammerToDiv",value:function(t,e){var i=new fa(t,{});rl.onTouch(i,e),this.manipulationHammers.push(i)}},{key:"_cleanupTemporaryNodesAndEdges",value:function(){for(var t=0;t<this.temporaryIds.edges.length;t++){var e;this.body.edges[this.temporaryIds.edges[t]].disconnect(),delete this.body.edges[this.temporaryIds.edges[t]];var i,o=zi(e=this.body.edgeIndices).call(e,this.temporaryIds.edges[t]);if(-1!==o)ee(i=this.body.edgeIndices).call(i,o,1)}for(var n=0;n<this.temporaryIds.nodes.length;n++){var s;delete this.body.nodes[this.temporaryIds.nodes[n]];var r,a=zi(s=this.body.nodeIndices).call(s,this.temporaryIds.nodes[n]);if(-1!==a)ee(r=this.body.nodeIndices).call(r,a,1)}this.temporaryIds={nodes:[],edges:[]}}},{key:"_controlNodeTouch",value:function(t){this.selectionHandler.unselectAll(),this.lastTouch=this.body.functions.getPointer(t.center),this.lastTouch.translation=e.extend({},this.body.view.translation)}},{key:"_controlNodeDragStart",value:function(t){var e=this.lastTouch,i=this.selectionHandler._pointerToPositionObject(e),o=this.body.nodes[this.temporaryIds.nodes[0]],n=this.body.nodes[this.temporaryIds.nodes[1]],s=this.body.edges[this.edgeBeingEditedId];this.selectedControlNode=void 0;var r=o.isOverlappingWith(i),a=n.isOverlappingWith(i);!0===r?(this.selectedControlNode=o,s.edgeType.from=o):!0===a&&(this.selectedControlNode=n,s.edgeType.to=n),void 0!==this.selectedControlNode&&this.selectionHandler.selectObject(this.selectedControlNode),this.body.emitter.emit("_redraw")}},{key:"_controlNodeDrag",value:function(t){this.body.emitter.emit("disablePhysics");var e=this.body.functions.getPointer(t.center),i=this.canvas.DOMtoCanvas(e);void 0!==this.selectedControlNode?(this.selectedControlNode.x=i.x,this.selectedControlNode.y=i.y):this.interactionHandler.onDrag(t),this.body.emitter.emit("_redraw")}},{key:"_controlNodeDragEnd",value:function(t){var e=this.body.functions.getPointer(t.center),i=this.selectionHandler._pointerToPositionObject(e),o=this.body.edges[this.edgeBeingEditedId];if(void 0!==this.selectedControlNode){this.selectionHandler.unselectAll();for(var n=this.selectionHandler._getAllNodesOverlappingWith(i),s=void 0,r=n.length-1;r>=0;r--)if(n[r]!==this.selectedControlNode.id){s=this.body.nodes[n[r]];break}if(void 0!==s&&void 0!==this.selectedControlNode)if(!0===s.isCluster)alert(this.options.locales[this.options.locale].createEdgeError||this.options.locales.en.createEdgeError);else{var a=this.body.nodes[this.temporaryIds.nodes[0]];this.selectedControlNode.id===a.id?this._performEditEdge(s.id,o.to.id):this._performEditEdge(o.from.id,s.id)}else o.updateEdgeType(),this.body.emitter.emit("restorePhysics");this.body.emitter.emit("_redraw")}}},{key:"_handleConnect",value:function(t){if((new Date).valueOf()-this.touchTime>100){this.lastTouch=this.body.functions.getPointer(t.center),this.lastTouch.translation=e.extend({},this.body.view.translation);var i=this.lastTouch,o=this.selectionHandler.getNodeAt(i);if(void 0!==o)if(!0===o.isCluster)alert(this.options.locales[this.options.locale].createEdgeError||this.options.locales.en.createEdgeError);else{var n=this._getNewTargetNode(o.x,o.y);this.body.nodes[n.id]=n,this.body.nodeIndices.push(n.id);var s=this.body.functions.createEdge({id:"connectionEdge"+e.randomUUID(),from:o.id,to:n.id,physics:!1,smooth:{enabled:!0,type:"continuous",roundness:.5}});this.body.edges[s.id]=s,this.body.edgeIndices.push(s.id),this.temporaryIds.nodes.push(n.id),this.temporaryIds.edges.push(s.id)}this.touchTime=(new Date).valueOf()}}},{key:"_dragControlNode",value:function(t){var e=this.body.functions.getPointer(t.center),i=this.selectionHandler._pointerToPositionObject(e),o=void 0;void 0!==this.temporaryIds.edges[0]&&(o=this.body.edges[this.temporaryIds.edges[0]].fromId);for(var n=this.selectionHandler._getAllNodesOverlappingWith(i),s=void 0,r=n.length-1;r>=0;r--){var a;if(-1===zi(a=this.temporaryIds.nodes).call(a,n[r])){s=this.body.nodes[n[r]];break}}if(t.controlEdge={from:o,to:s?s.id:void 0},this.selectionHandler._generateClickEvent("controlNodeDragging",t,e),void 0!==this.temporaryIds.nodes[0]){var h=this.body.nodes[this.temporaryIds.nodes[0]];h.x=this.canvas._XconvertDOMtoCanvas(e.x),h.y=this.canvas._YconvertDOMtoCanvas(e.y),this.body.emitter.emit("_redraw")}else this.interactionHandler.onDrag(t)}},{key:"_finishConnect",value:function(t){var e=this.body.functions.getPointer(t.center),i=this.selectionHandler._pointerToPositionObject(e),o=void 0;void 0!==this.temporaryIds.edges[0]&&(o=this.body.edges[this.temporaryIds.edges[0]].fromId);for(var n=this.selectionHandler._getAllNodesOverlappingWith(i),s=void 0,r=n.length-1;r>=0;r--){var a;if(-1===zi(a=this.temporaryIds.nodes).call(a,n[r])){s=this.body.nodes[n[r]];break}}this._cleanupTemporaryNodesAndEdges(),void 0!==s&&(!0===s.isCluster?alert(this.options.locales[this.options.locale].createEdgeError||this.options.locales.en.createEdgeError):void 0!==this.body.nodes[o]&&void 0!==this.body.nodes[s.id]&&this._performAddEdge(o,s.id)),t.controlEdge={from:o,to:s?s.id:void 0},this.selectionHandler._generateClickEvent("controlNodeDragEnd",t,e),this.body.emitter.emit("_redraw")}},{key:"_dragStartEdge",value:function(t){var e=this.lastTouch;this.selectionHandler._generateClickEvent("dragStart",t,e,void 0,!0)}},{key:"_performAddNode",value:function(t){var i=this,o={id:e.randomUUID(),x:t.pointer.canvas.x,y:t.pointer.canvas.y,label:"new"};if("function"==typeof this.options.addNode){if(2!==this.options.addNode.length)throw this.showManipulatorToolbar(),new Error("The function for add does not support two arguments (data,callback)");this.options.addNode(o,(function(t){null!=t&&"addNode"===i.inMode&&i.body.data.nodes.getDataSet().add(t),i.showManipulatorToolbar()}))}else this.body.data.nodes.getDataSet().add(o),this.showManipulatorToolbar()}},{key:"_performAddEdge",value:function(t,e){var i=this,o={from:t,to:e};if("function"==typeof this.options.addEdge){if(2!==this.options.addEdge.length)throw new Error("The function for connect does not support two arguments (data,callback)");this.options.addEdge(o,(function(t){null!=t&&"addEdge"===i.inMode&&(i.body.data.edges.getDataSet().add(t),i.selectionHandler.unselectAll(),i.showManipulatorToolbar())}))}else this.body.data.edges.getDataSet().add(o),this.selectionHandler.unselectAll(),this.showManipulatorToolbar()}},{key:"_performEditEdge",value:function(t,e){var i=this,o={id:this.edgeBeingEditedId,from:t,to:e,label:this.body.data.edges.get(this.edgeBeingEditedId).label},n=this.options.editEdge;if("object"===os(n)&&(n=n.editWithoutDrag),"function"==typeof n){if(2!==n.length)throw new Error("The function for edit does not support two arguments (data, callback)");n(o,(function(t){null==t||"editEdge"!==i.inMode?(i.body.edges[o.id].updateEdgeType(),i.body.emitter.emit("_redraw"),i.showManipulatorToolbar()):(i.body.data.edges.getDataSet().update(t),i.selectionHandler.unselectAll(),i.showManipulatorToolbar())}))}else this.body.data.edges.getDataSet().update(o),this.selectionHandler.unselectAll(),this.showManipulatorToolbar()}}]),t}(),Zl={black:"#000000",navy:"#000080",darkblue:"#00008B",mediumblue:"#0000CD",blue:"#0000FF",darkgreen:"#006400",green:"#008000",teal:"#008080",darkcyan:"#008B8B",deepskyblue:"#00BFFF",darkturquoise:"#00CED1",mediumspringgreen:"#00FA9A",lime:"#00FF00",springgreen:"#00FF7F",aqua:"#00FFFF",cyan:"#00FFFF",midnightblue:"#191970",dodgerblue:"#1E90FF",lightseagreen:"#20B2AA",forestgreen:"#228B22",seagreen:"#2E8B57",darkslategray:"#2F4F4F",limegreen:"#32CD32",mediumseagreen:"#3CB371",turquoise:"#40E0D0",royalblue:"#4169E1",steelblue:"#4682B4",darkslateblue:"#483D8B",mediumturquoise:"#48D1CC",indigo:"#4B0082",darkolivegreen:"#556B2F",cadetblue:"#5F9EA0",cornflowerblue:"#6495ED",mediumaquamarine:"#66CDAA",dimgray:"#696969",slateblue:"#6A5ACD",olivedrab:"#6B8E23",slategray:"#708090",lightslategray:"#778899",mediumslateblue:"#7B68EE",lawngreen:"#7CFC00",chartreuse:"#7FFF00",aquamarine:"#7FFFD4",maroon:"#800000",purple:"#800080",olive:"#808000",gray:"#808080",skyblue:"#87CEEB",lightskyblue:"#87CEFA",blueviolet:"#8A2BE2",darkred:"#8B0000",darkmagenta:"#8B008B",saddlebrown:"#8B4513",darkseagreen:"#8FBC8F",lightgreen:"#90EE90",mediumpurple:"#9370D8",darkviolet:"#9400D3",palegreen:"#98FB98",darkorchid:"#9932CC",yellowgreen:"#9ACD32",sienna:"#A0522D",brown:"#A52A2A",darkgray:"#A9A9A9",lightblue:"#ADD8E6",greenyellow:"#ADFF2F",paleturquoise:"#AFEEEE",lightsteelblue:"#B0C4DE",powderblue:"#B0E0E6",firebrick:"#B22222",darkgoldenrod:"#B8860B",mediumorchid:"#BA55D3",rosybrown:"#BC8F8F",darkkhaki:"#BDB76B",silver:"#C0C0C0",mediumvioletred:"#C71585",indianred:"#CD5C5C",peru:"#CD853F",chocolate:"#D2691E",tan:"#D2B48C",lightgrey:"#D3D3D3",palevioletred:"#D87093",thistle:"#D8BFD8",orchid:"#DA70D6",goldenrod:"#DAA520",crimson:"#DC143C",gainsboro:"#DCDCDC",plum:"#DDA0DD",burlywood:"#DEB887",lightcyan:"#E0FFFF",lavender:"#E6E6FA",darksalmon:"#E9967A",violet:"#EE82EE",palegoldenrod:"#EEE8AA",lightcoral:"#F08080",khaki:"#F0E68C",aliceblue:"#F0F8FF",honeydew:"#F0FFF0",azure:"#F0FFFF",sandybrown:"#F4A460",wheat:"#F5DEB3",beige:"#F5F5DC",whitesmoke:"#F5F5F5",mintcream:"#F5FFFA",ghostwhite:"#F8F8FF",salmon:"#FA8072",antiquewhite:"#FAEBD7",linen:"#FAF0E6",lightgoldenrodyellow:"#FAFAD2",oldlace:"#FDF5E6",red:"#FF0000",fuchsia:"#FF00FF",magenta:"#FF00FF",deeppink:"#FF1493",orangered:"#FF4500",tomato:"#FF6347",hotpink:"#FF69B4",coral:"#FF7F50",darkorange:"#FF8C00",lightsalmon:"#FFA07A",orange:"#FFA500",lightpink:"#FFB6C1",pink:"#FFC0CB",gold:"#FFD700",peachpuff:"#FFDAB9",navajowhite:"#FFDEAD",moccasin:"#FFE4B5",bisque:"#FFE4C4",mistyrose:"#FFE4E1",blanchedalmond:"#FFEBCD",papayawhip:"#FFEFD5",lavenderblush:"#FFF0F5",seashell:"#FFF5EE",cornsilk:"#FFF8DC",lemonchiffon:"#FFFACD",floralwhite:"#FFFAF0",snow:"#FFFAFA",yellow:"#FFFF00",lightyellow:"#FFFFE0",ivory:"#FFFFF0",white:"#FFFFFF"},$l=function(){function t(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;ma(this,t),this.pixelRatio=e,this.generated=!1,this.centerCoordinates={x:144.5,y:144.5},this.r=289*.49,this.color={r:255,g:255,b:255,a:1},this.hueCircle=void 0,this.initialColor={r:255,g:255,b:255,a:1},this.previousColor=void 0,this.applied=!1,this.updateCallback=function(){},this.closeCallback=function(){},this._create()}return _a(t,[{key:"insertTo",value:function(t){void 0!==this.hammer&&(this.hammer.destroy(),this.hammer=void 0),this.container=t,this.container.appendChild(this.frame),this._bindHammer(),this._setSize()}},{key:"setUpdateCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker update callback is not a function.");this.updateCallback=t}},{key:"setCloseCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker closing callback is not a function.");this.closeCallback=t}},{key:"_isColorString",value:function(t){if("string"==typeof t)return Zl[t]}},{key:"setColor",value:function(t){var i=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if("none"!==t){var o,n=this._isColorString(t);if(void 0!==n&&(t=n),!0===e.isString(t)){if(!0===e.isValidRGB(t)){var s=t.substr(4).substr(0,t.length-5).split(",");o={r:s[0],g:s[1],b:s[2],a:1}}else if(!0===e.isValidRGBA(t)){var r=t.substr(5).substr(0,t.length-6).split(",");o={r:r[0],g:r[1],b:r[2],a:r[3]}}else if(!0===e.isValidHex(t)){var a=e.hexToRGB(t);o={r:a.r,g:a.g,b:a.b,a:1}}}else if(t instanceof Object&&void 0!==t.r&&void 0!==t.g&&void 0!==t.b){var h=void 0!==t.a?t.a:"1.0";o={r:t.r,g:t.g,b:t.b,a:h}}if(void 0===o)throw new Error("Unknown color passed to the colorPicker. Supported are strings: rgb, hex, rgba. Object: rgb ({r:r,g:g,b:b,[a:a]}). Supplied: "+Qh(t));this._setColor(o,i)}}},{key:"show",value:function(){void 0!==this.closeCallback&&(this.closeCallback(),this.closeCallback=void 0),this.applied=!1,this.frame.style.display="block",this._generateHueCircle()}},{key:"_hide",value:function(){var t=this,i=!(arguments.length>0&&void 0!==arguments[0])||arguments[0];!0===i&&(this.previousColor=e.extend({},this.color)),!0===this.applied&&this.updateCallback(this.initialColor),this.frame.style.display="none",Io((function(){void 0!==t.closeCallback&&(t.closeCallback(),t.closeCallback=void 0)}),0)}},{key:"_save",value:function(){this.updateCallback(this.color),this.applied=!1,this._hide()}},{key:"_apply",value:function(){this.applied=!0,this.updateCallback(this.color),this._updatePicker(this.color)}},{key:"_loadLast",value:function(){void 0!==this.previousColor?this.setColor(this.previousColor,!1):alert("There is no last color to load...")}},{key:"_setColor",value:function(t){var i=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];!0===i&&(this.initialColor=e.extend({},t)),this.color=t;var o=e.RGBToHSV(t.r,t.g,t.b),n=2*Math.PI,s=this.r*o.s,r=this.centerCoordinates.x+s*Math.sin(n*o.h),a=this.centerCoordinates.y+s*Math.cos(n*o.h);this.colorPickerSelector.style.left=r-.5*this.colorPickerSelector.clientWidth+"px",this.colorPickerSelector.style.top=a-.5*this.colorPickerSelector.clientHeight+"px",this._updatePicker(t)}},{key:"_setOpacity",value:function(t){this.color.a=t/100,this._updatePicker(this.color)}},{key:"_setBrightness",value:function(t){var i=e.RGBToHSV(this.color.r,this.color.g,this.color.b);i.v=t/100;var o=e.HSVToRGB(i.h,i.s,i.v);o.a=this.color.a,this.color=o,this._updatePicker()}},{key:"_updatePicker",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.color,i=e.RGBToHSV(t.r,t.g,t.b),o=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(o.webkitBackingStorePixelRatio||o.mozBackingStorePixelRatio||o.msBackingStorePixelRatio||o.oBackingStorePixelRatio||o.backingStorePixelRatio||1)),o.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var n=this.colorPickerCanvas.clientWidth,s=this.colorPickerCanvas.clientHeight;o.clearRect(0,0,n,s),o.putImageData(this.hueCircle,0,0),o.fillStyle="rgba(0,0,0,"+(1-i.v)+")",o.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),Th(o).call(o),this.brightnessRange.value=100*i.v,this.opacityRange.value=100*t.a,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}},{key:"_setSize",value:function(){this.colorPickerCanvas.style.width="100%",this.colorPickerCanvas.style.height="100%",this.colorPickerCanvas.width=289*this.pixelRatio,this.colorPickerCanvas.height=289*this.pixelRatio}},{key:"_create",value:function(){var t,e,i,o;if(this.frame=document.createElement("div"),this.frame.className="vis-color-picker",this.colorPickerDiv=document.createElement("div"),this.colorPickerSelector=document.createElement("div"),this.colorPickerSelector.className="vis-selector",this.colorPickerDiv.appendChild(this.colorPickerSelector),this.colorPickerCanvas=document.createElement("canvas"),this.colorPickerDiv.appendChild(this.colorPickerCanvas),this.colorPickerCanvas.getContext){var n=this.colorPickerCanvas.getContext("2d");this.pixelRatio=(window.devicePixelRatio||1)/(n.webkitBackingStorePixelRatio||n.mozBackingStorePixelRatio||n.msBackingStorePixelRatio||n.oBackingStorePixelRatio||n.backingStorePixelRatio||1),this.colorPickerCanvas.getContext("2d").setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0)}else{var s=document.createElement("DIV");s.style.color="red",s.style.fontWeight="bold",s.style.padding="10px",s.innerHTML="Error: your browser does not support HTML canvas",this.colorPickerCanvas.appendChild(s)}this.colorPickerDiv.className="vis-color",this.opacityDiv=document.createElement("div"),this.opacityDiv.className="vis-opacity",this.brightnessDiv=document.createElement("div"),this.brightnessDiv.className="vis-brightness",this.arrowDiv=document.createElement("div"),this.arrowDiv.className="vis-arrow",this.opacityRange=document.createElement("input");try{this.opacityRange.type="range",this.opacityRange.min="0",this.opacityRange.max="100"}catch(t){}this.opacityRange.value="100",this.opacityRange.className="vis-range",this.brightnessRange=document.createElement("input");try{this.brightnessRange.type="range",this.brightnessRange.min="0",this.brightnessRange.max="100"}catch(t){}this.brightnessRange.value="100",this.brightnessRange.className="vis-range",this.opacityDiv.appendChild(this.opacityRange),this.brightnessDiv.appendChild(this.brightnessRange);var r=this;this.opacityRange.onchange=function(){r._setOpacity(this.value)},this.opacityRange.oninput=function(){r._setOpacity(this.value)},this.brightnessRange.onchange=function(){r._setBrightness(this.value)},this.brightnessRange.oninput=function(){r._setBrightness(this.value)},this.brightnessLabel=document.createElement("div"),this.brightnessLabel.className="vis-label vis-brightness",this.brightnessLabel.innerHTML="brightness:",this.opacityLabel=document.createElement("div"),this.opacityLabel.className="vis-label vis-opacity",this.opacityLabel.innerHTML="opacity:",this.newColorDiv=document.createElement("div"),this.newColorDiv.className="vis-new-color",this.newColorDiv.innerHTML="new",this.initialColorDiv=document.createElement("div"),this.initialColorDiv.className="vis-initial-color",this.initialColorDiv.innerHTML="initial",this.cancelButton=document.createElement("div"),this.cancelButton.className="vis-button vis-cancel",this.cancelButton.innerHTML="cancel",this.cancelButton.onclick=it(t=this._hide).call(t,this,!1),this.applyButton=document.createElement("div"),this.applyButton.className="vis-button vis-apply",this.applyButton.innerHTML="apply",this.applyButton.onclick=it(e=this._apply).call(e,this),this.saveButton=document.createElement("div"),this.saveButton.className="vis-button vis-save",this.saveButton.innerHTML="save",this.saveButton.onclick=it(i=this._save).call(i,this),this.loadButton=document.createElement("div"),this.loadButton.className="vis-button vis-load",this.loadButton.innerHTML="load last",this.loadButton.onclick=it(o=this._loadLast).call(o,this),this.frame.appendChild(this.colorPickerDiv),this.frame.appendChild(this.arrowDiv),this.frame.appendChild(this.brightnessLabel),this.frame.appendChild(this.brightnessDiv),this.frame.appendChild(this.opacityLabel),this.frame.appendChild(this.opacityDiv),this.frame.appendChild(this.newColorDiv),this.frame.appendChild(this.initialColorDiv),this.frame.appendChild(this.cancelButton),this.frame.appendChild(this.applyButton),this.frame.appendChild(this.saveButton),this.frame.appendChild(this.loadButton)}},{key:"_bindHammer",value:function(){var t=this;this.drag={},this.pinch={},this.hammer=new fa(this.colorPickerCanvas),this.hammer.get("pinch").set({enable:!0}),rl.onTouch(this.hammer,(function(e){t._moveSelector(e)})),this.hammer.on("tap",(function(e){t._moveSelector(e)})),this.hammer.on("panstart",(function(e){t._moveSelector(e)})),this.hammer.on("panmove",(function(e){t._moveSelector(e)})),this.hammer.on("panend",(function(e){t._moveSelector(e)}))}},{key:"_generateHueCircle",value:function(){if(!1===this.generated){var t=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(t.webkitBackingStorePixelRatio||t.mozBackingStorePixelRatio||t.msBackingStorePixelRatio||t.oBackingStorePixelRatio||t.backingStorePixelRatio||1)),t.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var i,o,n,s,r=this.colorPickerCanvas.clientWidth,a=this.colorPickerCanvas.clientHeight;t.clearRect(0,0,r,a),this.centerCoordinates={x:.5*r,y:.5*a},this.r=.49*r;var h,d=2*Math.PI/360,l=1/this.r;for(n=0;n<360;n++)for(s=0;s<this.r;s++)i=this.centerCoordinates.x+s*Math.sin(d*n),o=this.centerCoordinates.y+s*Math.cos(d*n),h=e.HSVToRGB(n*(1/360),s*l,1),t.fillStyle="rgb("+h.r+","+h.g+","+h.b+")",t.fillRect(i-.5,o-.5,2,2);t.strokeStyle="rgba(0,0,0,1)",t.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),t.stroke(),this.hueCircle=t.getImageData(0,0,r,a)}this.generated=!0}},{key:"_moveSelector",value:function(t){var i=this.colorPickerDiv.getBoundingClientRect(),o=t.center.x-i.left,n=t.center.y-i.top,s=.5*this.colorPickerDiv.clientHeight,r=.5*this.colorPickerDiv.clientWidth,a=o-r,h=n-s,d=Math.atan2(a,h),l=.98*Math.min(Math.sqrt(a*a+h*h),r),c=Math.cos(d)*l+s,u=Math.sin(d)*l+r;this.colorPickerSelector.style.top=c-.5*this.colorPickerSelector.clientHeight+"px",this.colorPickerSelector.style.left=u-.5*this.colorPickerSelector.clientWidth+"px";var p=d/(2*Math.PI);p=p<0?p+1:p;var f=l/this.r,v=e.RGBToHSV(this.color.r,this.color.g,this.color.b);v.h=p,v.s=f;var g=e.HSVToRGB(v.h,v.s,v.v);g.a=this.color.a,this.color=g,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}}]),t}(),Jl=function(){function t(i,o,n){var s=arguments.length>3&&void 0!==arguments[3]?arguments[3]:1;ma(this,t),this.parent=i,this.changedOptions=[],this.container=o,this.allowCreation=!1,this.options={},this.initialized=!1,this.popupCounter=0,this.defaultOptions={enabled:!1,filter:!0,container:void 0,showButton:!0},e.extend(this.options,this.defaultOptions),this.configureOptions=n,this.moduleOptions={},this.domElements=[],this.popupDiv={},this.popupLimit=5,this.popupHistory={},this.colorPicker=new $l(s),this.wrapper=void 0}return _a(t,[{key:"setOptions",value:function(t){if(void 0!==t){this.popupHistory={},this._removePopup();var e=!0;if("string"==typeof t)this.options.filter=t;else if(t instanceof Array)this.options.filter=t.join();else if("object"===os(t)){if(null==t)throw new TypeError("options cannot be null");void 0!==t.container&&(this.options.container=t.container),void 0!==zo(t)&&(this.options.filter=zo(t)),void 0!==t.showButton&&(this.options.showButton=t.showButton),void 0!==t.enabled&&(e=t.enabled)}else"boolean"==typeof t?(this.options.filter=!0,e=t):"function"==typeof t&&(this.options.filter=t,e=!0);!1===zo(this.options)&&(e=!1),this.options.enabled=e}this._clean()}},{key:"setModuleOptions",value:function(t){this.moduleOptions=t,!0===this.options.enabled&&(this._clean(),void 0!==this.options.container&&(this.container=this.options.container),this._create())}},{key:"_create",value:function(){this._clean(),this.changedOptions=[];var t=zo(this.options),e=0,i=!1;for(var o in this.configureOptions)this.configureOptions.hasOwnProperty(o)&&(this.allowCreation=!1,i=!1,"function"==typeof t?i=(i=t(o,[]))||this._handleObject(this.configureOptions[o],[o],!0):!0!==t&&-1===zi(t).call(t,o)||(i=!0),!1!==i&&(this.allowCreation=!0,e>0&&this._makeItem([]),this._makeHeader(o),this._handleObject(this.configureOptions[o],[o])),e++);this._makeButton(),this._push()}},{key:"_push",value:function(){this.wrapper=document.createElement("div"),this.wrapper.className="vis-configuration-wrapper",this.container.appendChild(this.wrapper);for(var t=0;t<this.domElements.length;t++)this.wrapper.appendChild(this.domElements[t]);this._showPopupIfNeeded()}},{key:"_clean",value:function(){for(var t=0;t<this.domElements.length;t++)this.wrapper.removeChild(this.domElements[t]);void 0!==this.wrapper&&(this.container.removeChild(this.wrapper),this.wrapper=void 0),this.domElements=[],this._removePopup()}},{key:"_getValue",value:function(t){for(var e=this.moduleOptions,i=0;i<t.length;i++){if(void 0===e[t[i]]){e=void 0;break}e=e[t[i]]}return e}},{key:"_makeItem",value:function(t){if(!0===this.allowCreation){var e=document.createElement("div");e.className="vis-configuration vis-config-item vis-config-s"+t.length;for(var i=arguments.length,o=new Array(i>1?i-1:0),n=1;n<i;n++)o[n-1]=arguments[n];return yi(o).call(o,(function(t){e.appendChild(t)})),this.domElements.push(e),this.domElements.length}return 0}},{key:"_makeHeader",value:function(t){var e=document.createElement("div");e.className="vis-configuration vis-config-header",e.innerHTML=t,this._makeItem([],e)}},{key:"_makeLabel",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],o=document.createElement("div");return o.className="vis-configuration vis-config-label vis-config-s"+e.length,o.innerHTML=!0===i?"<i><b>"+t+":</b></i>":t+":",o}},{key:"_makeDropdown",value:function(t,e,i){var o=document.createElement("select");o.className="vis-configuration vis-config-select";var n=0;void 0!==e&&-1!==zi(t).call(t,e)&&(n=zi(t).call(t,e));for(var s=0;s<t.length;s++){var r=document.createElement("option");r.value=t[s],s===n&&(r.selected="selected"),r.innerHTML=t[s],o.appendChild(r)}var a=this;o.onchange=function(){a._update(this.value,i)};var h=this._makeLabel(i[i.length-1],i);this._makeItem(i,h,o)}},{key:"_makeRange",value:function(t,e,i){var o=t[0],n=t[1],s=t[2],r=t[3],a=document.createElement("input");a.className="vis-configuration vis-config-range";try{a.type="range",a.min=n,a.max=s}catch(t){}a.step=r;var h="",d=0;if(void 0!==e){e<0&&1.2*e<n?(a.min=Math.ceil(1.2*e),d=a.min,h="range increased"):e/1.2<n&&(a.min=Math.ceil(e/1.2),d=a.min,h="range increased"),1.2*e>s&&1!==s&&(a.max=Math.ceil(1.2*e),d=a.max,h="range increased"),a.value=e}else a.value=o;var l=document.createElement("input");l.className="vis-configuration vis-config-rangeinput",l.value=a.value;var c=this;a.onchange=function(){l.value=this.value,c._update(Number(this.value),i)},a.oninput=function(){l.value=this.value};var u=this._makeLabel(i[i.length-1],i),p=this._makeItem(i,u,a,l);""!==h&&this.popupHistory[p]!==d&&(this.popupHistory[p]=d,this._setupPopup(h,p))}},{key:"_makeButton",value:function(){var t=this;if(!0===this.options.showButton){var e=document.createElement("div");e.className="vis-configuration vis-config-button",e.innerHTML="generate options",e.onclick=function(){t._printOptions()},e.onmouseover=function(){e.className="vis-configuration vis-config-button hover"},e.onmouseout=function(){e.className="vis-configuration vis-config-button"},this.optionsContainer=document.createElement("div"),this.optionsContainer.className="vis-configuration vis-config-option-container",this.domElements.push(this.optionsContainer),this.domElements.push(e)}}},{key:"_setupPopup",value:function(t,e){var i=this;if(!0===this.initialized&&!0===this.allowCreation&&this.popupCounter<this.popupLimit){var o=document.createElement("div");o.id="vis-configuration-popup",o.className="vis-configuration-popup",o.innerHTML=t,o.onclick=function(){i._removePopup()},this.popupCounter+=1,this.popupDiv={html:o,index:e}}}},{key:"_removePopup",value:function(){void 0!==this.popupDiv.html&&(this.popupDiv.html.parentNode.removeChild(this.popupDiv.html),clearTimeout(this.popupDiv.hideTimeout),clearTimeout(this.popupDiv.deleteTimeout),this.popupDiv={})}},{key:"_showPopupIfNeeded",value:function(){var t=this;if(void 0!==this.popupDiv.html){var e=this.domElements[this.popupDiv.index].getBoundingClientRect();this.popupDiv.html.style.left=e.left+"px",this.popupDiv.html.style.top=e.top-30+"px",document.body.appendChild(this.popupDiv.html),this.popupDiv.hideTimeout=Io((function(){t.popupDiv.html.style.opacity=0}),1500),this.popupDiv.deleteTimeout=Io((function(){t._removePopup()}),1800)}}},{key:"_makeCheckbox",value:function(t,e,i){var o=document.createElement("input");o.type="checkbox",o.className="vis-configuration vis-config-checkbox",o.checked=t,void 0!==e&&(o.checked=e,e!==t&&("object"===os(t)?e!==t.enabled&&this.changedOptions.push({path:i,value:e}):this.changedOptions.push({path:i,value:e})));var n=this;o.onchange=function(){n._update(this.checked,i)};var s=this._makeLabel(i[i.length-1],i);this._makeItem(i,s,o)}},{key:"_makeTextInput",value:function(t,e,i){var o=document.createElement("input");o.type="text",o.className="vis-configuration vis-config-text",o.value=e,e!==t&&this.changedOptions.push({path:i,value:e});var n=this;o.onchange=function(){n._update(this.value,i)};var s=this._makeLabel(i[i.length-1],i);this._makeItem(i,s,o)}},{key:"_makeColorField",value:function(t,e,i){var o=this,n=t[1],s=document.createElement("div");"none"!==(e=void 0===e?n:e)?(s.className="vis-configuration vis-config-colorBlock",s.style.backgroundColor=e):s.className="vis-configuration vis-config-colorBlock none",e=void 0===e?n:e,s.onclick=function(){o._showColorPicker(e,s,i)};var r=this._makeLabel(i[i.length-1],i);this._makeItem(i,r,s)}},{key:"_showColorPicker",value:function(t,e,i){var o=this;e.onclick=function(){},this.colorPicker.insertTo(e),this.colorPicker.show(),this.colorPicker.setColor(t),this.colorPicker.setUpdateCallback((function(t){var n="rgba("+t.r+","+t.g+","+t.b+","+t.a+")";e.style.backgroundColor=n,o._update(n,i)})),this.colorPicker.setCloseCallback((function(){e.onclick=function(){o._showColorPicker(t,e,i)}}))}},{key:"_handleObject",value:function(t){var i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],o=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=!1,s=zo(this.options),r=!1;for(var a in t)if(t.hasOwnProperty(a)){n=!0;var h=t[a],d=e.copyAndExtendArray(i,a);if("function"==typeof s&&!1===(n=s(a,i))&&!(h instanceof Array)&&"string"!=typeof h&&"boolean"!=typeof h&&h instanceof Object&&(this.allowCreation=!1,n=this._handleObject(h,d,!0),this.allowCreation=!1===o),!1!==n){r=!0;var l=this._getValue(d);if(h instanceof Array)this._handleArray(h,l,d);else if("string"==typeof h)this._makeTextInput(h,l,d);else if("boolean"==typeof h)this._makeCheckbox(h,l,d);else if(h instanceof Object){var c=!0;if(-1!==zi(i).call(i,"physics")&&this.moduleOptions.physics.solver!==a&&(c=!1),!0===c)if(void 0!==h.enabled){var u=e.copyAndExtendArray(d,"enabled"),p=this._getValue(u);if(!0===p){var f=this._makeLabel(a,d,!0);this._makeItem(d,f),r=this._handleObject(h,d)||r}else this._makeCheckbox(h,p,d)}else{var v=this._makeLabel(a,d,!0);this._makeItem(d,v),r=this._handleObject(h,d)||r}}else console.error("dont know how to handle",h,a,d)}}return r}},{key:"_handleArray",value:function(t,e,i){"string"==typeof t[0]&&"color"===t[0]?(this._makeColorField(t,e,i),t[1]!==e&&this.changedOptions.push({path:i,value:e})):"string"==typeof t[0]?(this._makeDropdown(t,e,i),t[0]!==e&&this.changedOptions.push({path:i,value:e})):"number"==typeof t[0]&&(this._makeRange(t,e,i),t[0]!==e&&this.changedOptions.push({path:i,value:Number(e)}))}},{key:"_update",value:function(t,e){var i=this._constructOptions(t,e);this.parent.body&&this.parent.body.emitter&&this.parent.body.emitter.emit&&this.parent.body.emitter.emit("configChange",i),this.initialized=!0,this.parent.setOptions(i)}},{key:"_constructOptions",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},o=i;t="false"!==(t="true"===t||t)&&t;for(var n=0;n<e.length;n++)"global"!==e[n]&&(void 0===o[e[n]]&&(o[e[n]]={}),n!==e.length-1?o=o[e[n]]:o[e[n]]=t);return i}},{key:"_printOptions",value:function(){var t=this.getOptions();this.optionsContainer.innerHTML="<pre>var options = "+Qh(t,null,2)+"</pre>"}},{key:"getOptions",value:function(){for(var t={},e=0;e<this.changedOptions.length;e++)this._constructOptions(this.changedOptions[e].value,this.changedOptions[e].path,t);return t}}]),t}(),Ql="string",tc="boolean",ec="number",ic="object",oc=["arrow","bar","box","circle","crow","curve","diamond","image","inv_curve","inv_triangle","triangle","vee"],nc={configure:{enabled:{boolean:tc},filter:{boolean:tc,string:Ql,array:"array",function:"function"},container:{dom:"dom"},showButton:{boolean:tc},__type__:{object:ic,boolean:tc,string:Ql,array:"array",function:"function"}},edges:{arrows:{to:{enabled:{boolean:tc},scaleFactor:{number:ec},type:{string:oc},imageHeight:{number:ec},imageWidth:{number:ec},src:{string:Ql},__type__:{object:ic,boolean:tc}},middle:{enabled:{boolean:tc},scaleFactor:{number:ec},type:{string:oc},imageWidth:{number:ec},imageHeight:{number:ec},src:{string:Ql},__type__:{object:ic,boolean:tc}},from:{enabled:{boolean:tc},scaleFactor:{number:ec},type:{string:oc},imageWidth:{number:ec},imageHeight:{number:ec},src:{string:Ql},__type__:{object:ic,boolean:tc}},__type__:{string:["from","to","middle"],object:ic}},arrowStrikethrough:{boolean:tc},background:{enabled:{boolean:tc},color:{string:Ql},size:{number:ec},dashes:{boolean:tc,array:"array"},__type__:{object:ic,boolean:tc}},chosen:{label:{boolean:tc,function:"function"},edge:{boolean:tc,function:"function"},__type__:{object:ic,boolean:tc}},color:{color:{string:Ql},highlight:{string:Ql},hover:{string:Ql},inherit:{string:["from","to","both"],boolean:tc},opacity:{number:ec},__type__:{object:ic,string:Ql}},dashes:{boolean:tc,array:"array"},font:{color:{string:Ql},size:{number:ec},face:{string:Ql},background:{string:Ql},strokeWidth:{number:ec},strokeColor:{string:Ql},align:{string:["horizontal","top","middle","bottom"]},vadjust:{number:ec},multi:{boolean:tc,string:Ql},bold:{color:{string:Ql},size:{number:ec},face:{string:Ql},mod:{string:Ql},vadjust:{number:ec},__type__:{object:ic,string:Ql}},boldital:{color:{string:Ql},size:{number:ec},face:{string:Ql},mod:{string:Ql},vadjust:{number:ec},__type__:{object:ic,string:Ql}},ital:{color:{string:Ql},size:{number:ec},face:{string:Ql},mod:{string:Ql},vadjust:{number:ec},__type__:{object:ic,string:Ql}},mono:{color:{string:Ql},size:{number:ec},face:{string:Ql},mod:{string:Ql},vadjust:{number:ec},__type__:{object:ic,string:Ql}},__type__:{object:ic,string:Ql}},hidden:{boolean:tc},hoverWidth:{function:"function",number:ec},label:{string:Ql,undefined:"undefined"},labelHighlightBold:{boolean:tc},length:{number:ec,undefined:"undefined"},physics:{boolean:tc},scaling:{min:{number:ec},max:{number:ec},label:{enabled:{boolean:tc},min:{number:ec},max:{number:ec},maxVisible:{number:ec},drawThreshold:{number:ec},__type__:{object:ic,boolean:tc}},customScalingFunction:{function:"function"},__type__:{object:ic}},selectionWidth:{function:"function",number:ec},selfReferenceSize:{number:ec},shadow:{enabled:{boolean:tc},color:{string:Ql},size:{number:ec},x:{number:ec},y:{number:ec},__type__:{object:ic,boolean:tc}},smooth:{enabled:{boolean:tc},type:{string:["dynamic","continuous","discrete","diagonalCross","straightCross","horizontal","vertical","curvedCW","curvedCCW","cubicBezier"]},roundness:{number:ec},forceDirection:{string:["horizontal","vertical","none"],boolean:tc},__type__:{object:ic,boolean:tc}},title:{string:Ql,undefined:"undefined"},width:{number:ec},widthConstraint:{maximum:{number:ec},__type__:{object:ic,boolean:tc,number:ec}},value:{number:ec,undefined:"undefined"},__type__:{object:ic}},groups:{useDefaultGroups:{boolean:tc},__any__:"get from nodes, will be overwritten below",__type__:{object:ic}},interaction:{dragNodes:{boolean:tc},dragView:{boolean:tc},hideEdgesOnDrag:{boolean:tc},hideEdgesOnZoom:{boolean:tc},hideNodesOnDrag:{boolean:tc},hover:{boolean:tc},keyboard:{enabled:{boolean:tc},speed:{x:{number:ec},y:{number:ec},zoom:{number:ec},__type__:{object:ic}},bindToWindow:{boolean:tc},__type__:{object:ic,boolean:tc}},multiselect:{boolean:tc},navigationButtons:{boolean:tc},selectable:{boolean:tc},selectConnectedEdges:{boolean:tc},hoverConnectedEdges:{boolean:tc},tooltipDelay:{number:ec},zoomView:{boolean:tc},zoomSpeed:{number:ec},__type__:{object:ic}},layout:{randomSeed:{undefined:"undefined",number:ec},improvedLayout:{boolean:tc},clusterThreshold:{number:ec},hierarchical:{enabled:{boolean:tc},levelSeparation:{number:ec},nodeSpacing:{number:ec},treeSpacing:{number:ec},blockShifting:{boolean:tc},edgeMinimization:{boolean:tc},parentCentralization:{boolean:tc},direction:{string:["UD","DU","LR","RL"]},sortMethod:{string:["hubsize","directed"]},shakeTowards:{string:["leaves","roots"]},__type__:{object:ic,boolean:tc}},__type__:{object:ic}},manipulation:{enabled:{boolean:tc},initiallyActive:{boolean:tc},addNode:{boolean:tc,function:"function"},addEdge:{boolean:tc,function:"function"},editNode:{function:"function"},editEdge:{editWithoutDrag:{function:"function"},__type__:{object:ic,boolean:tc,function:"function"}},deleteNode:{boolean:tc,function:"function"},deleteEdge:{boolean:tc,function:"function"},controlNodeStyle:"get from nodes, will be overwritten below",__type__:{object:ic,boolean:tc}},nodes:{borderWidth:{number:ec},borderWidthSelected:{number:ec,undefined:"undefined"},brokenImage:{string:Ql,undefined:"undefined"},chosen:{label:{boolean:tc,function:"function"},node:{boolean:tc,function:"function"},__type__:{object:ic,boolean:tc}},color:{border:{string:Ql},background:{string:Ql},highlight:{border:{string:Ql},background:{string:Ql},__type__:{object:ic,string:Ql}},hover:{border:{string:Ql},background:{string:Ql},__type__:{object:ic,string:Ql}},__type__:{object:ic,string:Ql}},fixed:{x:{boolean:tc},y:{boolean:tc},__type__:{object:ic,boolean:tc}},font:{align:{string:Ql},color:{string:Ql},size:{number:ec},face:{string:Ql},background:{string:Ql},strokeWidth:{number:ec},strokeColor:{string:Ql},vadjust:{number:ec},multi:{boolean:tc,string:Ql},bold:{color:{string:Ql},size:{number:ec},face:{string:Ql},mod:{string:Ql},vadjust:{number:ec},__type__:{object:ic,string:Ql}},boldital:{color:{string:Ql},size:{number:ec},face:{string:Ql},mod:{string:Ql},vadjust:{number:ec},__type__:{object:ic,string:Ql}},ital:{color:{string:Ql},size:{number:ec},face:{string:Ql},mod:{string:Ql},vadjust:{number:ec},__type__:{object:ic,string:Ql}},mono:{color:{string:Ql},size:{number:ec},face:{string:Ql},mod:{string:Ql},vadjust:{number:ec},__type__:{object:ic,string:Ql}},__type__:{object:ic,string:Ql}},group:{string:Ql,number:ec,undefined:"undefined"},heightConstraint:{minimum:{number:ec},valign:{string:Ql},__type__:{object:ic,boolean:tc,number:ec}},hidden:{boolean:tc},icon:{face:{string:Ql},code:{string:Ql},size:{number:ec},color:{string:Ql},weight:{string:Ql,number:ec},__type__:{object:ic}},id:{string:Ql,number:ec},image:{selected:{string:Ql,undefined:"undefined"},unselected:{string:Ql,undefined:"undefined"},__type__:{object:ic,string:Ql}},imagePadding:{top:{number:ec},right:{number:ec},bottom:{number:ec},left:{number:ec},__type__:{object:ic,number:ec}},label:{string:Ql,undefined:"undefined"},labelHighlightBold:{boolean:tc},level:{number:ec,undefined:"undefined"},margin:{top:{number:ec},right:{number:ec},bottom:{number:ec},left:{number:ec},__type__:{object:ic,number:ec}},mass:{number:ec},physics:{boolean:tc},scaling:{min:{number:ec},max:{number:ec},label:{enabled:{boolean:tc},min:{number:ec},max:{number:ec},maxVisible:{number:ec},drawThreshold:{number:ec},__type__:{object:ic,boolean:tc}},customScalingFunction:{function:"function"},__type__:{object:ic}},shadow:{enabled:{boolean:tc},color:{string:Ql},size:{number:ec},x:{number:ec},y:{number:ec},__type__:{object:ic,boolean:tc}},shape:{string:["ellipse","circle","database","box","text","image","circularImage","diamond","dot","star","triangle","triangleDown","square","icon","hexagon"]},shapeProperties:{borderDashes:{boolean:tc,array:"array"},borderRadius:{number:ec},interpolation:{boolean:tc},useImageSize:{boolean:tc},useBorderWithImage:{boolean:tc},__type__:{object:ic}},size:{number:ec},title:{string:Ql,dom:"dom",undefined:"undefined"},value:{number:ec,undefined:"undefined"},widthConstraint:{minimum:{number:ec},maximum:{number:ec},__type__:{object:ic,boolean:tc,number:ec}},x:{number:ec},y:{number:ec},__type__:{object:ic}},physics:{enabled:{boolean:tc},barnesHut:{gravitationalConstant:{number:ec},centralGravity:{number:ec},springLength:{number:ec},springConstant:{number:ec},damping:{number:ec},avoidOverlap:{number:ec},__type__:{object:ic}},forceAtlas2Based:{gravitationalConstant:{number:ec},centralGravity:{number:ec},springLength:{number:ec},springConstant:{number:ec},damping:{number:ec},avoidOverlap:{number:ec},__type__:{object:ic}},repulsion:{centralGravity:{number:ec},springLength:{number:ec},springConstant:{number:ec},nodeDistance:{number:ec},damping:{number:ec},__type__:{object:ic}},hierarchicalRepulsion:{centralGravity:{number:ec},springLength:{number:ec},springConstant:{number:ec},nodeDistance:{number:ec},damping:{number:ec},avoidOverlap:{number:ec},__type__:{object:ic}},maxVelocity:{number:ec},minVelocity:{number:ec},solver:{string:["barnesHut","repulsion","hierarchicalRepulsion","forceAtlas2Based"]},stabilization:{enabled:{boolean:tc},iterations:{number:ec},updateInterval:{number:ec},onlyDynamicEdges:{boolean:tc},fit:{boolean:tc},__type__:{object:ic,boolean:tc}},timestep:{number:ec},adaptiveTimestep:{boolean:tc},__type__:{object:ic,boolean:tc}},autoResize:{boolean:tc},clickToUse:{boolean:tc},locale:{string:Ql},locales:{__any__:{any:"any"},__type__:{object:ic}},height:{string:Ql},width:{string:Ql},__type__:{object:ic}};nc.groups.__any__=nc.nodes,nc.manipulation.controlNodeStyle=nc.nodes;var sc={nodes:{borderWidth:[1,0,10,1],borderWidthSelected:[2,0,10,1],color:{border:["color","#2B7CE9"],background:["color","#97C2FC"],highlight:{border:["color","#2B7CE9"],background:["color","#D2E5FF"]},hover:{border:["color","#2B7CE9"],background:["color","#D2E5FF"]}},fixed:{x:!1,y:!1},font:{color:["color","#343434"],size:[14,0,100,1],face:["arial","verdana","tahoma"],background:["color","none"],strokeWidth:[0,0,50,1],strokeColor:["color","#ffffff"]},hidden:!1,labelHighlightBold:!0,physics:!0,scaling:{min:[10,0,200,1],max:[30,0,200,1],label:{enabled:!1,min:[14,0,200,1],max:[30,0,200,1],maxVisible:[30,0,200,1],drawThreshold:[5,0,20,1]}},shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:[10,0,20,1],x:[5,-30,30,1],y:[5,-30,30,1]},shape:["ellipse","box","circle","database","diamond","dot","square","star","text","triangle","triangleDown","hexagon"],shapeProperties:{borderDashes:!1,borderRadius:[6,0,20,1],interpolation:!0,useImageSize:!1},size:[25,0,200,1]},edges:{arrows:{to:{enabled:!1,scaleFactor:[1,0,3,.05],type:"arrow"},middle:{enabled:!1,scaleFactor:[1,0,3,.05],type:"arrow"},from:{enabled:!1,scaleFactor:[1,0,3,.05],type:"arrow"}},arrowStrikethrough:!0,color:{color:["color","#848484"],highlight:["color","#848484"],hover:["color","#848484"],inherit:["from","to","both",!0,!1],opacity:[1,0,1,.05]},dashes:!1,font:{color:["color","#343434"],size:[14,0,100,1],face:["arial","verdana","tahoma"],background:["color","none"],strokeWidth:[2,0,50,1],strokeColor:["color","#ffffff"],align:["horizontal","top","middle","bottom"]},hidden:!1,hoverWidth:[1.5,0,5,.1],labelHighlightBold:!0,physics:!0,scaling:{min:[1,0,100,1],max:[15,0,100,1],label:{enabled:!0,min:[14,0,200,1],max:[30,0,200,1],maxVisible:[30,0,200,1],drawThreshold:[5,0,20,1]}},selectionWidth:[1.5,0,5,.1],selfReferenceSize:[20,0,200,1],shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:[10,0,20,1],x:[5,-30,30,1],y:[5,-30,30,1]},smooth:{enabled:!0,type:["dynamic","continuous","discrete","diagonalCross","straightCross","horizontal","vertical","curvedCW","curvedCCW","cubicBezier"],forceDirection:["horizontal","vertical","none"],roundness:[.5,0,1,.05]},width:[1,0,30,1]},layout:{hierarchical:{enabled:!1,levelSeparation:[150,20,500,5],nodeSpacing:[100,20,500,5],treeSpacing:[200,20,500,5],blockShifting:!0,edgeMinimization:!0,parentCentralization:!0,direction:["UD","DU","LR","RL"],sortMethod:["hubsize","directed"],shakeTowards:["leaves","roots"]}},interaction:{dragNodes:!0,dragView:!0,hideEdgesOnDrag:!1,hideEdgesOnZoom:!1,hideNodesOnDrag:!1,hover:!1,keyboard:{enabled:!1,speed:{x:[10,0,40,1],y:[10,0,40,1],zoom:[.02,0,.1,.005]},bindToWindow:!0},multiselect:!1,navigationButtons:!1,selectable:!0,selectConnectedEdges:!0,hoverConnectedEdges:!0,tooltipDelay:[300,0,1e3,25],zoomView:!0,zoomSpeed:[1,1,1,1]},manipulation:{enabled:!1,initiallyActive:!1},physics:{enabled:!0,barnesHut:{gravitationalConstant:[-2e3,-3e4,0,50],centralGravity:[.3,0,10,.05],springLength:[95,0,500,5],springConstant:[.04,0,1.2,.005],damping:[.09,0,1,.01],avoidOverlap:[0,0,1,.01]},forceAtlas2Based:{gravitationalConstant:[-50,-500,0,1],centralGravity:[.01,0,1,.005],springLength:[95,0,500,5],springConstant:[.08,0,1.2,.005],damping:[.4,0,1,.01],avoidOverlap:[0,0,1,.01]},repulsion:{centralGravity:[.2,0,10,.05],springLength:[200,0,500,5],springConstant:[.05,0,1.2,.005],nodeDistance:[100,0,500,5],damping:[.09,0,1,.01]},hierarchicalRepulsion:{centralGravity:[.2,0,10,.05],springLength:[100,0,500,5],springConstant:[.01,0,1.2,.005],nodeDistance:[120,0,500,5],damping:[.09,0,1,.01],avoidOverlap:[0,0,1,.01]},maxVelocity:[50,0,150,1],minVelocity:[.1,.01,.5,.01],solver:["barnesHut","forceAtlas2Based","repulsion","hierarchicalRepulsion"],timestep:[.5,.01,1,.01]}},rc=Object.freeze({__proto__:null,allOptions:nc,configureOptions:sc}),ac=function(){function t(){ma(this,t)}return _a(t,[{key:"getDistances",value:function(t,e,i){for(var o={},n=t.edges,s=0;s<e.length;s++){var r={};o[e[s]]=r;for(var a=0;a<e.length;a++)r[e[a]]=s==a?0:1e9}for(var h=0;h<i.length;h++){var d=n[i[h]];!0===d.connected&&void 0!==o[d.fromId]&&void 0!==o[d.toId]&&(o[d.fromId][d.toId]=1,o[d.toId][d.fromId]=1)}for(var l=e.length,c=0;c<l;c++)for(var u=e[c],p=o[u],f=0;f<l-1;f++)for(var v=e[f],g=o[v],y=f+1;y<l;y++){var m=e[y],b=o[m],w=Math.min(g[m],g[u]+p[m]);g[m]=w,b[v]=w}return o}}]),t}(),hc=function(){function t(e,i,o){ma(this,t),this.body=e,this.springLength=i,this.springConstant=o,this.distanceSolver=new ac}return _a(t,[{key:"setOptions",value:function(t){t&&(t.springLength&&(this.springLength=t.springLength),t.springConstant&&(this.springConstant=t.springConstant))}},{key:"solve",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],o=this.distanceSolver.getDistances(this.body,t,e);this._createL_matrix(o),this._createK_matrix(o),this._createE_matrix();for(var n=.01,s=1,r=0,a=Math.max(1e3,Math.min(10*this.body.nodeIndices.length,6e3)),h=5,d=1e9,l=0,c=0,u=0,p=0,f=0;d>n&&r<a;){r+=1;var v=this._getHighestEnergyNode(i),g=nh(v,4);for(l=g[0],d=g[1],c=g[2],u=g[3],p=d,f=0;p>s&&f<h;){f+=1,this._moveNode(l,c,u);var y=this._getEnergy(l),m=nh(y,3);p=m[0],c=m[1],u=m[2]}}}},{key:"_getHighestEnergyNode",value:function(t){for(var e=this.body.nodeIndices,i=this.body.nodes,o=0,n=e[0],s=0,r=0,a=0;a<e.length;a++){var h=e[a];if(!1===i[h].predefinedPosition||!0===i[h].isCluster&&!0===t||!0===i[h].options.fixed.x||!0===i[h].options.fixed.y){var d=this._getEnergy(h),l=nh(d,3),c=l[0],u=l[1],p=l[2];o<c&&(o=c,n=h,s=u,r=p)}}return[n,o,s,r]}},{key:"_getEnergy",value:function(t){var e=nh(this.E_sums[t],2),i=e[0],o=e[1];return[Math.sqrt(Math.pow(i,2)+Math.pow(o,2)),i,o]}},{key:"_moveNode",value:function(t,e,i){for(var o=this.body.nodeIndices,n=this.body.nodes,s=0,r=0,a=0,h=n[t].x,d=n[t].y,l=this.K_matrix[t],c=this.L_matrix[t],u=0;u<o.length;u++){var p=o[u];if(p!==t){var f=n[p].x,v=n[p].y,g=l[p],y=c[p],m=1/Math.pow(Math.pow(h-f,2)+Math.pow(d-v,2),1.5);s+=g*(1-y*Math.pow(d-v,2)*m),r+=g*(y*(h-f)*(d-v)*m),a+=g*(1-y*Math.pow(h-f,2)*m)}}var b=(e/s+i/r)/(r/s-a/r),w=-(r*b+e)/s;n[t].x+=w,n[t].y+=b,this._updateE_matrix(t)}},{key:"_createL_matrix",value:function(t){var e=this.body.nodeIndices,i=this.springLength;this.L_matrix=[];for(var o=0;o<e.length;o++){this.L_matrix[e[o]]={};for(var n=0;n<e.length;n++)this.L_matrix[e[o]][e[n]]=i*t[e[o]][e[n]]}}},{key:"_createK_matrix",value:function(t){var e=this.body.nodeIndices,i=this.springConstant;this.K_matrix=[];for(var o=0;o<e.length;o++){this.K_matrix[e[o]]={};for(var n=0;n<e.length;n++)this.K_matrix[e[o]][e[n]]=i*Math.pow(t[e[o]][e[n]],-2)}}},{key:"_createE_matrix",value:function(){var t=this.body.nodeIndices,e=this.body.nodes;this.E_matrix={},this.E_sums={};for(var i=0;i<t.length;i++)this.E_matrix[t[i]]=[];for(var o=0;o<t.length;o++){for(var n=t[o],s=e[n].x,r=e[n].y,a=0,h=0,d=o;d<t.length;d++){var l=t[d];if(l!==n){var c=e[l].x,u=e[l].y,p=1/Math.sqrt(Math.pow(s-c,2)+Math.pow(r-u,2));this.E_matrix[n][d]=[this.K_matrix[n][l]*(s-c-this.L_matrix[n][l]*(s-c)*p),this.K_matrix[n][l]*(r-u-this.L_matrix[n][l]*(r-u)*p)],this.E_matrix[l][o]=this.E_matrix[n][d],a+=this.E_matrix[n][d][0],h+=this.E_matrix[n][d][1]}}this.E_sums[n]=[a,h]}}},{key:"_updateE_matrix",value:function(t){for(var e=this.body.nodeIndices,i=this.body.nodes,o=this.E_matrix[t],n=this.K_matrix[t],s=this.L_matrix[t],r=i[t].x,a=i[t].y,h=0,d=0,l=0;l<e.length;l++){var c=e[l];if(c!==t){var u=o[l],p=u[0],f=u[1],v=i[c].x,g=i[c].y,y=1/Math.sqrt(Math.pow(r-v,2)+Math.pow(a-g,2)),m=n[c]*(r-v-s[c]*(r-v)*y),b=n[c]*(a-g-s[c]*(a-g)*y);o[l]=[m,b],h+=m,d+=b;var w=this.E_sums[c];w[0]+=m-p,w[1]+=b-f}}this.E_sums[t]=[h,d]}}]),t}();function dc(t,i,o){var n,s,r,a,h=this;if(!(this instanceof dc))throw new SyntaxError("Constructor must be called with the new operator");this.options={},this.defaultOptions={locale:"en",locales:ya,clickToUse:!1},e.extend(this.options,this.defaultOptions),this.body={container:t,nodes:{},nodeIndices:[],edges:{},edgeIndices:[],emitter:{on:it(n=this.on).call(n,this),off:it(s=this.off).call(s,this),emit:it(r=this.emit).call(r,this),once:it(a=this.once).call(a,this)},eventListeners:{onTap:function(){},onTouch:function(){},onDoubleTap:function(){},onHold:function(){},onDragStart:function(){},onDrag:function(){},onDragEnd:function(){},onMouseWheel:function(){},onPinch:function(){},onMouseMove:function(){},onRelease:function(){},onContext:function(){}},data:{nodes:null,edges:null},functions:{createNode:function(){},createEdge:function(){},getPointer:function(){}},modules:{},view:{scale:1,translation:{x:0,y:0}}},this.bindEventListeners(),this.images=new Ea((function(){return h.body.emitter.emit("_requestRedraw")})),this.groups=new Oa,this.canvas=new al(this.body),this.selectionHandler=new gl(this.body,this.canvas),this.interactionHandler=new vl(this.body,this.canvas,this.selectionHandler),this.view=new ul(this.body,this.canvas),this.renderer=new nl(this.body,this.canvas),this.physics=new Kd(this.body),this.layoutEngine=new Gl(this.body),this.clustering=new ol(this.body),this.manipulation=new Kl(this.body,this.canvas,this.selectionHandler,this.interactionHandler),this.nodesHandler=new sd(this.body,this.images,this.groups,this.layoutEngine),this.edgesHandler=new Ld(this.body,this.images,this.groups),this.body.modules.kamadaKawai=new hc(this.body,150,.05),this.body.modules.clustering=this.clustering,this.canvas._create(),this.setOptions(o),this.setData(i)}ie(dc.prototype),dc.prototype.setOptions=function(t){var i=this;if(null===t&&(t=void 0),void 0!==t){!0===id.validate(t,nc)&&console.log("%cErrors have been found in the supplied options object.",ed);if(e.selectiveDeepExtend(["locale","locales","clickToUse"],this.options,t),t=this.layoutEngine.setOptions(t.layout,t),this.canvas.setOptions(t),this.groups.setOptions(t.groups),this.nodesHandler.setOptions(t.nodes),this.edgesHandler.setOptions(t.edges),this.physics.setOptions(t.physics),this.manipulation.setOptions(t.manipulation,t,this.options),this.interactionHandler.setOptions(t.interaction),this.renderer.setOptions(t.interaction),this.selectionHandler.setOptions(t.interaction),void 0!==t.groups&&this.body.emitter.emit("refreshNodes"),"configure"in t&&(this.configurator||(this.configurator=new Jl(this,this.body.container,sc,this.canvas.pixelRatio)),this.configurator.setOptions(t.configure)),this.configurator&&!0===this.configurator.options.enabled){var o={nodes:{},edges:{},layout:{},interaction:{},manipulation:{},physics:{},global:{}};e.deepExtend(o.nodes,this.nodesHandler.options),e.deepExtend(o.edges,this.edgesHandler.options),e.deepExtend(o.layout,this.layoutEngine.options),e.deepExtend(o.interaction,this.selectionHandler.options),e.deepExtend(o.interaction,this.renderer.options),e.deepExtend(o.interaction,this.interactionHandler.options),e.deepExtend(o.manipulation,this.manipulation.options),e.deepExtend(o.physics,this.physics.options),e.deepExtend(o.global,this.canvas.options),e.deepExtend(o.global,this.options),this.configurator.setModuleOptions(o)}void 0!==t.clickToUse?!0===t.clickToUse?void 0===this.activator&&(this.activator=new ga(this.canvas.frame),this.activator.on("change",(function(){i.body.emitter.emit("activate")}))):(void 0!==this.activator&&(this.activator.destroy(),delete this.activator),this.body.emitter.emit("activate")):this.body.emitter.emit("activate"),this.canvas.setSize(),this.body.emitter.emit("startSimulation")}},dc.prototype._updateVisibleIndices=function(){var t=this.body.nodes,e=this.body.edges;for(var i in this.body.nodeIndices=[],this.body.edgeIndices=[],t)t.hasOwnProperty(i)&&(this.clustering._isClusteredNode(i)||!1!==t[i].options.hidden||this.body.nodeIndices.push(t[i].id));for(var o in e)if(e.hasOwnProperty(o)){var n=e[o],s=t[n.fromId],r=t[n.toId],a=void 0!==s&&void 0!==r;!this.clustering._isClusteredEdge(o)&&!1===n.options.hidden&&a&&!1===s.options.hidden&&!1===r.options.hidden&&this.body.edgeIndices.push(n.id)}},dc.prototype.bindEventListeners=function(){var t=this;this.body.emitter.on("_dataChanged",(function(){t.edgesHandler._updateState(),t.body.emitter.emit("_dataUpdated")})),this.body.emitter.on("_dataUpdated",(function(){t.clustering._updateState(),t._updateVisibleIndices(),t._updateValueRange(t.body.nodes),t._updateValueRange(t.body.edges),t.body.emitter.emit("startSimulation"),t.body.emitter.emit("_requestRedraw")}))},dc.prototype.setData=function(t){if(this.body.emitter.emit("resetPhysics"),this.body.emitter.emit("_resetData"),this.selectionHandler.unselectAll(),t&&t.dot&&(t.nodes||t.edges))throw new SyntaxError('Data must contain either parameter "dot" or  parameter pair "nodes" and "edges", but not both.');if(this.setOptions(t&&t.options),t&&t.dot){console.log("The dot property has been deprecated. Please use the static convertDot method to convert DOT into vis.network format and use the normal data format with nodes and edges. This converter is used like this: var data = vis.network.convertDot(dotString);");var e=yo.DOTToGraph(t.dot);this.setData(e)}else if(t&&t.gephi){console.log("The gephi property has been deprecated. Please use the static convertGephi method to convert gephi into vis.network format and use the normal data format with nodes and edges. This converter is used like this: var data = vis.network.convertGephi(gephiJson);");var i=xo(t.gephi);this.setData(i)}else this.nodesHandler.setData(t&&t.nodes,!0),this.edgesHandler.setData(t&&t.edges,!0),this.body.emitter.emit("_dataChanged"),this.body.emitter.emit("_dataLoaded"),this.body.emitter.emit("initPhysics")},dc.prototype.destroy=function(){for(var t in this.body.emitter.emit("destroy"),this.body.emitter.off(),this.off(),delete this.groups,delete this.canvas,delete this.selectionHandler,delete this.interactionHandler,delete this.view,delete this.renderer,delete this.physics,delete this.layoutEngine,delete this.clustering,delete this.manipulation,delete this.nodesHandler,delete this.edgesHandler,delete this.configurator,delete this.images,this.body.nodes)this.body.nodes.hasOwnProperty(t)&&delete this.body.nodes[t];for(var i in this.body.edges)this.body.edges.hasOwnProperty(i)&&delete this.body.edges[i];e.recursiveDOMDelete(this.body.container)},dc.prototype._updateValueRange=function(t){var e,i=void 0,o=void 0,n=0;for(e in t)if(t.hasOwnProperty(e)){var s=t[e].getValue();void 0!==s&&(i=void 0===i?s:Math.min(s,i),o=void 0===o?s:Math.max(s,o),n+=s)}if(void 0!==i&&void 0!==o)for(e in t)t.hasOwnProperty(e)&&t[e].setValueRange(i,o,n)},dc.prototype.isActive=function(){return!this.activator||this.activator.active},dc.prototype.setSize=function(){return this.canvas.setSize.apply(this.canvas,arguments)},dc.prototype.canvasToDOM=function(){return this.canvas.canvasToDOM.apply(this.canvas,arguments)},dc.prototype.DOMtoCanvas=function(){return this.canvas.DOMtoCanvas.apply(this.canvas,arguments)},dc.prototype.findNode=function(){return this.clustering.findNode.apply(this.clustering,arguments)},dc.prototype.isCluster=function(){return this.clustering.isCluster.apply(this.clustering,arguments)},dc.prototype.openCluster=function(){return this.clustering.openCluster.apply(this.clustering,arguments)},dc.prototype.cluster=function(){return this.clustering.cluster.apply(this.clustering,arguments)},dc.prototype.getNodesInCluster=function(){return this.clustering.getNodesInCluster.apply(this.clustering,arguments)},dc.prototype.clusterByConnection=function(){return this.clustering.clusterByConnection.apply(this.clustering,arguments)},dc.prototype.clusterByHubsize=function(){return this.clustering.clusterByHubsize.apply(this.clustering,arguments)},dc.prototype.clusterOutliers=function(){return this.clustering.clusterOutliers.apply(this.clustering,arguments)},dc.prototype.getSeed=function(){return this.layoutEngine.getSeed.apply(this.layoutEngine,arguments)},dc.prototype.enableEditMode=function(){return this.manipulation.enableEditMode.apply(this.manipulation,arguments)},dc.prototype.disableEditMode=function(){return this.manipulation.disableEditMode.apply(this.manipulation,arguments)},dc.prototype.addNodeMode=function(){return this.manipulation.addNodeMode.apply(this.manipulation,arguments)},dc.prototype.editNode=function(){return this.manipulation.editNode.apply(this.manipulation,arguments)},dc.prototype.editNodeMode=function(){return console.log("Deprecated: Please use editNode instead of editNodeMode."),this.manipulation.editNode.apply(this.manipulation,arguments)},dc.prototype.addEdgeMode=function(){return this.manipulation.addEdgeMode.apply(this.manipulation,arguments)},dc.prototype.editEdgeMode=function(){return this.manipulation.editEdgeMode.apply(this.manipulation,arguments)},dc.prototype.deleteSelected=function(){return this.manipulation.deleteSelected.apply(this.manipulation,arguments)},dc.prototype.getPositions=function(){return this.nodesHandler.getPositions.apply(this.nodesHandler,arguments)},dc.prototype.storePositions=function(){return this.nodesHandler.storePositions.apply(this.nodesHandler,arguments)},dc.prototype.moveNode=function(){return this.nodesHandler.moveNode.apply(this.nodesHandler,arguments)},dc.prototype.getBoundingBox=function(){return this.nodesHandler.getBoundingBox.apply(this.nodesHandler,arguments)},dc.prototype.getConnectedNodes=function(t){return void 0!==this.body.nodes[t]?this.nodesHandler.getConnectedNodes.apply(this.nodesHandler,arguments):this.edgesHandler.getConnectedNodes.apply(this.edgesHandler,arguments)},dc.prototype.getConnectedEdges=function(){return this.nodesHandler.getConnectedEdges.apply(this.nodesHandler,arguments)},dc.prototype.startSimulation=function(){return this.physics.startSimulation.apply(this.physics,arguments)},dc.prototype.stopSimulation=function(){return this.physics.stopSimulation.apply(this.physics,arguments)},dc.prototype.stabilize=function(){return this.physics.stabilize.apply(this.physics,arguments)},dc.prototype.getSelection=function(){return this.selectionHandler.getSelection.apply(this.selectionHandler,arguments)},dc.prototype.setSelection=function(){return this.selectionHandler.setSelection.apply(this.selectionHandler,arguments)},dc.prototype.getSelectedNodes=function(){return this.selectionHandler.getSelectedNodes.apply(this.selectionHandler,arguments)},dc.prototype.getSelectedEdges=function(){return this.selectionHandler.getSelectedEdges.apply(this.selectionHandler,arguments)},dc.prototype.getNodeAt=function(){var t=this.selectionHandler.getNodeAt.apply(this.selectionHandler,arguments);return void 0!==t&&void 0!==t.id?t.id:t},dc.prototype.getEdgeAt=function(){var t=this.selectionHandler.getEdgeAt.apply(this.selectionHandler,arguments);return void 0!==t&&void 0!==t.id?t.id:t},dc.prototype.selectNodes=function(){return this.selectionHandler.selectNodes.apply(this.selectionHandler,arguments)},dc.prototype.selectEdges=function(){return this.selectionHandler.selectEdges.apply(this.selectionHandler,arguments)},dc.prototype.unselectAll=function(){this.selectionHandler.unselectAll.apply(this.selectionHandler,arguments),this.redraw()},dc.prototype.redraw=function(){return this.renderer.redraw.apply(this.renderer,arguments)},dc.prototype.getScale=function(){return this.view.getScale.apply(this.view,arguments)},dc.prototype.getViewPosition=function(){return this.view.getViewPosition.apply(this.view,arguments)},dc.prototype.fit=function(){return this.view.fit.apply(this.view,arguments)},dc.prototype.moveTo=function(){return this.view.moveTo.apply(this.view,arguments)},dc.prototype.focus=function(){return this.view.focus.apply(this.view,arguments)},dc.prototype.releaseNode=function(){return this.view.releaseNode.apply(this.view,arguments)},dc.prototype.getOptionsFromConfigurator=function(){var t={};return this.configurator&&(t=this.configurator.getOptions.apply(this.configurator)),t};var lc=go;t.Network=dc,t.NetworkImages=Ea,t.networkDOTParser=mo,t.networkGephiParser=Eo,t.networkOptions=rc,t.parseDOTNetwork=lc,t.parseGephiNetwork=xo,Object.defineProperty(t,"__esModule",{value:!0})}));
//# sourceMappingURL=vis-network.min.js.map
